
package gov.va.med.via.audit;

import gov.va.med.via.audit.persistence.AuditLogPersistenceManager;

/**
 * Interface used to audit service requests
 * 
 *  @author ZZZZZZTALBOM
 */

public interface RequestAuditLogger {
	
	/**
	 * Method audits a request made through the web services
	 * 
	 * @param auditRequest
	 */
	void auditRequest(AuditRequest auditRequest);
	
	/**
	 * Configuration to set a delegate manager that will perform the audit functionality
	 * 
	 * @param auditLogPersistenceManager
	 */
	void setAuditLogPersistenceManager(AuditLogPersistenceManager auditLogPersistenceManager);

}
