package gov.va.med.via.common.validator;


public class CityValidator extends StringValidator
{

	public CityValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		
		String city = targetValue;
		
		if ( city==null || city.trim().length()<2)
		{
			throw new ValidationException(rule.target + " must be a valid city name");
		}
		
	}
	
	@Override
	public String toJavadocString()
	{
		return rule.target + " must be a valid city name";
	}

}
