package gov.va.med.via.common.validator;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateAfterValidator extends DateValidator {


	public DateAfterValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}			

		SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Date date;
		try {
			date = simpleDateFormat.parse(rule.value1);
		} catch (ParseException e) {
			throw new ValidationException(targetValue + " should be of format yyyy-MM-dd");
		}
		if ( targetValue.before(date)){
			throw new ValidationException(targetValue + " should be after " + date);
		}
		
	}

	public String toJavadocString() 
	{
		return rule.target+ " must be after " + rule.value1;	
	}

}
