package gov.va.med.via.common.validator;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateBetweenValidator extends DateValidator 
{
	
	public DateBetweenValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException
	{
		super.validate();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}			
		if (rule.value2==null ){
			throw new ValidationException("Value2 cannot be null");
		}	
		SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");


		Date value1Date;
		try {
			value1Date = simpleDateFormat.parse(rule.value1);
		} catch (ParseException e) {
			throw new ValidationException("rule.value1 '" + rule.value1 + "' should be of format yyyy-MM-dd");
		}

		
		Date value2Date;
		try {
			value2Date = simpleDateFormat.parse(rule.value2);
		} catch (ParseException e) {
			throw new ValidationException("rule.value2 '" + rule.value2 + "' should be of format yyyy-MM-dd");
		}
		
		if ( targetValue.before(value1Date) || targetValue.after(value2Date)){
			throw new ValidationException(targetValue + " should be between " + value1Date + " and " + value2Date);
		}		
		
	}
	

	public String toJavadocString()
	{
		return rule.target + " must have a value between dates "+rule.value1+" and "+rule.value2;
	}

}
