package gov.va.med.via.common.validator;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateEqualsValidator extends DateValidator {

	public DateEqualsValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}			

		SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Date value1Date;
		try {
			value1Date = simpleDateFormat.parse(rule.value1);
		} catch (ParseException e) {
			throw new ValidationException(targetValue + " should be of format yyyy-MM-dd");
		}
		if ( targetValue.compareTo(value1Date)!=0){
			throw new ValidationException(targetValue + " should be same as " + value1Date);
		}
		
	}

	public String toJavadocString() 
	{
		return rule.target+ " should be equal to " + rule.value1;	
	}

}
