package gov.va.med.via.common.validator;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateRangeValidator extends Value1Value2Validator {

	public static SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMdd");

	public DateRangeValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}



	@Override
	public void validate() throws ValidationException {
		super.validate();

		if (value1 != null && !value1.isEmpty() && value2 != null && !value2.isEmpty())
		{
			Date value1Date=null;
			try {
				if ( !value1.equals("-1"))
				{
					value1Date = simpleDateFormat.parse(value1);
				}
			} catch (ParseException e) {
				throw new ValidationException(value1 + " should be -1 or of format yyyyMMdd");
			}

			Date value2Date=null;

			try {
				if (!value2.equals("-1"))
				{
					value2Date = simpleDateFormat.parse(value2);
				}
			} catch (ParseException e) {
				throw new ValidationException(value2 + " should be -1 or of format yyyyMMdd");
			}
			if ( !value1.equals("-1") && !value2.equals("-1"))
			{
				if ( value1Date.after(value2Date) || value1Date.equals(value2Date))
				{
					throw new ValidationException(value1 + " should be before " + value2);
				}
			}
		}
	}

	public String toJavadocString() 
	{
		return rule.value1+ " should be before " + rule.value2;	
	}

}
