package gov.va.med.via.common.validator;

import java.util.Date;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class DateValidator extends RuleValidator
{
	protected Date targetValue;
	
	/*
	 * Constructor for Validator that checks if String target value is null
	 * @param target the target name that need to be validated
	 * @param targetValue the target value that is being checked for null
	 */
	public DateValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule,webMethodParameter);	

			
	}
	
	public void validate() throws ValidationException
	{
		String target = rule.getTarget();
		try {
			targetValue = (Date)PropertyUtils.getProperty(webMethodParameter, target);
		} catch (Exception e) {
			throw new ValidationException(rule.getTarget() + " not in input or not a Date");
		}	
	}

	@Override
	public String toJavadocString() {
		return rule.getTarget() + " is a required Date";
	}
	
	
}
