package gov.va.med.via.common.validator;


public class DuzStringValidator extends StringNotEmptyValidator
{

	public DuzStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		
		String duz = targetValue;
		if ( duz.trim().equals("0"))
		{
			if ( rule.errMsg!=null &&!rule.errMsg.trim().isEmpty())
			{
				throw new ValidationException(rule.errMsg);
			}
			throw new ValidationException("invalid DUZ: " + rule.target +" cannot have a value of 0");
		}
		if ( !isNumeric(duz))
		{
			if ( rule.errMsg!=null &&!rule.errMsg.trim().isEmpty())
			{
				throw new ValidationException(rule.errMsg);
			}
			throw new ValidationException("invalid DUZ: " + rule.target +" cannot have a value of " + targetValue + ": The value should be numeric");
		}
	}
	
	@Override
	public String toJavadocString()
	{
		if ( rule.errMsg!=null &&!rule.errMsg.trim().isEmpty())
		{
			return rule.errMsg;
		}
		
		return rule.target + " must be a valid DUZ. It must be an integer or decimal value greater than 0";
	}

}
