package gov.va.med.via.common.validator;


public class IENStringValidator extends StringNotEmptyValidator
{

	public IENStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		
		String ien = targetValue;
		if ( ien.trim().equals("0")) throw new ValidationException("invalid ien: " + rule.target +" cannot have a value of 0");
		if ( !isNumeric(ien) && !isDecimal(ien))
		{
			throw new ValidationException("invalid ien: " + rule.target +" cannot have a value of " + targetValue + ": The value should be a number or a decimal value");
		}
	}
	@Override
	public String toJavadocString()
	{
		return rule.target + " must be a valid IEN (a numeric or decimal value)";
	}

}
