package gov.va.med.via.common.validator;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class IntegerValidator extends RuleValidator
{
	protected Integer targetValue;
	
	/*
	 * Constructor for Validator that checks if String target value is null
	 * @param target the target name that need to be validated
	 * @param targetValue the target value that is being checked for null
	 */
	public IntegerValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule,webMethodParameter);			
	}
	
	public void validate() throws ValidationException
	{
		try 
		{
			Object value = PropertyUtils.getProperty(webMethodParameter, rule.target);
			if ( rule.getNullAllowed() && value==null )
			{
				targetValue=null;
			}
			else
			{
				targetValue = ((Integer)value).intValue();
			}
		} 
		catch (Exception e) 
		{			
			throw new ValidationException(rule.getTarget() + " not in input or not an int");
		}
	}
	
}
