package gov.va.med.via.common.validator;


public class IntegerValue1NotNullValidator extends IntegerValidator 
{
	protected int value1AsInt;

	public IntegerValue1NotNullValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}		
		try
		{
			value1AsInt = Integer.parseInt(rule.value1);
		}
		catch ( NumberFormatException e)
		{
			throw new ValidationException("Value1 "+rule.value1+" is not an integer");
		}
		
	}
	@Override
	public String toJavadocString() 
	{
		return rule.value1+ " cannot be null";	
	}

}
