package gov.va.med.via.common.validator;


public class IntegerValue1and2NotNullValidator extends IntegerValue1NotNullValidator 
{
	protected int value2AsInt;

	public IntegerValue1and2NotNullValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		
		if (rule.value2==null ){
			throw new ValidationException("Value2 cannot be null");
		}		
		try
		{
			value2AsInt = Integer.parseInt(rule.value2);
		}
		catch ( NumberFormatException e)
		{
			throw new ValidationException("Value1 "+rule.value2+" is not an integer");
		}
		
	}
	
	@Override
	public String toJavadocString() 
	{
		return rule.value1+ " and " + rule.value2 + " cannot be null";	
	}

}
