package gov.va.med.via.common.validator;

public class MaxRecordsStringValidator extends StringValidator {

	public MaxRecordsStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if ( rule.nullAllowed && targetValue==null )
		{
			targetValue=null;
		}
		else if ( !rule.nullAllowed && targetValue==null )
		{
			throw new ValidationException(rule.target + " not in input or not an int");
		}
		
		if ( targetValue == null )
		{
			return; /// ok if the max results value is null
		}
		else 
		{
			try
			{
				Integer nTargetValue = Integer.parseInt(targetValue);
				if (nTargetValue.intValue() <= 0)
				{
					throw new ValidationException(rule.target + " value " + targetValue + " should be an integer greater than zero");
				}
			}
			catch ( Exception e)
			{
				throw new ValidationException(rule.target + " value " + targetValue + " should be an integer greater than zero");
			}
		}	

	}

	@Override
	public String toJavadocString() 
	{
		return rule.target + " value, if set, must be an integer greater than zero";
	}
}
