package gov.va.med.via.common.validator;

public class NullOrIntegerStringValidator extends StringValidator 
{
	public NullOrIntegerStringValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule, webMethodParameter);
	}

	
	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if ( targetValue == null )		return;
		
		String integerValue = targetValue;
				
		if ( !isNumeric(integerValue))
		{
			throw new ValidationException("invalid date: " + rule.target +" cannot have a value of " + targetValue + ": The value should be numeric");
		}
	}

	@Override
	public String toJavadocString() 
	{
		return rule.target +" needs to be a valid integer value.";
	}
}
