package gov.va.med.via.common.validator;

public class NullOrNegativeOneIntegerValidator extends IntegerValidator 
{

	public NullOrNegativeOneIntegerValidator(Rule rule,
			Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if ( targetValue == null )
		{
			return;
		}
		if (!targetValue.equals(new Integer(-1)))
		{
			throw new ValidationException("The target '"+rule.target+"' value must be null (not present) or -1.");
		}
	}

	@Override
	public String toJavadocString()
	{
		return rule.target + " must be null (not present) or have a value of -1";
	}


}
