package gov.va.med.via.common.validator;

import gov.va.med.via.rpc.Timestamp;

public class NullOrUtcDateStringValidator extends StringValidator 
{

	

	public NullOrUtcDateStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	
	@Override
	public void validate() throws ValidationException {

		super.validate();
		if ( targetValue == null )		return;
		String date = targetValue;
		if ( date.trim().equals("0"))
		{
			throw new ValidationException("invalid date: " + rule.target +" cannot have a value of 0");
		}
		if ( !isNumeric(date))
		{
			throw new ValidationException("invalid date: " + rule.target +" cannot have a value of " + targetValue + ": The value should be numeric");
		}
		if ( !Timestamp.isWellFormedUtcDateTime(targetValue))
		{
			throw new ValidationException("invalid date: " + rule.target +" needs to have a valid UTC format: yyyymmdd");
		}
	}

	@Override
	public String toJavadocString() 
	{
		return rule.target +" needs to have a valid UTC format: yyyymmdd";
	}
}
