package gov.va.med.via.common.validator;

import java.text.SimpleDateFormat;

public class NullorNegativeOneorYYYYMMDDValidator extends StringValidator 
{
	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyymmdd");
	
	public NullorNegativeOneorYYYYMMDDValidator(Rule rule,
			Object webMethodParameter) 
	{
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		if ( targetValue==null) return;  /// a null date is fine

		String sTargetValue = targetValue.toString();
		try
		{
			if ( sTargetValue.length()!=2 && sTargetValue.length()!=8)
			{
				throw new ValidationException("The target '"+rule.target+"' value must be null,-1 or have the format 'YYYYMMDD'");
			}
			if ( sTargetValue.length()==2)
			{
				Integer nTargetValue = Integer.parseInt(sTargetValue);
				if (!nTargetValue.equals(new Integer(-1)))
				{
					throw new ValidationException("The target '"+rule.target+"' value must be null,-1 or have the format 'YYYYMMDD'");
				}
			}
			else  /// sTargetValue.length()==8
			{
				sdf.parse(sTargetValue);
			}
		}
		catch ( Exception e)
		{
			throw new ValidationException("The target '"+rule.target+"' value must be null,-1 or have the format 'YYYYMMDD'");
		}
	}

	@Override
	public String toJavadocString() 
	{
		return "The target '"+rule.target+"' value must be null,-1 or have the format 'YYYYMMDD'";
	}


}
