package gov.va.med.via.common.validator;

public class ObjectNotNullValidator extends ObjectValidator
{

	public ObjectNotNullValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		if ( targetValue == null ){
			throw new ValidationException(rule.target + " cannot be null");
		}
	}
	
	@Override	
	public String toJavadocString()
	{
		return rule.target + " cannot be a null value";
	}

}
