package gov.va.med.via.common.validator;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class ObjectValidator extends RuleValidator
{
	protected Object targetValue;
	
	/*
	 * Constructor for Validator that checks if String target value is null
	 * @param target the target name that need to be validated
	 * @param targetValue the target value that is being checked for null
	 */
	public ObjectValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule,webMethodParameter);	
		this.rule=rule;
		this.webMethodParameter=webMethodParameter;
	}
	
	public void validate() throws ValidationException
	{
		try 
		{
			targetValue = (Object)PropertyUtils.getProperty(webMethodParameter, rule.target);
		} 
		catch (Exception e) 
		{
			//	log.info("Error in retrieving value for target: " + rule.getTarget() + " : " + e.getMessage());
			throw new ValidationException(rule.getTarget() + " not in input or not an Object");
		}
	}
	
}
