package gov.va.med.via.common.validator;


public class OptionalIENStringValidator extends StringValidator
{

	public OptionalIENStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		if ( targetValue==null || targetValue.trim().equals("")) return;  /// allow a null value

		new IENStringValidator(rule,webMethodParameter).validate();
	}
	
	@Override
	public String toJavadocString()
	{
		return "When set, the " +rule.target + " must be a valid IEN (a numeric or decimal value)";
	}

}
