package gov.va.med.via.common.validator;

public class OptionalPatternValidator extends StringValidator {

	public OptionalPatternValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();

		if ( targetValue==null ) return;
		
		if ( !targetValue.matches(rule.value1) )
		{
			String errorMessage = "";
			if ( rule.errMsg!=null)
			{
				errorMessage = rule.errMsg;
			}
			else
			{
				errorMessage = rule.target + " needs to be of pattern " + rule.value1;
			}
			throw new ValidationException(errorMessage);
		}
	}

	@Override
	public String toJavadocString() 
	{
		if ( rule.errMsg!=null && !rule.errMsg.trim().isEmpty())
		{
			return rule.errMsg;
		}
		return rule.target + " needs to be of pattern '" + rule.value1+"'";	
	}

}
