package gov.va.med.via.common.validator;

/*
 * RuleNames is an enum that holds the list of valid Rules
 * @author      Sridhar Alluri
 * @version     %I%, %G%
 * @since		1.0

 */
public enum RuleNames {
	/*
	 * List of rule names
	 */
	notnull("notnull"), 
	notempty("notempty"),  
	minlength("minlength"),
	maxlength("maxlength"), 
	between("between"), 
	pattern("pattern"),
	optional_pattern("optional_pattern"),
	before("before"),  
	after("after"), 
	equals("equals"),
	lessthan("lessthan"),
	mandatory_pattern("mandatory_pattern"),
	morethan("morethan"),
	// customized via validation rules - to keep our validation 100% configurable
	maxRecords("maxRecords"),
	valid_accessionnumber("valid_accessionnumber"),
	valid_encounterstring("valid_encounterstring"),
	valid_visitstring("valid_visitstring"),
	valid_ien("valid_ien"),
	valid_optional_ien("valid_optional_ien"),
	valid_duz("valid_duz"),
	valid_ssn("valid_ssn"),
	valid_utcDate("valid_utcDate"),
	state_abbr("state_abbr"),
	city("city"),
	null_or_valid_utcDate("null_or_valid_utcDate"),// Can be null but, if it exists it has to be a valid utc date
	dateRangeNoTarget("dateRangeNoTarget"),
	value1BasedOnOptValue2("value1BasedOnOptValue2"),
	compareValue1Value2("compareValue1Value2"),
	null_or_negative_one("null_or_negative_one"),
	null_or_negative_one_or_valid_govt_date("null_or_negative_one_or_valid_govt_date"),
	get_notes_with_text_date_range("get_notes_with_text_date_range"),
	optional_string_not_emtpy("optional_string_not_emtpy"),
	null_or_valid_integer("null_or_valid_integer"),// Can be null but, if it exists it has to be a valid integer (numeric)
	parameter_required_based_on_compare_value("parameter_required_based_on_compare_value");
  
	private final String name;
  
	  private RuleNames(String name) {
		  this.name = name;
	  }
	
	  
	  public String toString() {
	 	return name;
	  }

}
