package gov.va.med.via.common.validator;

import gov.va.med.via.util.StringUtil;

public class SocialSecurityNumberStringValidator extends StringNotEmptyValidator
{

	public SocialSecurityNumberStringValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		
		String ssn = targetValue;
		
		for ( int i=0; i< ssn.length(); i++)
		{
			char c = ssn.charAt(i);
			if ( !Character.isDigit(c) && c!='-') throw new ValidationException("Invalid SSN");			
		}
		ssn = StringUtil.removeNonNumericChars(ssn);
		if ( ssn.length()!=9) throw new ValidationException("Invalid SSN");
	}
	
	@Override
	public String toJavadocString()
	{
		return rule.target + " must be a valid Social Security Number";
	}

}
