package gov.va.med.via.common.validator;


public class StateAbbreviationValidator extends StringValidator
{

	public StateAbbreviationValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		
		String abbr = targetValue;
		
		if (abbr==null || abbr.trim().length()!=2)
		{
			throw new ValidationException(rule.target + " must be a valid, 2-character US State abbreviation or valid US territory abbreviation");
		}
		
	}
	
	@Override
	public String toJavadocString()
	{
		return rule.target + " must be a valid, 2-character US State abbreviation or valid US territory abbreviation";
	}

}
