package gov.va.med.via.common.validator;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class StringArrayValidator extends RuleValidator
{
	protected String[] targetValue;
	
	public StringArrayValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException
	{
		try {
			targetValue = (String[])PropertyUtils.getProperty(webMethodParameter, rule.target);
		} catch (Exception e) {
			//	log.info("Error in retrieving value for target: " + rule.getTarget() + " : " + e.getMessage());
			throw new ValidationException(rule.getTarget() + " not in input or not a String");
		}
	}

}
