package gov.va.med.via.common.validator;

public class StringEqualsValue1Validator extends StringNotEmptyValidator 
{
	public StringEqualsValue1Validator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String target value is alphanumerically same as a particular value
	 * @exception the ValidationException related to the curent rule  
	 */
	/* (non-Javadoc)
	 * @see gov.va.med.via.common.validator.RuleValidator#validate()
	 */
	@Override
	public void validate() throws ValidationException
	{
		super.validate();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}					

		if (targetValue.compareTo(rule.value1)!=0){
			throw new ValidationException(rule.target + " needs to be same as " + rule.value1);
		}
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.common.validator.RuleValidator#toJavadocString()
	 */
	@Override
	public String toJavadocString()
	{
		return rule.target + " must be equal to value '+value1+'";
	}

}
