package gov.va.med.via.common.validator;

public class StringMaxLengthValidator extends StringNotEmptyValidator 
{
	

	public StringMaxLengthValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * checks if String target value has atmost maximum length
	 * @exception the ValidationException related to the curent rule  
	 */
	@Override
	public void validate() throws ValidationException
	{
		super.validate();
		
		int targetLength = targetValue.length();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}					
		
		int maxLength=-1;
		try
		{		
			maxLength =  Integer.parseInt(rule.value1);
		}
		catch ( NumberFormatException e)
		{
			throw new ValidationException("Value1 '"+rule.value1+"' must be a positive integer");
		}
		if ( maxLength<=0)
		{
			throw new ValidationException("Value1 '"+rule.value1+"' must be greater than or equal to 1");
		}
		if (targetLength>maxLength){
			throw new ValidationException(rule.target + " needs to have maximum length of " + maxLength);
		}
		
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.common.validator.RuleValidator#toJavadocString()
	 */
	@Override
	public String toJavadocString()
	{
		return rule.target + " must have a maximum length of '+rule.value1+'";
	}

}
