package gov.va.med.via.common.validator;

public class StringMinLengthValidator extends StringNotEmptyValidator 
{
	public StringMinLengthValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	/*
	 * This methods checks if String rule.target value has atleast a minimum length
	 * @exception the ValidationException related to the curent rule  
	 */
	@Override
	public void validate() throws ValidationException
	{
		super.validate();
		
		int targetLength = targetValue.length();
		if (rule.value1==null ){
			throw new ValidationException("Value1 cannot be null");
		}					
		
		int minLength=-1;
		try
		{		
			minLength =  Integer.parseInt(rule.value1);
		}
		catch ( NumberFormatException e)
		{
			throw new ValidationException("Value1 '"+rule.value1+"' must be a positive integer");
		}
		if ( minLength<0)
		{
			throw new ValidationException("Value1 '"+rule.value1+"' must be greater than or equal to 0");
		}
		if (targetLength<minLength){
			throw new ValidationException(rule.target + " needs to have minimum length of " + minLength);
		}
		
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.common.validator.RuleValidator#toJavadocString()
	 */
	@Override
	public String toJavadocString()
	{
		return rule.target + " must have a minimum length of '+rule.value1+'";
	}

}
