package gov.va.med.via.common.validator;

public class StringNotEmptyValidator extends StringNotNullValidator
{
	public StringNotEmptyValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule, webMethodParameter);
	}

	public void validate() throws ValidationException
	{
		super.validate();
		if (targetValue.trim().isEmpty())
		{
			if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
			{
				throw new ValidationException(rule.getErrMsg());
			}
			
			
			throw new ValidationException(rule.target + " cannot be empty");
		}
	}
	
	@Override
	public String toJavadocString()
	{
		if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
		{
			return rule.getErrMsg();
		}

		return rule.target + " cannot be a null value or an empty string";
	}

}
