package gov.va.med.via.common.validator;


public class StringNotNullValidator extends StringValidator
{
	
	/*
	 * Constructor for Validator that checks if String target value is null
	 * @param target the target name that need to be validated
	 * @param targetValue the target value that is being checked for null
	 */
	public StringNotNullValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule,webMethodParameter);		
	}
	
	/*
	 * This methods checks if String target value is null
	 * @exception the ValidationException related to the curent rule  
	 */
	public void validate() throws ValidationException
	{
		super.validate();
		if ( targetValue == null )
		{
			if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
			{
				throw new ValidationException(rule.getErrMsg());
			}
			
			throw new ValidationException(rule.target + " cannot be null");
		}
	}

	@Override
	public String toJavadocString() 
	{
		if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
		{
			return rule.getErrMsg();
		}
		return rule.target + " must not be null";
	}
	
}
