package gov.va.med.via.common.validator;

public class StringPatternValidator extends StringValidator {

	public StringPatternValidator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		
		/// from not null
		if ( targetValue == null )
		{
/*			if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
			{
				throw new ValidationException(rule.getErrMsg());
			}
			
*/			throw new ValidationException(rule.target + " cannot be null");
		}
		
		/// from not empty
		if (targetValue.trim().isEmpty())
		{
/*			if ( rule.getErrMsg()!=null && !rule.getErrMsg().trim().isEmpty())
			{
				throw new ValidationException(rule.getErrMsg());
			}
*/			throw new ValidationException(rule.target + " cannot be empty");
		}
		
		
		if ( !targetValue.matches(rule.value1) )
		{
			String errorMessage = "";
			if ( rule.errMsg!=null)
			{
				errorMessage = rule.target + " " + rule.errMsg;
			}
			else
			{
				errorMessage = rule.target + " needs to be of pattern " + rule.value1;
			}
			throw new ValidationException(errorMessage);
		}
	}

	@Override
	public String toJavadocString() 
	{
		if ( rule.errMsg!=null && !rule.errMsg.trim().isEmpty())
		{
			return rule.getTarget() + " " + rule.errMsg;
		}
		return rule.target + " needs to be of pattern '" + rule.value1+"'";	
	}

}
