package gov.va.med.via.common.validator;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class StringValidator extends RuleValidator
{
	protected String targetValue;
	
	/*
	 * Constructor for Validator that checks if String target value is null
	 * @param target the target name that need to be validated
	 * @param targetValue the target value that is being checked for null
	 */
	public StringValidator(Rule rule, Object webMethodParameter) 
	{
		super(rule,webMethodParameter);	
//		this.rule=rule;
//		this.webMethodParameter=webMethodParameter;
		
	}
	
	public void validate() throws ValidationException
	{
		try 
		{
			targetValue = (String)PropertyUtils.getProperty(webMethodParameter, rule.target);
		} 
		catch (Exception e) 
		{
			//	log.info("Error in retrieving value for target: " + rule.getTarget() + " : " + e.getMessage());
			throw new ValidationException(rule.getTarget() + " not in input or not a String");
		}
	}
	
	
	public static boolean isNumeric(String s)
	{
		if (s.equals(""))
		{
			return false;
		}
		for (int i=0; i<s.length(); i++)
		{
			if (s.charAt(i) < '0' || s.charAt(i) > '9')
			{
				return false;
			}
		}
		return true;
	}
	
	public static boolean isDecimal(String s) 
	{
		return (s.indexOf(".")!=-1) && isNumeric(s.replaceAll("\\.", ""));
	}
	
}
