package gov.va.med.via.common.validator;

import gov.va.med.via.exception.AbstractViaBaseException;
import gov.va.med.via.exception.ErrorCodeEnum;

/*
 * This class is used to hold the validation errors encountered during validation
 */
public class ValidationException extends AbstractViaBaseException{
	
	private static final long serialVersionUID = 1L;
	
	
	/*
	 * Holds the error description
	 */
	private String errorDescription;
	
	
	/*
	 * This method returns the error description
	 */
	public String getErrorDescription() {
		return errorDescription;
	}
	
	/*
	 * Sets the error description
	 * @param errorDescription
	 */
	public void setErrorDescription(String errorDescription) {
		this.errorDescription = errorDescription;
	}
	
	/*
	 * Contructor that takes in error code and description
	 * @param errorCode the error code
	 * @param errorDescription the error description
	 */
	public ValidationException(ErrorCodeEnum errorCode, String errorDescription){
		super(errorCode, errorDescription);
		this.errorDescription = errorDescription;
	}
	
	/*
	 * Contructor that takes in error description
	 * @param errorDescription the error description
	 */
	public ValidationException(String errorDescription){
		super( ErrorCodeEnum.VALIDATION_EXCEPTION, errorDescription);
		this.errorDescription = errorDescription;
	}
	
	/*
	 * This methods the string form of ValidationException
	 * @return the exception description
	 */
	public String toString(){
		return errorDescription;
	}
}
