package gov.va.med.via.common.validator;


public class Value1RequiredIfValue2PresentValidator extends Value1Value2Validator {

	public Value1RequiredIfValue2PresentValidator(Rule rule,
			Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	
	/*
	 * This methods validates that the rule.value1 is not null or empty if rule.value2 has a value.
	 * @ValidationException the ValidationException related to the curent rule  
	 */
	@Override
	public void validate() throws ValidationException 
	{
		super.validate();
		
		// If value2 is sent, value1 is required and cannot be empty or null
		if (value2 != null && !value2.isEmpty() && (value1 == null || value1.isEmpty()))
		{			
			throw new ValidationException(rule.getErrMsg());
		}
	}
	@Override
	public String toJavadocString()
	{
		return rule.value1 + " must be present if "+rule.value2 + " has a value";
	}

}
