package gov.va.med.via.common.validator;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class Value1Value2Validator extends RuleValidator {

	protected String value1;
	protected String value2;
	
	public Value1Value2Validator(Rule rule, Object webMethodParameter) {
		super(rule, webMethodParameter);
	}

	@Override
	public void validate() throws ValidationException 
	{		
		try {
			value1 = (String)PropertyUtils.getProperty(webMethodParameter, rule.getValue1());
		} catch (Exception e) {
			throw new ValidationException(rule.getValue1() + " not in input or not a String");
		}	

		try {
			value2 = (String)PropertyUtils.getProperty(webMethodParameter, rule.getValue2());
		} catch (Exception e) {
			throw new ValidationException(rule.getValue2() + " not in input or not a String");
		}	
	}

}
