package gov.va.med.via.common.validator;

import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Set;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/*
 * WMParamHelper is a helper class to provide a HashMap of properties from an object
 */
public class WMParamHelper {
	private static Log log = LogFactory.getLog(WMParamHelper.class);
	
	
	/*
	 * This method returns a hashmap of properties from one or more objects
	 *  @param params one or more objects whose properties need to be obtained as a hashmap
	 *  @return Hashmap of name value pairs of the input objects
	 */
	@SuppressWarnings("unchecked")
	public HashMap<Object, Object> getHashMap(Object ...params){
		HashMap<Object, Object> hashMap = new HashMap<Object, Object>();
		if (params == null)
			return hashMap;
		for(int index=0; index<params.length; index++){
			try {
				hashMap.putAll(PropertyUtils.describe(params[index]));
			} catch (Exception e) {
				log.error("Error while creating hashmap from parameters");
			}
		}

		return hashMap;
	}
	/*
	 * This is a helper methods to log the hashmap
	 * @param hashMap the hashMap that needs to be logged 
	 */
	public void logHashMap(HashMap<Object, Object> hashMap){
		Set<Object> keys = hashMap.keySet();		
		for(Object key: keys){
			log.info("key: " + key  + " value: " + hashMap.get(key));
		}
	}

}
