
package gov.va.med.via.databeans;

public class AdmissionDetail extends PatientAdmission 
{
  /**
   * Array of procedure objects representing procedures associated with this visit.
   * This will only be populated when requesting admission details.
   */
  private Procedure[] procedures;
  /**
   * Array of procedure Objects representing Diagnoses assoicated with this admission.
   * This will only be populated when requesting admission details.
   */
  private Diagnosis[] diagnoses;
  
  public AdmissionDetail()
  {
    procedures = null;
    diagnoses = null;
  }
 
  public AdmissionDetail(PatientAdmission adm)
  {
    super(adm);
  }
  
 
  /**
   * Array of procedures associated with the admission.  This will only be populated
   * when requesting admission details.
   */
  public Procedure[] getProcedures()
  {
    return procedures;
  }

  public void setProcedures(Procedure[] newProcedures)
  {
    procedures = newProcedures;
  }

  /**
   * Array of diagnoses associated with the admission.  This will only be populated
   * when requesting admission details.
   */
  public Diagnosis[] getDiagnoses()
  {
    return diagnoses;
  }

  public void setDiagnoses(Diagnosis[] newDiagnoses)
  {
    diagnoses = newDiagnoses;
  } 
}