
package gov.va.med.via.databeans;

import java.util.ArrayList;
import java.util.List;

import gov.va.med.via.databeans.snomed.SnoMedConcept;

/**
 * This class contains data regarding a patient's allergy.
 */
public class Allergy extends Observation
{
  /**
   * name of allergy.
   */
  private String allergyName;
  /**
   * comment regarding allergy.
   */
  private String comment;
  /**
   * Internal Id of allergy.  Used to retrieve detailed allery information.
   */
  private String allergyId;
  /**
   * Severity of the allergy reaction.
   */
  private String severity;

  private String allergyType;

  private SnoMedConcept snoMedAllergen;
  
  private SnoMedConcept snoMedReaction;
  
  List<Symptom> reactions = new ArrayList<Symptom>();
  
  //StringDictionary drugIngredients;
  //StringDictionary drugClasses;
  
  public Allergy()
  {	
  
  }
 
  /**
   * Name of allergy.
   */
  public String getAllergyName()
  {
    return allergyName;
  }

  public void setAllergyName(String newAllergyName)
  {
    allergyName = newAllergyName;
  }


  /**
   * Internal Id of Allergy.
   */
  public String getAllergyId()
  {
    return allergyId;
  }

  public void setAllergyId(String newAllergyId)
  {
    allergyId = newAllergyId;
  }

  /**
   * Comment about allergy
   */
  public String getComment()
  {
    return comment;
  }

  public void setComment(String newComment)
  {
    comment = newComment;
  }

  /**
   * Severity of the allery.
   */
  public String getSeverity()
  {
    return severity;
  }

  public void setSeverity(String newSeverity)
  {
    severity = newSeverity;
  }

  public String getAllergyType() {
	  return allergyType;
  }

  public void setAllergyType(String allergyType) {
	  this.allergyType = allergyType;
  }

  public SnoMedConcept getSnoMedAllergen() {
	  return snoMedAllergen;
  }

  public void setSnoMedAllergen(SnoMedConcept snoMedAllergen) {
	  this.snoMedAllergen = snoMedAllergen;
  }

  public SnoMedConcept getSnoMedReaction() {
	  return snoMedReaction;
  }

  public void setSnoMedReaction(SnoMedConcept snoMedReaction) {
	  this.snoMedReaction = snoMedReaction;
  }

  public List<Symptom> getReactions() {
	  return reactions;
  }

  public void setReactions(List<Symptom> reactions) {
	  this.reactions = reactions;
  }
  
  public void addReaction(Symptom reaction) {
	  this.reactions.add(reaction);
  }
}