
package gov.va.med.via.databeans;

public class AllergyDetail extends Allergy 
{
  /**
   * Type of allergy : D=Drug, F=Food, O=Other
   */
  private String allergyType;
  /**
   * Indicates whether the allergy was observed or obtained via historical data.
   */
  private String observedOrHistorical;
  /**
   * Set to Yes if the allergy has been verified.
   */
  private String verified;
  /**
   * Person who verified this allergy.
   */
  private String verifiedBy;
  
  public AllergyDetail()
  {
  }
 
  /**
   * Type of Allergy (D=Drug, F=Food, O=Other)
   */
  public String getAllergyType()
  {
    return allergyType;
  }

  public void setAllergyType(String newAllergyType)
  {
    allergyType = newAllergyType;
  }

  /**
   * Indicates whether allergy was observed or documented from patient history.
   */
  public String getObservedOrHistorical()
  {
    return observedOrHistorical;
  }

  public void setObservedOrHistorical(String newObservedOrHistorical)
  {
    observedOrHistorical = newObservedOrHistorical;
  }

  /**
   * Yes indicates allergy has been verified.
   */
  public String getVerified()
  {
    return verified;
  }

  public void setVerified(String newVerified)
  {
    verified = newVerified;
  }

  /**
   * Person who verified the allergy.
   */
  public String getVerifiedBy()
  {
    return verifiedBy;
  }

  public void setVerifiedBy(String newVerifiedBy)
  {
    verifiedBy = newVerifiedBy;
  }
}