
package gov.va.med.via.databeans;
import java.util.Calendar;


/**
 * ClinicalReminders are associated with a patient based on age, diagnosis, gender and various other parameters to enable preventive care maintanance.  Two type of ClinicalReminders are supported, those that are due or over due, and those that have been completed.
 */
public class ClinicalReminder extends BaseDataBean
{
  /**
   * Internal ID of the clinical reminder, used to retrieve the detailed text of a 
   * clinical reminder.
   */
  private String id;
  /**
   * Descriptive text of the ClinicalReminder.
   */
  private String description;
  /**
   * Date the clinical reminder is next due.
   */
  private Calendar dueDate;
  /**
   * Date the Clincialreminder was last completed.
   */
  private Calendar lastOccurrenceDate;

  public ClinicalReminder()
  {
  }

 

  /**
   * Internal Id of the Clinical Reminder.  This is used to retrieve detail information
   * of a clinical reminder.
   */
  public String getId()
  {
    return id;
  }

  public void setId(String newId)
  {
    id = newId;
  }

  /**
   * Description of the clinical reminder.
   */
  public String getDescription()
  {
    return description;
  }

  public void setDescription(String newDescription)
  {
    description = newDescription;
  }

  /**
   * Date the clinicalReminder is due.  This could be a date in the past if overdue.
   */
  public Calendar getDueDate()
  {
    return dueDate;
  }

  public void setDueDate(Calendar newDueDate)
  {
      dueDate = newDueDate;
  }

  /**
   * Last date the Clinical reminder was completed.
   */
  public Calendar getLastOccurrenceDate()
  {
    return lastOccurrenceDate;
  }

  public void setLastOccurrenceDate(Calendar newDate)
  {
    lastOccurrenceDate = newDate;
  }
}