package gov.va.med.via.databeans;

import gov.va.med.via.exception.AbstractViaBaseException;
import gov.va.med.via.exception.ExceptionUtil;

public class Fault implements DataBean
{
    /** The type. */
    protected String type;
    
    /** The message. */
    protected String message;
    
    /** The stack trace. */
    protected String stackTrace;
    
    /** The inner type. */
    protected String innerType;
    
    /** The inner message. */
    protected String innerMessage;
    
    /** The inner stack trace. */
    protected String innerStackTrace;
    
    /** The suggestion. */
    protected String suggestion;
    
    protected boolean logged = false;
    
    protected Exception exception;

    public Fault()
    {
    	
    }
    
    
    public Fault(Exception e)
    {
    	this.exception = e;
    	this.message = e.getMessage();
    	this.stackTrace = ExceptionUtil.buildErrorStackTraceString(e);
    	if(e.getCause() != null){
    		this.innerMessage = e.getCause().getMessage();
    		this.innerStackTrace = ExceptionUtil.buildErrorStackTraceString(e.getCause());
    	}
    	this.type = e.toString();
    	if( e instanceof AbstractViaBaseException){
    		this.logged = ((AbstractViaBaseException) e).isLogged();
    	}
    }
    
    public Fault(String appliationMessage, Exception e)
    {
    	this.exception = e;
    	this.message = appliationMessage + " - exception message: " + e.getMessage();
    	this.stackTrace = ExceptionUtil.buildErrorStackTraceString(e);
    	if(e.getCause() != null){
    		this.innerMessage = e.getCause().getMessage();
    		this.innerStackTrace = ExceptionUtil.buildErrorStackTraceString(e.getCause());
    	}
    	this.type = e.toString();
    	if( e instanceof AbstractViaBaseException){
    		this.logged = ((AbstractViaBaseException) e).isLogged();
    	}
    }
    
    public Fault(AbstractViaBaseException e)
    {
    	this.message = e.getMessage();
    	this.logged = e.isLogged();
    	this.exception=e;
    }
    
    public Fault(String message)
    {
    	this.message = message;
    }
    
	public String getType()
	{
		return type;
	}

	public void setType(String type)
	{
		this.type = type;
	}

	public String getMessage()
	{
		return message;
	}

	public void setMessage(String message)
	{
		this.message = message;
	}

	public String getStackTrace()
	{
		return stackTrace;
	}

	public void setStackTrace(String stackTrace)
	{
		this.stackTrace = stackTrace;
	}

	public String getInnerType()
	{
		return innerType;
	}

	public void setInnerType(String innerType)
	{
		this.innerType = innerType;
	}

	public String getInnerMessage()
	{
		return innerMessage;
	}

	public void setInnerMessage(String innerMessage)
	{
		this.innerMessage = innerMessage;
	}

	public String getInnerStackTrace()
	{
		return innerStackTrace;
	}

	public void setInnerStackTrace(String innerStackTrace)
	{
		this.innerStackTrace = innerStackTrace;
	}

	public String getSuggestion()
	{
		return suggestion;
	}

	public void setSuggestion(String suggestion)
	{
		this.suggestion = suggestion;
	}
	
	public Exception getException(){
		return this.exception;
	}
}
