package gov.va.med.via.databeans;

import gov.va.med.via.rpc.KeyValuePair;

import java.util.HashMap;

// TODO: Auto-generated Javadoc
/**
 * The Class HospitalLocation.
 * 
 * @author DOMAINROMERJ
 */
public class HospitalLocation extends BaseDataBean
{
    
    /** The id. */
    protected String id;
    
    /** The name. */
    protected String name;
    
    /** The abbr. */
    protected String abbr;
    
    /** The type. */
    protected String type;
    
    /** The type extension. */
    KeyValuePair<String, String> typeExtension;
    
    /** The institution. */
    KeyValuePair<String, String> institution;
    
    /** The division. */
    KeyValuePair<String, String> division;
    
    /** The module. */
    KeyValuePair<String, String> module;
    
    /** The disposition action. */
    protected String dispositionAction;
    
    /** The visit location. */
    protected String visitLocation;
    
    /** The stop code. */
    KeyValuePair<String, String> stopCode;
    
    /** The department. */
    KeyValuePair<String, String> department;
    
    /** The service. */
    KeyValuePair<String, String> service;
    
    /** The specialty. */
    KeyValuePair<String, String> specialty;
    
    /** The physical location. */
    protected String physicalLocation;
    
    /** The ward location. */
    KeyValuePair<String, String> wardLocation;
    
    /** The principal clinic. */
    KeyValuePair<String, String> principalClinic;    
    
    /** The site of the hospital location */
    SiteId facility;
    
    /** The building. */
   protected String building;
    
    /** The floor. */
    protected String floor;
    
    /** The room. */
    protected String room;
    
    /** The bed. */
    protected String bed;
    
    /** The status. */
    protected String status;
    
    /** The phone. */
    protected String phone;
    
    /** The appointment timestamp. */
    protected String appointmentTimestamp;
    
    /**
     * Instantiates a new hospital location.
     */
    public HospitalLocation(){
    	
    }
    		
    /**
     * Instantiates a new hospital location.
     *
     * @param id the id
     * @param name the name
     */
    public HospitalLocation(String id, String name)
    {
    	this.id = id;
    	this.name = name;
    }
    
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the abbr.
	 *
	 * @return the abbr
	 */
	public String getAbbr()
	{
		return abbr;
	}
	
	/**
	 * Sets the abbr.
	 *
	 * @param abbr the new abbr
	 */
	public void setAbbr(String abbr)
	{
		this.abbr = abbr;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the type extension.
	 *
	 * @return the type extension
	 */
	public KeyValuePair<String, String> getTypeExtension()
	{
		return typeExtension;
	}
	
	/**
	 * Sets the type extension.
	 *
	 * @param typeExtension the type extension
	 */
	public void setTypeExtension(KeyValuePair<String, String> typeExtension)
	{
		this.typeExtension = typeExtension;
	}
	
	/**
	 * Gets the institution.
	 *
	 * @return the institution
	 */
	public KeyValuePair<String, String> getInstitution()
	{
		return institution;
	}
	
	/**
	 * Sets the institution.
	 *
	 * @param institution the institution
	 */
	public void setInstitution(KeyValuePair<String, String> institution)
	{
		this.institution = institution;
	}
	
	/**
	 * Gets the division.
	 *
	 * @return the division
	 */
	public KeyValuePair<String, String> getDivision()
	{
		return division;
	}
	
	/**
	 * Sets the division.
	 *
	 * @param division the division
	 */
	public void setDivision(KeyValuePair<String, String> division)
	{
		this.division = division;
	}
	
	/**
	 * Gets the module.
	 *
	 * @return the module
	 */
	public KeyValuePair<String, String> getModule()
	{
		return module;
	}
	
	/**
	 * Sets the module.
	 *
	 * @param module the module
	 */
	public void setModule(KeyValuePair<String, String> module)
	{
		this.module = module;
	}
	
	/**
	 * Gets the disposition action.
	 *
	 * @return the disposition action
	 */
	public String getDispositionAction()
	{
		return dispositionAction;
	}
	
	/**
	 * Sets the disposition action.
	 *
	 * @param dispositionAction the new disposition action
	 */
	public void setDispositionAction(String dispositionAction)
	{
		this.dispositionAction = dispositionAction;
	}
	
	/**
	 * Gets the visit location.
	 *
	 * @return the visit location
	 */
	public String getVisitLocation()
	{
		return visitLocation;
	}
	
	/**
	 * Sets the visit location.
	 *
	 * @param visitLocation the new visit location
	 */
	public void setVisitLocation(String visitLocation)
	{
		this.visitLocation = visitLocation;
	}
	
	/**
	 * Gets the stop code.
	 *
	 * @return the stop code
	 */
	public KeyValuePair<String, String> getStopCode()
	{
		return stopCode;
	}
	
	/**
	 * Sets the stop code.
	 *
	 * @param stopCode the stop code
	 */
	public void setStopCode(KeyValuePair<String, String> stopCode)
	{
		this.stopCode = stopCode;
	}
	
	/**
	 * Gets the department.
	 *
	 * @return the department
	 */
	public KeyValuePair<String, String> getDepartment()
	{
		return department;
	}
	
	/**
	 * Sets the department.
	 *
	 * @param department the department
	 */
	public void setDepartment(KeyValuePair<String, String> department)
	{
		this.department = department;
	}
	
	/**
	 * Gets the service.
	 *
	 * @return the service
	 */
	public KeyValuePair<String, String> getService()
	{
		return service;
	}
	
	/**
	 * Sets the service.
	 *
	 * @param service the service
	 */
	public void setService(KeyValuePair<String, String> service)
	{
		this.service = service;
	}
	
	/**
	 * Gets the specialty.
	 *
	 * @return the specialty
	 */
	public KeyValuePair<String, String> getSpecialty()
	{
		return specialty;
	}
	
	/**
	 * Sets the specialty.
	 *
	 * @param specialty the specialty
	 */
	public void setSpecialty(KeyValuePair<String, String> specialty)
	{
		this.specialty = specialty;
	}
	
	/**
	 * Gets the physical location.
	 *
	 * @return the physical location
	 */
	public String getPhysicalLocation()
	{
		return physicalLocation;
	}
	
	/**
	 * Sets the physical location.
	 *
	 * @param physicalLocation the new physical location
	 */
	public void setPhysicalLocation(String physicalLocation)
	{
		this.physicalLocation = physicalLocation;
	}
	
	/**
	 * Gets the ward location.
	 *
	 * @return the ward location
	 */
	public KeyValuePair<String, String> getWardLocation()
	{
		return wardLocation;
	}
	
	/**
	 * Sets the ward location.
	 *
	 * @param wardLocation the ward location
	 */
	public void setWardLocation(KeyValuePair<String, String> wardLocation)
	{
		this.wardLocation = wardLocation;
	}
	
	/**
	 * Gets the principal clinic.
	 *
	 * @return the principal clinic
	 */
	public KeyValuePair<String, String> getPrincipalClinic()
	{
		return principalClinic;
	}
	
	/**
	 * Sets the principal clinic.
	 *
	 * @param principalClinic the principal clinic
	 */
	public void setPrincipalClinic(KeyValuePair<String, String> principalClinic)
	{
		this.principalClinic = principalClinic;
	}
	
	/**
	 * Gets the building.
	 *
	 * @return the building
	 */
	public String getBuilding()
	{
		return building;
	}
	
	/**
	 * Sets the building.
	 *
	 * @param building the new building
	 */
	public void setBuilding(String building)
	{
		this.building = building;
	}
	
	/**
	 * Gets the floor.
	 *
	 * @return the floor
	 */
	public String getFloor()
	{
		return floor;
	}
	
	/**
	 * Sets the floor.
	 *
	 * @param floor the new floor
	 */
	public void setFloor(String floor)
	{
		this.floor = floor;
	}
	
	/**
	 * Gets the room.
	 *
	 * @return the room
	 */
	public String getRoom()
	{
		return room;
	}
	
	/**
	 * Sets the room.
	 *
	 * @param room the new room
	 */
	public void setRoom(String room)
	{
		this.room = room;
	}
	
	/**
	 * Gets the bed.
	 *
	 * @return the bed
	 */
	public String getBed()
	{
		return bed;
	}
	
	/**
	 * Sets the bed.
	 *
	 * @param bed the new bed
	 */
	public void setBed(String bed)
	{
		this.bed = bed;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the phone.
	 *
	 * @return the phone
	 */
	public String getPhone()
	{
		return phone;
	}
	
	/**
	 * Sets the phone.
	 *
	 * @param phone the new phone
	 */
	public void setPhone(String phone)
	{
		this.phone = phone;
	}
	
	/**
	 * Gets the appointment timestamp.
	 *
	 * @return the appointment timestamp
	 */
	public String getAppointmentTimestamp()
	{
		return appointmentTimestamp;
	}
	
	/**
	 * Sets the appointment timestamp.
	 *
	 * @param appointmentTimestamp the new appointment timestamp
	 */
	public void setAppointmentTimestamp(String appointmentTimestamp)
	{
		this.appointmentTimestamp = appointmentTimestamp;
	}

	public SiteId getFacility() {
		return facility;
	}

	public void setFacility(SiteId facility) {
		this.facility = facility;
	}
}
