
package gov.va.med.via.databeans;

import java.util.Calendar;

/**
 * This class represents the inmmunization data within Vista.
 */
public class Immunization extends BaseDataBean
{
  /**
   * Internal Id of the immunization.
   */
  private String Id;
  /**
   * Date/Time of the immunzation.
   */
  private Calendar dateTime;
  /**
   * Name of the Immunization.
   */
  private String name;
  /**
   * Reaction to the immunization if any.
   */
  private String reaction;
  /**
   * the provider who was responsible for this immunization encounter.
   */
  private String encounterProvider;
  /**
   * Provider ordering the immunization.
   */
  private String orderingProvider;
  /**
   * The sequence if the immunizations is part of a series.
   */
  private String series;

  public Immunization()
  {
  }

 
  /**
   * Internal Id of the immunization.
   */
  public String getId()
  {
    return Id;
  }

  public void setId(String newId)
  {
    Id = newId;
  }

  /**
   * Date/Time of Immunization.
   */
  public Calendar getDateTime()
  {
    return dateTime;
  }


  public void setDateTime(Calendar newDateTime)
  {
      dateTime = newDateTime;
  }

  /**
   * Name of the immunization.
   */
  public String getName()
  {
    return name;
  }

  public void setName(String newName)
  {
    name = newName;
  }

  /**
   * reaction associated with the immunization.
   */
  public String getReaction()
  {
    return reaction;
  }

  public void setReaction(String newReaction)
  {
    reaction = newReaction;
  }

  /**
   * Provider associated with this immunization encounter.
   */
  public String getEncounterProvider()
  {
    return encounterProvider;
  }

  public void setEncounterProvider(String newEncounterProvider)
  {
    encounterProvider = newEncounterProvider;
  }

  /**
   * Provider who ordered the immunization.
   */
  public String getOrderingProvider()
  {
    return orderingProvider;
  }

  public void setOrderingProvider(String newOrderingProvider)
  {
    orderingProvider = newOrderingProvider;
  }

  /**
   * Sequence of series of this immunization is part of a series.
   */
  public String getSeries()
  {
    return series;
  }

  public void setSeries(String newSeries)
  {
    series = newSeries;
  }
}