
package gov.va.med.via.databeans;
import java.util.Calendar;

/**
 * This class support CH subscript lab results.
 */
public class LabResult extends BaseDataBean
{
	
	 
  /**
   * Internal Id of the test. Used to retieve all results for a particuler test over
   * time.
   */
  private String TestId;
  /**
   * Result value.
   */
  private String result;
  /**
   * accession number associated with the result.
   */
  private String accession;
  /**
   * Order Id associated with the result.
   */
  private String orderId;
  /**
   * Name of test associated with result.
   */
  private String testName;
  /**
   * Print name of the test.  This is usually a shorter name than the test name.
   */
  private String printName;
  /**
   * User initials who verified the result.
   */
  private String verifiedBy;
  /**
   * Flag indicating if the result is high or low.
   * Values: L =low L* = critical low, H = high, H* = critical high
   */
  private String hiLoFlag;
  /**
   * reference range for the test.
   */
  private String referenceRange;
  /**
   * status of result.
   */
  private String resultStatus;
  /**
   * Units associated with the result.
   */
  private String units;
  /**
   * Comment associated with the result.
   */
  private String comment;
  /**
   * Date the test was resulted.
   */
  private Calendar resultDate;
  /**
   * Specimen associated with the result.
   */
  private String specimen;
  
  private String specimenType;
  
  private LabTest labTest;
  
  private String value;
  
  private String boundaryStatus;
  
  private String labSiteId;
  

  private Calendar orderDate;
  

  public LabResult()
  {
  }

  /**
   * Internal Id of test.  Used to retrieve results for a test over time.
   */
  public String getTestId()
  {
    return TestId;
  }

  public void setTestId(String newTestId)
  {
    TestId = newTestId;
  }

  /**
   * Value of result.
   */
  public String getResult()
  {
    return result;
  }

  public void setResult(String newResult)
  {
    result = newResult;
  }

  /**
   * Accession number for lab result.
   */
  public String getAccession()
  {
    return accession;
  }

  public void setAccession(String newAccession)
  {
    accession = newAccession;
  }

  /**
   * Order Id of result.
   */
  public String getOrderId()
  {
    return orderId;
  }

  public void setOrderId(String newOrderId)
  {
    orderId = newOrderId;
  }

  /**
   * Test name for result.
   */
  public String getTestName()
  {
    return testName;
  }

  public void setTestName(String newTestName)
  {
    testName = newTestName;
  }

  /**
   * Print name of the test.  Print name is usually a short version of the test name. 
   */
  public String getPrintName()
  {
    return printName;
  }

  public void setPrintName(String newPrintName)
  {
    printName = newPrintName;
  }

  /**
   * User initials who verified the result.
   */
  public String getVerifiedBy()
  {
    return verifiedBy;
  }

  public void setVerifiedBy(String newVerifiedBy)
  {
    verifiedBy = newVerifiedBy;
  }

  /**
   * Flag indicatinf whether result is out of range. 
   * L=low, L*=critical low, H=High, H*=critical High
   */
  public String getHiLoFlag()
  {
    return hiLoFlag;
  }

  public void setHiLoFlag(String newHiLoFlag)
  {
    hiLoFlag = newHiLoFlag;
  }

  /**
   * Reference range for result.
   */
  public String getReferenceRange()
  {
    return referenceRange;
  }

  public void setReferenceRange(String newReferenceRange)
  {
    referenceRange = newReferenceRange;
  }

  /**
   * Status of result.
   */
  public String getResultStatus()
  {
    return resultStatus;
  }

  public void setResultStatus(String newResultStatus)
  {
    resultStatus = newResultStatus;
  }

  /**
   * Units for result.
   */
  public String getUnits()
  {
    return units;
  }

  public void setUnits(String newUnits)
  {
    units = newUnits;
  }

  /**
   * Comment associated with result.
   */
  public String getComment()
  {
    return comment;
  }

  public void setComment(String newComment)
  {
    comment = newComment;
  }

  /**
   * Calendar test was resulted.
   */
  public Calendar getResultDate()
  {
    return resultDate;
  }

  public void setResultDate(Calendar newResultDate)
  {
    resultDate = newResultDate;
  }

  /**
   * Specimen for the result.
   */
  public String getSpecimen()
  {
    return specimen;
  }

  public void setSpecimen(String newSpecimen)
  {
    specimen = newSpecimen;
  }

    public Calendar getOrderDate()
    {
        return orderDate;
    }

    public void setOrderDate(Calendar orderDate)
    {
        this.orderDate = orderDate;
    }

	public String getSpecimenType() {
		return specimenType;
	}

	public void setSpecimenType(String specimenType) {
		this.specimenType = specimenType;
	}

	public LabTest getLabTest() {
		return labTest;
	}

	public void setLabTest(LabTest labTest) {
		this.labTest = labTest;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public String getBoundaryStatus() {
		return boundaryStatus;
	}

	public void setBoundaryStatus(String boundaryStatus) {
		this.boundaryStatus = boundaryStatus;
	}

	public String getLabSiteId() {
		return labSiteId;
	}

	public void setLabSiteId(String labSiteId) {
		this.labSiteId = labSiteId;
	}
  

}