
package gov.va.med.via.databeans;


public class Medication extends BaseDataBean 
{
   /**
   * Date the outpatient prescription was last filled.
   * Date the inpatient medication was ordered.
   */
  //private Calendar fillOrderDate;
	
	private String id;
	
	private String startDate;
	
	
	private String fillOrderDate;
  /**
   * The stop date of an inpatient medication.
   */

	private String stopDate;



  /**
   * Name of drug ordered.
   */
  private String drugName;
  /**
   * Number of refills for a prescription.
   */
  private String refills;
  /**
   * Sig code of a prescription, Administration instruction of an inpatient medication.
   */
  private String sigCode;
  /**
   * Ordering provider of the medication/prescription.
   */
  private String orderingProvider;
  /**
   * Quantity ordered for an outpatient prescription or inpatient medication.
   */
  private String quantity;
  /**
   * Days supply of the outpatient prescription.
   */
  private String daysSupply;

  /**
   * Pharmacy name where the outpatient prescription was last dispensed.
   */
  private String lastDispensingPharmacy;
  /**
   * Internal ID of the medication.  Used to retrieve the detial of a medications/ prescription.
   * 
   */
  private String medId;
  /**
   * Flag to indicate if the prescription/medication is active. 1=active, 0=inactive
   */
  private String active;
  /**
   * Provider comments associated with the medication/prescription.
   */
  private String comment;
 
  /**
   * The type of medication (I = Inpatient, O = Outpatient)
   */
  private String medType;
  private String RXNumber;

  private String pharmacyId;

  private PrescriptionFill[] prescriptionFills;

  /** The status. */
  protected String status;
  
  /** The dose. */
  protected String dose;
    
  /** The order id. */
  protected String orderId;
  
  /** The total dose. */
  protected String totalDose;
  
  /** The unit dose. */
  protected String unitDose;
  
  protected String infRate;
  
  protected String name;
  
  protected Facility facility;
  
  protected String sig;
  
  /** The is outpatient. */
  Boolean isOutpatient;
  
  /** The is inpatient. */
  protected Boolean isInpatient;
  
  /** The is iv. */
  protected Boolean isIV;
  
  /** The is unit dose. */
  protected Boolean isUnitDose;
  
  /** The is non va. */
  protected Boolean isNonVA;
  
  /** The is imo. */
  protected Boolean isImo;
  
  private String type;
  
  private String dateDocumented;
  
  private Author documentor;
  
  private String lastFillDate;
  
  private String detail;
  
  private String route;
  
  public Medication()
  {
  }
  
  /**
   * Date the prescription was last filled. 
   * Date the medication was ordered.
   */
  public String getFillOrderDate()
  {
    return fillOrderDate;
  }

  public void setFillOrderDate(String newLastFillDate)
  {
    fillOrderDate = newLastFillDate;
  }

  /**
   * Name of drug.
   */
  public String getDrugName()
  {
    return drugName;
  }

  public void setDrugName(String newDrugName)
  {
    drugName = newDrugName;
  }

  /**
   * Number of refills for an Outpatient prescription.
   */
  public String getRefills()
  {
    return refills;
  }

  public void setRefills(String newRefills)
  {
    refills = newRefills;
  }

  /**
   * Sig code of the prescription.
   * Administration instructions/Schedule of inpatient medication.
   */
  public String getSigCode()
  {
    return sigCode;
  }

  public void setSigCode(String newSigCode)
  {
    sigCode = newSigCode;
  }

  /**
   * Provider ordering the medicaiton/prescription.
   */
  public String getOrderingProvider()
  {
    return orderingProvider;
  }

  public void setOrderingProvider(String newOrderingProvider)
  {
    orderingProvider = newOrderingProvider;
  }

  /**
   * Quantity of the medication/prescription.
   */
  public String getQuantity()
  {
    return quantity;
  }

  public void setQuantity(String newQuantity)
  {
    quantity = newQuantity;
  }

  /**
   * Days supply of prescription.
   */
  public String getDaysSupply()
  {
    return daysSupply;
  }

  public void setDaysSupply(String newDaysSupply)
  {
    daysSupply = newDaysSupply;
  }

  
  public String getStopDate()
  {
      return stopDate;
  }

public void setStopDate(String stopDate)
{
    this.stopDate = stopDate;
}
 
  /**
   * Name of pharmacy that last dispensed the outpatient prescription.
   */
  public String getLastDispensingPharmacy()
  {
    return lastDispensingPharmacy;
  }

  public void setLastDispensingPharmacy(String newLastDispensingPharmacy)
  {
    lastDispensingPharmacy = newLastDispensingPharmacy;
  }

  /**
   * Internal ID of medication/prescription.  Used to retrieve the details of the 
   * medication/prescription.
   */
  public String getMedId()
  {
    return medId;
  }

  public void setMedId(String newRxId)
  {
    medId = newRxId;
  }

  /**
   * Active =1 , Inactive = 0
   */
  public String getActive()
  {
    return active;
  }

  public void setActive(String newRxActive)
  {
    active = newRxActive;
  }

  /**
   * Provider comments associated with the medication/prescription.
   */
  public String getComment()
  {
    return comment;
  }

  public void setComment(String newComment)
  {
    comment = newComment;
  }
  /**
   * I = Inpatient Medication, O = Outpatient Prescription
   */
  public String getMedType()
  {
    return medType;
  }

  /**
   * I = Inpatient Medication, O = Oupatient Prescription
   */
  public void setMedType(String newMedType)
  {
    medType = newMedType;
  } 

  public String getRXNumber()
  {
    return RXNumber;
  }

  public void setRXNumber(String newRXNumber)
  {
    RXNumber = newRXNumber;
  }

    public String getPharmacyId() {
        return pharmacyId;
    }

    public void setPharmacyId(String pharmacyId) {
        this.pharmacyId = pharmacyId;
    }

    public PrescriptionFill[] getPrescriptionFills() {
        return prescriptionFills;
    }

    public void setPrescriptionFills(PrescriptionFill[] prescriptionFills) {
        this.prescriptionFills = prescriptionFills;
    }

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getDose() {
		return dose;
	}

	public void setDose(String dose) {
		this.dose = dose;
	}

	public String getOrderId() {
		return orderId;
	}

	public void setOrderId(String orderId) {
		this.orderId = orderId;
	}

	public String getTotalDose() {
		return totalDose;
	}

	public void setTotalDose(String totalDose) {
		this.totalDose = totalDose;
	}

	public String getUnitDose() {
		return unitDose;
	}

	public void setUnitDose(String unitDose) {
		this.unitDose = unitDose;
	}

	public String getInfRate() {
		return infRate;
	}

	public void setInfRate(String infRate) {
		this.infRate = infRate;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Facility getFacility() {
		return facility;
	}

	public void setFacility(Facility facility) {
		this.facility = facility;
	}

	public String getSig() {
		return sig;
	}

	public void setSig(String sig) {
		this.sig = sig;
	}

	public Boolean getIsOutpatient() {
		return isOutpatient;
	}

	public void setIsOutpatient(Boolean isOutpatient) {
		this.isOutpatient = isOutpatient;
	}

	public Boolean getIsInpatient() {
		return isInpatient;
	}

	public void setIsInpatient(Boolean isInpatient) {
		this.isInpatient = isInpatient;
	}

	public Boolean getIsIV() {
		return isIV;
	}

	public void setIsIV(Boolean isIV) {
		this.isIV = isIV;
	}

	public Boolean getIsUnitDose() {
		return isUnitDose;
	}

	public void setIsUnitDose(Boolean isUnitDose) {
		this.isUnitDose = isUnitDose;
	}

	public Boolean getIsNonVA() {
		return isNonVA;
	}

	public void setIsNonVA(Boolean isNonVA) {
		this.isNonVA = isNonVA;
	}

	public Boolean getIsImo() {
		return isImo;
	}

	public void setIsImo(Boolean isImo) {
		this.isImo = isImo;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getStartDate() {
		return startDate;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public String getDateDocumented() {
		return dateDocumented;
	}

	public void setDateDocumented(String dateDocumented) {
		this.dateDocumented = dateDocumented;
	}

	public Author getDocumentor() {
		return documentor;
	}

	public void setDocumentor(Author documentor) {
		this.documentor = documentor;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getLastFillDate() {
		return lastFillDate;
	}

	public void setLastFillDate(String lastFillDate) {
		this.lastFillDate = lastFillDate;
	}

	public String getDetail() {
		return detail;
	}

	public void setDetail(String detail) {
		this.detail = detail;
	}

	public String getRoute() {
		return route;
	}

	public void setRoute(String route) {
		this.route = route;
	}  
	
	
	
}