
package gov.va.med.via.databeans;

import java.util.Calendar;
import java.util.Date;

/**
 * The Class Order.
 * 
 * @author DOMAINROMERJ
 */
public class Order extends BaseDataBean 
{	
	/** The id. */
	String id;
    
    /** The timestamp. */
    Calendar timestamp;
    
    /** The ordering service name. */
    String orderingServiceName;
    
    /** The treating specialty. */
    String treatingSpecialty;
    
    /** The start date. */
    Calendar startDate;
    
    /** The stop date. */
    Calendar stopDate;
    
    /** The status. */
    String status;
    
    /** The sig status. */
    String sigStatus;
    
    /** The date signed. */
    Calendar dateSigned;
    
    /** The verifying nurse. */
    String verifyingNurse;
    
    /** The date verified. */
    Calendar dateVerified;
    
    /** The verifying clerk. */
    String verifyingClerk;
    
    /** The chart reviewer. */
    String chartReviewer;
    
    /** The date reviewed. */
    Calendar dateReviewed;
    
    /** The provider. */
    Provider provider;
    
    /** The text. */
    String text;
    
    /** The detail. */
    String detail;
    
    /** The err msg. */
    String errMsg;
    
    /** The flag. */
    Boolean flag;
    
    /** The type. */
    OrderType type;
    
    /** The patient id. */
    String patientId;
    
    /** The who entered id. */
    String whoEnteredId;
    
    /** The patient location id. */
    String patientLocationId;
    
    /** The location. */
    HospitalLocation location;
    
    /** The urgency. */
    String urgency;
    
    /** The collection sample. */
    CollectionSample collectionSample;
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public Calendar getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(Calendar timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the ordering service name.
	 *
	 * @return the ordering service name
	 */
	public String getOrderingServiceName()
	{
		return orderingServiceName;
	}
	
	/**
	 * Sets the ordering service name.
	 *
	 * @param orderingServiceName the new ordering service name
	 */
	public void setOrderingServiceName(String orderingServiceName)
	{
		this.orderingServiceName = orderingServiceName;
	}
	
	/**
	 * Gets the treating specialty.
	 *
	 * @return the treating specialty
	 */
	public String getTreatingSpecialty()
	{
		return treatingSpecialty;
	}
	
	/**
	 * Sets the treating specialty.
	 *
	 * @param treatingSpecialty the new treating specialty
	 */
	public void setTreatingSpecialty(String treatingSpecialty)
	{
		this.treatingSpecialty = treatingSpecialty;
	}
	
	/**
	 * Gets the start date.
	 *
	 * @return the start date
	 */
	public Calendar getStartDate()
	{
		return startDate;
	}
	
	/**
	 * Sets the start date.
	 *
	 * @param startDate the new start date
	 */
	public void setStartDate(Calendar startDate)
	{
		this.startDate = startDate;
	}
	
	/**
	 * Gets the stop date.
	 *
	 * @return the stop date
	 */
	public Calendar getStopDate()
	{
		return stopDate;
	}
	
	/**
	 * Sets the stop date.
	 *
	 * @param stopDate the new stop date
	 */
	public void setStopDate(Calendar stopDate)
	{
		this.stopDate = stopDate;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the sig status.
	 *
	 * @return the sig status
	 */
	public String getSigStatus()
	{
		return sigStatus;
	}
	
	/**
	 * Sets the sig status.
	 *
	 * @param sigStatus the new sig status
	 */
	public void setSigStatus(String sigStatus)
	{
		this.sigStatus = sigStatus;
	}
	
	/**
	 * Gets the date signed.
	 *
	 * @return the date signed
	 */
	public Calendar getDateSigned()
	{
		return dateSigned;
	}
	
	/**
	 * Sets the date signed.
	 *
	 * @param dateSigned the new date signed
	 */
	public void setDateSigned(Calendar dateSigned)
	{
		this.dateSigned = dateSigned;
	}
	
	/**
	 * Gets the verifying nurse.
	 *
	 * @return the verifying nurse
	 */
	public String getVerifyingNurse()
	{
		return verifyingNurse;
	}
	
	/**
	 * Sets the verifying nurse.
	 *
	 * @param verifyingNurse the new verifying nurse
	 */
	public void setVerifyingNurse(String verifyingNurse)
	{
		this.verifyingNurse = verifyingNurse;
	}
	
	/**
	 * Gets the date verified.
	 *
	 * @return the date verified
	 */
	public Calendar getDateVerified()
	{
		return dateVerified;
	}
	
	/**
	 * Sets the date verified.
	 *
	 * @param dateVerified the new date verified
	 */
	public void setDateVerified(Calendar dateVerified)
	{
		this.dateVerified = dateVerified;
	}
	
	/**
	 * Gets the verifying clerk.
	 *
	 * @return the verifying clerk
	 */
	public String getVerifyingClerk()
	{
		return verifyingClerk;
	}
	
	/**
	 * Sets the verifying clerk.
	 *
	 * @param verifyingClerk the new verifying clerk
	 */
	public void setVerifyingClerk(String verifyingClerk)
	{
		this.verifyingClerk = verifyingClerk;
	}
	
	/**
	 * Gets the chart reviewer.
	 *
	 * @return the chart reviewer
	 */
	public String getChartReviewer()
	{
		return chartReviewer;
	}
	
	/**
	 * Sets the chart reviewer.
	 *
	 * @param chartReviewer the new chart reviewer
	 */
	public void setChartReviewer(String chartReviewer)
	{
		this.chartReviewer = chartReviewer;
	}
	
	/**
	 * Gets the date reviewed.
	 *
	 * @return the date reviewed
	 */
	public Calendar getDateReviewed()
	{
		return dateReviewed;
	}
	
	/**
	 * Sets the date reviewed.
	 *
	 * @param dateReviewed the new date reviewed
	 */
	public void setDateReviewed(Calendar dateReviewed)
	{
		this.dateReviewed = dateReviewed;
	}
	
	/**
	 * Gets the provider.
	 *
	 * @return the provider
	 */
	public Provider getProvider()
	{
		return provider;
	}
	
	/**
	 * Sets the provider.
	 *
	 * @param provider the new provider
	 */
	public void setProvider(Provider provider)
	{
		this.provider = provider;
	}
	
	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}
	
	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}
	
	/**
	 * Gets the detail.
	 *
	 * @return the detail
	 */
	public String getDetail()
	{
		return detail;
	}
	
	/**
	 * Sets the detail.
	 *
	 * @param detail the new detail
	 */
	public void setDetail(String detail)
	{
		this.detail = detail;
	}
	
	/**
	 * Gets the err msg.
	 *
	 * @return the err msg
	 */
	public String getErrMsg()
	{
		return errMsg;
	}
	
	/**
	 * Sets the err msg.
	 *
	 * @param errMsg the new err msg
	 */
	public void setErrMsg(String errMsg)
	{
		this.errMsg = errMsg;
	}
	
	/**
	 * Gets the flag.
	 *
	 * @return the flag
	 */
	public Boolean getFlag()
	{
		return flag;
	}
	
	/**
	 * Sets the flag.
	 *
	 * @param flag the new flag
	 */
	public void setFlag(Boolean flag)
	{
		this.flag = flag;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public OrderType getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(OrderType type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the patient id.
	 *
	 * @return the patient id
	 */
	public String getPatientId()
	{
		return patientId;
	}
	
	/**
	 * Sets the patient id.
	 *
	 * @param patientId the new patient id
	 */
	public void setPatientId(String patientId)
	{
		this.patientId = patientId;
	}
	
	/**
	 * Gets the who entered id.
	 *
	 * @return the who entered id
	 */
	public String getWhoEnteredId()
	{
		return whoEnteredId;
	}
	
	/**
	 * Sets the who entered id.
	 *
	 * @param whoEnteredId the new who entered id
	 */
	public void setWhoEnteredId(String whoEnteredId)
	{
		this.whoEnteredId = whoEnteredId;
	}
	
	/**
	 * Gets the patient location id.
	 *
	 * @return the patient location id
	 */
	public String getPatientLocationId()
	{
		return patientLocationId;
	}
	
	/**
	 * Sets the patient location id.
	 *
	 * @param patientLocationId the new patient location id
	 */
	public void setPatientLocationId(String patientLocationId)
	{
		this.patientLocationId = patientLocationId;
	}
	
	/**
	 * Gets the location.
	 *
	 * @return the location
	 */
	public HospitalLocation getLocation()
	{
		return location;
	}
	
	/**
	 * Sets the location.
	 *
	 * @param location the new location
	 */
	public void setLocation(HospitalLocation location)
	{
		this.location = location;
	}
	
	/**
	 * Gets the urgency.
	 *
	 * @return the urgency
	 */
	public String getUrgency()
	{
		return urgency;
	}
	
	/**
	 * Sets the urgency.
	 *
	 * @param urgency the new urgency
	 */
	public void setUrgency(String urgency)
	{
		this.urgency = urgency;
	}
	
	/**
	 * Gets the collection sample.
	 *
	 * @return the collection sample
	 */
	public CollectionSample getCollectionSample()
	{
		return collectionSample;
	}
	
	/**
	 * Sets the collection sample.
	 *
	 * @param collectionSample the new collection sample
	 */
	public void setCollectionSample(CollectionSample collectionSample)
	{
		this.collectionSample = collectionSample;
	}
}