package gov.va.med.via.databeans;

import java.util.HashMap;

// TODO: Auto-generated Javadoc
/**
 * The Class OrderDialogColumn.
 */
public class OrderDialogColumn extends BaseDataBean
{
	
	/** The col num. */
	String colNum;
    
    /** The rows. */
    HashMap<String, OrderDialogRow> rows;
    
    public OrderDialogColumn()
    {    	
    }
    
    public OrderDialogColumn(String colNum)
    {    	
    	this.colNum = colNum;
    }
    
	/**
	 * Gets the col num.
	 *
	 * @return the col num
	 */
	public String getColNum()
	{
		return colNum;
	}
	
	/**
	 * Sets the col num.
	 *
	 * @param colNum the new col num
	 */
	public void setColNum(String colNum)
	{
		this.colNum = colNum;
	}
	
	/**
	 * Gets the rows.
	 *
	 * @return the rows
	 */
	public HashMap<String, OrderDialogRow> getRows()
	{
		return rows;
	}
	
	/**
	 * Sets the rows.
	 *
	 * @param rows the rows
	 */
	public void setRows(HashMap<String, OrderDialogRow> rows)
	{
		this.rows = rows;
	}
	
	/**
	 * Verify if the rowNum exists in the rows list
	 *
	 * @param rowNum the row num
	 * 
	 * @return true, if there is already a row with the same rowNum received in the rows list, false if not.
	 */
	public boolean rowExists(String rowNum)
	{
		if (rows == null)
		{
			return false;
		}
		
		return rows.containsKey(rowNum);
	}
	
	/**
	 * Adds the row.
	 *
	 * @param rowNum the row num
	 */
	public void addRow(String rowNum)
	{
		if (rows == null)
		{
			rows = new HashMap<String, OrderDialogRow>();
		}
		
		rows.put(rowNum, new OrderDialogRow(rowNum));
	}
	
	/**
	 * Gets the row.
	 *
	 * @param rowNum the row num
	 * @return the row
	 */
	public OrderDialogRow getRow(String rowNum)
	{
		return (OrderDialogRow)rows.get(rowNum);
	}
}
