package gov.va.med.via.databeans;

// TODO: Auto-generated Javadoc
/**
 * The Enum OrderStatus.
 */
public enum OrderStatus
{
	 
 	/** The discontinued. */
 	DISCONTINUED ("1","Discontinued","dc","dc"), 
     
     /** The complete. */
     COMPLETE ("2","Complete","comp","c"),
     
     /** The hold. */
     HOLD ("3","Hold","hold","h"),
     
     /** The flagged. */
     FLAGGED ("4","Flagged","flag","?"),
     
     /** The pending. */
     PENDING ("5", "Pending","pend","p"), 
     
     /** The active. */
     ACTIVE ("6","Active","actv","a"),
     
     /** The expired. */
     EXPIRED ("7", "Expired","exp","e"), 
     
     /** The scheduled. */
     SCHEDULED ("8","Scheduled","schd","s"), 
     
     /** The partial results. */
     PARTIAL_RESULTS ("9","Partial Results","part","pr"), 
     
     /** The delayed. */
     DELAYED ("10","Delayed","dlay","dly"),
     
     /** The unreleased. */
     UNRELEASED ("11","Unreleased","unr","u"),
     
     /** The discontinued edit. */
     DISCONTINUED_EDIT("12","Discontinued/Edit","dc/e","dce"),
     
     /** The cancelled. */
     CANCELLED ("13","Cancelled","canc","x"),
     
     /** The lapsed. */
     LAPSED ("14","Lapsed","laps","l"),
     
     /** The renewed. */
     RENEWED ("15", "Renewed","rnew","rn"), 
     
     /** The no status. */
     NO_STATUS ("99","No Status","none","'");
	 
	 /** The value. */
 	private final String value;
	 
 	/** The name. */
 	private final String name;
	 
 	/** The short name. */
 	private final String shortName;
	 
 	/** The code. */
 	private final String code;
	 
	 /**
 	 * Instantiates a new order status.
 	 *
 	 * @param value the value
 	 * @param name the name
 	 * @param shortName the short name
 	 * @param code the code
 	 */
 	OrderStatus(String value, String name, String shortName, String code)
	 {
		 this.value = value;
		 this.name = name;
		 this.shortName = shortName;
		 this.code = code;
	 }
 	
	/**
	 * Gets the by code.
	 *
	 * @param code the code
	 * @return the by code
	 */
 	public static String getNameByCode(String code)
	{
		for (OrderStatus status : values())
		{
			if (status.getCode().equals(code))
			{
				return status.getName();
			}
		}
		
		return null;
	}
 	
 	/**
	 * Gets the by code.
	 *
	 * @param code the code
	 * @return the by code
	 */
 	public static String getNameByValue(String value)
	{
		for (OrderStatus status : values())
		{
			if (status.getValue().equals(value))
			{
				return status.getName();
			}
		}
		
		return null;
	}
	 
	 /**
 	 * Gets the name.
 	 *
 	 * @return the name
 	 */
 	public String getName()
	 {
		 return name;
	 }

	/**
	 * Gets the value.
	 *
	 * @return the value
	 */
	public String getValue()
	{
		return value;
	}

	/**
	 * Gets the short name.
	 *
	 * @return the short name
	 */
	public String getShortName()
	{
		return shortName;
	}

	/**
	 * Gets the code.
	 *
	 * @return the code
	 */
	public String getCode()
	{
		return code;
	}	 
}
