/*
 * 
 */

package gov.va.med.via.databeans;

import gov.va.med.via.rpc.KeyValuePair;

import java.util.HashMap;
import java.util.List;

// TODO: Auto-generated Javadoc
/**
 * This is the generic patient object used for patient lookup. This class has a limited number of attributes.
 * 
 * @author DOMAINROMERJ
 */
public class Patient extends Person
{
    
    /** The inpatient. */
    public final int INPATIENT = 1;
    
    /** The outpatient. */
    public final int OUTPATIENT = 2;

    /** The mpi pid. */
    protected String mpiPid;
    
    /** The local pid. */
    protected String localPid;
    
   // StringDictionary sitePids;
    
    /** The vendor pid. */
    protected String vendorPid;
    
    /** The local site id. */
    protected String localSiteId;
    
    /** The mpi checksum. */
    protected String mpiChecksum;
    
    /** The locally assigned mpi pid. */
    protected  Boolean locallyAssignedMpiPid;
    
    /** The location. */
    protected HospitalLocation location;
    
    /** The cwad. */
    protected String cwad;
    
    /** The restricted. */
    protected Boolean restricted;
    
    /** The admit timestamp. */
    protected String admitTimestamp;
    
    /** The service connected. */
    protected Boolean serviceConnected;
    
    /** The sc percent. */
    protected Integer scPercent;
    
    /** The inpatient. */
    protected Boolean inpatient;
    
    /** The deceased date. */
    protected String deceasedDate;
    
    /** The confidentiality. */
    protected KeyValuePair<Integer, String> confidentiality;
    
    /** The needs means test. */
    protected Boolean needsMeansTest;
    
    /** The current means status. */
    protected String currentMeansStatus;
   
    /** The patient flags. */
    HashMap<String, String> patientFlags;
   
    /** The cmor site id. */
    protected String cmorSiteId;
    
    /** The active insurance. */
    protected String activeInsurance;
    
    /** The has insurance. */
    protected Boolean hasInsurance;
    
    /** The test patient. */
    protected Boolean testPatient;
    
    /** The preferred facility. */
    protected KeyValuePair<String, String> preferredFacility;
    
    /** The patient type. */
    protected String patientType;
    
    /** The SSN of the person */
    protected String ssn;
    
    /** The is veteran. */
    protected Boolean isVeteran;
    
    /** The team. */
    protected Team team;
    
    //TODO - NOTE, if IAM / MVI has us use getCorrespondingIds, then we will return a list of patient instances (that have the siteId, dfn, etc.) instead of vista locations, then we won't have to call for the dfn again to the remote site with the ICN - we will already have the localPid for remote sites
    protected List<SiteId> siteIDs;
    
    // TODO - SITE IDS AND VISTA LOCATION have the same IDs.
    
    /** The vista locations. */
    protected String[] vistaLocations; // TODO used instead of siteIDs.. not sure we would need something as complex
    
	/**
	 * Gets the mpi pid.
	 *
	 * @return the mpi pid
	 */
	public String getMpiPid()
	{
		return mpiPid;
	}
	
	/**
	 * Sets the mpi pid.
	 *
	 * @param mpiPid the new mpi pid
	 */
	public void setMpiPid(String mpiPid)
	{
		this.mpiPid = mpiPid;
	}
	
	/**
	 * Gets the local pid.
	 *
	 * @return the local pid
	 */
	public String getLocalPid()
	{
		return localPid;
	}
	
	/**
	 * Sets the local pid.
	 *
	 * @param localPid the new local pid
	 */
	public void setLocalPid(String localPid)
	{
		this.localPid = localPid;
	}
	
	/**
	 * Gets the vendor pid.
	 *
	 * @return the vendor pid
	 */
	public String getVendorPid()
	{
		return vendorPid;
	}
	
	/**
	 * Sets the vendor pid.
	 *
	 * @param vendorPid the new vendor pid
	 */
	public void setVendorPid(String vendorPid)
	{
		this.vendorPid = vendorPid;
	}
	
	/**
	 * Gets the local site id.
	 *
	 * @return the local site id
	 */
	public String getLocalSiteId()
	{
		return localSiteId;
	}
	
	/**
	 * Sets the local site id.
	 *
	 * @param localSiteId the new local site id
	 */
	public void setLocalSiteId(String localSiteId)
	{
		this.localSiteId = localSiteId;
	}
	
	/**
	 * Gets the mpi checksum.
	 *
	 * @return the mpi checksum
	 */
	public String getMpiChecksum()
	{
		return mpiChecksum;
	}
	
	/**
	 * Sets the mpi checksum.
	 *
	 * @param mpiChecksum the new mpi checksum
	 */
	public void setMpiChecksum(String mpiChecksum)
	{
		this.mpiChecksum = mpiChecksum;
	}
	
	/**
	 * Checks if is locally assigned mpi pid.
	 *
	 * @return true, if is locally assigned mpi pid
	 */
	public Boolean isLocallyAssignedMpiPid()
	{
		return locallyAssignedMpiPid;
	}
	
	/**
	 * Sets the locally assigned mpi pid.
	 *
	 * @param locallyAssignedMpiPid the new locally assigned mpi pid
	 */
	public void setLocallyAssignedMpiPid(Boolean locallyAssignedMpiPid)
	{
		this.locallyAssignedMpiPid = locallyAssignedMpiPid;
	}
	
	/**
	 * Gets the location.
	 *
	 * @return the location
	 */
	public HospitalLocation getLocation()
	{
		return location;
	}
	
	/**
	 * Sets the location.
	 *
	 * @param location the new location
	 */
	public void setLocation(HospitalLocation location)
	{
		this.location = location;
	}
	
	/**
	 * Gets the cwad.
	 *
	 * @return the cwad
	 */
	public String getCwad()
	{
		return cwad;
	}
	
	/**
	 * Sets the cwad.
	 *
	 * @param cwad the new cwad
	 */
	public void setCwad(String cwad)
	{
		this.cwad = cwad;
	}
	
	/**
	 * Checks if is restricted.
	 *
	 * @return true, if is restricted
	 */
	public Boolean isRestricted()
	{
		return restricted;
	}
	
	/**
	 * Sets the restricted.
	 *
	 * @param restricted the new restricted
	 */
	public void setRestricted(Boolean restricted)
	{
		this.restricted = restricted;
	}
	
	/**
	 * Gets the admit timestamp.
	 *
	 * @return the admit timestamp
	 */
	public String getAdmitTimestamp()
	{
		return admitTimestamp;
	}
	
	/**
	 * Sets the admit timestamp.
	 *
	 * @param admitTimestamp the new admit timestamp
	 */
	public void setAdmitTimestamp(String admitTimestamp)
	{
		this.admitTimestamp = admitTimestamp;
	}
	
	/**
	 * Checks if is service connected.
	 *
	 * @return true, if is service connected
	 */
	public Boolean isServiceConnected()
	{
		return serviceConnected;
	}
	
	/**
	 * Sets the service connected.
	 *
	 * @param serviceConnected the new service connected
	 */
	public void setServiceConnected(Boolean serviceConnected)
	{
		this.serviceConnected = serviceConnected;
	}
	
	/**
	 * Gets the sc percent.
	 *
	 * @return the sc percent
	 */
	public Integer getScPercent()
	{
		return scPercent;
	}
	
	/**
	 * Sets the sc percent.
	 *
	 * @param scPercent the new sc percent
	 */
	public void setScPercent(Integer scPercent)
	{
		this.scPercent = scPercent;
	}
	
	/**
	 * Checks if is inpatient.
	 *
	 * @return true, if is inpatient
	 */
	public Boolean isInpatient()
	{
		return inpatient;
	}
	
	/**
	 * Sets the inpatient.
	 *
	 * @param inpatient the new inpatient
	 */
	public void setInpatient(Boolean inpatient)
	{
		this.inpatient = inpatient;
	}
	
	/**
	 * Gets the deceased date.
	 *
	 * @return the deceased date
	 */
	public String getDeceasedDate()
	{
		return deceasedDate;
	}
	
	/**
	 * Sets the deceased date.
	 *
	 * @param deceasedDate the new deceased date
	 */
	public void setDeceasedDate(String deceasedDate)
	{
		this.deceasedDate = deceasedDate;
	}
		
	
	/**
	 * Checks if is needs means test.
	 *
	 * @return true, if is needs means test
	 */
	public Boolean isNeedsMeansTest()
	{
		return needsMeansTest;
	}
	
	/**
	 * Sets the needs means test.
	 *
	 * @param needsMeansTest the new needs means test
	 */
	public void setNeedsMeansTest(Boolean needsMeansTest)
	{
		this.needsMeansTest = needsMeansTest;
	}
	
	/**
	 * Gets the current means status.
	 *
	 * @return the current means status
	 */
	public String getCurrentMeansStatus()
	{
		return currentMeansStatus;
	}
	
	/**
	 * Sets the current means status.
	 *
	 * @param currentMeansStatus the new current means status
	 */
	public void setCurrentMeansStatus(String currentMeansStatus)
	{
		this.currentMeansStatus = currentMeansStatus;
	}
	
	
	/**
	 * Gets the patient flags.
	 *
	 * @return the patient flags
	 */
	public HashMap<String, String> getPatientFlags()
	{
		return patientFlags;
	}

	/**
	 * Sets the patient flags.
	 *
	 * @param patientFlags the patient flags
	 */
	public void setPatientFlags(HashMap<String, String> patientFlags)
	{
		this.patientFlags = patientFlags;
	}

	/**
	 * Gets the cmor site id.
	 *
	 * @return the cmor site id
	 */
	public String getCmorSiteId()
	{
		return cmorSiteId;
	}
	
	/**
	 * Sets the cmor site id.
	 *
	 * @param cmorSiteId the new cmor site id
	 */
	public void setCmorSiteId(String cmorSiteId)
	{
		this.cmorSiteId = cmorSiteId;
	}
	
	/**
	 * Gets the active insurance.
	 *
	 * @return the active insurance
	 */
	public String getActiveInsurance()
	{
		return activeInsurance;
	}
	
	/**
	 * Sets the active insurance.
	 *
	 * @param activeInsurance the new active insurance
	 */
	public void setActiveInsurance(String activeInsurance)
	{
		this.activeInsurance = activeInsurance;
	}
	
	/**
	 * Checks if is checks for insurance.
	 *
	 * @return true, if is checks for insurance
	 */
	public Boolean isHasInsurance()
	{
		return hasInsurance;
	}
	
	/**
	 * Sets the checks for insurance.
	 *
	 * @param hasInsurance the new checks for insurance
	 */
	public void setHasInsurance(Boolean hasInsurance)
	{
		this.hasInsurance = hasInsurance;
	}
	
	/**
	 * Checks if is test patient.
	 *
	 * @return true, if is test patient
	 */
	public Boolean isTestPatient()
	{
		return testPatient;
	}
	
	/**
	 * Sets the test patient.
	 *
	 * @param testPatient the new test patient
	 */
	public void setTestPatient(Boolean testPatient)
	{
		this.testPatient = testPatient;
	}
	
	
	/**
	 * Gets the confidentiality.
	 *
	 * @return the confidentiality
	 */
	public KeyValuePair<Integer, String> getConfidentiality()
	{
		return confidentiality;
	}

	/**
	 * Sets the confidentiality.
	 *
	 * @param confidentiality the confidentiality
	 */
	public void setConfidentiality(KeyValuePair<Integer, String> confidentiality)
	{
		this.confidentiality = confidentiality;
	}

	/**
	 * Gets the preferred facility.
	 *
	 * @return the preferred facility
	 */
	public KeyValuePair<String, String> getPreferredFacility()
	{
		return preferredFacility;
	}

	/**
	 * Sets the preferred facility.
	 *
	 * @param preferredFacility the preferred facility
	 */
	public void setPreferredFacility(KeyValuePair<String, String> preferredFacility)
	{
		this.preferredFacility = preferredFacility;
	}

	/**
	 * Gets the patient type.
	 *
	 * @return the patient type
	 */
	public String getPatientType()
	{
		return patientType;
	}
	
	/**
	 * Sets the patient type.
	 *
	 * @param patientType the new patient type
	 */
	public void setPatientType(String patientType)
	{
		this.patientType = patientType;
	}
	
	/**
	 * Checks if is veteran.
	 *
	 * @return true, if is veteran
	 */
	public Boolean isVeteran()
	{
		return isVeteran;
	}
	
	/**
	 * Sets the veteran.
	 *
	 * @param isVeteran the new veteran
	 */
	public void setVeteran(Boolean isVeteran)
	{
		this.isVeteran = isVeteran;
	}
	
	/**
	 * Gets the team.
	 *
	 * @return the team
	 */
	public Team getTeam()
	{
		return team;
	}
	
	/**
	 * Sets the team.
	 *
	 * @param team the new team
	 */
	public void setTeam(Team team)
	{
		this.team = team;
	}
	
	
	/**
	 * Gets the site i ds.
	 *
	 * @return the site i ds
	 */
	public List<SiteId> getSiteIDs()
	{
		return siteIDs;
	}

	public void setSiteIDs(List<SiteId> siteIDs)
	{
		this.siteIDs = siteIDs;
	}

	/**
	 * Gets the vista locations.
	 *
	 * @return the vista locations
	 */
	public String[] getVistaLocations()
	{
		return vistaLocations; // TODO - if empty, set and return from SiteId list if not empty.
	}
	
	/**
	 * Sets the vista locations.
	 *
	 * @param vistaLocations the new vista locations
	 */
	public void setVistaLocations(String[] vistaLocations)
	{
		this.vistaLocations = vistaLocations;
	}

	public String getSsn() {
		return ssn;
	}

	public void setSsn(String ssn) {
		this.ssn = ssn;
	}
}
