
package gov.va.med.via.databeans;

import java.util.Calendar;

/**
 * This class represents Appointments associated with a patient;
 */
public class PatientAppointments extends BaseDataBean
{
  /**
   * Date/time of appointment.
   */
  private Calendar apptDate;
  /**
   * Name of clinic associated with appointment.
   */
  private String clinic;
  /**
   * Status of appointment.
   */
  private String status;
  /**
   * Type of appointment.
   */
  private String apptType;
  /**
   * Name of provider associated with appointment. Not populated for vista appointments.
   */
  private String providerName;
  /**
   * Reason for appointment.
   */
  private String reason;
  /**
   * Internal id of clinic for this appointment.
   */
  private String clinicId;
  /**
   * Internal ID of provider associated with appointment.  Not populated for vista
   * appointments.
   */
  private String providerId;
  /**
   * Provider class of the provider associated with appointment.  Not populated for 
   * vista appointments.
   */
  private String providerClass;
  /**
   * Phone number of provider associated with appointment. Not populated for vista
   * appointments.
   */
  private String providerPhone;
  /**
   * pager number of provider associated with this appointment.  This property
   * is not populated for vista appointments.
   */
  private String providerPager;
  /**
   * internal id of appointment.  this is used to retieve notes, diagnoses and/or
   * procedures associated with an appointment/visit.
   */
  private String apptId;

  public PatientAppointments()
  {
  }

   
  /**
   * Date/Time of appointment.
   */
  public Calendar getApptDate()
  {
    return apptDate;
  }

  public void setApptDate(Calendar newApptDate)
  {
    apptDate = newApptDate;
  }

  /**
   * Clinic name for the appointment.
   */
  public String getClinic()
  {
    return clinic;
  }

  public void setClinic(String newClinic)
  {
    clinic = newClinic;
  }

  /**
   * Status of appointment.
   */
  public String getStatus()
  {
    return status;
  }

  public void setStatus(String newStatus)
  {
    status = newStatus;
  }

  /**
   * Type of Appointment.
   */
  public String getApptType()
  {
    return apptType;
  }

  public void setApptType(String newApptType)
  {
    apptType = newApptType;
  }

  /**
   * Name of Provider for the appointment. Not defined for vista data.
   */
  public String getProviderName()
  {
    return providerName;
  }

  public void setProviderName(String newProviderName)
  {
    providerName = newProviderName;
  }

  /**
   * Reason for appointment.
   */
  public String getReason()
  {
    return reason;
  }

  public void setReason(String newReason)
  {
    reason = newReason;
  }

  /**
   * Internal id of clinic.
   */
  public String getClinicId()
  {
    return clinicId;
  }

  public void setClinicId(String newClinicId)
  {
    clinicId = newClinicId;
  }

  /**
   * Internal ID of provider.  Not set for vista data.
   */
  public String getProviderId()
  {
    return providerId;
  }

  public void setProviderId(String newProviderId)
  {
    providerId = newProviderId;
  }

  /**
   * Provider Class of provider associated with appointment. Not set for vista data.
   */
  public String getProviderClass()
  {
    return providerClass;
  }

  public void setProviderClass(String newProviderClass)
  {
    providerClass = newProviderClass;
  }

  /**
   * Phone number for clinic if vista data, otherwise phone number of provider.
   */
  public String getProviderPhone()
  {
    return providerPhone;
  }

  public void setProviderPhone(String newProviderPhone)
  {
    providerPhone = newProviderPhone;
  }

  /**
   * Provider's pager number. Not defined for vista data.
   */
  public String getProviderPager()
  {
    return providerPager;
  }

  public void setProviderPager(String newProviderPager)
  {
    providerPager = newProviderPager;
  }

  /**
   * Internal Id of appointment.  Used to retrieve notes, procedures or diagnoses
   * associated with an appointment.
   */
  public String getApptId()
  {
    return apptId;
  }

  public void setApptId(String newApptId)
  {
    apptId = newApptId;
  }
}