
package gov.va.med.via.databeans;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * This class represents fill data associated with an outpatient prescription.
 */
public class PrescriptionFill extends BaseDataBean
{
  /**
   * Date the fill was dispensed.
   */
  private Calendar DispenseDate;
  /**
   * Name of pharmacy dispensing the fill
   */
  private String DispensingPharmacy;
  /**
   * Amount dispensed.
   */
  private String DispensingQuantity;

  public PrescriptionFill()
  {
  }

 

  /**
   * Calendar this fill was dispensed.
   */
  public Calendar getDispenseDate()
  {
    return DispenseDate;
  }

  public void setDispenseDate(String newDispenseDate)
  {
    Calendar d = null;
      
       try {  
              SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm");
              d = new java.util.GregorianCalendar();
              d.setTime(df.parse(newDispenseDate));
            } catch (Exception e) {};

            
    DispenseDate = d;
  }

  public void setDispenseDate(Calendar newDispenseDate)
  {
    DispenseDate = newDispenseDate;
  }

  /**
   * Name of pharmacy that dispensed this fill.
   */
  public String getDispensingPharmacy()
  {
    return DispensingPharmacy;
  }

  public void setDispensingPharmacy(String newDispensingPharmacy)
  {
    DispensingPharmacy = newDispensingPharmacy;
  }

  /**
   * Quantity dispensed for this fill.
   */
  public String getDispensingQuantity()
  {
    return DispensingQuantity;
  }

  public void setDispensingQuantity(String newDispensingQuantity)
  {
    DispensingQuantity = newDispensingQuantity;
  }
}