package gov.va.med.via.databeans;

import java.util.HashMap;


// TODO: Auto-generated Javadoc
/**
 * Class representing patient problems.
 */
public class Problem extends Observation
{
  /**
   * Internal ID of problem. Used to retrieve problem details.
   */
  private String Id;
  /**
   * ICD code of the problem.
   */
  private String icdCode;
  /**
   * Description of problem.
   */
  private String description;
  
  /** Acuity of problem (Acute or chronic). */
  private String acuity;
  /**
   * Date of  onset of the problem.
   */
  private String onsetDate;
  /**
   * Status of a problem.
   */
  private String status;
  /**
   * Date the problem was last modified.
   */ 
  private String lastModifiedDate;
   /**
   * Indicator as to whether this is service connected. (YES if service connected)
   */
  private String serviceConnected;
  
  /** The provider narrative. */
  private String providerNarrative;
  
  /** The org props. */
  private HashMap<String, String> orgProps;
  
  /** The exposures. */
  private String exposures;
  
  /** The note narratives. */
  private String noteNarratives;

  /**
   * Instantiates a new problem.
   */
  public Problem()
  {
 
  }

  /**
   * Interal Id of problem. Used to request problem details.
   *
   * @return the id
   */
  public String getId()
  {
    return Id;
  }

  /**
   * Sets the id.
   *
   * @param newId the new id
   */
  public void setId(String newId)
  {
    Id = newId;
  }

  /**
   * ICD code for problem.
   *
   * @return the icd code
   */
  public String getIcdCode()
  {
    return icdCode;
  }

  /**
   * Sets the icd code.
   *
   * @param newIcdCode the new icd code
   */
  public void setIcdCode(String newIcdCode)
  {
    icdCode = newIcdCode;
  }

  /**
   * Problem description text.
   *
   * @return the description
   */
  public String getDescription()
  {
    return description;
  }

  /**
   * Sets the description.
   *
   * @param newDescription the new description
   */
  public void setDescription(String newDescription)
  {
    description = newDescription;
  }

  /**
   * Acuity of problem (Acute or Chronic).
   *
   * @return the acuity
   */
  public String getAcuity()
  {
    return acuity;
  }

  /**
   * Sets the acuity.
   *
   * @param newAcuity the new acuity
   */
  public void setAcuity(String newAcuity)
  {
    acuity = newAcuity;
  }

  /**
   * Date of  onset for the problem.
   *
   * @return the onset date
   */
  public String getOnsetDate()
  {
    return onsetDate;
  }

  /**
   * Sets the onset date.
   *
   * @param newOnsetDate the new onset date
   */
  public void setOnsetDate(String newOnsetDate)
  {
    onsetDate = newOnsetDate;
  }

  /**
   * Status of problem (Active or Inactive).
   *
   * @return the status
   */
  public String getStatus()
  {
    return status;
  }

  /**
   * Sets the status.
   *
   * @param newStatus the new status
   */
  public void setStatus(String newStatus)
  {
    status = newStatus;
  }

  /**
   * Calendar problem last modified.
   *
   * @return the last modified date
   */
  public String getLastModifiedDate()
  {
    return lastModifiedDate;
  }

  /**
   * Sets the last modified date.
   *
   * @param newLastModifiedDate the new last modified date
   */
  public void setLastModifiedDate(String newLastModifiedDate)
  {
    lastModifiedDate = newLastModifiedDate;
  }

  /**
   * Indicates whether this problem is service connected. (YES= service connected).
   *
   * @return the service connected
   */
  public String getServiceConnected()
  {
    return serviceConnected;
  }

  /**
   * Indicates whether this problem is service connected. (YES = service connected)
   *
   * @param newServiceConnected the new service connected
   */
  public void setServiceConnected(String newServiceConnected)
  {
    serviceConnected = newServiceConnected;
  }

	/**
	 * Gets the provider narrative.
	 *
	 * @return the provider narrative
	 */
	public String getProviderNarrative()
	{
		return providerNarrative;
	}
	
	/**
	 * Sets the provider narrative.
	 *
	 * @param providerNarrative the new provider narrative
	 */
	public void setProviderNarrative(String providerNarrative)
	{
		this.providerNarrative = providerNarrative;
	}
	
	/**
	 * Gets the org props.
	 *
	 * @return the org props
	 */
	public HashMap<String, String> getOrgProps()
	{
		return orgProps;
	}
	
	/**
	 * Sets the org props.
	 *
	 * @param orgProps the org props
	 */
	public void setOrgProps(HashMap<String, String> orgProps)
	{
		this.orgProps = orgProps;
	}

	/**
	 * Gets the exposures.
	 *
	 * @return the exposures
	 */
	public String getExposures()
	{
		return exposures;
	}

	/**
	 * Sets the exposures.
	 *
	 * @param exposures the new exposures
	 */
	public void setExposures(String exposures)
	{
		this.exposures = exposures;
	}

	/**
	 * Gets the note narratives.
	 *
	 * @return the note narratives
	 */
	public String getNoteNarratives()
	{
		return noteNarratives;
	}

	/**
	 * Sets the note narratives.
	 *
	 * @param noteNarratives the new note narratives
	 */
	public void setNoteNarratives(String noteNarratives)
	{
		this.noteNarratives = noteNarratives;
	}
  
}