
 
package gov.va.med.via.databeans;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * This class represents the notes associated with a problem.
 */
public class ProblemNote extends BaseDataBean
{
  /**
   * Date the note was entered.
   */
  private Calendar noteDate;
  /**
   * Person who entered the note.
   */
  private String noteEnteredBy;
  /**
   * text of the note.
   */
  private String noteText;

  public ProblemNote()
  {
  }

  
  /**
   * Calendar note was entered.
   */
  public Calendar getNoteDate()
  {
    return noteDate;
  }

  public void setNoteDate(String newNoteDate)
  {
    Calendar d = null;
      
       try {  
              SimpleDateFormat df = new SimpleDateFormat("MMM dd, yyyy@HH:mm");        
              d = new java.util.GregorianCalendar();
              d.setTime(df.parse(newNoteDate));
            } catch (Exception e) {};
            
    noteDate = d;
  }

  public void setNoteDate(Calendar newNoteDate)
  {
    noteDate = newNoteDate;
  }

  /**
   * Person who entered the note.
   */
  public String getNoteEnteredBy()
  {
    return noteEnteredBy;
  }

  public void setNoteEnteredBy(String newNoteEnteredBy)
  {
    noteEnteredBy = newNoteEnteredBy;
  }

  /**
   * Text of the note.
   */
  public String getNoteText()
  {
    return noteText;
  }

  public void setNoteText(String newNoteText)
  {
    noteText = newNoteText;
  }
}