
package gov.va.med.via.databeans;

import java.util.Calendar;

/**
 * This class represents radiology exam data.
 */
public class RadiologyExam extends BaseDataBean
{
  /**
   * Date of  the exam.
   */
  private Calendar examDate;
  /**
   * radiology study requested/ordered.
   */
  private String study;
  /**
   * Status of the exam.
   */
  private String status;
  /**
   * Internal Id for exam.  Used to retrieve Radiology report data.
   */
  private String examId;
  /**
   * reason for the exam.
   */
  private String reasonForOrder;

  /**
   * Exam accession number.
   *
   */
  private String accessionNumber;

  public RadiologyExam()
  {
  }


  /**
   * Date of  the radiology exam.
   */
  public Calendar getExamDate()
  {
    return examDate;
  }

   public void setExamDate(Calendar newExamDate)
  {       
    examDate = newExamDate;
  }

  /**
   * Radiology study performed for the exam.
   */
  public String getStudy()
  {
    return study;
  }

  public void setStudy(String newStudy)
  {
    study = newStudy;
  }

  /**
   * Status of the radiology exam.
   */
  public String getStatus()
  {
    return status;
  }

  public void setStatus(String newStatus)
  {
    status = newStatus;
  }

  /**
   * Internal ID of radiology exam.  Used to retrieve Radiology Report data.
   */
  public String getExamId()
  {
    return examId;
  }

  public void setExamId(String newExamId)
  {
    examId = newExamId;
  }

  /**
   * Reason for the radiology order.
   */
  public String getReasonForOrder()
  {
    return reasonForOrder;
  }

  public void setReasonForOrder(String newReasonForOrder)
  {
    reasonForOrder = newReasonForOrder;
  }

    public String getAccessionNumber() {
        return accessionNumber;
    }

    public void setAccessionNumber(String accessionNumber) {
        this.accessionNumber = accessionNumber;
    }

  
}