package gov.va.med.via.databeans;

import gov.va.med.via.rpc.DateFormat;
import gov.va.med.via.rpc.RPCStringUtils;
	
// TODO: Auto-generated Javadoc
/**
 * This class respresents a Radiology reports and extends the RadiologyExam class.
 */
public class RadiologyReport extends TextReport 
{
		
	/** The exam. */
	private ImagingExam exam;
	
	/** The accession number. */
	private String accessionNumber;
	
	/** The status. */
	private String status;
	
	/** The cpt code. */
	private String cptCode;
	
	/** The clinical hx. */
	private String clinicalHx;
	
	/** The impression. */
	private String impression;

   /**
    * Instantiates a new radiology report.
    */
   public RadiologyReport()
   {
   }
	
	/**
	 * Gets the exam.
	 *
	 * @return the exam
	 */
	public ImagingExam getExam()
	{
		return exam;
	}
	
	/**
	 * Sets the exam.
	 *
	 * @param exam the new exam
	 */
	public void setExam(ImagingExam exam)
	{
		this.exam = exam;
	}
	
	/**
	 * Gets the accession number.
	 *
	 * @return the accession number
	 */
	public String getAccessionNumber()
	{
		return accessionNumber;
	}
	
	/**
	 * Sets the accession number.
	 *
	 * @param accessionNumber the new accession number
	 */
	public void setAccessionNumber(String accessionNumber)
	{
		this.accessionNumber = accessionNumber;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the cpt code.
	 *
	 * @return the cpt code
	 */
	public String getCptCode()
	{
		return cptCode;
	}
	
	/**
	 * Sets the cpt code.
	 *
	 * @param cptCode the new cpt code
	 */
	public void setCptCode(String cptCode)
	{
		this.cptCode = cptCode;
	}
	
	/**
	 * Gets the clinical hx.
	 *
	 * @return the clinical hx
	 */
	public String getClinicalHx()
	{
		return clinicalHx;
	}
	
	/**
	 * Sets the clinical hx.
	 *
	 * @param clinicalHx the new clinical hx
	 */
	public void setClinicalHx(String clinicalHx)
	{
		this.clinicalHx = clinicalHx;
	}
	
	/**
	 * Gets the impression.
	 *
	 * @return the impression
	 */
	public String getImpression()
	{
		return impression;
	}
	
	/**
	 * Sets the impression.
	 *
	 * @param impression the new impression
	 */
	public void setImpression(String impression)
	{
		this.impression = impression;
	}
	   	 
	public String getAccessionNumber(String vistaProcedureDateTime, String caseNumber, DateFormat dateFormat)
    {
        if(RPCStringUtils.isNullOrEmpty(caseNumber))
        {
            //throw new exceptions.MdoException(exceptions.MdoExceptionCode.ARGUMENT_NULL, "Need to supply the case number");
        }

        if (dateFormat == DateFormat.VISTA)
        {
            if (RPCStringUtils.isNullOrEmpty(vistaProcedureDateTime) || vistaProcedureDateTime.length() < 7)
            {
                //throw new exceptions.MdoException(exceptions.MdoExceptionCode.ARGUMENT_DATE_FORMAT, "Expected a Vista format timestamp (e.g. 3011225 or 3011225.120005)");
            }
            return RPCStringUtils.CSubstring(vistaProcedureDateTime, 3, 2) +
            		RPCStringUtils.CSubstring(vistaProcedureDateTime, 5, 2) + 
            		RPCStringUtils.CSubstring(vistaProcedureDateTime, 1, 2) + "-" + caseNumber;
        }
        if (dateFormat == DateFormat.ISO)
        {
            if (RPCStringUtils.isNullOrEmpty(vistaProcedureDateTime) || vistaProcedureDateTime.length() < 8)
            {
                //throw new exceptions.MdoException(exceptions.MdoExceptionCode.ARGUMENT_DATE_FORMAT, "Expected a ISO format timestamp (e.g. 20101225)");

            }
            return RPCStringUtils.CSubstring(vistaProcedureDateTime, 4, 2) + 
            	   RPCStringUtils.CSubstring(vistaProcedureDateTime, 6, 2) +
            	   RPCStringUtils.CSubstring(vistaProcedureDateTime, 2, 2) + "-" + caseNumber;
        }

        return null;
    }
}