package gov.va.med.via.databeans;

import java.util.ArrayList;
import java.util.List;

public class VitalSign extends Observation {
	
	
	private String value1;
	private String value2;
	private String units;
	private String qualifiers;
	
	
	public VitalSign(){
		super();
		init();
	}
	
	public String getValue1() {
		return value1;
	}
	public void setValue1(String value1) {
		this.value1 = value1;
	}
	public String getValue2() {
		return value2;
	}
	public void setValue2(String value2) {
		this.value2 = value2;
	}
	public String getUnits() {
		return units;
	}
	public void setUnits(String units) {
		this.units = units;
	}
	public String getQualifiers() {
		return qualifiers;
	}
	public void setQualifiers(String qualifiers) {
		this.qualifiers = qualifiers;
	}
	
	
	public static String VITAL_SIGN = "Vital Sign";
    public static String TEMPERATURE = "Temperature";
    public static String PULSE = "Pulse";
    public static String RESPIRATION = "Respiration";
    public static String BLOOD_PRESSURE = "Blood Pressure";
    public static String SYSTOLIC_BP = "Systolic Blood Pressure";
    public static String DIASTOLIC_BP = "Diastolic Blood Pressure";
    public static String HEIGHT = "Height";
    public static String WEIGHT = "Weight";
    public static String PAIN = "Pain";
    public static String PULSE_OXYMETRY = "Pulse Oxymetry";
    public static String CIRCUMFERENCE_GIRTH = "Circumference/Girth";
    public static String CENTRAL_VENOUS_PRESSURE = "Central Venous Pressure";
    public static String BODY_MASS_INDEX = "Body Mass Index";

    protected static List<String>validVitalSignTypes;
    
    static void init() {
    	validVitalSignTypes = new ArrayList<String>();
    	validVitalSignTypes.add(VITAL_SIGN);
    	validVitalSignTypes.add(TEMPERATURE);
    	validVitalSignTypes.add(PULSE);
    	validVitalSignTypes.add(RESPIRATION);
    	validVitalSignTypes.add(BLOOD_PRESSURE);
    	validVitalSignTypes.add(SYSTOLIC_BP);
    	validVitalSignTypes.add(DIASTOLIC_BP);
    	validVitalSignTypes.add(HEIGHT);
    	validVitalSignTypes.add(WEIGHT);
    	validVitalSignTypes.add(PAIN);
    	validVitalSignTypes.add(PULSE_OXYMETRY);
    	validVitalSignTypes.add(CIRCUMFERENCE_GIRTH);
    	validVitalSignTypes.add(CIRCUMFERENCE_GIRTH);
    	validVitalSignTypes.add(CENTRAL_VENOUS_PRESSURE);
    	validVitalSignTypes.add(BODY_MASS_INDEX);		
	}
    
    public static boolean isValidType(String type)
    {
       return validVitalSignTypes.contains(type) ? true : false;
    }
   
}
