package gov.va.med.via.databeans;

import gov.va.med.via.rpc.RPCStringUtils;

import java.util.HashMap;
import java.util.Map;

public class VitalSignSet extends BaseDataBean {
	
	
	public static int NSIGNS = 14;

    private String timestamp;
    private  SiteId facility;
    private String units;
    private String qualifiers;
    
    private Map<String, VitalSign> vitalSigns = new HashMap<String,VitalSign>();
    
    public VitalSignSet(){
    	super();
    }

	public String getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(String timestamp) {
		this.timestamp = timestamp;
	}

	public SiteId getFacility() {
		return facility;
	}

	public void setFacility(SiteId facility) {
		this.facility = facility;
	}

	public String getUnits() {
		return units;
	}

	public void setUnits(String units) {
		this.units = units;
	}

	public String getQualifiers() {
		return qualifiers;
	}

	public void setQualifiers(String qualifiers) {
		this.qualifiers = qualifiers;
	}
	
	
	public void addVitalSign(String type, VitalSign s)
    {
 
        if(VitalSign.isValidType(type) && !vitalSigns.containsKey(type)){
        	
        	vitalSigns.put(type, s);
       
	        if (type == VitalSign.BLOOD_PRESSURE)
	        {
	        	String[] parts = RPCStringUtils.split(s.getValue1(), RPCStringUtils.SLASH);
	            if (parts.length == 2)
	            {
	                VitalSign vs1 = new VitalSign();
	                vs1.setType(new ObservationType(null, VitalSign.VITAL_SIGN, VitalSign.SYSTOLIC_BP));
	                vs1.setTimestamp(s.getTimestamp());
	                vs1.setValue1(parts[0]);
	                vs1.setUnits(s.getUnits());
	                vs1.setQualifiers( s.getQualifiers());
	                vitalSigns.put(VitalSign.SYSTOLIC_BP, vs1);
	                
	                VitalSign vs2 = new VitalSign();
	                vs2.setType(new ObservationType(null, VitalSign.VITAL_SIGN, VitalSign.DIASTOLIC_BP));
	                vs2.setTimestamp(s.getTimestamp());
	                vs2.setValue1(parts[1]);
	                vs2.setUnits(s.getUnits());
	                vs2.setQualifiers(s.getQualifiers());
	                vitalSigns.put(VitalSign.DIASTOLIC_BP, vs2);
	            }
	        }
        }
    }
	
	public Map<String, VitalSign> getVitalSigns() {
		return vitalSigns;
	}
   

    public VitalSign getVitalSign(String type)
    {
        return vitalSigns.get(type);
    }

    public int count()
    {
       return vitalSigns.size();
    }

	public static int getNSIGNS() {
		return NSIGNS;
	}

	public static void setNSIGNS(int nSIGNS) {
		NSIGNS = nSIGNS;
	}

	

}
