
package gov.va.med.via.databeans;
import java.util.Calendar;

/**
 * Class representing a vital sign value.
 */
public class Vitals extends BaseDataBean
{

  /**
   * Internal id of the vital sign.  Used to retrieve vital sign results over time for
   * a particular vistal sign.
   */
  private String VitalsIEN;
  /**
   * Type of vital sign. (TEMP, BP, Pulse, RR, Pain)
   */
  private String VitalType;
  /**
   * Value of the vital sign.
   */
  private String Rate;
  /**
   * Date/time the vital sign was taken.
   */
  private Calendar DateTimeTaken;

  private String units;

  private String unitsCode;

  private String qualifiers;
  
  public Vitals()
  {
  }


  /**
   * Internal Id of vital sign type. Used to retrieve vital sign data of a particular
   * type over time.
   */
  public String getVitalsIEN()
  {
    return VitalsIEN;
  }

  public void setVitalsIEN(String NewVitalsIEN)
  {
    VitalsIEN = NewVitalsIEN;
  }

  /**
   * Type of vital sign. (T = Temperature, P = Pulse, BP = Blood Pressure, 
   * R=Respiratory Rate, PN = Pain)
   */
   public String getVitalType()
  {
    return VitalType;
  }

  public void setVitalType(String NewVitalType)
  {
    VitalType = NewVitalType;
  }

  /**
   * Value of vital sign.
   */
   public String getRate()
  {
    return Rate;
  }

  public void setRate(String NewRate)
  {
    Rate= NewRate;
  }

  /**
   * Date/Time vital sign was taken.
   */
    public Calendar getDateTimeTaken()
  {
    return DateTimeTaken;
  }

   public void setDateTimeTaken(Calendar NewDateTimeTaken)
  {
      DateTimeTaken = NewDateTimeTaken;
  }

    public String getUnits() {
        return units;
    }

    public void setUnits(String units) {
        this.units = units;
    }

    public String getQualifiers() {
        return qualifiers;
    }

    public void setQualifiers(String qualifiers) {
        this.qualifiers = qualifiers;
    }

    public String getUnitsCode() {
        return unitsCode;
    }

    public void setUnitsCode(String unitsCode) {
        this.unitsCode = unitsCode;
    }
}