package gov.va.med.via.databeans.snomed;

import java.util.ArrayList;
import java.util.List;

public class SnoMedConcept {
	
	String id;
    SnoMedDescription fsn;
    SnoMedDescription preferredTerm;
    List<SnoMedDescription> synonyms = new ArrayList<SnoMedDescription>();
    List<SnoMedAttribute> attributes = new ArrayList<SnoMedAttribute>();
	
    public String getId() {
		return id;
	}
    
	public void setId(String id) {
		this.id = id;
	}
	
	public SnoMedDescription getFsn() {
		return fsn;
	}
	
	public void setFsn(SnoMedDescription fsn) {
		this.fsn = fsn;
	}
	
	public SnoMedDescription getPreferredTerm() {
		return preferredTerm;
	}
	
	public void setPreferredTerm(SnoMedDescription preferredTerm) {
		this.preferredTerm = preferredTerm;
	}
	
	public List<SnoMedDescription> getSynonyms() {
		return synonyms;
	}
	
	public void setSynonyms(List<SnoMedDescription> synonyms) {
		this.synonyms = synonyms;
	}
	
	public void addSynonym(SnoMedDescription synonym) {
		this.synonyms.add(synonym);
	}
	
	public List<SnoMedAttribute> getAttributes() {
		return attributes;
	}
	
	public void setAttributes(List<SnoMedAttribute> attributes) {
		this.attributes = attributes;
	}
    
	public void addAttribute(SnoMedAttribute attribute) {
		this.attributes.add(attribute);
	}
    
	public boolean hasSynonyms()
	{
	    return this.synonyms.size()>0 ? true : false;
	}
	
	public boolean hasAttributes()
	{
	    return this.attributes.size()>0 ? true : false;
	}

    public String semanticTag()
    {
        if(this.preferredTerm == null || this.preferredTerm.getTerm() == null){
        	return "";
        }
    
    	String perfTerm = this.getPreferredTerm().getTerm();
        int i = perfTerm.indexOf('(');
        return perfTerm.substring(i);
    }
}
