
package gov.va.med.via.exception;


/**
 * @author ZZZZZZTALBOM
 * 
 * Defines error messages used by the exceptions thrown in VIA Core project.
 */
public enum ErrorCodeEnum
{
    // General
    COULD_NOT_CREATE_A_URL( "Could not create a URL. {0}. The reason is {1}. " ),

    CONFIDENTIALITY_SENSITIVE_RECORD_ACCESS_EXCEPTION("DG_SENSITIVE_RECORD_ACCESS RPC returned error"),
    // persistence
    VIA_OPERATION_FAILED( "{0} Error: {1}. Working with object: {2}." ),
    VIA_CONSTRAINT_VIOLATED( "VIA Integrity constraint violated: {0}" ),
    ROOT_CAUSE_MSG( "VIA Persistence Failure Message: {0}." ),
    METHOD_NOT_IMPLEMENTED( "{0} getPropertyValue method not implemented." ),
    
   
    //vistalink
    MISSING_DUZ_EXCEPTION("Missing DUZ:  User DUZ not set during login."),
    
    //audit
    VIA_AUDIT_LOG_ERROR("Error in auditing VHIM read request."),
    
    // transaction
    TRANSACTION_WORK_EXCEPTION("WorkExcpetion encountered in transaction manager processing"),
    
    //cprsLaunch
    MULTIPLE_USER_EXCEPTION("Found more than one User with the information provided."),
    MULTIPLE_PATIENT_EXCEPTION("Found more than one Patient with the information provided."),
    
    //notes
    NOTE_IEN_EXCEPTION("Note IEN does not exists."),
    NOTE_NOT_SAVED_EXCEPTION("Unsaved message: {0}"),
    NOTE_INVALID_SIGNATURE_PERMISSION_EXCEPTION("Invalid signature action: expected SIGNATURE, got: {0}"),
    NOTE_USER_NOT_AUTHORIZED_EXCEPTION("User not authorized to sign note: {0}"),
    NOTE_INVALID_SIGNATURE_EXCEPTION("Invalid signature."),
    NOTE_CANNOT_UNLOCK_CONSULT("Unable to unlock consult {0}"),
    NOTE_UNABLE_TO_CREATE_NOTE("Unable to create note: {0}" ),
    NOTE_UNABLE_TO_LOCK_NOTE("Unable to lock note: {0}"),
    NOTE_UNABLE_TO_LOCK_ORDER("Unable to lock order: {0}"),
    NOTE_ERROR_UPDATING_NOTE("Error updating note {0}: expected IEN, got {1}"),
    NOTE_UNABLE_TO_SET_NOTE_TEXT("Unable to set note text: {0}"),
    NOTE_INDEX_OUT_OF_BOUNDS("Note index out of bounds: {0}"),
    NOTE_UNABLE_TO_LINK_PRF_NOTE("Unable to link note {0} to PRF: invalid IEN ({1})"), 
    NOTE_UNABLE_TO_LINK_PRF_NOTE_REASON("Unable to link note {0} to PRF {1}. Reason: {2}"), 
    NOTE_UNABLE_TO_UNLOCK_NOTE("Unable to unlock note: {0}"), 
    NOTE_CANNOT_CREATE_SURGERY_NOTE("Cannot create new surgery note at this time"), 
    NOTE_ONE_PER_VISIT("There is already a {0} note for this visit.  \r\n" +
			"Only ONE record of this type per Visit is allowed...\r\n\r\n" +
			"You can addend the existing record."), 
	NOTE_MISSING_CONSULT_IEN("Missing consult IEN"), 
	NOTE_MISSING_PRF_IEN( "Missing PRF IEN"), 
	NOTE_MISSING_COSIGNER("Missing cosigner"), 
	
	//StayMovements
	MISSING_ADT_PATIENT("Missing patient in ADT (InpatientMove) databean for checkin id: {0} at site {1}.  Cannot select a validpatient."),
    
    
    
    // ******************************************************************
    WORK_EXCEPTION("Unexpected Exeption encountered in Work framework. "),
    
    WORK_EXCEPTION_WITH_CLIENT_MESSAGES("Unexpected Exeption encountered in Work framework processing site: {0}. "),
    
    READ_WORK_EXCEPTION_WITH_CLIENT_MESSAGES("Unexpected Exeption encountered in ReadWork processing site: {0}. "), 
    READ_WORK_EXCEPTION_WITH_CLIENT_MESSAGES_FOR_DUZEXCEPTION("MissingDUZException Exeption encountered in ReadWork processing site: {0}. "), 
    READ_WORK_EXCEPTION_WITH_CLIENT_MESSAGES_FOR_EXCEPTION("Unexpected Exception Exeption encountered in ReadWork processing site: {0}. Original Exception Message: {1}"), 
    //******************************************************************
    LOGIN_UNABLE_TO_DETERMINE_PROVIDER_DUZ("Unable to determine DUZ"), 
    LOGIN_UNABLE_TO_GET_USER_INFO("Unable to get user info"), 
    LOGIN_NO_USER_ID_FOR_SITE("No user ID for site"), 
    LOGIN_UNABLE_TO_GET_USER_SSN("Unable to get user SSN"),
    
    //Dao Processing Exception
    DAO_EXCEPTION_MISSING_ICN("The MpiPid / ICN is missing for the patient - unable to obtain remote data for site: {0}. "),
    DAO_EXCEPTION_UNFOUND_DFN("Unable to obtain remote data, could not retrieve a local DFN at site: {0} for the provided MpiPid/ICN: {1}."),
    DAO_EXCEPTION_MISSING_DFN("DFN has not been defined, cannot process RPC request."),
    DAO_EXCEPTION_MISSING_PATIENT("The Patient is NULL - exception thrown processing site: {0}"),
    DAO_EXCEPTION_UNFOUND_LRDFN("Unable to obtain the LRDFN (LR Pointer Reference) - cannot retrieve lab data for patient DFN: {0}"),
    // *****************************************************************
    //because this exception is never actually thrown, but only constructed in order to log an exception message - we need the name of the exception to log ...
    VALIDATION_EXCEPTION("gov.va.med.via.common.validator.ValidationException  Validation Exception validating web service paramaters: {0}")
     
        
    ;
    
    // ******************************************************************
    // ******************************************************************
    // ******************************************************************
    
    
    private String clientMessage = null;
   
    ErrorCodeEnum( String clientMessage )
    {
        this.clientMessage = clientMessage;
    }

	public String getClientMessage() {
		return clientMessage;
	}

	public void setClientMessage(String clientMessage) {
		this.clientMessage = clientMessage;
	}
}
