package gov.va.med.via.exception;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.MessageFormat;

public class ExceptionUtil {

	/*public static String buildErrorStackTraceString(Exception exception) {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw, true);
		exception.printStackTrace(pw);
		return sw.getBuffer().toString();
	}*/
	
	/**
	 * Builds a stacktrace into a printable string
	 * 
	 * @param throwable
	 * @return
	 */
	public static String buildErrorStackTraceString(Throwable throwable) {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw, true);
		throwable.printStackTrace(pw);
		return sw.getBuffer().toString();
	}
	
	 /**
     * Formats a client message to add dynamic values like siteId/siteCode,etc. to the message.
     *
     * @param userMessage Message with markers where dataArgs are to be inserted.
     * @param dataArgs Argument list to populate in the user message.
     * @return Properly formatted message.
     */
    public static String formatMessage( String userMessage, String[] dataArgs )
    {
        if ( dataArgs != null && dataArgs.length > 0 )
        {
            MessageFormat messageFormat = new MessageFormat( userMessage );
            userMessage = messageFormat.format( dataArgs );
        }
        return userMessage;
    }

}
