

package gov.va.med.via.exceptionframework;


import gov.va.med.via.exception.AbstractViaBaseException;
import gov.va.med.via.exception.ExceptionUtil;

import org.apache.commons.logging.Log;


/**
 *
 * Handle the creation of the error message and error id of the exception.
 * The sanitized versions will contain no identifiable health information - only enough info
 * to look up more detailed exception info.
 *
 */
public class ExceptionHandler
{
    //private static final int INIT_BUFFER_SIZE = 4500;

    //TBD
    
    public static void logException( Exception exception, LoggingSeverity loggingSeverity, Log logger, String category,
            String requestingApp, String errorMessage)
    {
    	logMessage( logger, loggingSeverity, LogMessageUtil.buildMessage(category, requestingApp, errorMessage, exception), exception );
    }
    
	public static void logException( Exception exception, LoggingSeverity loggingSeverity, Log logger, String category,
            String requestingApp)
    {
    	logException( exception, loggingSeverity, logger, category, requestingApp, exception.getMessage() );
    }
    
    public static void logException( Exception exception, LoggingSeverity loggingSeverity, Log logger)
    {
    	logException( exception,loggingSeverity, logger, null, null, exception.getMessage() );
    }
        
    private static void logMessage( Log logger, LoggingSeverity loggingSeverity, Object message, Exception exception )
    {
    	if(exception instanceof AbstractViaBaseException){
    		if(((AbstractViaBaseException)exception).isLogged())
    		{
    			return;
    		}
    	}
    	
        switch ( loggingSeverity )
        {
        case WARNING:
            logger.warn( message, exception);
            break;
        case ERROR:
            logger.error( message );
            break;
        case FATAL:
        default:
            logger.fatal( message );
        }
    }
}
