package gov.va.med.via.hl7.mpi;

import gov.va.med.via.util.StringUtil;

public class QakSegment {

	EncodingCharacters encChars = new EncodingCharacters();
	String qryTag = "";
	String qryResponseStatus = "";

	public QakSegment() 
	{
	}

	public QakSegment(String rawSegmentString) 
	{
		parse(rawSegmentString);
	}

	public void parse(String rawSegmentString)
	{
		String[] flds = StringUtil.split(rawSegmentString, getEncodingChars().getFieldSeparator());

		if (flds.length < 3)
		{
			throw new RuntimeException("Invalid QAK segment: less than 3 fields");
		}

		if (!"QAK".equals(flds[0]))
		{
			throw new RuntimeException("Invalid QAK segment: incorrect header");
		}

		setQueryTag( flds[1]);
		setQueryResponseStatus( flds[2].trim());
	}


	public EncodingCharacters getEncodingChars() {
		return encChars;
	}

	public void setEncodingChars(EncodingCharacters encChars) {
		this.encChars = encChars;
	}

	public String getQueryTag() {
		return qryTag;
	}

	public void setQueryTag(String qryTag) {
		this.qryTag = qryTag;
	}

	public String getQueryResponseStatus() {
		return qryResponseStatus;
	}

	public void setQueryResponseStatus(String qryResponseStatus) {
		this.qryResponseStatus = qryResponseStatus;
	}

}
