package gov.va.med.via.hl7.mpi;

import gov.va.med.via.util.StringUtil;

public class SelectionCriterion 
{
	
    EncodingCharacters encChars = new EncodingCharacters();
    String fieldName = "";
    String relationalOperator = "";
    String value = "";
    String relationalConjunction = "";
    
    public SelectionCriterion(String fieldName, String op, String val, String conj)
    {
        setFieldName( fieldName);
        setRelationalOperator( op);
        setValue( val);
        setRelationalConjunction(conj);
    }
    
    public String toComponent()
    {
        String result = getFieldName() +
            getEncodingChars().getComponentSeparator() + getRelationalOperator() +
            getEncodingChars().getComponentSeparator() + getValue();
        
        if (!StringUtil.isEmpty(getRelationalConjunction()))
        {
            result += getEncodingChars().getComponentSeparator() + getRelationalConjunction()
                + getEncodingChars().getRepetitionSeparator();
        }
        return result;
    }

    
	public EncodingCharacters getEncodingChars() {
		return encChars;
	}
	public void setEncodingChars(EncodingCharacters encChars) {
		this.encChars = encChars;
	}
	public String getFieldName() {
		return fieldName;
	}
	public void setFieldName(String fieldName) {
		this.fieldName = fieldName;
	}
	public String getRelationalOperator() {
		return relationalOperator;
	}
	public void setRelationalOperator(String relationalOperator) {
		this.relationalOperator = relationalOperator;
	}
	public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
	}
	public String getRelationalConjunction() {
		return relationalConjunction;
	}
	public void setRelationalConjunction(String relationalConjunction) {
		this.relationalConjunction = relationalConjunction;
	}


}
