package gov.va.med.via.hl7.mpi;

import java.util.ArrayList;

public class VtqSegment {

	private EncodingCharacters encChars = new EncodingCharacters();
	private String queryTag = "";
	private String formatCode = "";
	private String queryName = "";
	private String virtualTableName = "";
	private ArrayList<SelectionCriterion> selectionCriteria;


	public VtqSegment() {
	}

	public String toSegment()
	{
		String result = "VTQ" +
				getEncodingChars().getFieldSeparator() + getQueryTag() +
				getEncodingChars().getFieldSeparator() + getFormatCode() +
				getEncodingChars().getFieldSeparator() + getQueryName() +
				getEncodingChars().getFieldSeparator() + getVirtualTableName() +
				getEncodingChars().getFieldSeparator();
		for (int i = 0; i < getSelectionCriteria().size(); i++)
		{
			result += getSelectionCriteria().get(i).toComponent();
		}
		return result + '\r';
	}



	public EncodingCharacters getEncodingChars() {
		return encChars;
	}


	public void setEncodingChars(EncodingCharacters encChars) {
		this.encChars = encChars;
	}


	public String getQueryTag() {
		return queryTag;
	}


	public void setQueryTag(String queryTag) {
		this.queryTag = queryTag;
	}


	public String getFormatCode() {
		return formatCode;
	}


	public void setFormatCode(String formatCode) {
		this.formatCode = formatCode;
	}


	public String getQueryName() {
		return queryName;
	}


	public void setQueryName(String queryName) {
		this.queryName = queryName;
	}


	public String getVirtualTableName() {
		return virtualTableName;
	}


	public void setVirtualTableName(String virtualTableName) {
		this.virtualTableName = virtualTableName;
	}


	public ArrayList<SelectionCriterion> getSelectionCriteria() {
		return selectionCriteria;
	}


	public void setSelectionCriteria(ArrayList<SelectionCriterion> selectionCriteria) {
		this.selectionCriteria = selectionCriteria;
	}



}
