package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AppointmentsDao extends BaseDao {
	
	/*
	 * VistaUtils.CheckRpcParams(dfn);
	 * DdrLister query = new DdrLister(cxn);
	 * query.File = "2.98";
	 * 
	 * //Took out .01E because it blows up the query when it's a zombie pointer
	 * //We'll get the Hospital Location name conditionally with Id.
	 * //Leaving 9.5E in there since it points to APPOINTMENT TYPE which seems
	 * //like it should be stable.
	 * string sFlds = ".001;.01;3;5;6;7;9;9.5";
	 * query.Fields = sFlds;
	 *  query.Flags = "IP";
	 * query.Iens = "," + dfn + ",";
	 * query.Xref = "#";
	 * 
	 * (non-Javadoc)
	 * @see gov.va.med.via.dao.Dao#callRpc(java.lang.String, java.util.Map, gov.va.med.via.vistalink.ConnectionFactoryLocator)
	 */
	@Override
	public List<DataBean> callRpc(String currentSiteId,
			Map<String, Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) 
	{

			QueryBean queryBean = (QueryBean) requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY);
			String webMethodName =  (String) requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);
			VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
			String dfn = queryBean.getPatient().getLocalPid();
			
			String queryId = "S D0=DA(1),D1=DA,HL=$P(^(0),U,1) " +
		                "D CURRENT^SDAMU D EN^DDIOL(X) " +
		                "I $D(^SC(HL,0))'=0 D EN^DDIOL($P(^SC(HL,0),U,1)_U_$P(^SC(HL,0),U,15)) " + // see ticket #2848 - invalid global ^SC(81,0) at site 556
		                "I $D(^SC(HL,99))'=0 D EN^DDIOL(^SC(HL,99))";
			
			List<Object> params =new ArrayList<Object>();		
			HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
			hashMap.put("FILE",2.98);
			hashMap.put("FIELDS",".001;.01;3;5;6;7;9;9.5");
			hashMap.put("FLAGS","IP");
			hashMap.put("ID", queryId);
			hashMap.put("IENS",","+dfn+",");
			hashMap.put("XREF","#");
			params.add(hashMap);
	        String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
	        return parseResponseToDataBeans(result, queryBean, null, currentSiteId, webMethodName, vistaLinkCommand);
	        
	        
	  
	}
	
	@Override
	public String getDaoName() 
	{
		return DaoNameConstants.APPOINTMENTS_DAO;
	}

}
