package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.response.DataBeanParser;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;

import java.util.List;
import java.util.Map;

public interface Dao {
	
	//public final static String APP_PROXY_NAME="VIAB,APPLICATIONPROXYVIAB";
	public final static String APP_PROXY_NAME="VIABAPPLICATIONPROXY,VIAB";
	
	/**
	 * Executes an RPC call via VistaLink
	 * 
	 * @param currentSiteId
	 * @param requestParameterMap
	 * @param connectionFactoryLocator
	 * @return List<DataBean> - set of populated data beans parsed from the RPC response
	 */
	public List<DataBean> callRpc( String currentSiteId, Map<String, Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator);

	
	/**
	 * @return String value of the Dao's name
	 */
	public String getDaoName();

	/**
	 * 
	 * @return Map of DataBeanParsers stored against all web service method names
	 */
	public Map<String, DataBeanParser> getDataBeanParsers();

	/**
	 * Sets a Map of DataBeanParsers to be used to retrieve an parser type for a service method call
	 * 
	 * @param dataBeanParsers
	 */
	public void setDataBeanParsers(Map<String, DataBeanParser> dataBeanParsers);
	
}
