package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetDRGRecordsDao extends BaseDao 
{


	@Override
	public List<DataBean> callRpc(String currentSiteId,
			Map<String, Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) 
	{

			QueryBean queryBean = (QueryBean) requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY);
			String webMethodName =  (String) requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);
			
			VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
			
			/* MDWS code
			DdrLister query = buildGetDrgRecordsQuery();
			
			DdrLister query = new DdrLister(cxn);
            query.File = "80.2";
            query.Fields = "@";
            query.Flags = "P";
            query.Id = "D EN^DDIOL($G(^ICD($E($P(^(0),U,1),4,99),1,1,0)))";
            return query;
			*/

	        List<Object> params =new ArrayList<Object>();          
	        HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
	        hashMap.put("FILE",80.2);
	        hashMap.put("FIELDS","@");
	        hashMap.put("FLAGS","P");
	        hashMap.put("ID","D EN^DDIOL($G(^ICD($E($P(^(0),U,1),4,99),1,1,0)))");
	        params.add(hashMap);

	        String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
			
	        
	        
			/*
			internal Drg[] toDrg(string[] response)
        {
            if (response.Length == 0)
            {
                return null;
            }
            Drg[] result = new Drg[response.Length];
            for (int i = 0; i < response.Length; i++)
            {
                string[] flds = StringUtils.split(response[i], StringUtils.CARET);
                result[i] = new Drg(flds[0], flds[1]);
            }
            return result;
        }
			
			*/
			
	        return parseResponseToDataBeans(result, queryBean, null, currentSiteId, webMethodName, vistaLinkCommand);
	       
	}
	
	@Override
	public String getDaoName() 
	{
		return getClass().getSimpleName();
	}

}
