package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetInpatientDischargesDao extends BaseDao 
{

/**
 * 
 * 
  			performs the same SC LISTER RPC call as the following MDWS code<p>
			DdrLister query = buildGetDrgRecordsQuery();<br/>
			/// from buildBasicGetInpatientMovesQuery<br/>
			DdrLister query = new DdrLister(cxn);<br/>
            query.File = "405";<br/>
            query.Fields = ".01;.02;.03;.04;.06;.07;.09;.14;.17;.18;.19;.24;201;202;203;.1;.16;.11;.25";<br/>
            query.Flags = "IP";<br/>
            query.Id = "S DZ=$P(^(0),U,19) I DZ'=\"\",($D(^VA(200,DZ,0))#10)'=0 D EN^DDIOL($P($G(^VA(200,DZ,0)),U,1))";<br/>
            return query;<br/>
			
			/// from buildGetInpatientDischargesQuery(string dfn)<br/>
			DdrLister query = buildBasicGetInpatientMovesQuery();<br/>
            query.From = VistaUtils.adjustForNumericSearch(dfn);<br/>
            query.Part = dfn;<br/>
            query.Xref = "C";<br/>
            query.Screen = "I $P(^(0),U,2)=3";<br/>
			return query;<br/>

 * 
 * 
 */
	@Override
	public List<DataBean> callRpc(String currentSiteId,
			Map<String, Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) 
	{

			QueryBean queryBean = (QueryBean) requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY);
			String webMethodName =  (String) requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);
			VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
			String dfn = queryBean.getPatient().getLocalPid();
			List<Object> params =new ArrayList<Object>();		
			HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
			hashMap.put("FILE",405);
			hashMap.put("FIELDS",".01;.02;.03;.04;.06;.07;.09;.14;.17;.18;.19;.24;201;202;203;.1;.16;.11;.25");
			hashMap.put("FLAGS","IP");
			hashMap.put("ID","S DZ=$P(^(0),U,19) I DZ'=\"\",($D(^VA(200,DZ,0))#10)'=0 D EN^DDIOL($P($G(^VA(200,DZ,0)),U,1))");
	    	hashMap.put("FROM",RPCUtils.adjustForNumericSearch(dfn));
			hashMap.put("PART",dfn);
			hashMap.put("XREF","C");
			hashMap.put("SCREEN", "I $P(^(0),U,2)=3");
			params.add(hashMap);
	        String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
	        return parseResponseToDataBeans(result, queryBean, null, currentSiteId, webMethodName, vistaLinkCommand);
	       
	}
	
	@Override
	public String getDaoName() 
	{
		return getClass().getSimpleName();
	}

}
