package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.util.VistaTimestamp;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class GetVistaTimestampsDao extends BaseDao 
{


	@Override
	public List<DataBean> callRpc(String currentSiteId,
			Map<String, Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) 
	{

			QueryBean queryBean = (QueryBean) requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY);
			VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
			List<Object> params =new ArrayList<Object>();
			params.add("NOW");
			String response = vistaLinkCommand.executeRpc(RpcNameConstants.ORWU_DT, params);
			String utcString = VistaTimestamp.toUtcString(response); 

			Text text = new Text();
			text.setText(utcString);
			text.setTag(queryBean.getLoginSiteCode());
			
			List<DataBean> resultList = new ArrayList<DataBean>();
			resultList.add(text);
			return resultList;
	}
	
	@Override
	public String getDaoName() 
	{
		return getClass().getSimpleName();
	}

}
