package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Provider;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.response.MatchByNameCityStateParser;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MatchByNameCityStateDao extends BaseDao {

	@Override
	public List<DataBean> callRpc(String currentSiteId, Map<String,Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator) {		


		// Get data from Query Bean
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY);

		Provider provider = queryBean.getProvider();

/*		@SuppressWarnings("unchecked")
		HashMap<Object, Object> hashMap = (HashMap<Object, Object>)requestParameterMap.get(ViaRequestMapKeyConstants.HASHMAP_KEY);
*/
		//Create VistaLink Command
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator,currentSiteId, provider, VistaConstants.CPRS_CONTEXT);


		/// get State IEN for state Abbreviation
		String stateAbbr = queryBean.getCriteria();
		String stateIen = getStateIen(vistaLinkCommand, stateAbbr);
		String name = queryBean.getName();
		String city = queryBean.getTarget();
		/*		MDWS code
				DdrLister query = new DdrLister(cxn);
		        query.File = "2";
		        query.Fields = ".01;.02;.03;.09;.111;.112;.113;.114;.115E;.116;.117;.131;991.01;991.02";
		        query.Flags = "IP";
		        query.From = VistaUtils.adjustForNameSearch(name.ToUpper());
		        query.Part = name.ToUpper();
		        query.Xref = "B";
		        query.Screen = "I $D(^(.11))=1, " +
		            "$P(^(.11),U,4)[\"" + city.ToUpper() + "\", " +
		            "$P(^(.11),U,5)=" + stateIEN;
		 */		


		List<Object> params =new ArrayList<Object>();		
		HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
		hashMap.put("FILE",2);
		hashMap.put("FIELDS",".01;.02;.03;.09;.111;.112;.113;.114;.115E;.116;.117;.131;991.01;991.02;.134;.033");
		hashMap.put("FLAGS", "IP");
		hashMap.put("FROM", RPCUtils.adjustForNameSearch(name) );
		hashMap.put("PART", name.toUpperCase());
		hashMap.put("XREF", "B");
		String screen = "I $D(^(.11))=1, $P(^(.11),U,4)[\"" + city.toUpperCase() + "\", $P(^(.11),U,5)=" + stateIen;
		hashMap.put("SCREEN", screen);
		params.add(hashMap);
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);

		//Invoke parser and return databeans
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY); 		
		MatchByNameCityStateParser parser = (MatchByNameCityStateParser)getDataBeanParser(webMethodName);
		return parser.populateDataBeans(result, queryBean, null/*dfn*/, currentSiteId, webMethodName,vistaLinkCommand);
	}


	/* 
	 * @return - the DAO name
	 */
	@Override
	public String getDaoName() {
		return DaoNameConstants.MATCH_BY_NAME_CITY_STATE_DAO;
	}

	private String getStateIen(VistaLinkCommand vistaLinkCommand, String stateAbbr) 
	{
		List<Object> params =new ArrayList<Object>();		
		HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
		hashMap.put("FILE",5);
		hashMap.put("FIELDS",".001;");  /// .001 is the IEN of the STATE in the Vista table
		hashMap.put("PART",stateAbbr);
		hashMap.put("XREF","C");
		params.add(hashMap);
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
		result = result.trim();
		if ( result.startsWith("[Data]"))
		{
			result = result.substring(6).trim();
		}
		return result;
	}


}