package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

// TODO: Auto-generated Javadoc
/**
 * The Class MentalHealthInstrumentResultSetDao.
 * 
 * @author DOMAINROMERJ
 */
public class MentalHealthInstrumentResultSetDao extends BaseDao 
{

	/**
	 * Retrieve all records from the MH_RESULTS Vista File that match the administrationId received in the queryBean.ItemId attribute 
	 *
	 * returns a list of DataBeans with the data from the MH_RESULTS Vista File
	 **/
	@Override
	public List<DataBean> callRpc(String currentSiteId, Map<String,Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator) 
	{		
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);		
		
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);

		List<Object> params =new ArrayList<Object>();		
		HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
		hashMap.put("FILE", VistaConstants.MH_RESULTS); 
		hashMap.put("FIELDS","2;3;4;5;6");
		hashMap.put("FLAGS","IP");
		hashMap.put("XREF","AC");
		hashMap.put("FROM",RPCUtils.adjustForNumericSearch(queryBean.getItemId()));		// ItemId is the AdministrationID/IEN
		hashMap.put("PART",queryBean.getItemId());										
		params.add(hashMap); 								// add hashMap to parameters List to invoke RPC call		
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);		
		
		String dfn = getLocalDfn(queryBean.getPatient(), currentSiteId, vistaLinkCommand);
		return parseResponseToDataBeans(result, queryBean, dfn, currentSiteId, webMethodName, vistaLinkCommand);
	}


	/* (non-Javadoc)
	 * @see gov.va.med.via.dao.BaseDao#getDaoName()
	 */
	@Override
	public String getDaoName() 
	{
		return DaoNameConstants.MENTAL_HEALTH_INSTRUMENT_RESULT_SET_DAO;
	}
}