package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

// TODO: Auto-generated Javadoc
/**
 * The Class MentalHealthInstrumentsForPatientDao.
 */
public class MentalHealthInstrumentsForPatientDao extends BaseDao 
{
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dao.Dao#callRpc(java.lang.String, java.util.Map, gov.va.med.via.vistalink.ConnectionFactoryLocator)
	 */
	@Override
	public List<DataBean> callRpc(String currentSiteId, Map<String,Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator) 
	{		
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);		
		
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
		
		String dfn = getLocalDfn(queryBean.getPatient(), currentSiteId, vistaLinkCommand);
		
		List<Object> params =new ArrayList<Object>();		
		HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
		hashMap.put("FILE",VistaConstants.MH_ADMINISTRATIONS);
		hashMap.put("FIELDS","1;1E;2;3;4;5;5E;6;6E;7;8;9;11;12;13");
		hashMap.put("FLAGS","IP");
		hashMap.put("FROM",RPCUtils.adjustForNumericSearch(dfn));
		hashMap.put("PART",dfn);		
		hashMap.put("XREF","C");
		hashMap.put("ID","S X=$P(^(0),U,11) I X'=\"\",$D(^SC(X,0)) S X=$P($G(^SC(X,0)),U) D EN^DDIOL(X)");
		
		params.add(hashMap); // add hashMap to parameters List to invoke RPC call		
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
		
		return parseResponseToDataBeans(result, queryBean, dfn, currentSiteId, webMethodName, vistaLinkCommand);	
	}


	/* 
	 * @return - the DAO name
	 */
	/* (non-Javadoc)
	 * @see gov.va.med.via.dao.BaseDao#getDaoName()
	 */
	@Override
	public String getDaoName() 
	{
		return DaoNameConstants.MENTAL_HEALTH_INSTRUMENTS_FOR_PATIENT_DAO;
	}


}