package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.List;
import java.util.Map;

// TODO: Auto-generated Javadoc
/**
 * The Class NoteTitleDao.
 * 
 * @author DOMAINROMERJ
 */
public class NoteTitleDao extends BaseDao
{	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dao.Dao#callRpc(java.lang.String, java.util.Map, gov.va.med.via.vistalink.ConnectionFactoryLocator)
	 */
	@Override
	public List<DataBean> callRpc( String currentSiteId, Map<String,Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator) 
	{
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);		

		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);

		String dfn = null; /// we don't require a patient dfn to get note titles -- getLocalDfn(queryBean.getPatient(), currentSiteId, vistaLinkCommand);
		String target = queryBean.getTarget();
		String direction = queryBean.getDirection();

		if (target == null || target.equals("")) 
		{
			target = "";
		}
		else
		{
			target = RPCUtils.adjustForNameSearch(target);
		}
		
		
		
		/* url:  http://apidocs.medsphere.org/openvista-server/latest/data/rpcs/TIU%20LONG%20LIST%20OF%20TITLES
		 * 
		 * RETURN PARAMETER DESCRIPTION:   This is an array of the 44 nearest titles to that indicate by the user in
		 *  the direction passed by the longlist component.
		 *  
		 * Note that this RPC only returns the 44 nearest targets - it never returns a complete list of note titles.
		 *  
		 */
		
		
		
		
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.TIU_LONG_LIST_OF_TITLES, "3", target,  RPCUtils.setDirectionParam(direction));

		return parseResponseToDataBeans(result, queryBean, dfn, currentSiteId, webMethodName, vistaLinkCommand);
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dao.BaseDao#getDaoName()
	 */
	@Override
	public String getDaoName() 
	{
		return DaoNameConstants.NOTE_TITLE_DAO;
	}
}
