package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.request.ViaWebMethodNameConstants;
import gov.va.med.via.rpc.RPCUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PatientMatchDao extends BaseDao 
{

	@Override
	public List<DataBean> callRpc( String currentSiteId, Map<String,Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) 
	{	

		// Based on web method name call a match method as this will be called several web methods
		String result = "";
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);
		@SuppressWarnings("unchecked")
		HashMap<Object, Object> hashMap = (HashMap<Object, Object>)requestParameterMap.get(ViaRequestMapKeyConstants.HASHMAP_KEY);
		String targetValue = queryBean.getTarget();
		
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
		String  targetRpcName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.TARGET_RPC_NAME_KEY); 
		String rpcArg = targetValue;
		
		if ( ViaWebMethodNameConstants.EMRSVC_MATCH.equals(webMethodName) 
				||	ViaWebMethodNameConstants.NUMISVC_MATCH.equals(webMethodName) 
				||	ViaWebMethodNameConstants.CLAIMSVC_MATCH.equals(webMethodName)
				||  ViaWebMethodNameConstants.CALLSVC_MATCH.equals(webMethodName))
		{
			if ( RpcNameConstants.ORWPT_LIST_ALL.compareTo(targetRpcName) == 0 )
			{
				//result = vistaLinkTemplate.callRpcAsUser(currentSiteId, getUserDuz(queryBean.getProvider()), VistaConstants.CPRS_CONTEXT, targetRpcName, RPCUtils.adjustForNameSearch(rpcArg), "1");
				result = vistaLinkCommand.executeRpc(targetRpcName, RPCUtils.adjustForNameSearch(rpcArg), "1");
			}
			else
			{			
				result = vistaLinkCommand.executeRpc(targetRpcName, rpcArg);				
			}
		}
			
		return parseResponseToDataBeans(result, queryBean, null, currentSiteId, webMethodName, vistaLinkCommand);

	}

	@Override
	public String getDaoName() {
		return DaoNameConstants.PATIENT_MATCH_DAO;
	}

}
