package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.List;
import java.util.Map;

public class PcpForPatientDao extends BaseDao {

	@Override
	public List<DataBean> callRpc(String currentSiteId, Map<String, Object> requestParameterMap,
			ConnectionFactoryLocator connectionFactoryLocator) {
		
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);		
		
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
		
		String dfn = getLocalDfn(queryBean.getPatient(), currentSiteId, vistaLinkCommand);
		
		String response = vistaLinkCommand.executeRpc(RpcNameConstants.ORWPT1_PRCARE, dfn);
		
		return parseResponseToDataBeans(response.toString(), queryBean, dfn, currentSiteId, webMethodName, vistaLinkCommand);
	}

	@Override
	public String getDaoName() {
		return DaoNameConstants.PCP_FOR_PATIENT_DAO;
	}

}
