package gov.va.med.via.dao;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.request.ViaRequestMapKeyConstants;
import gov.va.med.via.response.RatedDisabilitiesForPatientParser;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.rpc.VistaConstants;
import gov.va.med.via.vistalink.ConnectionFactoryLocator;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author ZZZZZZAPOSTI
 *
 */
public class RatedDisabilitiesForPatientDao extends BaseDao {

	@Override
	public List<DataBean> callRpc(String currentSiteId, Map<String,Object> requestParameterMap, ConnectionFactoryLocator connectionFactoryLocator) {		

		/*
		 * DdrLister query = new DdrLister(cxn);
            query.File = "2.04";
            query.Iens = "," + dfn + ",";
            query.Fields = ".01;.01E;2;3;4;5;6";
            query.Flags = "IP";
            query.Xref = "#";
		 */
		QueryBean queryBean = (QueryBean)requestParameterMap.get(ViaRequestMapKeyConstants.QUERY_BEAN_KEY); 
		String webMethodName = (String)requestParameterMap.get(ViaRequestMapKeyConstants.WEB_METHOD_NAME_KEY);		
		
		VistaLinkCommand vistaLinkCommand = createVistaLinkCommand(connectionFactoryLocator, currentSiteId, queryBean.getProvider(), VistaConstants.CPRS_CONTEXT);
		
		String dfn = getLocalDfn(queryBean.getPatient(), currentSiteId, vistaLinkCommand);
		
		List<Object> params =new ArrayList<Object>();		
		HashMap<Object,Object> hashMap = new HashMap<Object,Object>();
		hashMap.put("FILE",2.04);
		hashMap.put("IENS", ","+dfn+",");
		hashMap.put("FIELDS",".01;.01E;2;3;4;5;6");
		hashMap.put("FLAGS","IP");
		hashMap.put("XREF","#");		
		params.add(hashMap); // add hashMap to parameters List to invoke RPC call	
		
		String result = vistaLinkCommand.executeRpc(RpcNameConstants.SC_LISTER, params);
		
		return parseResponseToDataBeans(result, queryBean, null, currentSiteId, webMethodName, vistaLinkCommand);
		
	}


	/* 
	 * @return - the DAO name
	 */
	@Override
	public String getDaoName() {
		return DaoNameConstants.RATED_DISABILITIES_FOR_PATIENT_DAO;
	}


}