package gov.va.med.via.dao.lookup;

import java.util.Arrays;

public class ReferenceDataCacheKey
{
	private String fileNumber;
	private String code;
	
	public ReferenceDataCacheKey(String fileNumber, String code) 
	{
		if ( fileNumber==null ) throw new IllegalArgumentException("fileNumber cannot be null");
		if ( code==null ) throw new IllegalArgumentException("code cannot be null");
		
		this.fileNumber = fileNumber;
		this.code=code;
	}
	
	public String toString()
	{
		return getClass().getSimpleName()+"::fileNumber:"+fileNumber+";code="+code;	
	}
	
	@Override
	public boolean equals(Object object)
	{
		if ( this == object) return true;
		try
		{
			ReferenceDataCacheKey other = (ReferenceDataCacheKey)object;
			if ( !fileNumber.equals(other.fileNumber)) return false;
			if ( !code.equals(other.code)) return false;
			return true;			
		}
		catch ( Exception e)
		{
			return false;
		}
	}
	
	@Override
	public int hashCode() 
	{ 
		return Arrays.hashCode(new Object[] { fileNumber, code });		
    }

	
}
