package gov.va.med.via.dao.lookup;

import java.util.Arrays;


public class ReferenceDataCacheValue 
{
	private long lastUpdateTime;
	private String cachedValue;
	
	public ReferenceDataCacheValue(String result)
	{
		if ( result==null ) throw new IllegalArgumentException("The result argument cannot be null");
		this.cachedValue = result;
		lastUpdateTime = System.currentTimeMillis();		
	}
	
	
	public long getLastUpdateTime() {
		return lastUpdateTime;
	}

	public String getCachedValue() 
	{
		return cachedValue;
	}

	/** indicates whether this QueryCacheValue's age is greater than the argument time in seconds. **/
	public boolean exceedsMaxAge( long maxAgeInSeconds)
	{
		if ( maxAgeInSeconds<=0) return false;
		long maxAgeTime = maxAgeInSeconds*1000;
		long currentTime = System.currentTimeMillis();
		return (currentTime - maxAgeTime)>lastUpdateTime;
	}
	
	@Override
	public String toString()
	{
		return getClass().getSimpleName()+"::cachedValue="+cachedValue+";lastUpdateTime="+lastUpdateTime;
	}
	
	@Override
	public boolean equals(Object other) 
	{
		try
		{
			return cachedValue.equals(((ReferenceDataCacheValue)other).cachedValue);
		}
		catch ( Exception e)
		{
			return false;
		}
	}

	@Override
	public int hashCode() 
	{
		return Arrays.hashCode(new Object[] { cachedValue });
	}
	

}
