

package gov.va.med.via.exception;


import gov.va.med.via.exception.AbstractViaBaseException;
import gov.va.med.via.exception.ErrorCodeEnum;


/**
 * Exceptions thrown by persistence / dao classes.
 * 
 * @author ZZZZZZTALBOM
 *
 */
public class RpcException
    extends
        AbstractViaBaseException
{

    private static final long serialVersionUID = 4783429399489832692L;


    /**
     * Constructor
     * 
     * @param errorCodeName - enum to populate and return to caller.
     */
    public RpcException( ErrorCodeEnum errorCodeName )
    {
        super( errorCodeName );
    }
    
    public RpcException(ErrorCodeEnum errorCode, Exception e){
		super(errorCode, e);
	}


    /**
     * Constructor
     * 
     * @param errorCodeName - enum to populate and return to caller.
     * @param messages - list of messages to be integrated into exception message.
     */
    public RpcException( ErrorCodeEnum errorCodeName, String... messages )
    {
        super( errorCodeName, messages );
    }


    /**
     * Constructor
     * 
     * @param errorCode - enum to populate and return to caller.
     * @param cause - exception thrown in hibernate persistence module.
     * @param customMsg - list of messages to be integrated into exception message.
     */
    public RpcException( ErrorCodeEnum errorCode, Throwable cause, String... customMsg )
    {
        super( errorCode, cause, customMsg );
    }

}
