package gov.va.med.via.request;

import gov.va.med.via.business.ViaResponse;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.transaction.RpcTransactionManager;

import java.util.List;
import java.util.Map;


/**
 * Implementing processor class
 * 
 * @author ZZZZZZTALBOM
 *
 */
/**
 * @author ZZZZZZTALBOM
 *
 */
public class ViaReadProcessorImpl implements ViaReadProcessor {

	
	protected RpcTransactionManager transactionManager;
	
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.request.ViaReadProcessor#loginProvider(java.util.Map)
	 */
	@Override
	public ViaResponse loginProvider(
			Map<String, Object> requestParameterMap) {

		return transactionManager.loginProvider(requestParameterMap);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.request.ViaReadProcessor#matchPatient(java.util.Map)
	 */
	@Override
	public ViaResponse matchPatient(Map<String, Object> requestParameterMap) {
		return transactionManager.matchPatient(requestParameterMap);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.business.VistaService#selectPatient(java.util.Map)
	 */
	@Override
	public ViaResponse selectPatient(Map<String, Object> requestParameterMap) {
		return transactionManager.selectPatient(requestParameterMap);
	}

	
	/* (non-Javadoc)
	 * @see gov.va.med.via.request.ViaReadProcessor#processVistaRead(java.util.Map)
	 */
	@Override
	public ViaResponse processVistaRead(Map<String,Object>requestParameterMap) {
		//TODO - all processing here should be in a try/catch for any unforseen exceptions - throwables - that need to be logged and messages created/returned ...
		
		return transactionManager.performRpcRead(requestParameterMap);
	}
	

	/* (non-Javadoc)
	 * @see gov.va.med.via.request.ViaReadProcessor#setTransactionManager(gov.va.med.via.transaction.RpcTransactionManager)
	 */
	public void setTransactionManager(RpcTransactionManager transactionManager) {
		this.transactionManager = transactionManager;
	}
	
}
