package gov.va.med.via.request;

/**
 * Constant class that defines the Web service method names - used to store configured objects into maps that can be injected into processing components that need to make application logic descions based upon the service method accessed, or client.
 * 
 * @author ZZZZZZTALBOM
 *
 */
public class ViaWebMethodNameConstants {
	
	/*
	 * This naming convention is Service.WebMethod
	 * The service name is taken from the MDWS code base with the exception of the JMeadows VistaDataService
	 * -in MDWS some services are named with service abbreviated - others are not and these names reflect the naming of
	 * the service as defined
	 */
	
	//BhieService
	
	//CallService
	public static final String CALLSVC_LOGIN="CallService.login";
	public static final String CALLSVC_CLOSENOTE = "CallService.closeNote";
	public static final String CALLSVC_CPRSUSERLOOKUP = "CallService.cprsUserLookup";
	public static final String CALLSVC_GETADMISSIONS = "CallService.getAdmissions";
	public static final String CALLSVC_GETCONSULTSFORPATIENT = "CallService.getConsultsForPatient";
	public static final String CALLSVC_GETLOCATIONS = "CallService.getLocations";
	public static final String CALLSVC_GETNOTETITLES = "CallService.getNoteTitles";
	public static final String CALLSVC_GETPRFNOTEACTIONS = "CallService.getPrfNoteActions";
	public static final String CALLSVC_GETVISITS = "CallService.getVisits";
	public static final String CALLSVC_ISCONSULTNOTE = "CallService.isConsultNote";
	public static final String CALLSVC_ISCOSIGNERREQUIRED = "CallService.isCosignerRequired";
	public static final String CALLSVC_ISPRFNOTE = "CallService.isPrfNote";
	public static final String CALLSVC_ISONEVISITNOTE = "CallService.isOneVisitNote";
	public static final String CALLSVC_ISSURGERYNOTE = "CallService.isSurgeryNote";	
	public static final String CALLSVC_MATCH = "CallService.match";
	public static final String CALLSVC_MATCHBYNAMECITYSTATE="CallService.matchByNameCityState";
	public static final String CALLSVC_MPILOOKUP = "CallService.mpiLookup";
	public static final String CALLSVC_SELECT="CallService.select";
	public static final String CALLSVC_SIGNNOTE = "CallService.signNote";
	public static final String CALLSVC_WRITENOTE = "CallService.writeNote";
	
	
	
	//ClaimSvc
	public static final String CLAIMSVC_LOGIN="ClaimSvc.login";
	public static final String CLAIMSVC_SELECT="ClaimSvc.select";
	public static final String CLAIMSVC_MATCH = "ClaimSvc.match";
	public static final String CLAIMSVC_GETCONSULTNOTE="ClaimSvc.getConsultNote";
	public static final String CLAIMSVC_GETPROSTHETICCLAIMS="ClaimSvc.getProstheticClaims";
	public static final String CLAIMSVC_GETRATEDDISABILITIESFORPATIENT="ClaimSvc.getRatedDisabilitiesForPatient";
	public static final String CLAIMSVC_ISSUECONFIDENTIALITYBULLETIN="ClaimSvc.issueConfidentialityBulletin";
	
	//EmrSvc	
	public static final String EMRSVC_CLOSENOTE = "EMRService.closeNote";
	public static final String EMRSVC_CPRSLAUNCH = "EmrSvc.cprsLaunch";//will be used to define the main webmethod and assign the main databean parser for user/provider
	public static final String EMRSVC_CPRSUSERLOOKUP = "EmrSvc.cprsUserLookup";
	public static final String EMRSVC_GETADHOCHEALTHSUMMARYBYDISPLAYNAME="EmrService.getAdhocHealthSummaryByDisplayName";
	public static final String EMRSVC_GETADMISSIONS="EmrService.getAdmissions";
	public static final String EMRSVC_GETADMISSIONSREPORTS="EmrService.getAdmissionsReports";
	public static final String EMRSVC_GETADVANCEDIRECTIVES="EmrService.getAdvanceDirectives";
	public static final String EMRSVC_GETALLERGIES = "EmrSvc.getAllergies";
	public static final String EMRSVC_GETAPPOINTMENTS = "EmrSvc.getAppointments";
	public static final String EMRSVC_GETALLMEDS = "EmrSvc.getAllMeds";
	public static final String EMRSVC_GETALLORDERS="EmrSvc.getAllOrders";
	public static final String EMRSVC_GETAPPOINTMENTTEXT = "EmrSvc.getAppointmentText";
	public static final String EMRSVC_GETAUTOPSYREPORTS="EmrService.getAutopsyReports";
	public static final String EMRSVC_GETBLOODAVAILABILITYREPORTS = "EmrSvc.getBloodAvailabilityReports";			
	public static final String EMRSVC_GETBLOODBANKREPORTS = "EmrSvc.getBloodBankReports";		
	public static final String EMRSVC_GETBLOODTRANSFUSIONREPORTS = "EmrSvc.getBloodTransfusionReports";
	public static final String EMRSVC_GETCARETEAMREPORTS = "EMRService.getCareTeamReports";	
	public static final String EMRSVC_GETCLINICS="EmrService.getClinics";
	public static final String EMRSVC_GETCLINICALWARNINGS="EmrService.getClinicalWarnings";
	public static final String EMRSVC_GETCHEMHEMREPORTS="EmrService.getChemHemReports";
	public static final String EMRSVC_GETCHEMHEMREPORTSSIMPLE = "EmrSvc.getChemHemReportsSimple";	
	public static final String EMRSVC_GETCOMPANDPENREPORTS="EmrService.getCompAndPenReports";
	public static final String EMRSVC_GETCONFIDENTIALITY = "EmrSvc.getConfidentiality";
	public static final String EMRSVC_GETCONSULTSFORPATIENT = "EmrSvc.getConsultsForPatient";
	public static final String EMRSVC_GETCRISISNOTES = "EmrSvc.getCrisisNotes";
	public static final String EMRSVC_GETCORRESPONDINGIDS = "EmrSvc.getCorrespondingIds";
	public static final String EMRSVC_GETCYTOLOGYREPORTS = "EmrSvc.getCytologyReports";
	public static final String EMRSVC_GETCYTOPATHOLOGYREPORTS = "EmrSvc.getCytopathologyReports";
	public static final String EMRSVC_GETDEMOGRAPHICS = "EmrSvc.getDemographics";	
	public static final String EMRSVC_GETDISCHARGEDIAGNOSISREPORT = "EmrSvc.getDischargeDiagnosisReport";	
	public static final String EMRSVC_GETDISCHARGESREPORT = "EmrSvc.getDischargeReport";
	public static final String EMRSVC_GETDISCHARGESSUMMARIES = "EmrSvc.getDischargeSummaries";
	public static final String EMRSVC_GETELECTRONMICROSCOPYREPORTS = "EmrSvc.getElectronMicroscopyReports";	
	public static final String EMRSVC_GETEXPANDEDADTREPORT = "EmrSvc.getExpandedAdtReport";	
	public static final String EMRSVC_GETFUTURECLINICVISITSREPORTS = "EmrSvc.getFutureClinicVisitsReports";
	public static final String EMRSVC_GETHOSPITALLOCATIONS="EmrSvc.getHospitalLocations";
	public static final String EMRSVC_GETICDPROCEDURESREPORTS = "EmrSvc.getIcdProceduresReports";
	public static final String EMRSVC_GETICDSURGERYREPORTS = "EmrSvc.getIcdSurgeryReports";
	public static final String EMRSVC_GETIMAGINGREPORT="EmrSvc.getImagingReport";
	public static final String EMRSVC_GETMEDICATIONDETAIL="EmrSvc.getMedicationDetail";
	public static final String EMRSVC_GETIMMUNIZATIONS = "EmrSvc.getImmunizations";
	public static final String EMRSVC_GETIMOMEDS = "EmrSvc.getImoMeds";
	public static final String EMRSVC_GETIVMEDS = "EmrSvc.getIvMeds";
	public static final String EMRSVC_GETLABTESTS="EmrSvc.getLabTests";
	public static final String EMRSVC_GETLABTESTDESCRIPTION = "EmrSvc.getLabTestDescription";
	public static final String EMRSVC_GETLATESTVITALSIGNS="EmrSvc.getLatestVitalSigns";
	public static final String EMRSVC_GETLOCATIONS = "EmrSvc.getLocations";
	public static final String EMRSVC_GETMICROBIOLOGYREPORTS = "EmrSvc.getMicrobiologyReports";	
	public static final String EMRSVC_GETMEDSADMINHX = "EmrSvc.getMedsAdminHx";	
	public static final String EMRSVC_GETMEDSADMINLOG = "EmrSvc.getMedsAdminLog";	
	public static final String EMRSVC_GETMENTALHEALTHINSTRUMENTRESULTSET="EmrSvc.getMentalHealthInstrumentResultSet";
	public static final String EMRSVC_GETNHINDATA = "EmrSvc.getNhinData";
	public static final String EMRSVC_GETMENTALHEALTHINSTRUMENTSFORPATIENT="EmrSvc.getMentalHealthInstrumentsForPatient";
	public static final String EMRSVC_GETNOTE = "EmrSvc.getNote";
	public static final String EMRSVC_GETNOTESWITHTEXT="EmrSvc.getNotesWithText";
	public static final String EMRSVC_GETNOTETITLES = "EmrSvc.getNoteTitles";
	public static final String EMRSVC_GETPCPFORPATIENT = "EmrSvc.getPcpForPatient";
	public static final String EMRSVC_GETOTHERMEDS = "EmrSvc.getOtherMeds";
	public static final String EMRSVC_GETOUTPATIENTENCOUNTERREPORT = "EmrSvc.getOutpatientEncounterReport";	
	public static final String EMRSVC_GETOUTPATIENTMEDS = "EmrSvc.getOutpatientMeds";
	public static final String EMRSVC_GETOUTPATIENTRXPROFILE = "EmrSvc.getOutpatientRxProfile";
	public static final String EMRSVC_GETPASTCLINICVISITSREPORTS = "EmrSvc.getPastClinicVisitsReports";
	public static final String EMRSVC_GETPATIENTASSOCIATES="EmrSvc.getPatientAssociates";
	public static final String EMRSVC_GETPATIENTSBYCLINIC = "EmrSvc.getPatientsByClinic";
	public static final String EMRSVC_GETPATIENTSBYPROVIDER = "EmrSvc.getPatientsByProvider";
	public static final String EMRSVC_GETPATIENTSBYSPECIALTY = "EmrSvc.getPatientsBySpecialty";
	public static final String EMRSVC_GETPATIENTSBYTEAM = "EmrSvc.getPatientsByTeam";
	public static final String EMRSVC_GETPATIENTSBYWARD = "EmrSvc.getPatientsByWard";
	public static final String EMRSVC_GETPRFNOTEACTIONS="EmrSvc.getPrfNoteActions";
	public static final String EMRSVC_GETPROBLEMLIST = "EmrSvc.getProblemList";	
	public static final String EMRSVC_GETRADIOLOGYREPORTS="EmrService.getRadiologyReports";	
	public static final String EMRSVC_GETSIGNEDNOTES="EmrSvc.getSignedNotes";
	public static final String EMRSVC_GETSPECIALTIES="EmrSvc.getSpecialties";
	public static final String EMRSVC_GETSURGERYREPORTS = "EmrSvc.getSurgeryReports";
	public static final String EMRSVC_GETSURGERYREPORTSWITHTEXT = "EmrSvc.getSurgeryReportsWithText";
	public static final String EMRSVC_GETSURGERYREPORTTEXT = "EmrSvc.getSurgeryReportText";	
	public static final String EMRSVC_GETSURGICALPATHOLOGYREPORTS = "EmrSvc.getSurgicalPathologyReports";	
	public static final String EMRSVC_GETTRANSFERSREPORT = "EmrSvc.getTrasfersReport";
	public static final String EMRSVC_GETTREATINGSPECIALTYREPORT = "EmrSvc.getTreatingSpecialtyReport";
	public static final String EMRSVC_GETUNCOSIGNEDNOTES="EmrSvc.getUncosignedNotes";
	public static final String EMRSVC_GETTEAMS = "EmrSvc.getTeams";
	public static final String EMRSVC_GETVISITS="EMRService.getVisits";
	public static final String EMRSVC_GETVITALSIGNS="EMRService.getVitalSigns";	
	public static final String EMRSVC_GETUNITDOSEMEDS="EMRService.getUnitDoseMeds";
	public static final String EMRSVC_GETUNSIGNEDNOTES="EmrSvc.getUnsignedNotes";
	public static final String EMRSVC_GETWARDS="EMRService.getWards";
	public static final String EMRSVC_ISCONSULTNOTE="EMRService.isConsultNote";
	public static final String EMRSVC_ISCOSIGNERREQUIRED="EMRService.isCosignerRequired";	
	public static final String EMRSVC_ISONEVISITNOTE="EMRService.isOneVisitNote";
	public static final String EMRSVC_ISPRFNOTE="EMRService.isPrfNote";			
	public static final String EMRSVC_ISSUECONFIDENTIALITYBULLETIN="EmrSvc.issueConfidentialityBulletin";
	public static final String EMRSVC_ISSURGERYNOTE="EMRService.isSurgeryNote";
	public static final String EMRSVC_ISVALIDESIG="EmrSvc.isValidEsig";
	public static final String EMRSVC_LOGIN="EmrSvc.login";
	public static final String EMRSVC_MATCH = "EmrSvc.match";
	public static final String EMRSVC_MPILOOKUP = "EmrService.mpiLookup";
	public static final String EMRSVC_PATIENTINQUIRY = "EmrSvc.patientInquiry";
	public static final String EMRSVC_SELECT = "EmrSvc.select";
	public static final String EMRSVC_SIGNNOTE = "EmrService.signNote";
	public static final String EMRSVC_WRITENOTE="EmrService.writeNote";
	public static final String EMRSVC_WRITESIMPLEORDERBYPOLICY="EmrService.writeSimpleOrderByPolicy";
	
	//ErmSvs web method name extensions
	public static final String EMRSVC_CPRSLAUNCH_PATIENTSELECT = "EmrSvc.cprsLaunch_patientselect";//extended with patientselect in order to define more than one databean parser for EmrSvc.cprsLaunch - this defines a patient select databean parser
	
	//FindPatientService
	public static final String FINDPATIENTSVC_LOGIN="FindPatientService.login";
	public static final String FINDPATIENTSVC_MATCHBYNAMECITYSTATEMS="FindPatientService.matchByNameCityStateMS";
	public static final String FINDPATIENTSVC_MATCHBYCITYANDSTATE="FindPatientService.matchCityAndState";
	public static final String FINDPATIENTSVC_MPILOOKUP = "FindPatientService.mpiLookup";
	
	//FixThePhonesService
	public static final String FIXTHEPHONESSVC_CLOSENOTE = "FixThePhonesService.closeNote";
	public static final String FIXTHEPHONESSVC_GETADHOCHEALTHSUMMARYBYDISPLAYNAME="FixThePhonesService.getAdhocHealthSummaryByDisplayName";
	public static final String FIXTHEPHONESSVC_GETADVANCEDIRECTIVES="FixThePhonesService.getAdvanceDirectives";
	public static final String FIXTHEPHONESSVC_GETALLERGIES = "FixThePhonesService.getAllergies";
	public static final String FIXTHEPHONESSVC_GETALLMEDS = "FixThePhonesService.getAllMeds";
	public static final String FIXTHEPHONESSVC_GETCONSULTSFORPATIENT = "FixThePhonesService.getConsultsForPatient";
	public static final String FIXTHEPHONESSVC_GETDEMOGRAPHICS = "FixThePhonesService.getDemographics";	
	public static final String FIXTHEPHONESSVC_GETFUTURECLINICVISITSREPORTS = "FixThePhonesService.getFutureClinicVisitsReports";
	public static final String FIXTHEPHONESSVC_GETIMMUNIZATIONS = "FixThePhonesService.getImmunizations";
	public static final String FIXTHEPHONESSVC_GETPASTCLINICVISITSREPORTS = "FixThePhonesService.getPastClinicVisitsReports";
	public static final String FIXTHEPHONESSVC_GETRADIOLOGYREPORTS="FixThePhonesService.getRadiologyReports";
	public static final String FIXTHEPHONESSVC_GETVISITS="FixThePhonesService.getVisits";
	public static final String FIXTHEPHONESSVC_GETVITALSIGNS="FixThePhonesService.getVitalSigns";	
	public static final String FIXTHEPHONESSVC_LOGIN="FixThePhonesService.login";
	public static final String FIXTHEPHONESSVC_MATCH="FixThePhonesService.match";
	public static final String FIXTHEPHONESSVC_SIGNNOTE = "FixThePhonesService.signNote";	
	public static final String FIXTHEPHONESSVC_WRITENOTE="FixThePhonesService.writeNote";
		
	//MdwsSvc
	
	//MhvServc
	public static final String MHVSVC_LOGIN="MhvServc.login";
	
	//NumiService
	public static final String NUMISVC_GETINPATIENTMOVES="NumiService.getInpatientMoves";
	public static final String NUMISVC_GETINPATIENTMOVESBYCHECKINID="NumiService.getInpatientMovesByCheckIn";
	public static final String NUMISVC_GETINPATIENTMOVESBYDATERANGE="NumiService.getInpatientMovesByDateRange";
	public static final String NUMISVC_GETINPATIENTMOVESBYDATETIMERANGE="NumiService.getInpatientMovesByDateTimeRange";	
	public static final String NUMISVC_LOGIN="NumiService.login";
	public static final String NUMISVC_MATCH="NumiSvcService.match";
	public static final String NUMISVC_SELECT="NumiSvcService.select";
	public static final String NUMISVC_GETWARDS="NumiSvcService.getWards";
	public static final String NUMISVC_GETCONFIDENTIALITY="NumiSvcService.getConfidentiality";
	public static final String NUMISVC_ISSUECONFIDENTIALITYBULLETIN="NumiSvcService.issueConfidentialityBulletin";
	public static final String NUMISVC_USERLOOKUP="NumiService.userLookup";
	public static final String NUMISVC_GETVISTATIMESTAMPS="NumiService.getVistaTimestamps";
	public static final String NUMISVC_GETDRGRECORDS = "NumiService.getDRGRecords";
	public static final String NUMISVC_GETSTAYMOVEMENTS = "NumiService.getStayMovements";
	public static final String NUMISVC_GETSTAYMOVEMENTSBYDATERANGE = "NumiService.getStayMovementsByDateRange";
	public static final String NUMISVC_GETSTAYMOVEMENTSBYPATIENT = "NumiService.getStayMovementsByPatient";
	public static final String NUMISVC_GETINPATIENTDISCHARGES="NumiService.getInpatientDischarges";

	
	//PhrSvc
	public static final String PHRSVC_GETALLERGIES = "PhrSvc.getAllergies";
	public static final String PHRSVC_LOGIN="PhrSvc.login";
	
	//TbiService
	public static final String TBISVC_CPRSLAUNCH = "TbiSvc.cprsLaunch";
	public static final String TBISVC_CPRSUSERLOOKUP = "TbiSvc.cprsUserLookup";
	public static final String TBISVC_GETADMISSIONS="TBIService.getAdmissions";
	public static final String TBISVC_GETCLINICS="TBIService.getClinics";	
	public static final String TBISVC_GETCONSULTSFORPATIENT = "TbiSvc.getConsultsForPatient";
	public static final String TBISVC_GETLOCATIONS = "TbiSvc.getLocations";
	public static final String TBISVC_GETNOTETEXT = "TbiSvc.getNoteText";
	public static final String TBISVC_GETNOTETITLES = "TbiSvc.getNoteTitles";
	public static final String TBISVC_GETPATIENTSBYWARD = "TbiSvc.getPatientsByWard";
	public static final String TBISVC_GETPATIENTSBYCLINIC = "TbiSvc.getPatientsByClinic";
	public static final String TBISVC_GETVISITS="TBIService.getVisits";	
	public static final String TBISVC_GETWARDS="TBIService.getWards";
	public static final String TBISVC_ISCONSULTNOTE="TBIService.isConsultNote";
	public static final String TBISVC_ISCOSIGNERREQUIRED="TBIService.isCosignerRequired";	
	public static final String TBISVC_ISONEVISITNOTE="TBIService.isOneVisitNote";
	public static final String TBISVC_ISSURGERYNOTE="TBIService.isSurgeryNote";	
	public static final String TBISVC_ISPRFNOTE="TBIService.isPrfNote";	
	public static final String TBISVC_LOGIN="TBIService.login";
	public static final String TBISVC_SIGNNOTE = "TBIService.signNote";
	public static final String TBISVC_WRITENOTE="TBIService.writeNote";
	public static final String TBISVC_CLOSENOTE = "TBIService.closeNote";
	
	//VistaDataService
	public static final String VISTADATASERVICE_GETPATIENTALLERGIES = "VistaDataService.getPatientAllergies";
	public static final String VISTADATASERVICE_LOGIN="VistaDataService.login";
	
	//TestService
	public static final String TESTSERVICE_EXECUTE_RPC_AS_PROXY="TestService.executeRpcAsProxy";
	public static final String TESTSERVICE_EXECUTE_RPC_AS_USER="TestService.executeRpcAsUser";
	
	
	
	
}
