package gov.va.med.via.response;

import gov.va.med.via.databeans.AdhocHealthSummary;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.util.StringUtil;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AdhocHealthSummaryDataBeanParser extends BaseDataBeanParser {

	@Override
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId,
			String webMethodName, VistaLinkCommand vistaLinkCommand) {
		// TODO Auto-generated method stub
		
		AdhocHealthSummary adhocHealthSummary = toAdhocHealthSummary(response, queryBean);
		String summaryText = getAdhocHealthSummaryText(dfn, adhocHealthSummary, vistaLinkCommand);
		
		Text text = new Text(summaryText);
		List<DataBean> databeans = new ArrayList<DataBean>();
		databeans.add(text);
		return databeans;
	}
	
	
	private String getAdhocHealthSummaryText(String dfn, AdhocHealthSummary adhocHealthSummary, VistaLinkCommand vistaLinkCommand) {
		String adhocHealthSummaryText = null;
		
		if(adhocHealthSummary != null){
			
			String ien = adhocHealthSummary.getId();
			String title = adhocHealthSummary.getTitle();
			Map<String,String>paramsMap = new HashMap<String, String>();
			paramsMap.put("1", ien + "^^^"+title+"^^^");
		
			adhocHealthSummaryText = vistaLinkCommand.executeRpc(RpcNameConstants.ORWRP2_HS_REPORT_TEXT, paramsMap, dfn);
		}
		return adhocHealthSummaryText;
	}
	

	protected AdhocHealthSummary toAdhocHealthSummary(String response, QueryBean queryBean)
    {	
		 AdhocHealthSummary result = null;
		 String displayName = queryBean.getName();
		 if (StringUtil.isNullOrEmpty(response) || StringUtil.isNullOrEmpty(displayName))
         {
             return result;
         }
		 
		 //check end of line characters - standardize to linux format
	     response = RPCStringUtils.replaceEndofLineCharacters(response);
	        
         String[] lines = StringUtil.split(response, RPCStringUtils.CRLF);
         lines = StringUtil.trimArray(lines);
         for (int i = 0; i < lines.length; i++)
         {
             String[] flds = RPCStringUtils.split(lines[i], RPCStringUtils.CARET);
             if (displayName.equalsIgnoreCase(flds[1]))
             {
                 result = new AdhocHealthSummary();
                 result.setId(flds[0]);
                 result.setTitle(flds[4]);  
             }
             if(result != null){
            	 break;
             }
         }
         return result;

    }

}
