package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * This class parses the response from the RPC ORWCV DTLVST into DataBeans
 * @author DOMAINALLURS
 */
public class AppointmentTextDataBeanParser extends BaseDataBeanParser {
	
	@Override
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand){		
		List<DataBean> list = Arrays.asList((DataBean[])toTextTO(response));
		return list;
	}
	
	/**
	 * Parses the RPC ORWCV DTLVST and populates an array of DataBean objects
	 * @param response - The response from RPC ORWCV DTLVST
	 * @return an array of Text DataBeans populated from the content stored in the RPC response string
	 */
	protected Text[] toTextTO(String response)
    {        
		if (response.equals("")) {
            return new Text[0];
        }		
		ArrayList<Text> lst = new ArrayList<Text>();
		Text text = new Text();
		text.setText(response);
		lst.add(text);
		Text[] array =  (Text[])lst.toArray(new Text[lst.size()]);
        return array;
    }	
}
