package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


/**
 * Parser for the RPC ORQQCN DETAIL.
 * @author ZZZZZZAPOSTI
 *
 */
public class ConsultNoteParser extends BaseDataBeanParser {
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	@Override
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand){		
		List<DataBean> list = Arrays.asList((DataBean[])toTextTO(response));
		return list;
	}
	
	/**
	 * Parses the RPC ORQQCN DETAIL and populates an array of DataBean objects
	 * @param response - The response from RPC ORQQCN DETAIL
	 * @return an array of Text DataBeans populated from the content stored in the RPC response string
	 */
	protected Text[] toTextTO(String response)
    {        
		if (RPCStringUtils.isNullOrEmpty(response)) {
            return new Text[0];
		}
		
		response = RPCStringUtils.replaceEndofLineCharacters(response);
		response = response.replace(RPCStringUtils.CRLF, " ");
		
		ArrayList<Text> lst = new ArrayList<Text>();
		Text text = new Text();
		text.setText(response);
		lst.add(text);
		Text[] array =  (Text[])lst.toArray(new Text[lst.size()]);
        return array;
    }	
}
