package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.List;

/**
 * Interface the exposes the population/pasing of RPC requests into DataBeans
 * 
 * @author ZZZZZZTALBOM
 *
 */
public interface DataBeanParser {

	/**
	 * Method parses an RPC response into a Set of DataBeans
	 * 
	 * @param response	RPC response String
	 * @param queryBean QueryBean contains provider/patient/query content for additional Vista Rpc calls needed for additional databean values
	 * @param dfn		Patient owner of databean records
	 * @param siteId	Facility Site Id / Code where records were obtained
	 * @param webMethodName The name of the web method that invoked this data parser. 
	 * @param vistaLinkCommand 	Command object that allows access with to subsequent RPC calls need to populate children and additional data not returned from primary RPC
	 * @return	List of DataBean objects populated from the RPC response String
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand);
}
