package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.HospitalLocation;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.List;

public class HospitalLocationsParser extends BaseDataBeanParser
{
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return toHospitalLocationArray(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand);
	}

	/**
	 * To text.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return 
	 */
	protected List<DataBean> toHospitalLocationArray(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		List<DataBean> hospitalLocations = new ArrayList<DataBean>();		
		if (response == "")
		{
			return hospitalLocations;
		}
		
		String[] lines = response.split("\\n");
		for ( String line: lines)
		{
			line = line.trim();
			String[] fields = line.split("\\^");
			if ( fields.length<2) continue;
			hospitalLocations.add(new HospitalLocation(fields[0],fields[1]));
		}
		return hospitalLocations;		
	}
}
