package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.Arrays;
import java.util.List;

public class IsValidEsigParser extends BaseDataBeanParser
{
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toTextTO(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand));
	}
	
	/**
	 * To text.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return 
	 */
	protected Text[] toTextTO(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		Text text = new Text();
		
        if (response == null|| response.equals("")) 
        {
        	text.setFault(new Fault("Cannot retrieve text using the information provided."));        	
        }
        else
        {
        	/// if response ="1", true
        	/// o/w false
        	if ( response.trim().equals("1"))
        	{
        		text.setText("TRUE");        		
        	}
        	else
        	{
        		text.setText("FALSE");
        	}        	
        }
        return new Text[]{text};
	}
}
