package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * This class parses the response from the Issue Confidentiality Bulletin RPC DG SENSITIVE RECORD BULLETIN call into DataBeans
 * @author DOMAINALLURS
 *
 */
public class IssueConfidentialityBulletinDataBeanParser extends BaseDataBeanParser {
	
	@Override
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand){		
		List<DataBean> list = Arrays.asList((DataBean[])toText(response, dfn, siteId));
		return list;
	}
	
	/**
	 * Parses the Issue Confidentiality Bulletin RPC and populates an array of DataBean objects
	 * @param response - The response from RPC  DG SENSITIVE RECORD BULLETIN
	 * @param dfn - the dfn
	 * @return an array of Text DataBeans populated from the content stored in the RPC response string
	 */
	protected Text[] toText(String response, String dfn, String siteId)
    {
        
		if (response.equals("")) {
            return new Text[0];
        }
        
        //check end of line characters - standardize to linux format
        response = RPCStringUtils.replaceEndofLineCharacters(response);       

        String message = "";
        if ( response.compareTo("1")== 0){
        	message = "Sent";
        }else{
        	message = "Unable to send sensitivity bulletin: " + response;
        }
        ArrayList<Text> lst = new ArrayList<Text>();
        Text text = new Text();
        text.setTag(siteId);
        text.setText(message);
        lst.add(text);
        
        Text[] array =  (Text[])lst.toArray(new Text[lst.size()]);
        return array;
    }	
}
