package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.LabTest;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedHashMap;
import java.util.List;

public class LabTestsDataBeanParser extends BaseDataBeanParser
{
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toLabTest(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand));
	}
	
	/**
	 * To text.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return 
	 */
	protected LabTest[] toLabTest(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		List<LabTest> responseArray = new ArrayList<LabTest>();
		LabTest labTest = new LabTest();
		
        if (response == null|| response.equals("")) 
        {
        	labTest.setFault(new Fault("Cannot retrieve data using the information provided."));
        	responseArray.add(labTest);
        }
        else
        {
        	response = RPCStringUtils.replaceEndofLineCharacters(response);
        	String[] lines = RPCStringUtils.split(response, RPCStringUtils.CRLF);
        	
        	for (int i= 0; i < lines.length; i++)
        	{
        		if (lines[i].equals("")) continue;
        		
        		String[] fields = RPCStringUtils.split(lines[i], RPCStringUtils.CARET);
        		
        		if (fields == null || fields.length != 2) continue;
        		
        		labTest = new LabTest(lines[i], fields[1]);
        		responseArray.add(labTest);
        	}
        }                
        
        return responseArray.toArray(new LabTest[0]);
	}
}
