package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.MentalHealthInstrumentResultSet;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.rpc.KeyValuePair;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

// TODO: Auto-generated Javadoc
/**
 * The Class MentalHealthInstrumentResultSetParser.
 * 
 * @author DOMAINROMERJ
 */
public class MentalHealthInstrumentResultSetParser extends BaseDataBeanParser
{
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toMentalHealthInstrumentResultSet(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand));
	}
	
	/**
	 * To text.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return the mental health instrument result set[]
	 */
	protected MentalHealthInstrumentResultSet[] toMentalHealthInstrumentResultSet(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		List<MentalHealthInstrumentResultSet> responseArray = new ArrayList<MentalHealthInstrumentResultSet>();
		MentalHealthInstrumentResultSet mentalHealthInstrumentResultSet = new MentalHealthInstrumentResultSet();
		
        if (response == null || response.length() == 0 || response.equals("[Data]\n") || response.equals("[Data]")) 
        {
        	mentalHealthInstrumentResultSet.setFault(new Fault("Cannot retrieve text using the information provided."));
            responseArray.add(mentalHealthInstrumentResultSet);
        }
        else
        {
        	response = RPCStringUtils.replaceEndofLineCharacters(response);
        	String[] lines = RPCStringUtils.split(response, RPCStringUtils.CRLF);
        	
        	for (int i= 0; i < lines.length; i++)
        	{
        		if (lines[i].equals("") || "[Data]".equals(lines[i])) continue;
        		
	    		String[] fields = RPCStringUtils.split(lines[i], RPCStringUtils.CARET);
	    		mentalHealthInstrumentResultSet.setId(fields[0]);
	    		mentalHealthInstrumentResultSet.setScale(fields.length > 1? new KeyValuePair<String,String>("", fields[1]): null);
	    		mentalHealthInstrumentResultSet.setRawScore(fields.length > 2? fields[2]: null);
	    		
	    		HashMap<String,String> scores = new HashMap<String,String>();
	    		if (fields.length > 3)
	    		{
	    			scores.put("1", fields[3]);
	    		}
	    		if (fields.length > 4)
	    		{
	    			scores.put("2", fields[4]);
	    		}
	    		if (fields.length > 5)
	    		{
	    			scores.put("3", fields[5]);
	    		}
	    		mentalHealthInstrumentResultSet.setTransformedScores(scores);
	    		responseArray.add(mentalHealthInstrumentResultSet);
        	}
        }        
	
        return responseArray.toArray(new MentalHealthInstrumentResultSet[0]);
	}
}
