package gov.va.med.via.response;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.request.ViaWebMethodNameConstants;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

// TODO: Auto-generated Javadoc
/**
 * The Class NoteTypeQuestionsDataParser.
 * 
 * @author DOMAINROMERJ
 */
public class NoteTypeQuestionsDataParser extends BaseDataBeanParser
{
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toNoteTypeResponse(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand));
	}
	
	/**
	 * To note type response.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return the text[]
	 */
	protected Text[] toNoteTypeResponse(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		List<Text> responseArray = new ArrayList<Text>();
		Text text = new Text();
		
        if (response == null|| response.equals("")) 
        {
        	text.setFault(new Fault("Cannot retrieve note using the noteDefinitionIEN provided"));
        }
        else
        {
        	response = RPCStringUtils.replaceEndofLineCharacters(response);        
        	String[] fields = RPCStringUtils.split(response, RPCStringUtils.CRLF);
        	List<String> textArray = new ArrayList<String>();		
        
        	text.setText(fields[0].equals("1") ? "Y" : "N");
        	        	
        	if (ViaWebMethodNameConstants.TBISVC_ISSURGERYNOTE.compareTo(webMethodName) == 0)
        	{
        		textArray.add(fields[0].equals("1") ? "Cannot create new surgery note at this time" : "");
        	}
        	else if (ViaWebMethodNameConstants.TBISVC_ISONEVISITNOTE.compareTo(webMethodName) == 0)
        	{
        		textArray.add(fields[0].equals("1") ? "There is already a note for this visit." +
        				"Only ONE record of this type per Visit is allowed. You can addend the existing record.": "");
        	}
        	
        	if (textArray.size() > 0)
        	{
        		text.setTextArray(textArray.toArray(new String[0]));
        	}
        }
        responseArray.add(text);
        return responseArray.toArray(new Text[0]);
	}
}
