package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Patient;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.util.VistaTimestamp;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

// if the same for match and select -> separate rpc calls... maybe send in the method name to populate extra rpcs
/**
 * The Class PatientDataBeanParser.
 * 
 */
public class PatientMatchDataBeanParser extends BaseDataBeanParser 
{    
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toPatients(response));
	}

	protected Patient[] toPatients(String response)
    {
        if (response.equals(""))
        {
            return new Patient[0];
        }
        
        //check end of line characters - standardize to linux format
        response = RPCStringUtils.replaceEndofLineCharacters(response);
        
        String[] lines = RPCStringUtils.split(response, RPCStringUtils.CRLF);
        ArrayList<Patient> lst = new ArrayList<Patient>();
 
    
        for (int i = 0; i < lines.length; i++)
        {
            if (lines[i].equals(""))
            {
                continue;
            }
            Patient rec = new Patient();
            String[] flds = RPCStringUtils.split(lines[i], RPCStringUtils.CARET);
            rec.setLocalPid(flds[0]);
            rec.setName(flds[1]);
            if ( flds[2]!= null ){
            	rec.setDob(VistaTimestamp.toUtcString(flds[2]));
            }
            rec.setSsn(flds[3]);
            if (rec != null)
            {
                lst.add(rec);
            }
        }
		Patient[] array =  (Patient[])lst.toArray(new Patient[lst.size()]);
        return array;
    }


}