package gov.va.med.via.response;

import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.rpc.RpcNameConstants;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

public class ReportDelegate
{
	
	/** The vista link command. */
	private VistaLinkCommand vistaLinkCommand;

	public ReportDelegate(VistaLinkCommand vistaLinkCommand)
	{
		this.vistaLinkCommand = vistaLinkCommand;
	}
	
	/**
	 * Adds the patient id info (patient type, room, bed) from Vista to the patient instance.
	 * 
	 * @param the patient to be updated with the room and bed data
	 * 
	 * @return patient's type, room and bed attributes populated if successful.
	 */
	public String getReportText(String dfn, String ien, String type)
	{		
		if (RPCStringUtils.isNullOrEmpty(dfn) || 
			RPCStringUtils.isNullOrEmpty(ien) ||
			RPCStringUtils.isNullOrEmpty(type)) 
		{
			return "";
		}

		return vistaLinkCommand.executeRpc(RpcNameConstants.ORWRP_REPORT_TEXT, dfn, type,"","",ien,"0","0");    	
	}
}
