package gov.va.med.via.response;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.QueryBean;
import gov.va.med.via.databeans.SurgeryReport;
import gov.va.med.via.databeans.Text;
import gov.va.med.via.request.ViaWebMethodNameConstants;
import gov.va.med.via.rpc.RPCStringUtils;
import gov.va.med.via.vistalink.command.VistaLinkCommand;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

// TODO: Auto-generated Javadoc
/**
 * The Class TextDataBeanParser.
 * 
 * @author DOMAINROMERJ
 */
public class TextDataBeanParser extends BaseDataBeanParser
{
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.response.BaseDataBeanParser#populateDataBeans(java.lang.String, gov.va.med.via.databeans.QueryBean, java.lang.String, java.lang.String, java.lang.String, gov.va.med.via.vistalink.command.VistaLinkCommand)
	 */
	public List<DataBean> populateDataBeans(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{				
		return Arrays.asList((DataBean[])toText(response, queryBean, dfn, siteId, webMethodName, vistaLinkCommand));
	}
	
	/**
	 * To text.
	 *
	 * @param response the response
	 * @param queryBean the query bean
	 * @param dfn the dfn
	 * @param siteId the site id
	 * @param webMethodName the web method name
	 * @param vistaLinkCommand the vista link command
	 * @return the text[]
	 */
	protected Text[] toText(String response, QueryBean queryBean, String dfn, String siteId, String webMethodName, VistaLinkCommand vistaLinkCommand)
	{
		List<Text> responseArray = new ArrayList<Text>();
		Text text = new Text();
		
        if (response == null|| response.equals("")) 
        {
        	text.setFault(new Fault("Cannot retrieve text using the information provided."));
        	responseArray.add(text);
        }
        // These method calls return code/description values
        else if ((ViaWebMethodNameConstants.EMRSVC_GETTEAMS.compareTo(webMethodName) == 0) ||
        		  ViaWebMethodNameConstants.EMRSVC_GETSPECIALTIES.compareTo(webMethodName) == 0)
        {
        	response = RPCStringUtils.replaceEndofLineCharacters(response);
        	String[] lines = RPCStringUtils.split(response, RPCStringUtils.CRLF);        	
        	for (int i=0; i < lines.length; i++)
        	{
        		String[] fields = RPCStringUtils.split(lines[i], RPCStringUtils.CARET);
        		if (fields!= null && fields.length > 1)
        		{
        			text = new Text(fields[1], fields[0]);
        			responseArray.add(text);
        		}
        		
        	}
        }
        else // The default is all the calls that return 1 value only, a text value
        {
        	response = RPCStringUtils.replaceEndofLineCharacters(response);
        	response = response.replace(RPCStringUtils.CRLF, " ");
        	text = new Text(response);
        	responseArray.add(text);
        }        
                
        return responseArray.toArray(new Text[0]);
	}
}
