

package gov.va.med.via.transaction;


import java.util.List;

import commonj.work.Work;
import commonj.work.WorkException;
import commonj.work.WorkItem;
import commonj.work.WorkManager;


/**
 * Implementing class of the VIA ReadRpcWorkManager interface.  Class implments thread management and delegates functionality to an injected commonj WorkManager that hooks into the WorkManagement framework in Weblogic
 * 
 * @author ZZZZZZTALBOM
 *
 */
public class ViaWorkManagerScheduler
    implements
        ReadRpcWorkManager
{
    private WorkManager workManager;


    /* (non-Javadoc)
     * @see gov.va.med.via.transaction.ReadRpcWorkManager#schedule(commonj.work.Work)
     */
    public WorkItem schedule( Work work )
        throws WorkException
    {
        WorkItem workItem = null;
        workItem = workManager.schedule( work );

        return workItem;
    }
    

    /* (non-Javadoc)
     * @see gov.va.med.via.transaction.ReadRpcWorkManager#waitForAll(java.util.List)
     */
    public boolean waitForAll( List<? extends WorkItem> workItems )
        throws WorkException
    {
        return waitForAll( workItems, WorkManager.INDEFINITE );
    }


    /* (non-Javadoc)
     * @see gov.va.med.via.transaction.ReadRpcWorkManager#waitForAll(java.util.List, long)
     */
    public boolean waitForAll( List<? extends WorkItem> jobs, long timeout )
        throws WorkException
    {
        try
        {
            workManager.waitForAll( jobs, timeout );
        }
        catch ( InterruptedException e )
        {
            throw new WorkException( "Work interrupted.", e );
        }
        
        return false;
    }


    /**
     * Setter that injects a commonj WorkManager that this class delegates thread management functionality
     * 
     * @param workManager
     */
    public void setWorkManager( WorkManager workManager )
    {
        this.workManager = workManager;
    }
}
