/**
 * 
 */
package gov.va.med.via.vistalink;

import gov.va.med.exception.FoundationsException;
import gov.va.med.vistalink.adapter.cci.VistaLinkConnection;
import gov.va.med.vistalink.adapter.cci.VistaLinkConnectionFactory;
import gov.va.med.vistalink.adapter.cci.VistaLinkVpidConnectionSpec;
import gov.va.med.vistalink.adapter.record.VistaLinkFaultException;
import gov.va.med.vistalink.institution.InstitutionMappingDelegate;
import gov.va.med.vistalink.rpc.RpcRequest;
import gov.va.med.vistalink.rpc.RpcRequestFactory;
import gov.va.med.vistalink.rpc.RpcResponse;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.resource.ResourceException;

/**
 * Temp smoke testing class - not intended to be used by VIA framework - ConnectionFactoryLocator to be used instead.
 *
 */
public class VistaLinkFindConnection
{
    
    public void findVistaConnection() 
    {

    	VistaLinkConnection myConnection = null;
    	String results = null;
    	String division="500";//523A"; // ordinarily get from KAAJEE, FatKAAT, etc.
    	String vpid = "0000002987654321V654321000000"; // ditto

    	try {
    		Context ic = new InitialContext();
    	for ( Object key: ic.getEnvironment().keySet())
    	{
    		System.out.println("obj: " + key + "="+ ic.getEnvironment().get(key));
    	}
    	String jndiName="vistalink/500";	
    	
    	for ( Object o: InstitutionMappingDelegate.getVistaLinkMappedStationNumberSet())
    	{
    		System.out.println("vistalink object=" + o);
    	}
    	
    	jndiName = InstitutionMappingDelegate.
    	getJndiConnectorNameForInstitution(division);
    	
    	for ( Object o: InstitutionMappingDelegate.getVistaLinkMappedStationNumberSet())
    	{
    		System.out.println("object=" + o);
    	}
    			
    	
   		VistaLinkConnectionFactory cf = (VistaLinkConnectionFactory)ic.lookup(jndiName);
    	VistaLinkVpidConnectionSpec connSpec = new 
    	VistaLinkVpidConnectionSpec(division, vpid);
    		myConnection = (VistaLinkConnection) cf.getConnection(connSpec);
    		myConnection.setTimeOut(10000); // set 10 second socket timeout

    		RpcRequest vReq = RpcRequestFactory.getRpcRequest();
    		vReq.setUseProprietaryMessageFormat(true);
    		vReq.setRpcName("XOBV TEST PING");
    		vReq.setRpcContext("XOBV VISTALINK TESTER");
    		RpcResponse vResp = myConnection.executeRPC(vReq);
    		results = vResp.getResults();
    		System.out.println("** VISTALINK RESULTS:" + results);
    	} 
    	catch (VistaLinkFaultException e) 
    	{
    		System.out.println("FAILURE: " + e);
    		
    	} 
    	catch (NamingException e) 
    	{
    		System.out.println("FAILURE: " + e);
    	} 
    	catch (ResourceException e) 
    	{
    		System.out.println("FAILURE: " + e);
    	} 
    	catch (FoundationsException e) 
    	{
    		System.out.println("FAILURE: " + e);
    	} 
    	finally 
    	{
    		if (myConnection != null) {
    			try {
    				myConnection.close();
    			} catch (ResourceException e) {
    				// ...
    			}
    		}
    	}

    	
    }



}
