package gov.va.med.via.vistalink.command;

import java.util.ArrayList;
import java.util.List;

public abstract class AbstractBaseVistaLinkCommand implements VistaLinkCommand {
	
	protected String targetSiteCode;
	protected String rpcContext;
	
	@Override
	public void setTargetSiteCode(String targetSiteCode) {
		this.targetSiteCode = targetSiteCode;
	}

	public AbstractBaseVistaLinkCommand(String targetSiteCode, String rpcContext) {
		super();
		this.targetSiteCode = targetSiteCode;
		this.rpcContext = rpcContext;
	}

	@Override
	public void setPermissionContext(String context) {
		this.rpcContext = context;
	}

	@Override
	public abstract String executeRpc(String rpcName);
		
	@Override
	public abstract String executeRpc(String rpcName, Object... params);

	@Override
	public abstract String executeRpc(String rpcName, List<Object> params) ;
	
	protected List<Object> createParameterList(Object... params) {
		List<Object> paramList = new ArrayList<Object>();
		for (Object param : params) {
			paramList.add(param);
		}

		return paramList;
	}
}
