package gov.va.med.via.vistalink.command;

import gov.va.med.via.vistalink.VistaRpcAppProxyTemplate;

/**
 * Application Proxy type of VistaLinkTemplate command object - restricts usage of a VistaLinkTemplate to application proxy specific methods/calls
 * 
 * @author ZZZZZZTALBOM
 *
 */
public interface VistaLinkAppProxyCommand extends VistaLinkCommand{
	
	/**
	 * Sets the app proxy name
	 * 
	 * @param appProxyName - String name of the application proxy
	 */
	public void setAppProxyName(String appProxyName);
	
	/**
	 * Sets an instance type of VistaLinkTemplate for this type of command interface
	 * 
	 * @param vistaLinkTemplate - the type of VistaLinkTemplate this command will interface with
	 */
	public void setVistaRpcAppProxyTemplate(VistaRpcAppProxyTemplate vistaLinkTemplate);

}
