package gov.va.med.via.vistalink.command;

import gov.va.med.via.vistalink.VistaRpcAppProxyTemplate;

import java.util.List;

/**
 * Implementation of VistaLinkAppProxyCommand
 * 
 * @see VistaLinkAppProxyCommand
 * 
 * @author ZZZZZZTALBOM
 *
 */
public class VistaLinkAppProxyCommandImpl extends AbstractBaseVistaLinkCommand implements VistaLinkAppProxyCommand {
	
	private VistaRpcAppProxyTemplate vistaLinkTemplate;
	private String appProxyName;

	
	
	public VistaLinkAppProxyCommandImpl(String targetSiteCode, String rpcContext, String appProxyName, VistaRpcAppProxyTemplate vistaLinkTemplate) {
		super(targetSiteCode, rpcContext);
		setAppProxyName(appProxyName);
		setVistaRpcAppProxyTemplate(vistaLinkTemplate);
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String)
	 */
	@Override
	public String executeRpc(String rpcName) {
		return vistaLinkTemplate.callRpcAsApplication(this.targetSiteCode, this.appProxyName, this.rpcContext, rpcName);
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String, java.lang.Object[])
	 */
	@Override
	public String executeRpc(String rpcName, Object... params) {
		return executeRpc(rpcName, createParameterList(params));
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String, java.util.List)
	 */
	@Override
	public String executeRpc(String rpcName, List<Object> params) {
		return vistaLinkTemplate.callRpcAsApplication(this.targetSiteCode, this.appProxyName, this.rpcContext, rpcName, params);
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.VistaLinkAppProxyCommand#setAppProxyName(java.lang.String)
	 */
	@Override
	public void setAppProxyName(String appProxyName) {
		this.appProxyName = appProxyName;		
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.VistaLinkAppProxyCommand#setVistaRpcAppProxyTemplate(gov.va.med.via.vistalink.VistaRpcAppProxyTemplate)
	 */
	@Override
	public void setVistaRpcAppProxyTemplate(VistaRpcAppProxyTemplate vistaLinkTemplate) {
		this.vistaLinkTemplate = vistaLinkTemplate;	
	}
	
	

}
