package gov.va.med.via.vistalink.command;

import gov.va.med.via.vistalink.VistaRpcUserDuzTemplate;

import java.util.List;

/**
 * Implementation of a VistaLinkDuzCommand
 * 
 * @see VistaLinkDuzCommand
 * 
 * @author ZZZZZZTALBOM
 *
 */
public class VistaLinkDuzCommandImpl extends AbstractBaseVistaLinkCommand implements VistaLinkDuzCommand{
	
	private VistaRpcUserDuzTemplate vistaLinkTemplate;
	private String userDuz;
	
	public VistaLinkDuzCommandImpl(String targetSiteCode, String rpcContext, String userDuz, VistaRpcUserDuzTemplate vistaLinkTemplate ) {
		super(targetSiteCode, rpcContext);
		setUserDuz(userDuz);
		setVistaRpcUserDuzTemplate(vistaLinkTemplate);	
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String)
	 */
	@Override
	public String executeRpc(String rpcName) {
		return vistaLinkTemplate.callRpcAsUser(this.targetSiteCode, this.userDuz, this.rpcContext, rpcName);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String, java.lang.Object[])
	 */
	@Override
	public String executeRpc(String rpcName, Object... params) {
		return executeRpc(rpcName, createParameterList(params));
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.AbstractBaseVistaLinkCommand#executeRpc(java.lang.String, java.util.List)
	 */
	@Override
	public String executeRpc(String rpcName, List<Object> params) {
		return vistaLinkTemplate.callRpcAsUser(this.targetSiteCode, this.userDuz, this.rpcContext, rpcName, params);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.VistaLinkDuzCommand#setUserDuz(java.lang.String)
	 */
	@Override
	public void setUserDuz(String userDuz) {
		this.userDuz = userDuz;
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.vistalink.command.VistaLinkDuzCommand#setVistaRpcUserDuzTemplate(gov.va.med.via.vistalink.VistaRpcUserDuzTemplate)
	 */
	@Override
	public void setVistaRpcUserDuzTemplate(VistaRpcUserDuzTemplate vistaLinkTemplate) {
		this.vistaLinkTemplate = vistaLinkTemplate;	
	}
	
}
