package gov.va.med.via.dto.common;

import java.text.SimpleDateFormat;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.Adt;
import gov.va.med.via.util.DateTimeUtil;

// TODO: Auto-generated Javadoc
/**
 * The Class AdtTO.
 */
@XmlRootElement(name="AdtTO")
@XmlAccessorType(XmlAccessType.NONE)
public class AdtTO extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The patient. */
	@XmlElement(name="patient")
    protected PatientTO patient;
    
    /** The check in id. */
	@XmlElement(name="checkInId")
    protected String checkInId;
    
    /** The check out id. */
	@XmlElement(name="checkOutId")
    protected String checkOutId;
    
    /** The related physical movement id. */
	@XmlElement(name="relatedPhysicalMovementId")
    protected String relatedPhysicalMovementId;
    
    /** The transaction. */
	@XmlElement(name="transaction")
    protected String transaction;
    
    /** The movement type. */
	@XmlElement(name="movementType")
    protected String movementType;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The diagnosis. */
	@XmlElement(name="diagnosis")
    protected String diagnosis;
    
    /** The assigned location. */
	@XmlElement(name="assignedLocation")
    protected HospitalLocationTO assignedLocation;
    
    /** The provider. */
	@XmlElement(name="provider")
    protected UserTO provider;
    
    /** The attending. */
	@XmlElement(name="attending")
    protected UserTO attending;
    
    /** The transfer facility. */
	@XmlElement(name="transferFacility")
    protected String transferFacility;
    
    /** The specialty. */
	@XmlElement(name="specialty")
    protected TaggedText specialty;
    
    /** The patient tx id. */
	@XmlElement(name="patientTxId")
    protected String patientTxId;
    
    /** The visit id. */
	@XmlElement(name="visitId")
    protected String visitId;
    
    /** The patient movement number. */
	@XmlElement(name="patientMovementNumber")
    protected String patientMovementNumber;
    
    /** The next patient movement. */
	@XmlElement(name="nextPatientMovement")
    protected String nextPatientMovement;
    
    /** The entered by. */
	@XmlElement(name="enteredBy")
    protected UserTO enteredBy;
    
    /** The length of stay. */
	@XmlElement(name="lengthOfStay")
    protected String lengthOfStay;
    
    /** The pass days. */
	@XmlElement(name="passDays")
    protected String passDays;
    
    /** The days absent. */
	@XmlElement(name="daysAbsent")
    protected String daysAbsent;
    
    /** The asih admission. */
	@XmlElement(name="asihAdmission")
    protected TaggedText asihAdmission;
    
    /** The asih transfer. */
	@XmlElement(name="asihTransfer")
    protected String asihTransfer;
    
    /** The asih sequence. */
	@XmlElement(name="asihSequence")
    protected String asihSequence;
    
    /** The asih days. */
	@XmlElement(name="asihDays")
    protected String asihDays;
    
    /** The absence return date. */
	@XmlElement(name="absenceReturnDate")
    protected String absenceReturnDate;
    
    /** The admitted for sc condition. */
	@XmlElement(name="admittedForScCondition")
    protected boolean admittedForScCondition;
    
    /** The scheduled admission. */
	@XmlElement(name="scheduledAdmission")
    protected boolean scheduledAdmission;
    
    /** The admission source. */
	@XmlElement(name="admissionSource")
    protected String admissionSource;
    
    /** The admitting category. */
	@XmlElement(name="admittingCategory")
    protected String admittingCategory;
    
    /** The admitting regulation. */
	@XmlElement(name="admittingRegulation")
    protected TaggedText admittingRegulation;
    
    /** The admitting eligibility. */
	@XmlElement(name="admittingEligibility")
    protected TaggedText admittingEligibility;
    
    /** The mas movement type. */
	@XmlElement(name="masMovementType")
    protected TaggedText masMovementType;
    
    /** The lodging reason. */
	@XmlElement(name="lodgingReason")
    protected String lodgingReason;
    
    /** The lodging comments. */
	@XmlElement(name="lodgingComments")
    protected String lodgingComments;
    
    /** The disposition. */
	@XmlElement(name="disposition")
    protected String disposition;
    
    /** The eligibility. */
	@XmlElement(name="eligibility")
    protected String eligibility;
    
    /** The pre admit id. */
	@XmlElement(name="preAdmitId")
    protected String preAdmitId;
    
    /** The referring. */
	@XmlElement(name="referring")
    protected UserTO referring;
    
    /** The consulting. */
	@XmlElement(name="consulting")
    protected UserTO consulting;
    
    /** The admitting. */
	@XmlElement(name="admitting")
    protected UserTO admitting;
    
    /** The service. */
	@XmlElement(name="service")
    protected TaggedText service;
    
    /** The prior location. */
	@XmlElement(name="priorLocation")
    protected HospitalLocationTO priorLocation;
    
    /** The temporary location. */
	@XmlElement(name="temporaryLocation")
    protected HospitalLocationTO temporaryLocation;
    
    /** The pending location. */
	@XmlElement(name="pendingLocation")
    protected HospitalLocationTO pendingLocation;
    
    /** The patient type. */
	@XmlElement(name="patientType")
    protected String patientType;
    
    /** The admit timestamp. */
	@XmlElement(name="admitTimestamp")
    protected String admitTimestamp;
    
    /** The discharge timestamp. */
	@XmlElement(name="dischargeTimestamp")
    protected String dischargeTimestamp;
    
    /** The admit reason. */
	@XmlElement(name="admitReason")
    protected String admitReason;
    
    /** The transfer reason. */
	@XmlElement(name="transferReason")
    protected String transferReason;
    
    /**
     * Instantiates a new adt to.
     */
    public AdtTO()
    {    	
    }
    
    /**
     * Instantiates a new adt to.
     *
     * @param adt the adt
     */
    public AdtTO(Adt adt)
    {
        if (adt == null)
        {
            return;
        }
        if ( adt.getFault()!=null ){
			this.setFault(new FaultTO(adt.getFault()));
		}
		else
		{        
	        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(DateTimeUtil.FORMAT_DATE_TIME);        
	        this.id = adt.getId();
	        this.patient = adt.getPatient() != null? new PatientTO(adt.getPatient()): null;
	        this.checkInId = adt.getCheckInId();
	        this.checkOutId = adt.getCheckOutId();
	        this.relatedPhysicalMovementId = adt.getRelatedPhysicalMovementId();
	        this.transaction = adt.getTransaction();
	        this.movementType = adt.getMovementType();
	       	this.timestamp = adt.getTimestamp() != null? simpleDateFormat.format(adt.getTimestamp().getTime()): null;
	        this.diagnosis = adt.getDiagnosis();
	        this.assignedLocation = adt.getAssignedLocation() != null? new HospitalLocationTO(adt.getAssignedLocation()): null;
	        this.provider = adt.getProvider() != null? new UserTO(adt.getProvider()) : null;
	        this.attending = adt.getAttending() != null? new UserTO(adt.getAttending()) : null;
	        this.transferFacility = adt.getTransferFacility();
	        this.specialty = adt.getSpecialty() != null? new TaggedText(adt.getSpecialty()): null;
	        this.patientTxId = adt.getPatientTxId();
	        this.visitId = adt.getVisitId();
	        this.patientMovementNumber = adt.getPatientMovementNumber();
	        this.nextPatientMovement = adt.getNextPatientMovement();
	        this.enteredBy = new UserTO(adt.getEnteredBy());
	        this.lengthOfStay = adt.getLengthOfStay();
	        this.passDays = adt.getPassDays();
	        this.daysAbsent = adt.getDaysAbsent();
	        this.asihAdmission = adt.getAsihAdmission() != null? new TaggedText(adt.getAsihAdmission()): null;
	        this.asihTransfer = adt.getAsihTransfer();
	        this.asihSequence = adt.getAsihSequence();
	        this.asihDays = adt.getAsihDays();
	        this.absenceReturnDate = adt.getAbsenceReturnDate() != null? simpleDateFormat.format(adt.getAbsenceReturnDate().getTime()) : null;
	        this.admittedForScCondition = adt.getAdmittedForScCondition();
	        this.scheduledAdmission = adt.getScheduledAdmission();
	        this.admissionSource = adt.getAdmissionSource();
	        this.admittingCategory = adt.getAdmittingCategory();
	        this.admittingRegulation = adt.getAdmittingRegulation() != null? new TaggedText(adt.getAdmittingRegulation()): null;
	        this.admittingEligibility = adt.getAdmittingEligibility() != null? new TaggedText(adt.getAdmittingEligibility()): null;
	        this.masMovementType = adt.getMasMovementType() != null? new TaggedText(adt.getMasMovementType()): null;
	        this.lodgingReason = adt.getLodgingReason();
	        this.lodgingComments = adt.getLodgingComments();
	        this.disposition = adt.getDisposition();
	        this.eligibility = adt.getEligibility();
	        this.preAdmitId = adt.getPreAdmitId();
	        this.referring = adt.getReferring() != null ? new UserTO(adt.getReferring()): null;
	        this.consulting = adt.getConsulting() != null? new UserTO(adt.getConsulting()): null;
	        this.admitting = adt.getAdmitting() != null? new UserTO(adt.getAdmitting()): null;
	        this.service = adt.getService() != null? new TaggedText(adt.getService()): null;
	        this.priorLocation = adt.getPriorLocation() != null? new HospitalLocationTO(adt.getPriorLocation()): null;
	        this.temporaryLocation = adt.getTemporaryLocation() != null? new HospitalLocationTO(adt.getTemporaryLocation()): null;
	        this.pendingLocation = adt.getPendingLocation() != null? new HospitalLocationTO(adt.getPendingLocation()): null;
	        this.patientType = adt.getPatientType();
	        this.admitTimestamp = adt.getAdmitTimestamp() != null? simpleDateFormat.format(adt.getAdmitTimestamp().getTime()) : null;
	        this.dischargeTimestamp = adt.getDischargeTimestamp() != null? simpleDateFormat.format(adt.getDischargeTimestamp().getTime()) : null;
	        this.admitReason = adt.getAdmitReason();
	        this.transferReason = adt.getTransferReason();
		}
    }
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the patient.
	 *
	 * @return the patient
	 */
	public PatientTO getPatient()
	{
		return patient;
	}
	
	/**
	 * Sets the patient.
	 *
	 * @param patient the new patient
	 */
	public void setPatient(PatientTO patient)
	{
		this.patient = patient;
	}
	
	/**
	 * Gets the check in id.
	 *
	 * @return the check in id
	 */
	public String getCheckInId()
	{
		return checkInId;
	}
	
	/**
	 * Sets the check in id.
	 *
	 * @param checkInId the new check in id
	 */
	public void setCheckInId(String checkInId)
	{
		this.checkInId = checkInId;
	}
	
	/**
	 * Gets the check out id.
	 *
	 * @return the check out id
	 */
	public String getCheckOutId()
	{
		return checkOutId;
	}
	
	/**
	 * Sets the check out id.
	 *
	 * @param checkOutId the new check out id
	 */
	public void setCheckOutId(String checkOutId)
	{
		this.checkOutId = checkOutId;
	}
	
	/**
	 * Gets the related physical movement id.
	 *
	 * @return the related physical movement id
	 */
	public String getRelatedPhysicalMovementId()
	{
		return relatedPhysicalMovementId;
	}
	
	/**
	 * Sets the related physical movement id.
	 *
	 * @param relatedPhysicalMovementId the new related physical movement id
	 */
	public void setRelatedPhysicalMovementId(String relatedPhysicalMovementId)
	{
		this.relatedPhysicalMovementId = relatedPhysicalMovementId;
	}
	
	/**
	 * Gets the transaction.
	 *
	 * @return the transaction
	 */
	public String getTransaction()
	{
		return transaction;
	}
	
	/**
	 * Sets the transaction.
	 *
	 * @param transaction the new transaction
	 */
	public void setTransaction(String transaction)
	{
		this.transaction = transaction;
	}
	
	/**
	 * Gets the movement type.
	 *
	 * @return the movement type
	 */
	public String getMovementType()
	{
		return movementType;
	}
	
	/**
	 * Sets the movement type.
	 *
	 * @param movementType the new movement type
	 */
	public void setMovementType(String movementType)
	{
		this.movementType = movementType;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the diagnosis.
	 *
	 * @return the diagnosis
	 */
	public String getDiagnosis()
	{
		return diagnosis;
	}
	
	/**
	 * Sets the diagnosis.
	 *
	 * @param diagnosis the new diagnosis
	 */
	public void setDiagnosis(String diagnosis)
	{
		this.diagnosis = diagnosis;
	}
	
	/**
	 * Gets the assigned location.
	 *
	 * @return the assigned location
	 */
	public HospitalLocationTO getAssignedLocation()
	{
		return assignedLocation;
	}
	
	/**
	 * Sets the assigned location.
	 *
	 * @param assignedLocation the new assigned location
	 */
	public void setAssignedLocation(HospitalLocationTO assignedLocation)
	{
		this.assignedLocation = assignedLocation;
	}
	
	/**
	 * Gets the provider.
	 *
	 * @return the provider
	 */
	public UserTO getProvider()
	{
		return provider;
	}
	
	/**
	 * Sets the provider.
	 *
	 * @param provider the new provider
	 */
	public void setProvider(UserTO provider)
	{
		this.provider = provider;
	}
	
	/**
	 * Gets the attending.
	 *
	 * @return the attending
	 */
	public UserTO getAttending()
	{
		return attending;
	}
	
	/**
	 * Sets the attending.
	 *
	 * @param attending the new attending
	 */
	public void setAttending(UserTO attending)
	{
		this.attending = attending;
	}
	
	/**
	 * Gets the transfer facility.
	 *
	 * @return the transfer facility
	 */
	public String getTransferFacility()
	{
		return transferFacility;
	}
	
	/**
	 * Sets the transfer facility.
	 *
	 * @param transferFacility the new transfer facility
	 */
	public void setTransferFacility(String transferFacility)
	{
		this.transferFacility = transferFacility;
	}
	
	/**
	 * Gets the specialty.
	 *
	 * @return the specialty
	 */
	public TaggedText getSpecialty()
	{
		return specialty;
	}
	
	/**
	 * Sets the specialty.
	 *
	 * @param specialty the new specialty
	 */
	public void setSpecialty(TaggedText specialty)
	{
		this.specialty = specialty;
	}
	
	/**
	 * Gets the patient tx id.
	 *
	 * @return the patient tx id
	 */
	public String getPatientTxId()
	{
		return patientTxId;
	}
	
	/**
	 * Sets the patient tx id.
	 *
	 * @param patientTxId the new patient tx id
	 */
	public void setPatientTxId(String patientTxId)
	{
		this.patientTxId = patientTxId;
	}
	
	/**
	 * Gets the visit id.
	 *
	 * @return the visit id
	 */
	public String getVisitId()
	{
		return visitId;
	}
	
	/**
	 * Sets the visit id.
	 *
	 * @param visitId the new visit id
	 */
	public void setVisitId(String visitId)
	{
		this.visitId = visitId;
	}
	
	/**
	 * Gets the patient movement number.
	 *
	 * @return the patient movement number
	 */
	public String getPatientMovementNumber()
	{
		return patientMovementNumber;
	}
	
	/**
	 * Sets the patient movement number.
	 *
	 * @param patientMovementNumber the new patient movement number
	 */
	public void setPatientMovementNumber(String patientMovementNumber)
	{
		this.patientMovementNumber = patientMovementNumber;
	}
	
	/**
	 * Gets the next patient movement.
	 *
	 * @return the next patient movement
	 */
	public String getNextPatientMovement()
	{
		return nextPatientMovement;
	}
	
	/**
	 * Sets the next patient movement.
	 *
	 * @param nextPatientMovement the new next patient movement
	 */
	public void setNextPatientMovement(String nextPatientMovement)
	{
		this.nextPatientMovement = nextPatientMovement;
	}
	
	/**
	 * Gets the entered by.
	 *
	 * @return the entered by
	 */
	public UserTO getEnteredBy()
	{
		return enteredBy;
	}
	
	/**
	 * Sets the entered by.
	 *
	 * @param enteredBy the new entered by
	 */
	public void setEnteredBy(UserTO enteredBy)
	{
		this.enteredBy = enteredBy;
	}
	
	/**
	 * Gets the length of stay.
	 *
	 * @return the length of stay
	 */
	public String getLengthOfStay()
	{
		return lengthOfStay;
	}
	
	/**
	 * Sets the length of stay.
	 *
	 * @param lengthOfStay the new length of stay
	 */
	public void setLengthOfStay(String lengthOfStay)
	{
		this.lengthOfStay = lengthOfStay;
	}
	
	/**
	 * Gets the pass days.
	 *
	 * @return the pass days
	 */
	public String getPassDays()
	{
		return passDays;
	}
	
	/**
	 * Sets the pass days.
	 *
	 * @param passDays the new pass days
	 */
	public void setPassDays(String passDays)
	{
		this.passDays = passDays;
	}
	
	/**
	 * Gets the days absent.
	 *
	 * @return the days absent
	 */
	public String getDaysAbsent()
	{
		return daysAbsent;
	}
	
	/**
	 * Sets the days absent.
	 *
	 * @param daysAbsent the new days absent
	 */
	public void setDaysAbsent(String daysAbsent)
	{
		this.daysAbsent = daysAbsent;
	}
	
	/**
	 * Gets the asih admission.
	 *
	 * @return the asih admission
	 */
	public TaggedText getAsihAdmission()
	{
		return asihAdmission;
	}
	
	/**
	 * Sets the asih admission.
	 *
	 * @param asihAdmission the new asih admission
	 */
	public void setAsihAdmission(TaggedText asihAdmission)
	{
		this.asihAdmission = asihAdmission;
	}
	
	/**
	 * Gets the asih transfer.
	 *
	 * @return the asih transfer
	 */
	public String getAsihTransfer()
	{
		return asihTransfer;
	}
	
	/**
	 * Sets the asih transfer.
	 *
	 * @param asihTransfer the new asih transfer
	 */
	public void setAsihTransfer(String asihTransfer)
	{
		this.asihTransfer = asihTransfer;
	}
	
	/**
	 * Gets the asih sequence.
	 *
	 * @return the asih sequence
	 */
	public String getAsihSequence()
	{
		return asihSequence;
	}
	
	/**
	 * Sets the asih sequence.
	 *
	 * @param asihSequence the new asih sequence
	 */
	public void setAsihSequence(String asihSequence)
	{
		this.asihSequence = asihSequence;
	}
	
	/**
	 * Gets the asih days.
	 *
	 * @return the asih days
	 */
	public String getAsihDays()
	{
		return asihDays;
	}
	
	/**
	 * Sets the asih days.
	 *
	 * @param asihDays the new asih days
	 */
	public void setAsihDays(String asihDays)
	{
		this.asihDays = asihDays;
	}
	
	/**
	 * Gets the absence return date.
	 *
	 * @return the absence return date
	 */
	public String getAbsenceReturnDate()
	{
		return absenceReturnDate;
	}
	
	/**
	 * Sets the absence return date.
	 *
	 * @param absenceReturnDate the new absence return date
	 */
	public void setAbsenceReturnDate(String absenceReturnDate)
	{
		this.absenceReturnDate = absenceReturnDate;
	}
	
	/**
	 * Checks if is admitted for sc condition.
	 *
	 * @return true, if is admitted for sc condition
	 */
	public boolean isAdmittedForScCondition()
	{
		return admittedForScCondition;
	}
	
	/**
	 * Sets the admitted for sc condition.
	 *
	 * @param admittedForScCondition the new admitted for sc condition
	 */
	public void setAdmittedForScCondition(boolean admittedForScCondition)
	{
		this.admittedForScCondition = admittedForScCondition;
	}
	
	/**
	 * Checks if is scheduled admission.
	 *
	 * @return true, if is scheduled admission
	 */
	public boolean isScheduledAdmission()
	{
		return scheduledAdmission;
	}
	
	/**
	 * Sets the scheduled admission.
	 *
	 * @param scheduledAdmission the new scheduled admission
	 */
	public void setScheduledAdmission(boolean scheduledAdmission)
	{
		this.scheduledAdmission = scheduledAdmission;
	}
	
	/**
	 * Gets the admission source.
	 *
	 * @return the admission source
	 */
	public String getAdmissionSource()
	{
		return admissionSource;
	}
	
	/**
	 * Sets the admission source.
	 *
	 * @param admissionSource the new admission source
	 */
	public void setAdmissionSource(String admissionSource)
	{
		this.admissionSource = admissionSource;
	}
	
	/**
	 * Gets the admitting category.
	 *
	 * @return the admitting category
	 */
	public String getAdmittingCategory()
	{
		return admittingCategory;
	}
	
	/**
	 * Sets the admitting category.
	 *
	 * @param admittingCategory the new admitting category
	 */
	public void setAdmittingCategory(String admittingCategory)
	{
		this.admittingCategory = admittingCategory;
	}
	
	/**
	 * Gets the admitting regulation.
	 *
	 * @return the admitting regulation
	 */
	public TaggedText getAdmittingRegulation()
	{
		return admittingRegulation;
	}
	
	/**
	 * Sets the admitting regulation.
	 *
	 * @param admittingRegulation the new admitting regulation
	 */
	public void setAdmittingRegulation(TaggedText admittingRegulation)
	{
		this.admittingRegulation = admittingRegulation;
	}
	
	/**
	 * Gets the admitting eligibility.
	 *
	 * @return the admitting eligibility
	 */
	public TaggedText getAdmittingEligibility()
	{
		return admittingEligibility;
	}
	
	/**
	 * Sets the admitting eligibility.
	 *
	 * @param admittingEligibility the new admitting eligibility
	 */
	public void setAdmittingEligibility(TaggedText admittingEligibility)
	{
		this.admittingEligibility = admittingEligibility;
	}
	
	/**
	 * Gets the mas movement type.
	 *
	 * @return the mas movement type
	 */
	public TaggedText getMasMovementType()
	{
		return masMovementType;
	}
	
	/**
	 * Sets the mas movement type.
	 *
	 * @param masMovementType the new mas movement type
	 */
	public void setMasMovementType(TaggedText masMovementType)
	{
		this.masMovementType = masMovementType;
	}
	
	/**
	 * Gets the lodging reason.
	 *
	 * @return the lodging reason
	 */
	public String getLodgingReason()
	{
		return lodgingReason;
	}
	
	/**
	 * Sets the lodging reason.
	 *
	 * @param lodgingReason the new lodging reason
	 */
	public void setLodgingReason(String lodgingReason)
	{
		this.lodgingReason = lodgingReason;
	}
	
	/**
	 * Gets the lodging comments.
	 *
	 * @return the lodging comments
	 */
	public String getLodgingComments()
	{
		return lodgingComments;
	}
	
	/**
	 * Sets the lodging comments.
	 *
	 * @param lodgingComments the new lodging comments
	 */
	public void setLodgingComments(String lodgingComments)
	{
		this.lodgingComments = lodgingComments;
	}
	
	/**
	 * Gets the disposition.
	 *
	 * @return the disposition
	 */
	public String getDisposition()
	{
		return disposition;
	}
	
	/**
	 * Sets the disposition.
	 *
	 * @param disposition the new disposition
	 */
	public void setDisposition(String disposition)
	{
		this.disposition = disposition;
	}
	
	/**
	 * Gets the eligibility.
	 *
	 * @return the eligibility
	 */
	public String getEligibility()
	{
		return eligibility;
	}
	
	/**
	 * Sets the eligibility.
	 *
	 * @param eligibility the new eligibility
	 */
	public void setEligibility(String eligibility)
	{
		this.eligibility = eligibility;
	}
	
	/**
	 * Gets the pre admit id.
	 *
	 * @return the pre admit id
	 */
	public String getPreAdmitId()
	{
		return preAdmitId;
	}
	
	/**
	 * Sets the pre admit id.
	 *
	 * @param preAdmitId the new pre admit id
	 */
	public void setPreAdmitId(String preAdmitId)
	{
		this.preAdmitId = preAdmitId;
	}
	
	/**
	 * Gets the referring.
	 *
	 * @return the referring
	 */
	public UserTO getReferring()
	{
		return referring;
	}
	
	/**
	 * Sets the referring.
	 *
	 * @param referring the new referring
	 */
	public void setReferring(UserTO referring)
	{
		this.referring = referring;
	}
	
	/**
	 * Gets the consulting.
	 *
	 * @return the consulting
	 */
	public UserTO getConsulting()
	{
		return consulting;
	}
	
	/**
	 * Sets the consulting.
	 *
	 * @param consulting the new consulting
	 */
	public void setConsulting(UserTO consulting)
	{
		this.consulting = consulting;
	}
	
	/**
	 * Gets the admitting.
	 *
	 * @return the admitting
	 */
	public UserTO getAdmitting()
	{
		return admitting;
	}
	
	/**
	 * Sets the admitting.
	 *
	 * @param admitting the new admitting
	 */
	public void setAdmitting(UserTO admitting)
	{
		this.admitting = admitting;
	}
	
	/**
	 * Gets the service.
	 *
	 * @return the service
	 */
	public TaggedText getService()
	{
		return service;
	}
	
	/**
	 * Sets the service.
	 *
	 * @param service the new service
	 */
	public void setService(TaggedText service)
	{
		this.service = service;
	}
	
	/**
	 * Gets the prior location.
	 *
	 * @return the prior location
	 */
	public HospitalLocationTO getPriorLocation()
	{
		return priorLocation;
	}
	
	/**
	 * Sets the prior location.
	 *
	 * @param priorLocation the new prior location
	 */
	public void setPriorLocation(HospitalLocationTO priorLocation)
	{
		this.priorLocation = priorLocation;
	}
	
	/**
	 * Gets the temporary location.
	 *
	 * @return the temporary location
	 */
	public HospitalLocationTO getTemporaryLocation()
	{
		return temporaryLocation;
	}
	
	/**
	 * Sets the temporary location.
	 *
	 * @param temporaryLocation the new temporary location
	 */
	public void setTemporaryLocation(HospitalLocationTO temporaryLocation)
	{
		this.temporaryLocation = temporaryLocation;
	}
	
	/**
	 * Gets the pending location.
	 *
	 * @return the pending location
	 */
	public HospitalLocationTO getPendingLocation()
	{
		return pendingLocation;
	}
	
	/**
	 * Sets the pending location.
	 *
	 * @param pendingLocation the new pending location
	 */
	public void setPendingLocation(HospitalLocationTO pendingLocation)
	{
		this.pendingLocation = pendingLocation;
	}
	
	/**
	 * Gets the patient type.
	 *
	 * @return the patient type
	 */
	public String getPatientType()
	{
		return patientType;
	}
	
	/**
	 * Sets the patient type.
	 *
	 * @param patientType the new patient type
	 */
	public void setPatientType(String patientType)
	{
		this.patientType = patientType;
	}
	
	/**
	 * Gets the admit timestamp.
	 *
	 * @return the admit timestamp
	 */
	public String getAdmitTimestamp()
	{
		return admitTimestamp;
	}
	
	/**
	 * Sets the admit timestamp.
	 *
	 * @param admitTimestamp the new admit timestamp
	 */
	public void setAdmitTimestamp(String admitTimestamp)
	{
		this.admitTimestamp = admitTimestamp;
	}
	
	/**
	 * Gets the discharge timestamp.
	 *
	 * @return the discharge timestamp
	 */
	public String getDischargeTimestamp()
	{
		return dischargeTimestamp;
	}
	
	/**
	 * Sets the discharge timestamp.
	 *
	 * @param dischargeTimestamp the new discharge timestamp
	 */
	public void setDischargeTimestamp(String dischargeTimestamp)
	{
		this.dischargeTimestamp = dischargeTimestamp;
	}
	
	/**
	 * Gets the admit reason.
	 *
	 * @return the admit reason
	 */
	public String getAdmitReason()
	{
		return admitReason;
	}
	
	/**
	 * Sets the admit reason.
	 *
	 * @param admitReason the new admit reason
	 */
	public void setAdmitReason(String admitReason)
	{
		this.admitReason = admitReason;
	}
	
	/**
	 * Gets the transfer reason.
	 *
	 * @return the transfer reason
	 */
	public String getTransferReason()
	{
		return transferReason;
	}
	
	/**
	 * Sets the transfer reason.
	 *
	 * @param transferReason the new transfer reason
	 */
	public void setTransferReason(String transferReason)
	{
		this.transferReason = transferReason;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "AdtTO [id=" + id + ", patient=" + patient + ", checkInId="
				+ checkInId + ", checkOutId=" + checkOutId
				+ ", relatedPhysicalMovementId=" + relatedPhysicalMovementId
				+ ", transaction=" + transaction + ", movementType="
				+ movementType + ", timestamp=" + timestamp + ", diagnosis="
				+ diagnosis + ", assignedLocation=" + assignedLocation
				+ ", provider=" + provider + ", attending=" + attending
				+ ", transferFacility=" + transferFacility + ", specialty="
				+ specialty + ", patientTxId=" + patientTxId + ", visitId="
				+ visitId + ", patientMovementNumber=" + patientMovementNumber
				+ ", nextPatientMovement=" + nextPatientMovement
				+ ", enteredBy=" + enteredBy + ", lengthOfStay=" + lengthOfStay
				+ ", passDays=" + passDays + ", daysAbsent=" + daysAbsent
				+ ", asihAdmission=" + asihAdmission + ", asihTransfer="
				+ asihTransfer + ", asihSequence=" + asihSequence
				+ ", asihDays=" + asihDays + ", absenceReturnDate="
				+ absenceReturnDate + ", admittedForScCondition="
				+ admittedForScCondition + ", scheduledAdmission="
				+ scheduledAdmission + ", admissionSource=" + admissionSource
				+ ", admittingCategory=" + admittingCategory
				+ ", admittingRegulation=" + admittingRegulation
				+ ", admittingEligibility=" + admittingEligibility
				+ ", masMovementType=" + masMovementType + ", lodgingReason="
				+ lodgingReason + ", lodgingComments=" + lodgingComments
				+ ", disposition=" + disposition + ", eligibility="
				+ eligibility + ", preAdmitId=" + preAdmitId + ", referring="
				+ referring + ", consulting=" + consulting + ", admitting="
				+ admitting + ", service=" + service + ", priorLocation="
				+ priorLocation + ", temporaryLocation=" + temporaryLocation
				+ ", pendingLocation=" + pendingLocation + ", patientType="
				+ patientType + ", admitTimestamp=" + admitTimestamp
				+ ", dischargeTimestamp=" + dischargeTimestamp
				+ ", admitReason=" + admitReason + ", transferReason="
				+ transferReason + ", toString()=" + super.toString() + "]";
	}
}
