package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.Appointment;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.DataBean;


/**
 * The Class AppointmentTO.
 */
@XmlRootElement(name="AppointmentTO")
@XmlAccessorType(XmlAccessType.NONE)
public class AppointmentTO
    extends AbstractTO
{
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The title. */
	@XmlElement(name="title")
    protected String title;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The text. */
	@XmlElement(name="text")
    protected String text;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The clinic. */
	@XmlElement(name="clinic")
    protected HospitalLocationTO clinic;
    
    /** The lab date time. */
	@XmlElement(name="labDateTime")
    protected String labDateTime;
    
    /** The xray date time. */
	@XmlElement(name="xrayDateTime")
    protected String xrayDateTime;
    
    /** The ekg date time. */
	@XmlElement(name="ekgDateTime")
    protected String ekgDateTime;
    
    /** The purpose. */
	@XmlElement(name="purpose")
    protected String purpose;
    
    /** The type. */
	@XmlElement(name="type")
    protected String type;
    
    /** The current status. */
	@XmlElement(name="currentStatus")
    protected String currentStatus;
	
	public AppointmentTO() {
		
	}

	
	public AppointmentTO(DataBean appointment) {
				
		if ((appointment == null)  ) {
			return;
		}
		if((appointment instanceof Fault)){
			this.setFault(new FaultTO((Fault)appointment));
		}
		else{
			populateFields((Appointment)appointment);
		}

	}

	private void populateFields(Appointment appointment) {
			
		this.id = appointment.getId();
		this.timestamp = appointment.getTimestamp();
		this.title = appointment.getTitle();
		this.status = appointment.getStatus();
		this.text = appointment.getText();
		this.facility = new TaggedText(appointment.getFacility());
		this.clinic = new HospitalLocationTO(appointment.getClinic());
		this.labDateTime = appointment.getLabDateTime();
		this.xrayDateTime = appointment.getXrayDateTime();
		this.ekgDateTime = appointment.getEkgDateTime();
		this.purpose = appointment.getPurpose();
		this.type = appointment.getType();
		this.currentStatus = appointment.getCurrentStatus();	
	}

	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}
	
	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the clinic.
	 *
	 * @return the clinic
	 */
	public HospitalLocationTO getClinic()
	{
		return clinic;
	}
	
	/**
	 * Sets the clinic.
	 *
	 * @param clinic the new clinic
	 */
	public void setClinic(HospitalLocationTO clinic)
	{
		this.clinic = clinic;
	}
	
	/**
	 * Gets the lab date time.
	 *
	 * @return the lab date time
	 */
	public String getLabDateTime()
	{
		return labDateTime;
	}
	
	/**
	 * Sets the lab date time.
	 *
	 * @param labDateTime the new lab date time
	 */
	public void setLabDateTime(String labDateTime)
	{
		this.labDateTime = labDateTime;
	}
	
	/**
	 * Gets the xray date time.
	 *
	 * @return the xray date time
	 */
	public String getXrayDateTime()
	{
		return xrayDateTime;
	}
	
	/**
	 * Sets the xray date time.
	 *
	 * @param xrayDateTime the new xray date time
	 */
	public void setXrayDateTime(String xrayDateTime)
	{
		this.xrayDateTime = xrayDateTime;
	}
	
	/**
	 * Gets the ekg date time.
	 *
	 * @return the ekg date time
	 */
	public String getEkgDateTime()
	{
		return ekgDateTime;
	}
	
	/**
	 * Sets the ekg date time.
	 *
	 * @param ekgDateTime the new ekg date time
	 */
	public void setEkgDateTime(String ekgDateTime)
	{
		this.ekgDateTime = ekgDateTime;
	}
	
	/**
	 * Gets the purpose.
	 *
	 * @return the purpose
	 */
	public String getPurpose()
	{
		return purpose;
	}
	
	/**
	 * Sets the purpose.
	 *
	 * @param purpose the new purpose
	 */
	public void setPurpose(String purpose)
	{
		this.purpose = purpose;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the current status.
	 *
	 * @return the current status
	 */
	public String getCurrentStatus()
	{
		return currentStatus;
	}
	
	/**
	 * Sets the current status.
	 *
	 * @param currentStatus the new current status
	 */
	public void setCurrentStatus(String currentStatus)
	{
		this.currentStatus = currentStatus;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "AppointmentTO [id=" + id + ", timestamp=" + timestamp
				+ ", title=" + title + ", status=" + status + ", text=" + text
				+ ", facility=" + facility + ", clinic=" + clinic
				+ ", labDateTime=" + labDateTime + ", xrayDateTime="
				+ xrayDateTime + ", ekgDateTime=" + ekgDateTime + ", purpose="
				+ purpose + ", type=" + type + ", currentStatus="
				+ currentStatus + ", toString()=" + super.toString() + "]";
	}
        
}