package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.Author;

// TODO: Auto-generated Javadoc
/**
 * The Class AuthorTO.
 */
@XmlRootElement(name="AuthorTO")
@XmlAccessorType(XmlAccessType.NONE)
public class AuthorTO
    extends AbstractTO
{

    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The signature. */
	@XmlElement(name="signature")
    protected String signature;
    
    public AuthorTO()
    {
    	
    }
    
    public AuthorTO(Author author)
    {
		if(author != null){
			if ( author.getFault()!=null )
			{
				this.setFault(new FaultTO(author.getFault()));
			}
			else
			{
				this.id = author.getId();
				this.name = author.getName();
				this.signature = author.getSignature();
			}
		}
    }
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the signature.
	 *
	 * @return the signature
	 */
	public String getSignature()
	{
		return signature;
	}
	
	/**
	 * Sets the signature.
	 *
	 * @param signature the new signature
	 */
	public void setSignature(String signature)
	{
		this.signature = signature;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "AuthorTO [id=" + id + ", name=" + name + ", signature="
				+ signature + ", toString()=" + super.toString() + "]";
	}
}
