package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Claim;
import gov.va.med.via.databeans.ProstheticClaim;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * The Class ClaimTO.
 */
@XmlRootElement(name = "ClaimTO")
@XmlAccessorType(XmlAccessType.NONE)
public class ClaimTO
    extends AbstractTO
{

    /** The id. */
	@XmlElement(name = "id")
    protected String id;
    
    /** The patient id. */
	@XmlElement(name = "patientId")
    protected String patientId;
    
    /** The patient name. */
	@XmlElement(name = "patientName")
    protected String patientName;
    
    /** The patient ssn. */
	@XmlElement(name = "patientSsn")
    protected String patientSsn;
    
    /** The episode date. */
	@XmlElement(name = "episodeDate")
    protected String episodeDate;
    
    /** The timestamp. */
	@XmlElement(name = "timestamp")
    protected String timestamp;
    
    /** The last edit timestamp. */
	@XmlElement(name = "lastEditTimestamp")
    protected String lastEditTimestamp;
    
    /** The insurance name. */
	@XmlElement(name = "insuranceName")
    protected String insuranceName;
    
    /** The cost. */
	@XmlElement(name = "cost")
    protected String cost;
    
    /** The billable status. */
	@XmlElement(name = "billableStatus")
    protected String billableStatus;
    
    /** The condition. */
	@XmlElement(name = "condition")
    protected String condition;
    
    /** The service connected percent. */
	@XmlElement(name = "serviceConnectedPercent")
    protected String serviceConnectedPercent;
    
    /** The consult id. */
	@XmlElement(name = "consultId")
    protected String consultId;
    
    /** The comment. */
	@XmlElement(name = "comment")
    protected String comment;
	
	/**
	 * Instantiates a new ClaimTO.
	 */
	public ClaimTO() {
	}

	/**
	 * Instantiates a new ClaimTO with a claim.
	 * 
	 * @param claim The claim object
	 */
	public ClaimTO(Claim claim) {
		if (claim.getFault() != null) {
			setFault(new FaultTO(claim.getFault()));
		} else {
			
			this.id = claim.getId();
			this.patientId = claim.getPatientId();
			this.patientName = claim.getPatientName();
			this.patientSsn = claim.getPatientSsn();
			this.episodeDate = claim.getEpisodeDate();
		    this.timestamp = claim.getTimestamp();
		    this.lastEditTimestamp = claim.getLastEditTimestamp();
		    this.insuranceName = claim.getInsuranceName();
		    this.cost = claim.getCost();
		    this.billableStatus = claim.getBillableStatus();
		    this.condition = claim.getCondition();
		    this.serviceConnectedPercent = claim.getServiceConnectedPercent();
		    this.consultId = claim.getConsultId();
		    this.comment = claim.getComment();

		}
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the patient id.
	 *
	 * @return the patient id
	 */
	public String getPatientId()
	{
		return patientId;
	}
	
	/**
	 * Sets the patient id.
	 *
	 * @param patientId the new patient id
	 */
	public void setPatientId(String patientId)
	{
		this.patientId = patientId;
	}
	
	/**
	 * Gets the patient name.
	 *
	 * @return the patient name
	 */
	public String getPatientName()
	{
		return patientName;
	}
	
	/**
	 * Sets the patient name.
	 *
	 * @param patientName the new patient name
	 */
	public void setPatientName(String patientName)
	{
		this.patientName = patientName;
	}
	
	/**
	 * Gets the patient ssn.
	 *
	 * @return the patient ssn
	 */
	public String getPatientSsn()
	{
		return patientSsn;
	}
	
	/**
	 * Sets the patient ssn.
	 *
	 * @param patientSsn the new patient ssn
	 */
	public void setPatientSsn(String patientSsn)
	{
		this.patientSsn = patientSsn;
	}
	
	/**
	 * Gets the episode date.
	 *
	 * @return the episode date
	 */
	public String getEpisodeDate()
	{
		return episodeDate;
	}
	
	/**
	 * Sets the episode date.
	 *
	 * @param episodeDate the new episode date
	 */
	public void setEpisodeDate(String episodeDate)
	{
		this.episodeDate = episodeDate;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the last edit timestamp.
	 *
	 * @return the last edit timestamp
	 */
	public String getLastEditTimestamp()
	{
		return lastEditTimestamp;
	}
	
	/**
	 * Sets the last edit timestamp.
	 *
	 * @param lastEditTimestamp the new last edit timestamp
	 */
	public void setLastEditTimestamp(String lastEditTimestamp)
	{
		this.lastEditTimestamp = lastEditTimestamp;
	}
	
	/**
	 * Gets the insurance name.
	 *
	 * @return the insurance name
	 */
	public String getInsuranceName()
	{
		return insuranceName;
	}
	
	/**
	 * Sets the insurance name.
	 *
	 * @param insuranceName the new insurance name
	 */
	public void setInsuranceName(String insuranceName)
	{
		this.insuranceName = insuranceName;
	}
	
	/**
	 * Gets the cost.
	 *
	 * @return the cost
	 */
	public String getCost()
	{
		return cost;
	}
	
	/**
	 * Sets the cost.
	 *
	 * @param cost the new cost
	 */
	public void setCost(String cost)
	{
		this.cost = cost;
	}
	
	/**
	 * Gets the billable status.
	 *
	 * @return the billable status
	 */
	public String getBillableStatus()
	{
		return billableStatus;
	}
	
	/**
	 * Sets the billable status.
	 *
	 * @param billableStatus the new billable status
	 */
	public void setBillableStatus(String billableStatus)
	{
		this.billableStatus = billableStatus;
	}
	
	/**
	 * Gets the condition.
	 *
	 * @return the condition
	 */
	public String getCondition()
	{
		return condition;
	}
	
	/**
	 * Sets the condition.
	 *
	 * @param condition the new condition
	 */
	public void setCondition(String condition)
	{
		this.condition = condition;
	}
	
	/**
	 * Gets the service connected percent.
	 *
	 * @return the service connected percent
	 */
	public String getServiceConnectedPercent()
	{
		return serviceConnectedPercent;
	}
	
	/**
	 * Sets the service connected percent.
	 *
	 * @param serviceConnectedPercent the new service connected percent
	 */
	public void setServiceConnectedPercent(String serviceConnectedPercent)
	{
		this.serviceConnectedPercent = serviceConnectedPercent;
	}
	
	/**
	 * Gets the consult id.
	 *
	 * @return the consult id
	 */
	public String getConsultId()
	{
		return consultId;
	}
	
	/**
	 * Sets the consult id.
	 *
	 * @param consultId the new consult id
	 */
	public void setConsultId(String consultId)
	{
		this.consultId = consultId;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "ClaimTO [id=" + id + ", patientId=" + patientId
				+ ", patientName=" + patientName + ", patientSsn=" + patientSsn
				+ ", episodeDate=" + episodeDate + ", timestamp=" + timestamp
				+ ", lastEditTimestamp=" + lastEditTimestamp
				+ ", insuranceName=" + insuranceName + ", cost=" + cost
				+ ", billableStatus=" + billableStatus + ", condition="
				+ condition + ", serviceConnectedPercent="
				+ serviceConnectedPercent + ", consultId=" + consultId
				+ ", comment=" + comment + ", toString()=" + super.toString()
				+ "]";
	}
    
    
}

