package gov.va.med.via.dto.common;

import java.text.SimpleDateFormat;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;


import gov.va.med.via.databeans.Consult;
import gov.va.med.via.util.DateTimeUtil;

// TODO: Auto-generated Javadoc
/**
 * The Class ConsultTO.
 */
@XmlRootElement(name="ConsultTO")
@XmlAccessorType(XmlAccessType.NONE)
public class ConsultTO
    extends OrderTO
{
    
    /** The to service. */
	@XmlElement(name="toService")
    protected TaggedText toService;
    
    /** The title. */
	@XmlElement(name="title")
    protected String title;
    
    public ConsultTO()
    {    	
    }
    
    public ConsultTO(Consult consult)
    {
    	this.id = consult.getId();
    	this.status = consult.getStatus();
    	this.title = consult.getTitle();

    	if (consult.getTimestamp() != null)
    	{
    		SimpleDateFormat simpleDateFormat = new SimpleDateFormat(DateTimeUtil.FORMAT_DATE_TIME);
    		this.timestamp = simpleDateFormat.format(consult.getTimestamp().getTime()); 
    	}
    	
    	if (consult.getService() != null)
    	{
    		this.toService = new TaggedText(consult.getService());
    	}
    	
    	this.text = consult.getText();
    }
    
	/**
	 * Gets the to service.
	 *
	 * @return the to service
	 */
	public TaggedText getToService()
	{
		return toService;
	}
	
	/**
	 * Sets the to service.
	 *
	 * @param toService the new to service
	 */
	public void setToService(TaggedText toService)
	{
		this.toService = toService;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "ConsultTO [toService=" + toService + ", title=" + title
				+ ", toString()=" + super.toString() + "]";
	}
}
