package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Address;
import gov.va.med.via.databeans.DemographicSet;
import gov.va.med.via.databeans.PersonName;
import gov.va.med.via.databeans.PhoneNum;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class DemographicSetTO.
 */
@XmlRootElement(name="DemographicSetTO")
@XmlAccessorType(XmlAccessType.NONE)
public class DemographicSetTO 
{
    
    /** The tag. */
	@XmlElement(name="tag")	
    protected String tag;
    
    /** The addresses. */
	@XmlElementWrapper(name="addresses")
	@XmlElement(name="addressTO")
    protected List<AddressTO> addresses;
    
    /** The phones. */
	@XmlElementWrapper(name="phones")
	@XmlElement(name="phoneNumTO")
    protected List<PhoneNumTO> phones;
    
    /** The email addresses. */
	@XmlElementWrapper(name="emails")
	@XmlElement(name="emailAddresses")
    protected List<String> emailAddresses;
    
    /** The names. */
	@XmlElementWrapper(name="demographicNames")
	@XmlElement(name="names")
    protected List<String> names;
    
    /**
     * Instantiates a new demographic set to.
     */
    public DemographicSetTO()
    {    	
    }
    
    /**
     * Instantiates a new demographic set to.
     *
     * @param tag the tag
     * @param demographicBean the demographic bean
     */
    public DemographicSetTO(String tag, DemographicSet demographicBean)
    {
    	this.tag = tag;
        if (demographicBean.getAddresses() != null && demographicBean.getAddresses().size() > 0)
        {
            this.addresses = new ArrayList<AddressTO>();
            for (Address address : demographicBean.getAddresses())
            {
            	addresses.add(new AddressTO(address));            	
            }
        }
        if (demographicBean.getPhones() != null && demographicBean.getPhones().size() > 0)
        {
        	this.phones = new ArrayList<PhoneNumTO>();
            for (PhoneNum phone : demographicBean.getPhones())
            {
            	this.phones.add(new PhoneNumTO(phone));
            }
        }
        if (demographicBean.getEmailAddresses() != null && demographicBean.getEmailAddresses().size() > 0)
        {
            this.emailAddresses = new ArrayList<String>();
            for (String email : demographicBean.getEmailAddresses())
            {
                this.emailAddresses.add(email);
            }
        }
        if (demographicBean.getNames() != null && demographicBean.getNames().size() > 0)
        {
            this.names = new ArrayList<String>();
            for (PersonName name : demographicBean.getNames())
            {
                this.names.add(name.getLastname() + ", " + name.getFirstname());  // name.getLastNameFirst();  // TODO
            }
        }
    }
    
	/**
	 * Gets the tag.
	 *
	 * @return the tag
	 */
	public String getTag()
	{
		return tag;
	}
	
	/**
	 * Sets the tag.
	 *
	 * @param tag the new tag
	 */
	public void setTag(String tag)
	{
		this.tag = tag;
	}
	
	/**
	 * Gets the addresses.
	 *
	 * @return the addresses
	 */
	public List<AddressTO> getAddresses()
	{
		return addresses;
	}
	
	/**
	 * Sets the addresses.
	 *
	 * @param addresses the new addresses
	 */
	public void setAddresses(List<AddressTO> addresses)
	{
		this.addresses = addresses;
	}
	
	/**
	 * Gets the phones.
	 *
	 * @return the phones
	 */
	public List<PhoneNumTO> getPhones()
	{
		return phones;
	}
	
	/**
	 * Sets the phones.
	 *
	 * @param phones the new phones
	 */
	public void setPhones(List<PhoneNumTO> phones)
	{
		this.phones = phones;
	}
	
	/**
	 * Gets the email addresses.
	 *
	 * @return the email addresses
	 */
	public List<String> getEmailAddresses()
	{
		return emailAddresses;
	}
	
	/**
	 * Sets the email addresses.
	 *
	 * @param emailAddresses the new email addresses
	 */
	public void setEmailAddresses(List<String> emailAddresses)
	{
		this.emailAddresses = emailAddresses;
	}
	
	/**
	 * Gets the names.
	 *
	 * @return the names
	 */
	public List<String> getNames()
	{
		return names;
	}
	
	/**
	 * Sets the names.
	 *
	 * @param names the new names
	 */
	public void setNames(List<String> names)
	{
		this.names = names;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "DemographicSetTO [tag=" + tag + ", addresses=" + addresses
				+ ", phones=" + phones + ", emailAddresses=" + emailAddresses
				+ ", names=" + names + ", toString()=" + super.toString() + "]";
	}
}