package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessType;

import gov.va.med.via.databeans.HospitalLocation;

// TODO: Auto-generated Javadoc
/**
 * The Class HospitalLocationTO.
 * 
 * @author DOMAINROMERJ
 */
@XmlRootElement(name="HospitalLocationTO")
@XmlAccessorType(XmlAccessType.NONE)
public class HospitalLocationTO
    extends AbstractTO
{

    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The department. */
	@XmlElement(name="department")
    protected TaggedText department;
    
    /** The service. */
	@XmlElement(name="service")
    protected TaggedText service;
    
    /** The specialty. */
	@XmlElement(name="specialty")
    protected TaggedText specialty;
    
    /** The stop code. */
	@XmlElement(name="stopCode")
    protected TaggedText stopCode;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected SiteTO facility;
    
    /** The building. */
	@XmlElement(name="building")
    protected String building;
    
    /** The floor. */
	@XmlElement(name="floor")
    protected String floor;
    
    /** The room. */
	@XmlElement(name="room")
    protected String room;
    
    /** The bed. */
	@XmlElement(name="bed")
    protected String bed;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The phone. */
	@XmlElement(name="phone")
    protected String phone;
    
    /** The appointment timestamp. */
	@XmlElement(name="appointmentTimestamp")
    protected String appointmentTimestamp;
    
    /** The type. */
	@XmlElement(name="type")
    protected String type;
    
    /** The physical location. */
	@XmlElement(name="physicalLocation")
    protected String physicalLocation;
    
    /** The ask for check in. */	
	@XmlElement(name="askForCheckIn")
    protected Boolean askForCheckIn;
    
    /** The appointment length. */
	@XmlElement(name="appointmentLength")
    protected String appointmentLength;
    
    /** The clinic display start time. */
	@XmlElement(name="clinicDisplayStartTime")
    protected String clinicDisplayStartTime;
    
    /** The display increments. */
	@XmlElement(name="displayIncrements")
    protected String displayIncrements;
    
    /** The availability. */
	@XmlElement(name="availability")
    protected TimeSlotArray availability;
    
    public HospitalLocationTO()
    {
    	
    }
    
    public HospitalLocationTO(HospitalLocation location)
    {
    	if (location == null) return;
    	
    	this.id = location.getId();
        this.name = location.getName();
          
        if ( location.getDepartment()!= null ){
        	  this.department = new TaggedText(location.getDepartment());
        }
          
        if ( location.getService()!= null ){
        	  this.service = new TaggedText(location.getService());
        }
          
        if ( location.getSpecialty()!=null ){
        	  this.specialty = new TaggedText(location.getSpecialty());
        }
        this.building = location.getBuilding();
        this.floor = location.getFloor();
        this.room = location.getRoom();
        this.bed = location.getBed();
        this.status = location.getStatus();
        this.phone = location.getPhone();
        this.appointmentTimestamp = location.getAppointmentTimestamp();
        this.type = location.getType();
        this.physicalLocation = location.getPhysicalLocation();
        
        if(location.getFacility() != null){
        	this.facility = new SiteTO(location.getFacility());
        }
          
    }
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the department.
	 *
	 * @return the department
	 */
	public TaggedText getDepartment()
	{
		return department;
	}
	
	/**
	 * Sets the department.
	 *
	 * @param department the new department
	 */
	public void setDepartment(TaggedText department)
	{
		this.department = department;
	}
	
	/**
	 * Gets the service.
	 *
	 * @return the service
	 */
	public TaggedText getService()
	{
		return service;
	}
	
	/**
	 * Sets the service.
	 *
	 * @param service the new service
	 */
	public void setService(TaggedText service)
	{
		this.service = service;
	}
	
	/**
	 * Gets the specialty.
	 *
	 * @return the specialty
	 */
	public TaggedText getSpecialty()
	{
		return specialty;
	}
	
	/**
	 * Sets the specialty.
	 *
	 * @param specialty the new specialty
	 */
	public void setSpecialty(TaggedText specialty)
	{
		this.specialty = specialty;
	}
	
	/**
	 * Gets the stop code.
	 *
	 * @return the stop code
	 */
	public TaggedText getStopCode()
	{
		return stopCode;
	}
	
	/**
	 * Sets the stop code.
	 *
	 * @param stopCode the new stop code
	 */
	public void setStopCode(TaggedText stopCode)
	{
		this.stopCode = stopCode;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public SiteTO getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(SiteTO facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the building.
	 *
	 * @return the building
	 */
	public String getBuilding()
	{
		return building;
	}
	
	/**
	 * Sets the building.
	 *
	 * @param building the new building
	 */
	public void setBuilding(String building)
	{
		this.building = building;
	}
	
	/**
	 * Gets the floor.
	 *
	 * @return the floor
	 */
	public String getFloor()
	{
		return floor;
	}
	
	/**
	 * Sets the floor.
	 *
	 * @param floor the new floor
	 */
	public void setFloor(String floor)
	{
		this.floor = floor;
	}
	
	/**
	 * Gets the room.
	 *
	 * @return the room
	 */
	public String getRoom()
	{
		return room;
	}
	
	/**
	 * Sets the room.
	 *
	 * @param room the new room
	 */
	public void setRoom(String room)
	{
		this.room = room;
	}
	
	/**
	 * Gets the bed.
	 *
	 * @return the bed
	 */
	public String getBed()
	{
		return bed;
	}
	
	/**
	 * Sets the bed.
	 *
	 * @param bed the new bed
	 */
	public void setBed(String bed)
	{
		this.bed = bed;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the phone.
	 *
	 * @return the phone
	 */
	public String getPhone()
	{
		return phone;
	}
	
	/**
	 * Sets the phone.
	 *
	 * @param phone the new phone
	 */
	public void setPhone(String phone)
	{
		this.phone = phone;
	}
	
	/**
	 * Gets the appointment timestamp.
	 *
	 * @return the appointment timestamp
	 */
	public String getAppointmentTimestamp()
	{
		return appointmentTimestamp;
	}
	
	/**
	 * Sets the appointment timestamp.
	 *
	 * @param appointmentTimestamp the new appointment timestamp
	 */
	public void setAppointmentTimestamp(String appointmentTimestamp)
	{
		this.appointmentTimestamp = appointmentTimestamp;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the physical location.
	 *
	 * @return the physical location
	 */
	public String getPhysicalLocation()
	{
		return physicalLocation;
	}
	
	/**
	 * Sets the physical location.
	 *
	 * @param physicalLocation the new physical location
	 */
	public void setPhysicalLocation(String physicalLocation)
	{
		this.physicalLocation = physicalLocation;
	}
	
	/**
	 * Checks if is ask for check in.
	 *
	 * @return true, if is ask for check in
	 */
	public Boolean isAskForCheckIn()
	{
		return askForCheckIn;
	}
	
	/**
	 * Sets the ask for check in.
	 *
	 * @param askForCheckIn the new ask for check in
	 */
	public void setAskForCheckIn(Boolean askForCheckIn)
	{
		this.askForCheckIn = askForCheckIn;
	}
	
	/**
	 * Gets the appointment length.
	 *
	 * @return the appointment length
	 */
	public String getAppointmentLength()
	{
		return appointmentLength;
	}
	
	/**
	 * Sets the appointment length.
	 *
	 * @param appointmentLength the new appointment length
	 */
	public void setAppointmentLength(String appointmentLength)
	{
		this.appointmentLength = appointmentLength;
	}
	
	/**
	 * Gets the clinic display start time.
	 *
	 * @return the clinic display start time
	 */
	public String getClinicDisplayStartTime()
	{
		return clinicDisplayStartTime;
	}
	
	/**
	 * Sets the clinic display start time.
	 *
	 * @param clinicDisplayStartTime the new clinic display start time
	 */
	public void setClinicDisplayStartTime(String clinicDisplayStartTime)
	{
		this.clinicDisplayStartTime = clinicDisplayStartTime;
	}
	
	/**
	 * Gets the display increments.
	 *
	 * @return the display increments
	 */
	public String getDisplayIncrements()
	{
		return displayIncrements;
	}
	
	/**
	 * Sets the display increments.
	 *
	 * @param displayIncrements the new display increments
	 */
	public void setDisplayIncrements(String displayIncrements)
	{
		this.displayIncrements = displayIncrements;
	}
	
	/**
	 * Gets the availability.
	 *
	 * @return the availability
	 */
	public TimeSlotArray getAvailability()
	{
		return availability;
	}
	
	/**
	 * Sets the availability.
	 *
	 * @param availability the new availability
	 */
	public void setAvailability(TimeSlotArray availability)
	{
		this.availability = availability;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "HospitalLocationTO [id=" + id + ", name=" + name
				+ ", department=" + department + ", service=" + service
				+ ", specialty=" + specialty + ", stopCode=" + stopCode
				+ ", facility=" + facility + ", building=" + building
				+ ", floor=" + floor + ", room=" + room + ", bed=" + bed
				+ ", status=" + status + ", phone=" + phone
				+ ", appointmentTimestamp=" + appointmentTimestamp + ", type="
				+ type + ", physicalLocation=" + physicalLocation
				+ ", askForCheckIn=" + askForCheckIn + ", appointmentLength="
				+ appointmentLength + ", clinicDisplayStartTime="
				+ clinicDisplayStartTime + ", displayIncrements="
				+ displayIncrements + ", availability=" + availability
				+ ", toString()=" + super.toString() + "]";
	}
    
}