package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.IcdReport;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class IcdRpt.
 */
@XmlRootElement(name="IcdRpt")
@XmlAccessorType(XmlAccessType.NONE)
public class IcdRpt
    extends AbstractTO
{
    
    /** The title. */
	@XmlElement(name="title")
    protected String title;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The icd code. */
	@XmlElement(name="icdCode")
    protected String icdCode;
	
    public IcdRpt()
    {    	
    }
    
    public IcdRpt(IcdReport report)
    {    	
    	if ( report.getFault()!=null ){
			this.setFault(new FaultTO(report.getFault()));
		}
		else{
			this.title = report.getTitle();
			this.timestamp = report.getTimestamp();
			this.icdCode = report.getIcdCode();
						
			if (report.getFacility() != null)
			{
				this.facility = new TaggedText(report.getFacility().getId(), report.getFacility().getName());
			}
		}    	
    	
    }
    
    
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the icd code.
	 *
	 * @return the icd code
	 */
	public String getIcdCode()
	{
		return icdCode;
	}
	
	/**
	 * Sets the icd code.
	 *
	 * @param icdCode the new icd code
	 */
	public void setIcdCode(String icdCode)
	{
		this.icdCode = icdCode;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "IcdRpt [title=" + title + ", timestamp=" + timestamp
				+ ", facility=" + facility + ", icdCode=" + icdCode
				+ ", toString()=" + super.toString() + "]";
	}
}