package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.ImagingExam;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name="ImagingExamTO")
@XmlAccessorType(XmlAccessType.NONE)
public class ImagingExamTO 
{
    
	@XmlElement(name="accessionNum")
    protected String accessionNum;
    
	@XmlElement(name="casenum")
    protected String casenum;
    
	@XmlElement(name="encounterId")
    protected String encounterId;
    
	@XmlElement(name="facility")
    protected SiteTO facility;
    
	@XmlElement(name="hasImages")
    protected Boolean hasImages;
    
	@XmlElement(name="id")
    protected String id;
    
	@XmlElement(name="imagingType")
    protected String imagingType;
    
	@XmlElement(name="interpretation")
    protected String interpretation;
    
	@XmlElement(name="imagingLocation")
    protected HospitalLocationTO imagingLocation;
    
	@XmlElement(name="modifiers")
    protected List<CptCodeTO> modifiers;
    
	@XmlElement(name="name")
    protected String name;
    
	@XmlElement(name="order")
    protected OrderTO order;
    
	@XmlElement(name="provider")
    protected UserTO provider;
    
	@XmlElement(name="reports")
    protected List<RadiologyReportTO> reports;
    
	@XmlElement(name="reportId")
    protected String reportId;
    
	@XmlElement(name="status")
    protected String status;
    
	@XmlElement(name="timestamp")
    protected String timestamp;
    
	@XmlElement(name="type")
    protected CptCodeTO type;
	
	public ImagingExamTO(ImagingExam exam) 
	{
		this.status = exam.getStatus();
	}
	
	public ImagingExamTO() 
	{
	}
	

	/**
	 * Gets the accession num.
	 *
	 * @return the accession num
	 */
	public String getAccessionNum()
	{
		return accessionNum;
	}
	
	/**
	 * Sets the accession num.
	 *
	 * @param accessionNum the new accession num
	 */
	public void setAccessionNum(String accessionNum)
	{
		this.accessionNum = accessionNum;
	}
	
	/**
	 * Gets the casenum.
	 *
	 * @return the casenum
	 */
	public String getCasenum()
	{
		return casenum;
	}
	
	/**
	 * Sets the casenum.
	 *
	 * @param casenum the new casenum
	 */
	public void setCasenum(String casenum)
	{
		this.casenum = casenum;
	}
	
	/**
	 * Gets the encounter id.
	 *
	 * @return the encounter id
	 */
	public String getEncounterId()
	{
		return encounterId;
	}
	
	/**
	 * Sets the encounter id.
	 *
	 * @param encounterId the new encounter id
	 */
	public void setEncounterId(String encounterId)
	{
		this.encounterId = encounterId;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public SiteTO getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(SiteTO facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Checks if is checks for images.
	 *
	 * @return true, if is checks for images
	 */
	public Boolean isHasImages()
	{
		return hasImages;
	}
	
	/**
	 * Sets the checks for images.
	 *
	 * @param hasImages the new checks for images
	 */
	public void setHasImages(Boolean hasImages)
	{
		this.hasImages = hasImages;
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the imaging type.
	 *
	 * @return the imaging type
	 */
	public String getImagingType()
	{
		return imagingType;
	}
	
	/**
	 * Sets the imaging type.
	 *
	 * @param imagingType the new imaging type
	 */
	public void setImagingType(String imagingType)
	{
		this.imagingType = imagingType;
	}
	
	/**
	 * Gets the interpretation.
	 *
	 * @return the interpretation
	 */
	public String getInterpretation()
	{
		return interpretation;
	}
	
	/**
	 * Sets the interpretation.
	 *
	 * @param interpretation the new interpretation
	 */
	public void setInterpretation(String interpretation)
	{
		this.interpretation = interpretation;
	}
	
	/**
	 * Gets the imaging location.
	 *
	 * @return the imaging location
	 */
	public HospitalLocationTO getImagingLocation()
	{
		return imagingLocation;
	}
	
	/**
	 * Sets the imaging location.
	 *
	 * @param imagingLocation the new imaging location
	 */
	public void setImagingLocation(HospitalLocationTO imagingLocation)
	{
		this.imagingLocation = imagingLocation;
	}
	
	/**
	 * Gets the modifiers.
	 *
	 * @return the modifiers
	 */
	public List<CptCodeTO> getModifiers()
	{
		return modifiers;
	}
	
	/**
	 * Sets the modifiers.
	 *
	 * @param modifiers the new modifiers
	 */
	public void setModifiers(List<CptCodeTO> modifiers)
	{
		this.modifiers = modifiers;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the order.
	 *
	 * @return the order
	 */
	public OrderTO getOrder()
	{
		return order;
	}
	
	/**
	 * Sets the order.
	 *
	 * @param order the new order
	 */
	public void setOrder(OrderTO order)
	{
		this.order = order;
	}
	
	/**
	 * Gets the provider.
	 *
	 * @return the provider
	 */
	public UserTO getProvider()
	{
		return provider;
	}
	
	/**
	 * Sets the provider.
	 *
	 * @param provider the new provider
	 */
	public void setProvider(UserTO provider)
	{
		this.provider = provider;
	}
	
	/**
	 * Gets the reports.
	 *
	 * @return the reports
	 */
	public List<RadiologyReportTO> getReports()
	{
		return reports;
	}
	
	/**
	 * Sets the reports.
	 *
	 * @param reports the new reports
	 */
	public void setReports(List<RadiologyReportTO> reports)
	{
		this.reports = reports;
	}
	
	/**
	 * Gets the report id.
	 *
	 * @return the report id
	 */
	public String getReportId()
	{
		return reportId;
	}
	
	/**
	 * Sets the report id.
	 *
	 * @param reportId the new report id
	 */
	public void setReportId(String reportId)
	{
		this.reportId = reportId;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public CptCodeTO getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(CptCodeTO type)
	{
		this.type = type;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "ImagingExamTO [accessionNum=" + accessionNum + ", casenum="
				+ casenum + ", encounterId=" + encounterId + ", facility="
				+ facility + ", hasImages=" + hasImages + ", id=" + id
				+ ", imagingType=" + imagingType + ", interpretation="
				+ interpretation + ", imagingLocation=" + imagingLocation
				+ ", modifiers=" + modifiers + ", name=" + name + ", order="
				+ order + ", provider=" + provider + ", reports=" + reports
				+ ", reportId=" + reportId + ", status=" + status
				+ ", timestamp=" + timestamp + ", type=" + type
				+ ", toString()=" + super.toString() + "]";
	}
}