package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.LabResult;

/**
 * The Class LabResultTO.
 */
@XmlRootElement(name="LabResultTO")
@XmlAccessorType(XmlAccessType.NONE)
public class LabResultTO
    extends AbstractTO
{
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The test. */
	@XmlElement(name="test")
    protected LabTestTO test;
    
    /** The specimen type. */
	@XmlElement(name="specimenType")
    protected String specimenType;
    
    /** The comment. */
	@XmlElement(name="comment")
    protected String comment;
    
    /** The value. */
	@XmlElement(name="value")
    protected String value;
    
    /** The boundary status. */
	@XmlElement(name="boundaryStatus")
    protected String boundaryStatus;
    
    /** The lab site id. */
	@XmlElement(name="labSiteId")
    protected String labSiteId;
	
    public LabResultTO() {
		
	}
    
    public LabResultTO(LabResult result) {
		//this.timestamp  - isn't ever captured in the LabResult bean
    	this.test = new LabTestTO(result.getLabTest());
    	this.specimenType = result.getSpecimenType();
    	this.comment = result.getComment();
    	this.value = result.getValue();
    	this.boundaryStatus = result.getBoundaryStatus();
    	this.labSiteId = result.getLabSiteId();
   
	}

	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the test.
	 *
	 * @return the test
	 */
	public LabTestTO getTest()
	{
		return test;
	}
	
	/**
	 * Sets the test.
	 *
	 * @param test the new test
	 */
	public void setTest(LabTestTO test)
	{
		this.test = test;
	}
	
	/**
	 * Gets the specimen type.
	 *
	 * @return the specimen type
	 */
	public String getSpecimenType()
	{
		return specimenType;
	}
	
	/**
	 * Sets the specimen type.
	 *
	 * @param specimenType the new specimen type
	 */
	public void setSpecimenType(String specimenType)
	{
		this.specimenType = specimenType;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/**
	 * Gets the value.
	 *
	 * @return the value
	 */
	public String getValue()
	{
		return value;
	}
	
	/**
	 * Sets the value.
	 *
	 * @param value the new value
	 */
	public void setValue(String value)
	{
		this.value = value;
	}
	
	/**
	 * Gets the boundary status.
	 *
	 * @return the boundary status
	 */
	public String getBoundaryStatus()
	{
		return boundaryStatus;
	}
	
	/**
	 * Sets the boundary status.
	 *
	 * @param boundaryStatus the new boundary status
	 */
	public void setBoundaryStatus(String boundaryStatus)
	{
		this.boundaryStatus = boundaryStatus;
	}
	
	/**
	 * Gets the lab site id.
	 *
	 * @return the lab site id
	 */
	public String getLabSiteId()
	{
		return labSiteId;
	}
	
	/**
	 * Sets the lab site id.
	 *
	 * @param labSiteId the new lab site id
	 */
	public void setLabSiteId(String labSiteId)
	{
		this.labSiteId = labSiteId;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "LabResultTO [timestamp=" + timestamp + ", test=" + test
				+ ", specimenType=" + specimenType + ", comment=" + comment
				+ ", value=" + value + ", boundaryStatus=" + boundaryStatus
				+ ", labSiteId=" + labSiteId + ", toString()="
				+ super.toString() + "]";
	}
}