package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.LabSpecimen;

/**
 * The Class LabSpecimenTO.
 */
@XmlRootElement(name="LabSpecimenTO")
@XmlAccessorType(XmlAccessType.NONE)
public class LabSpecimenTO extends AbstractTO
{

	/** The id. */
	@XmlElement(name="id")
	protected String id;
    
    /** The name. */
	@XmlElement(name="name")
	protected String name;
    
    /** The collection date. */
	@XmlElement(name="collectionDate")
	protected String collectionDate;
    
    /** The accession num. */
	@XmlElement(name="accessionNum")
	protected String accessionNum;
    
    /** The site. */
	@XmlElement(name="site")
	protected String site;
    
    /** The facility. */
	@XmlElement(name="facility")
	protected TaggedText facility;
	
	public LabSpecimenTO()
	{
		
	}
	
	public LabSpecimenTO(LabSpecimen specimen)
	{
		this.id = specimen.getId();
		this.name = specimen.getName();
		this.collectionDate = specimen.getCollectionDate();
		this.accessionNum = specimen.getAccessionNumber();
		this.site = specimen.getSite();
		if (specimen.getFacility() != null)
		{
			this.facility = new TaggedText(specimen.getFacility().getName());
		}
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the collection date.
	 *
	 * @return the collection date
	 */
	public String getCollectionDate()
	{
		return collectionDate;
	}
	
	/**
	 * Sets the collection date.
	 *
	 * @param collectionDate the new collection date
	 */
	public void setCollectionDate(String collectionDate)
	{
		this.collectionDate = collectionDate;
	}
	
	/**
	 * Gets the accession num.
	 *
	 * @return the accession num
	 */
	public String getAccessionNum()
	{
		return accessionNum;
	}
	
	/**
	 * Sets the accession num.
	 *
	 * @param accessionNum the new accession num
	 */
	public void setAccessionNum(String accessionNum)
	{
		this.accessionNum = accessionNum;
	}
	
	/**
	 * Gets the site.
	 *
	 * @return the site
	 */
	public String getSite()
	{
		return site;
	}
	
	/**
	 * Sets the site.
	 *
	 * @param site the new site
	 */
	public void setSite(String site)
	{
		this.site = site;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "LabSpecimenTO [id=" + id + ", name=" + name
				+ ", collectionDate=" + collectionDate + ", accessionNum="
				+ accessionNum + ", site=" + site + ", facility=" + facility
				+ ", toString()=" + super.toString() + "]";
	}
    
    
}
