package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.LabTest;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class LabTestArray.
 */
@XmlRootElement(name="LabTestArray")
@XmlAccessorType(XmlAccessType.NONE)
public class LabTestArray
    extends AbstractArrayTO
{
    
    /** The tests. */
	@XmlElementWrapper(name="tests")
	@XmlElement(name="labTestTO")
    protected List<LabTestTO> tests;

    public LabTestArray()
    {    	
    }
    
    public LabTestArray(List<DataBean> databeans)
    {
    	List<LabTestTO> labTestList = new ArrayList<LabTestTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			labTestList.add(new LabTestTO((LabTest)dataBean));
		}
		
		if(!foundFault){
			this.setTests(labTestList);
			setCount(labTestList.size());
		}
    	
    }
    
	/**
	 * Gets the tests.
	 *
	 * @return the tests
	 */
	public List<LabTestTO> getTests()
	{
		return tests;
	}

	/**
	 * Sets the tests.
	 *
	 * @param tests the new tests
	 */
	public void setTests(List<LabTestTO> tests)
	{
		this.tests = tests;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "LabTestArray [tests=" + tests + ", toString()="
				+ super.toString() + "]";
	}
     
}
