package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.LabTest;
import gov.va.med.via.databeans.Provider;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class LabTestTO.
 */
@XmlRootElement(name="LabTestTO")
@XmlAccessorType(XmlAccessType.NONE)
public class LabTestTO
    extends AbstractTO
{
    
    /** The result. */
	@XmlElement(name="result")
    protected LabResultTO result;
    
    /** The specimen. */
	@XmlElement(name="specimen")
    protected LabSpecimenTO specimen;
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The category. */
	@XmlElement(name="category")
    protected String category;
    
    /** The units. */
	@XmlElement(name="units")
    protected String units;
    
    /** The low ref. */
	@XmlElement(name="lowRef")
    protected String lowRef;
    
    /** The hi ref. */
	@XmlElement(name="hiRef")
    protected String hiRef;
    
    /** The ref range. */
	@XmlElement(name="refRange")
    protected String refRange;
    
    /** The loinc. */
	@XmlElement(name="loinc")
    protected String loinc;
	
	/**
	 * Instantiates a new lab test to.
	 */
	public LabTestTO()
	{		
	}
	
	/**
	 * Instantiates a new lab test to.
	 *
	 * @param test the test
	 */
	public LabTestTO(LabTest test) 
	{
		if ( test.getFault()!=null ){
			this.setFault(new FaultTO(test.getFault()));
		}
		else
		{
			this.id = test.getId();
			this.name = test.getName();
			this.units = test.getUnits();
			this.lowRef = test.getLowRef();
			this.hiRef = test.getHiRef();
			this.refRange = test.getRefRange();
			this.loinc = test.getLoinc();
			this.category = test.getCategory();
		}
	}
	
	
	
	/**
	 * Gets the result.
	 *
	 * @return the result
	 */
	public LabResultTO getResult()
	{
		return result;
	}
	
	/**
	 * Sets the result.
	 *
	 * @param result the new result
	 */
	public void setResult(LabResultTO result)
	{
		this.result = result;
	}
	
	/**
	 * Gets the specimen.
	 *
	 * @return the specimen
	 */
	public LabSpecimenTO getSpecimen()
	{
		return specimen;
	}
	
	/**
	 * Sets the specimen.
	 *
	 * @param specimen the new specimen
	 */
	public void setSpecimen(LabSpecimenTO specimen)
	{
		this.specimen = specimen;
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the category.
	 *
	 * @return the category
	 */
	public String getCategory()
	{
		return category;
	}
	
	/**
	 * Sets the category.
	 *
	 * @param category the new category
	 */
	public void setCategory(String category)
	{
		this.category = category;
	}
	
	/**
	 * Gets the units.
	 *
	 * @return the units
	 */
	public String getUnits()
	{
		return units;
	}
	
	/**
	 * Sets the units.
	 *
	 * @param units the new units
	 */
	public void setUnits(String units)
	{
		this.units = units;
	}
	
	/**
	 * Gets the low ref.
	 *
	 * @return the low ref
	 */
	public String getLowRef()
	{
		return lowRef;
	}
	
	/**
	 * Sets the low ref.
	 *
	 * @param lowRef the new low ref
	 */
	public void setLowRef(String lowRef)
	{
		this.lowRef = lowRef;
	}
	
	/**
	 * Gets the hi ref.
	 *
	 * @return the hi ref
	 */
	public String getHiRef()
	{
		return hiRef;
	}
	
	/**
	 * Sets the hi ref.
	 *
	 * @param hiRef the new hi ref
	 */
	public void setHiRef(String hiRef)
	{
		this.hiRef = hiRef;
	}
	
	/**
	 * Gets the ref range.
	 *
	 * @return the ref range
	 */
	public String getRefRange()
	{
		return refRange;
	}
	
	/**
	 * Sets the ref range.
	 *
	 * @param refRange the new ref range
	 */
	public void setRefRange(String refRange)
	{
		this.refRange = refRange;
	}
	
	/**
	 * Gets the loinc.
	 *
	 * @return the loinc
	 */
	public String getLoinc()
	{
		return loinc;
	}
	
	/**
	 * Sets the loinc.
	 *
	 * @param loinc the new loinc
	 */
	public void setLoinc(String loinc)
	{
		this.loinc = loinc;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "LabTestTO [result=" + result + ", specimen=" + specimen
				+ ", id=" + id + ", name=" + name + ", category=" + category
				+ ", units=" + units + ", lowRef=" + lowRef + ", hiRef="
				+ hiRef + ", refRange=" + refRange + ", loinc=" + loinc
				+ ", toString()=" + super.toString() + "]";
	}
}

