package gov.va.med.via.dto.common;

import java.util.Arrays;
import java.util.Calendar;

// TODO: Auto-generated Javadoc
/**
 * The Class Medication.
 */
public class Medication extends DataBean 
{
   /**
   * Date the outpatient prescription was last filled.
   * Date the inpatient medication was ordered.
   */
	  protected Calendar fillOrderDate;
	
	  /**
	   * The stop date of an inpatient medication.
	   */
	  protected Calendar stopDate;
	
	  /**
	   * Name of drug ordered.
	   */
	  protected String drugName;
	  /**
	   * Number of refills for a prescription.
	   */
	  protected String refills;
	  /**
	   * Sig code of a prescription, Administration instruction of an inpatient medication.
	   */
	  protected String sigCode;
	  /**
	   * Ordering provider of the medication/prescription.
	   */
	  protected String orderingProvider;
	  /**
	   * Quantity ordered for an outpatient prescription or inpatient medication.
	   */
	  protected String quantity;
	  /**
	   * Days supply of the outpatient prescription.
	   */
	  protected String daysSupply;
	
	  /**
	   * Pharmacy name where the outpatient prescription was last dispensed.
	   */
	  protected String lastDispensingPharmacy;
	  /**
	   * Internal ID of the medication.  Used to retrieve the detial of a medications/ prescription.
	   * 
	   */
	  protected String medId;
	  /**
	   * Flag to indicate if the prescription/medication is active. 1=active, 0=inactive
	   */
	  protected String active;
	  /**
	   * Provider comments associated with the medication/prescription.
	   */
	  protected String comment;
	 
	  /** The type of medication (I = Inpatient, O = Outpatient). */
	  protected String medType;
	  
  	  /** The RX number. */
	  protected String RXNumber;
	
	  /** The pharmacy id. */
	  protected String pharmacyId;
	
	  /** The prescription fills. */
	  protected PrescriptionFill[] prescriptionFills;

	/**
	 * Gets the fill order date.
	 *
	 * @return the fill order date
	 */
	public Calendar getFillOrderDate()
	{
		return fillOrderDate;
	}

	/**
	 * Sets the fill order date.
	 *
	 * @param fillOrderDate the new fill order date
	 */
	public void setFillOrderDate(Calendar fillOrderDate)
	{
		this.fillOrderDate = fillOrderDate;
	}

	/**
	 * Gets the stop date.
	 *
	 * @return the stop date
	 */
	public Calendar getStopDate()
	{
		return stopDate;
	}

	/**
	 * Sets the stop date.
	 *
	 * @param stopDate the new stop date
	 */
	public void setStopDate(Calendar stopDate)
	{
		this.stopDate = stopDate;
	}

	/**
	 * Gets the drug name.
	 *
	 * @return the drug name
	 */
	public String getDrugName()
	{
		return drugName;
	}

	/**
	 * Sets the drug name.
	 *
	 * @param drugName the new drug name
	 */
	public void setDrugName(String drugName)
	{
		this.drugName = drugName;
	}

	/**
	 * Gets the refills.
	 *
	 * @return the refills
	 */
	public String getRefills()
	{
		return refills;
	}

	/**
	 * Sets the refills.
	 *
	 * @param refills the new refills
	 */
	public void setRefills(String refills)
	{
		this.refills = refills;
	}

	/**
	 * Gets the sig code.
	 *
	 * @return the sig code
	 */
	public String getSigCode()
	{
		return sigCode;
	}

	/**
	 * Sets the sig code.
	 *
	 * @param sigCode the new sig code
	 */
	public void setSigCode(String sigCode)
	{
		this.sigCode = sigCode;
	}

	/**
	 * Gets the ordering provider.
	 *
	 * @return the ordering provider
	 */
	public String getOrderingProvider()
	{
		return orderingProvider;
	}

	/**
	 * Sets the ordering provider.
	 *
	 * @param orderingProvider the new ordering provider
	 */
	public void setOrderingProvider(String orderingProvider)
	{
		this.orderingProvider = orderingProvider;
	}

	/**
	 * Gets the quantity.
	 *
	 * @return the quantity
	 */
	public String getQuantity()
	{
		return quantity;
	}

	/**
	 * Sets the quantity.
	 *
	 * @param quantity the new quantity
	 */
	public void setQuantity(String quantity)
	{
		this.quantity = quantity;
	}

	/**
	 * Gets the days supply.
	 *
	 * @return the days supply
	 */
	public String getDaysSupply()
	{
		return daysSupply;
	}

	/**
	 * Sets the days supply.
	 *
	 * @param daysSupply the new days supply
	 */
	public void setDaysSupply(String daysSupply)
	{
		this.daysSupply = daysSupply;
	}

	/**
	 * Gets the last dispensing pharmacy.
	 *
	 * @return the last dispensing pharmacy
	 */
	public String getLastDispensingPharmacy()
	{
		return lastDispensingPharmacy;
	}

	/**
	 * Sets the last dispensing pharmacy.
	 *
	 * @param lastDispensingPharmacy the new last dispensing pharmacy
	 */
	public void setLastDispensingPharmacy(String lastDispensingPharmacy)
	{
		this.lastDispensingPharmacy = lastDispensingPharmacy;
	}

	/**
	 * Gets the med id.
	 *
	 * @return the med id
	 */
	public String getMedId()
	{
		return medId;
	}

	/**
	 * Sets the med id.
	 *
	 * @param medId the new med id
	 */
	public void setMedId(String medId)
	{
		this.medId = medId;
	}

	/**
	 * Gets the active.
	 *
	 * @return the active
	 */
	public String getActive()
	{
		return active;
	}

	/**
	 * Sets the active.
	 *
	 * @param active the new active
	 */
	public void setActive(String active)
	{
		this.active = active;
	}

	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}

	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}

	/**
	 * Gets the med type.
	 *
	 * @return the med type
	 */
	public String getMedType()
	{
		return medType;
	}

	/**
	 * Sets the med type.
	 *
	 * @param medType the new med type
	 */
	public void setMedType(String medType)
	{
		this.medType = medType;
	}

	/**
	 * Gets the rX number.
	 *
	 * @return the rX number
	 */
	public String getRXNumber()
	{
		return RXNumber;
	}

	/**
	 * Sets the rX number.
	 *
	 * @param rXNumber the new rX number
	 */
	public void setRXNumber(String rXNumber)
	{
		RXNumber = rXNumber;
	}

	/**
	 * Gets the pharmacy id.
	 *
	 * @return the pharmacy id
	 */
	public String getPharmacyId()
	{
		return pharmacyId;
	}

	/**
	 * Sets the pharmacy id.
	 *
	 * @param pharmacyId the new pharmacy id
	 */
	public void setPharmacyId(String pharmacyId)
	{
		this.pharmacyId = pharmacyId;
	}

	/**
	 * Gets the prescription fills.
	 *
	 * @return the prescription fills
	 */
	public PrescriptionFill[] getPrescriptionFills()
	{
		return prescriptionFills;
	}

	/**
	 * Sets the prescription fills.
	 *
	 * @param prescriptionFills the new prescription fills
	 */
	public void setPrescriptionFills(PrescriptionFill[] prescriptionFills)
	{
		this.prescriptionFills = prescriptionFills;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.DataBean#toString()
	 */
	@Override
	public String toString()
	{
		return "Medication [fillOrderDate=" + fillOrderDate + ", stopDate="
				+ stopDate + ", drugName=" + drugName + ", refills=" + refills
				+ ", sigCode=" + sigCode + ", orderingProvider="
				+ orderingProvider + ", quantity=" + quantity + ", daysSupply="
				+ daysSupply + ", lastDispensingPharmacy="
				+ lastDispensingPharmacy + ", medId=" + medId + ", active="
				+ active + ", comment=" + comment + ", medType=" + medType
				+ ", RXNumber=" + RXNumber + ", pharmacyId=" + pharmacyId
				+ ", prescriptionFills=" + Arrays.toString(prescriptionFills)
				+ ", toString()=" + super.toString() + "]";
	}  
}
