package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Author;
import gov.va.med.via.databeans.Facility;
import gov.va.med.via.databeans.Medication;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class MedicationTO.
 */
@XmlRootElement(name="MedicationTO")
@XmlAccessorType(XmlAccessType.NONE)
public class MedicationTO extends AbstractTO
{    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The rx num. */
    protected String rxNum;
    
    /** The quantity. */
    @XmlElement(name="quantity")
    protected String quantity;
    
    /** The expiration date. */
    protected String expirationDate;
    
    /** The issue date. */
    protected String issueDate;
    
    /** The start date. */
	@XmlElement(name="startDate")
    protected String startDate;
    
    /** The stop date. */
	@XmlElement(name="stopDate")
    protected String stopDate;
    
    /** The order id. */
	@XmlElement(name="orderId")
    protected String orderId;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The refills. */
    protected String refills;
    

    /** The is outpatient. */
    @XmlElement(name="isOutpatient")
    Boolean isOutpatient;
    
    /** The is inpatient. */
    @XmlElement(name="isInpatient")
    protected Boolean isInpatient;
    
    /** The is iv. */
    @XmlElement(name="isIV")
    protected Boolean isIV;
    
    /** The is unit dose. */
    @XmlElement(name="isUnitDose")
    protected Boolean isUnitDose;
    
    /** The is non va. */
    @XmlElement(name="isNonVA")
    protected Boolean isNonVA;
    
    /** The is imo. */
    @XmlElement(name="isImo")
    protected Boolean isImo;
    
    /** The last fill date. */
    @XmlElement(name="lastFillDate")
    protected String lastFillDate;
    
    /** The remaining. */
    protected String remaining;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The provider. */
    protected AuthorTO provider;
    
    /** The cost. */
    protected String cost;
    
    /** The sig. */
	@XmlElement(name="sig")
    protected String sig;
    
    /** The type. */
	@XmlElement(name="type")
    protected String type;
    
    /** The additives. */
    protected String additives;
    
    /** The solution. */
    protected String solution;
    
    /** The rate. */
    protected String rate;
    
    /** The dose. */
    protected String dose;
    
    /** The instruction. */
    protected String instruction;
    
    /** The comment. */
	@XmlElement(name="comment")
    protected String comment;
    
    /** The date documented. */
	@XmlElement(name="dateDocumented")
    protected String dateDocumented;
    
    /** The documentor. */
	@XmlElement(name="documentor")
    protected AuthorTO documentor;
    
    /** The detail. */
	@XmlElement(name="detail")
    protected String detail;
    
    /** The schedule. */
    protected String schedule;
    
    /** The days supply. */
    @XmlElement(name="daysSupply")
    protected String daysSupply;
    
    /** The hospital. */
    protected TaggedText hospital;
    
    /** The drug. */
    protected TaggedText drug;
	
    // Variable for WSDL ONLY
    protected Boolean isSupply;
    
    /** The total dose. */
    protected String totalDose;
    
    /** The unit dose. */
    protected String unitDose;
    
    protected String infRate;
    
    @XmlElement(name="route")
    protected String route;
    
    public MedicationTO(){  	
    }
    
    public MedicationTO(Medication medication)
    {
    	 this.setId(medication.getId());
    	 this.setName(medication.getName());
    	 this.setInfRate(medication.getInfRate());
    	 this.setStartDate(medication.getStartDate());
    	 this.setStopDate(medication.getStopDate());
    	 this.setComment(medication.getComment());    	 
    	 this.setTotalDose(medication.getTotalDose());
    	 this.setOrderId(medication.getOrderId());
    	 this.setStatus(medication.getStatus());
    	 this.setSig(medication.getSig());
    	 this.setDetail(medication.getDetail());
    	 this.setQuantity(medication.getQuantity());
    	 this.setDaysSupply(medication.getDaysSupply());
    	 this.setLastFillDate(medication.getLastFillDate());
    	 this.setOutpatient(medication.getIsOutpatient());
    	 this.setInpatient(medication.getIsInpatient());
    	 this.setIV(medication.getIsIV());
    	 this.setImo(medication.getIsImo());
    	 this.setNonVA(medication.getIsNonVA());
    	 this.setUnitDose(medication.getIsUnitDose());
    	 this.setType(medication.getType());
    	 this.setDateDocumented(medication.getDateDocumented());
    	 this.setRoute(medication.getRoute());
    	 this.setDose(medication.getDose());
    	 
    	 Facility facility = medication.getFacility();
    	 if ( facility!= null){
    		 TaggedText facilityTaggedText = new TaggedText();
    		 facilityTaggedText.setTag(facility.getTag());
    		 facilityTaggedText.setText(facility.getText());
    		 setFacility(facilityTaggedText); 
    	 }
    	 
    	 Author author = medication.getDocumentor();
    	 if ( author!= null ){
    		 AuthorTO authorTO = new AuthorTO();
    		 authorTO.setId(author.getId());
    		 authorTO.setName(author.getName());
    		 authorTO.setSignature(author.getSignature());
    		 setDocumentor(authorTO);
    	 }
    	 
    }
    
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the rx num.
	 *
	 * @return the rx num
	 */
	public String getRxNum()
	{
		return rxNum;
	}
	
	/**
	 * Sets the rx num.
	 *
	 * @param rxNum the new rx num
	 */
	public void setRxNum(String rxNum)
	{
		this.rxNum = rxNum;
	}
	
	/**
	 * Gets the quantity.
	 *
	 * @return the quantity
	 */
	public String getQuantity()
	{
		return quantity;
	}
	
	/**
	 * Sets the quantity.
	 *
	 * @param quantity the new quantity
	 */
	public void setQuantity(String quantity)
	{
		this.quantity = quantity;
	}
	
	/**
	 * Gets the expiration date.
	 *
	 * @return the expiration date
	 */
	public String getExpirationDate()
	{
		return expirationDate;
	}
	
	/**
	 * Sets the expiration date.
	 *
	 * @param expirationDate the new expiration date
	 */
	public void setExpirationDate(String expirationDate)
	{
		this.expirationDate = expirationDate;
	}
	
	/**
	 * Gets the issue date.
	 *
	 * @return the issue date
	 */
	public String getIssueDate()
	{
		return issueDate;
	}
	
	/**
	 * Sets the issue date.
	 *
	 * @param issueDate the new issue date
	 */
	public void setIssueDate(String issueDate)
	{
		this.issueDate = issueDate;
	}
	
	/**
	 * Gets the start date.
	 *
	 * @return the start date
	 */
	public String getStartDate()
	{
		return startDate;
	}
	
	/**
	 * Sets the start date.
	 *
	 * @param startDate the new start date
	 */
	public void setStartDate(String startDate)
	{
		this.startDate = startDate;
	}
	
	/**
	 * Gets the stop date.
	 *
	 * @return the stop date
	 */
	public String getStopDate()
	{
		return stopDate;
	}
	
	/**
	 * Sets the stop date.
	 *
	 * @param stopDate the new stop date
	 */
	public void setStopDate(String stopDate)
	{
		this.stopDate = stopDate;
	}
	
	/**
	 * Gets the order id.
	 *
	 * @return the order id
	 */
	public String getOrderId()
	{
		return orderId;
	}
	
	/**
	 * Sets the order id.
	 *
	 * @param orderId the new order id
	 */
	public void setOrderId(String orderId)
	{
		this.orderId = orderId;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the refills.
	 *
	 * @return the refills
	 */
	public String getRefills()
	{
		return refills;
	}
	
	/**
	 * Sets the refills.
	 *
	 * @param refills the new refills
	 */
	public void setRefills(String refills)
	{
		this.refills = refills;
	}
	
	/**
	 * Checks if is outpatient.
	 *
	 * @return true, if is outpatient
	 */
	public Boolean isOutpatient()
	{
		return isOutpatient;
	}
	
	/**
	 * Sets the outpatient.
	 *
	 * @param isOutpatient the new outpatient
	 */
	public void setOutpatient(Boolean isOutpatient)
	{
		this.isOutpatient = isOutpatient;
	}
	
	/**
	 * Checks if is inpatient.
	 *
	 * @return true, if is inpatient
	 */
	public Boolean isInpatient()
	{
		return isInpatient;
	}
	
	/**
	 * Sets the inpatient.
	 *
	 * @param isInpatient the new inpatient
	 */
	public void setInpatient(Boolean isInpatient)
	{
		this.isInpatient = isInpatient;
	}
	
	/**
	 * Checks if is iv.
	 *
	 * @return true, if is iv
	 */
	public Boolean isIV()
	{
		return isIV;
	}
	
	/**
	 * Sets the iv.
	 *
	 * @param isIV the new iv
	 */
	public void setIV(Boolean isIV)
	{
		this.isIV = isIV;
	}
	
	/**
	 * Checks if is unit dose.
	 *
	 * @return true, if is unit dose
	 */
	public Boolean isUnitDose()
	{
		return isUnitDose;
	}
	
	/**
	 * Sets the unit dose.
	 *
	 * @param isUnitDose the new unit dose
	 */
	public void setUnitDose(Boolean isUnitDose)
	{
		this.isUnitDose = isUnitDose;
	}
	
	/**
	 * Checks if is non va.
	 *
	 * @return true, if is non va
	 */
	public Boolean isNonVA()
	{
		return isNonVA;
	}
	
	/**
	 * Sets the non va.
	 *
	 * @param isNonVA the new non va
	 */
	public void setNonVA(Boolean isNonVA)
	{
		this.isNonVA = isNonVA;
	}
	
	/**
	 * Checks if is imo.
	 *
	 * @return true, if is imo
	 */
	public Boolean isImo()
	{
		return isImo;
	}
	
	/**
	 * Sets the imo.
	 *
	 * @param isImo the new imo
	 */
	public void setImo(Boolean isImo)
	{
		this.isImo = isImo;
	}
	
	/**
	 * Gets the last fill date.
	 *
	 * @return the last fill date
	 */
	public String getLastFillDate()
	{
		return lastFillDate;
	}
	
	/**
	 * Sets the last fill date.
	 *
	 * @param lastFillDate the new last fill date
	 */
	public void setLastFillDate(String lastFillDate)
	{
		this.lastFillDate = lastFillDate;
	}
	
	/**
	 * Gets the remaining.
	 *
	 * @return the remaining
	 */
	public String getRemaining()
	{
		return remaining;
	}
	
	/**
	 * Sets the remaining.
	 *
	 * @param remaining the new remaining
	 */
	public void setRemaining(String remaining)
	{
		this.remaining = remaining;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the provider.
	 *
	 * @return the provider
	 */
	public AuthorTO getProvider()
	{
		return provider;
	}
	
	/**
	 * Sets the provider.
	 *
	 * @param provider the new provider
	 */
	public void setProvider(AuthorTO provider)
	{
		this.provider = provider;
	}
	
	/**
	 * Gets the cost.
	 *
	 * @return the cost
	 */
	public String getCost()
	{
		return cost;
	}
	
	/**
	 * Sets the cost.
	 *
	 * @param cost the new cost
	 */
	public void setCost(String cost)
	{
		this.cost = cost;
	}
	
	/**
	 * Gets the sig.
	 *
	 * @return the sig
	 */
	public String getSig()
	{
		return sig;
	}
	
	/**
	 * Sets the sig.
	 *
	 * @param sig the new sig
	 */
	public void setSig(String sig)
	{
		this.sig = sig;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the additives.
	 *
	 * @return the additives
	 */
	public String getAdditives()
	{
		return additives;
	}
	
	/**
	 * Sets the additives.
	 *
	 * @param additives the new additives
	 */
	public void setAdditives(String additives)
	{
		this.additives = additives;
	}
	
	/**
	 * Gets the solution.
	 *
	 * @return the solution
	 */
	public String getSolution()
	{
		return solution;
	}
	
	/**
	 * Sets the solution.
	 *
	 * @param solution the new solution
	 */
	public void setSolution(String solution)
	{
		this.solution = solution;
	}
	
	/**
	 * Gets the rate.
	 *
	 * @return the rate
	 */
	public String getRate()
	{
		return rate;
	}
	
	/**
	 * Sets the rate.
	 *
	 * @param rate the new rate
	 */
	public void setRate(String rate)
	{
		this.rate = rate;
	}
	
	/**
	 * Gets the route.
	 *
	 * @return the route
	 */
	public String getRoute()
	{
		return route;
	}
	
	/**
	 * Sets the route.
	 *
	 * @param route the new route
	 */
	public void setRoute(String route)
	{
		this.route = route;
	}
	
	/**
	 * Gets the dose.
	 *
	 * @return the dose
	 */
	public String getDose()
	{
		return dose;
	}
	
	/**
	 * Sets the dose.
	 *
	 * @param dose the new dose
	 */
	public void setDose(String dose)
	{
		this.dose = dose;
	}
	
	/**
	 * Gets the instruction.
	 *
	 * @return the instruction
	 */
	public String getInstruction()
	{
		return instruction;
	}
	
	/**
	 * Sets the instruction.
	 *
	 * @param instruction the new instruction
	 */
	public void setInstruction(String instruction)
	{
		this.instruction = instruction;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/**
	 * Gets the date documented.
	 *
	 * @return the date documented
	 */
	public String getDateDocumented()
	{
		return dateDocumented;
	}
	
	/**
	 * Sets the date documented.
	 *
	 * @param dateDocumented the new date documented
	 */
	public void setDateDocumented(String dateDocumented)
	{
		this.dateDocumented = dateDocumented;
	}
	
	/**
	 * Gets the documentor.
	 *
	 * @return the documentor
	 */
	public AuthorTO getDocumentor()
	{
		return documentor;
	}
	
	/**
	 * Sets the documentor.
	 *
	 * @param documentor the new documentor
	 */
	public void setDocumentor(AuthorTO documentor)
	{
		this.documentor = documentor;
	}
	
	/**
	 * Gets the detail.
	 *
	 * @return the detail
	 */
	public String getDetail()
	{
		return detail;
	}
	
	/**
	 * Sets the detail.
	 *
	 * @param detail the new detail
	 */
	public void setDetail(String detail)
	{
		this.detail = detail;
	}
	
	/**
	 * Gets the schedule.
	 *
	 * @return the schedule
	 */
	public String getSchedule()
	{
		return schedule;
	}
	
	/**
	 * Sets the schedule.
	 *
	 * @param schedule the new schedule
	 */
	public void setSchedule(String schedule)
	{
		this.schedule = schedule;
	}
	
	/**
	 * Gets the days supply.
	 *
	 * @return the days supply
	 */
	public String getDaysSupply()
	{
		return daysSupply;
	}
	
	/**
	 * Sets the days supply.
	 *
	 * @param daysSupply the new days supply
	 */
	public void setDaysSupply(String daysSupply)
	{
		this.daysSupply = daysSupply;
	}
	
	/**
	 * Gets the hospital.
	 *
	 * @return the hospital
	 */
	public TaggedText getHospital()
	{
		return hospital;
	}
	
	/**
	 * Sets the hospital.
	 *
	 * @param hospital the new hospital
	 */
	public void setHospital(TaggedText hospital)
	{
		this.hospital = hospital;
	}
	
	/**
	 * Gets the drug.
	 *
	 * @return the drug
	 */
	public TaggedText getDrug()
	{
		return drug;
	}
	
	/**
	 * Sets the drug.
	 *
	 * @param drug the new drug
	 */
	public void setDrug(TaggedText drug)
	{
		this.drug = drug;
	}
	
	public String getTotalDose() {
		return totalDose;
	}

	public void setTotalDose(String totalDose) {
		this.totalDose = totalDose;
	}

	public String getUnitDose() {
		return unitDose;
	}

	public void setUnitDose(String unitDose) {
		this.unitDose = unitDose;
	}

	public String getInfRate() {
		return infRate;
	}

	public void setInfRate(String infRate) {
		this.infRate = infRate;
	}

	public Boolean getIsOutpatient() {
		return isOutpatient;
	}

	public void setIsOutpatient(Boolean isOutpatient) {
		this.isOutpatient = isOutpatient;
	}

	public Boolean getIsInpatient() {
		return isInpatient;
	}

	public void setIsInpatient(Boolean isInpatient) {
		this.isInpatient = isInpatient;
	}

	public Boolean getIsIV() {
		return isIV;
	}

	public void setIsIV(Boolean isIV) {
		this.isIV = isIV;
	}

	public Boolean getIsUnitDose() {
		return isUnitDose;
	}

	public void setIsUnitDose(Boolean isUnitDose) {
		this.isUnitDose = isUnitDose;
	}

	public Boolean getIsNonVA() {
		return isNonVA;
	}

	public void setIsNonVA(Boolean isNonVA) {
		this.isNonVA = isNonVA;
	}

	public Boolean getIsImo() {
		return isImo;
	}

	public void setIsImo(Boolean isImo) {
		this.isImo = isImo;
	}

	public Boolean getIsSupply() {
		return isSupply;
	}

	public void setIsSupply(Boolean isSupply) {
		this.isSupply = isSupply;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "MedicationTO [id=" + id + ", name=" + name + ", rxNum=" + rxNum
				+ ", quantity=" + quantity + ", expirationDate="
				+ expirationDate + ", issueDate=" + issueDate + ", startDate="
				+ startDate + ", stopDate=" + stopDate + ", orderId=" + orderId
				+ ", status=" + status + ", refills=" + refills
				+ ", isOutpatient=" + isOutpatient + ", isInpatient="
				+ isInpatient + ", isIV=" + isIV + ", isUnitDose=" + isUnitDose
				+ ", isNonVA=" + isNonVA + ", isImo=" + isImo
				+ ", lastFillDate=" + lastFillDate + ", remaining=" + remaining
				+ ", facility=" + facility + ", provider=" + provider
				+ ", cost=" + cost + ", sig=" + sig + ", type=" + type
				+ ", additives=" + additives + ", solution=" + solution
				+ ", rate=" + rate + ", route=" + route + ", dose=" + dose
				+ ", instruction=" + instruction + ", comment=" + comment
				+ ", dateDocumented=" + dateDocumented + ", documentor="
				+ documentor + ", detail=" + detail + ", schedule=" + schedule
				+ ", daysSupply=" + daysSupply + ", hospital=" + hospital
				+ ", drug=" + drug + ", toString()=" + super.toString() + "]";
	}
    
}
