package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.MentalHealthInstrumentAdministration;

// TODO: Auto-generated Javadoc
/**
 * The Class MentalHealthInstrumentAdministrationTO.
 */
@XmlRootElement(name="MentalHealthInstrumentAdministrationTO")
@XmlAccessorType(XmlAccessType.NONE)
public class MentalHealthInstrumentAdministrationTO
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The patient. */
	@XmlElement(name="patient")
    protected TaggedText patient;
    
    /** The instrument. */
	@XmlElement(name="instrument")
    protected TaggedText instrument;
    
    /** The date administered. */
	@XmlElement(name="dateAdministered")
    protected String dateAdministered;
    
    /** The date saved. */
	@XmlElement(name="dateSaved")
    protected String dateSaved;
    
    /** The ordered by. */
	@XmlElement(name="orderedBy")
    protected TaggedText orderedBy;
    
    /** The administered by. */
	@XmlElement(name="administeredBy")
    protected TaggedText administeredBy;
    
    /** The is signed. */
	@XmlElement(name="isSigned")
    protected Boolean isSigned;
    
    /** The is complete. */
	@XmlElement(name="isComplete")
    protected Boolean isComplete;
    
    /** The number of questions answered. */
	@XmlElement(name="numberOfQuestionsAnswered")
    protected String numberOfQuestionsAnswered;
    
    /** The transmit status. */
	@XmlElement(name="transmitStatus")
    protected String transmitStatus;
    
    /** The transmit time. */
	@XmlElement(name="transmitTime")
    protected String transmitTime;
    
    /** The hospital location. */
	@XmlElement(name="hospitalLocation")
    protected TaggedText hospitalLocation;
    
    /** The results. */
	@XmlElement(name="results")
    protected MentalHealthInstrumentResultSetTO results;
	
	/**
	 * Instantiates a new mental health instrument administration to.
	 */
	public MentalHealthInstrumentAdministrationTO() 
	{
	}
	
	/**
	 * Instantiates a new mental health instrument administration to.
	 *
	 * @param mentalInstrumentAdmin the mental instrument admin
	 */
	public MentalHealthInstrumentAdministrationTO(MentalHealthInstrumentAdministration mentalInstrumentAdmin) 
	{
		if ( mentalInstrumentAdmin.getFault()!=null ){
			this.setFault(new FaultTO(mentalInstrumentAdmin.getFault()));
		}
		else{
			this.id = mentalInstrumentAdmin.getId();
			this.patient = mentalInstrumentAdmin.getPatient() != null ? new TaggedText(mentalInstrumentAdmin.getPatient()) : null;
			this.instrument = mentalInstrumentAdmin.getInstrument() != null ? new TaggedText(mentalInstrumentAdmin.getInstrument()) : null;
			this.dateSaved = mentalInstrumentAdmin.getDateSaved();
			this.dateAdministered = mentalInstrumentAdmin.getDateAdministered();
			this.orderedBy = mentalInstrumentAdmin.getOrderedBy() != null ? new TaggedText(mentalInstrumentAdmin.getOrderedBy()) : null;
			this.administeredBy = mentalInstrumentAdmin.getAdministeredBy() != null ? new TaggedText(mentalInstrumentAdmin.getAdministeredBy()) : null;
			this.isSigned = new Boolean(mentalInstrumentAdmin.isSigned());
			this.isComplete = new Boolean(mentalInstrumentAdmin.isComplete());
			this.numberOfQuestionsAnswered = mentalInstrumentAdmin.getNumberOfQuestionsAnswered();
			this.transmitStatus = mentalInstrumentAdmin.getTransmitStatus();
			this.transmitTime = mentalInstrumentAdmin.getTransmitTime();
			this.hospitalLocation = mentalInstrumentAdmin.getHospitalLocation() != null ? new TaggedText(mentalInstrumentAdmin.getHospitalLocation()) : null;
			this.results = mentalInstrumentAdmin.getResults() != null? new MentalHealthInstrumentResultSetTO(mentalInstrumentAdmin.getResults()) : null;
		}
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the patient.
	 *
	 * @return the patient
	 */
	public TaggedText getPatient()
	{
		return patient;
	}
	
	/**
	 * Sets the patient.
	 *
	 * @param patient the new patient
	 */
	public void setPatient(TaggedText patient)
	{
		this.patient = patient;
	}
	
	/**
	 * Gets the instrument.
	 *
	 * @return the instrument
	 */
	public TaggedText getInstrument()
	{
		return instrument;
	}
	
	/**
	 * Sets the instrument.
	 *
	 * @param instrument the new instrument
	 */
	public void setInstrument(TaggedText instrument)
	{
		this.instrument = instrument;
	}
	
	/**
	 * Gets the date administered.
	 *
	 * @return the date administered
	 */
	public String getDateAdministered()
	{
		return dateAdministered;
	}
	
	/**
	 * Sets the date administered.
	 *
	 * @param dateAdministered the new date administered
	 */
	public void setDateAdministered(String dateAdministered)
	{
		this.dateAdministered = dateAdministered;
	}
	
	/**
	 * Gets the date saved.
	 *
	 * @return the date saved
	 */
	public String getDateSaved()
	{
		return dateSaved;
	}
	
	/**
	 * Sets the date saved.
	 *
	 * @param dateSaved the new date saved
	 */
	public void setDateSaved(String dateSaved)
	{
		this.dateSaved = dateSaved;
	}
	
	/**
	 * Gets the ordered by.
	 *
	 * @return the ordered by
	 */
	public TaggedText getOrderedBy()
	{
		return orderedBy;
	}
	
	/**
	 * Sets the ordered by.
	 *
	 * @param orderedBy the new ordered by
	 */
	public void setOrderedBy(TaggedText orderedBy)
	{
		this.orderedBy = orderedBy;
	}
	
	/**
	 * Gets the administered by.
	 *
	 * @return the administered by
	 */
	public TaggedText getAdministeredBy()
	{
		return administeredBy;
	}
	
	/**
	 * Sets the administered by.
	 *
	 * @param administeredBy the new administered by
	 */
	public void setAdministeredBy(TaggedText administeredBy)
	{
		this.administeredBy = administeredBy;
	}
	
	/**
	 * Checks if is signed.
	 *
	 * @return true, if is signed
	 */
	public boolean isSigned()
	{
		return isSigned;
	}
	
	/**
	 * Sets the signed.
	 *
	 * @param isSigned the new signed
	 */
	public void setSigned(boolean isSigned)
	{
		this.isSigned = isSigned;
	}
	
	/**
	 * Checks if is complete.
	 *
	 * @return true, if is complete
	 */
	public boolean isComplete()
	{
		return isComplete;
	}
	
	/**
	 * Sets the complete.
	 *
	 * @param isComplete the new complete
	 */
	public void setComplete(boolean isComplete)
	{
		this.isComplete = isComplete;
	}
	
	/**
	 * Gets the number of questions answered.
	 *
	 * @return the number of questions answered
	 */
	public String getNumberOfQuestionsAnswered()
	{
		return numberOfQuestionsAnswered;
	}
	
	/**
	 * Sets the number of questions answered.
	 *
	 * @param numberOfQuestionsAnswered the new number of questions answered
	 */
	public void setNumberOfQuestionsAnswered(String numberOfQuestionsAnswered)
	{
		this.numberOfQuestionsAnswered = numberOfQuestionsAnswered;
	}
	
	/**
	 * Gets the transmit status.
	 *
	 * @return the transmit status
	 */
	public String getTransmitStatus()
	{
		return transmitStatus;
	}
	
	/**
	 * Sets the transmit status.
	 *
	 * @param transmitStatus the new transmit status
	 */
	public void setTransmitStatus(String transmitStatus)
	{
		this.transmitStatus = transmitStatus;
	}
	
	/**
	 * Gets the transmit time.
	 *
	 * @return the transmit time
	 */
	public String getTransmitTime()
	{
		return transmitTime;
	}
	
	/**
	 * Sets the transmit time.
	 *
	 * @param transmitTime the new transmit time
	 */
	public void setTransmitTime(String transmitTime)
	{
		this.transmitTime = transmitTime;
	}
	
	/**
	 * Gets the hospital location.
	 *
	 * @return the hospital location
	 */
	public TaggedText getHospitalLocation()
	{
		return hospitalLocation;
	}
	
	/**
	 * Sets the hospital location.
	 *
	 * @param hospitalLocation the new hospital location
	 */
	public void setHospitalLocation(TaggedText hospitalLocation)
	{
		this.hospitalLocation = hospitalLocation;
	}
	
	/**
	 * Gets the results.
	 *
	 * @return the results
	 */
	public MentalHealthInstrumentResultSetTO getResults()
	{
		return results;
	}
	
	/**
	 * Sets the results.
	 *
	 * @param results the new results
	 */
	public void setResults(MentalHealthInstrumentResultSetTO results)
	{
		this.results = results;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "MentalHealthInstrumentAdministrationTO [id=" + id
				+ ", patient=" + patient + ", instrument=" + instrument
				+ ", dateAdministered=" + dateAdministered + ", dateSaved="
				+ dateSaved + ", orderedBy=" + orderedBy + ", administeredBy="
				+ administeredBy + ", isSigned=" + isSigned + ", isComplete="
				+ isComplete + ", numberOfQuestionsAnswered="
				+ numberOfQuestionsAnswered + ", transmitStatus="
				+ transmitStatus + ", transmitTime=" + transmitTime
				+ ", hospitalLocation=" + hospitalLocation + ", results="
				+ results + ", toString()=" + super.toString() + "]";
	}
    
    
    
}