package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.MentalHealthInstrumentResultSet;

import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * The Class MentalHealthInstrumentResultSetTO.
 */
@XmlRootElement(name="MentalHealthInstrumentResultSetTO")
@XmlAccessorType(XmlAccessType.NONE)
public class MentalHealthInstrumentResultSetTO
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The administration id. */
    @XmlElement(name="administrationId")
    protected String administrationId;
    
    /** The scale. */
    @XmlElement(name="scale")
    protected TaggedText scale;
    
    /** The raw score. */
    @XmlElement(name="rawScore")
    protected String rawScore;
    
    /** The transformed scores. */
    @XmlElement(name="transformedScores")
    protected TaggedTextArray transformedScores;
    
    /** The instrument. */
    @XmlElement(name="instrument")
    protected TaggedText instrument;
    
    /** The survey given date time. */
    @XmlElement(name="surveyGivenDateTime")
    protected String surveyGivenDateTime;
    
    /** The survey saved date time. */
    @XmlElement(name="surveySavedDateTime")
    protected String surveySavedDateTime;
	
    /**
     * Instantiates a new mental health instrument result set to.
     */
    public MentalHealthInstrumentResultSetTO()
    {    	
    }
    
    /**
     * Instantiates a new mental health instrument result set to.
     *
     * @param daoSiteDataBeans the dao site data beans
     */
    public MentalHealthInstrumentResultSetTO(Map<String, List<DataBean>> daoSiteDataBeans) 
    {    	
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys)
		{
			if (daoSiteDataBeans.get(siteKey).size() != 1)			// Should only be one at this level
	    		return; 
	    	
			for(DataBean dataBean: daoSiteDataBeans.get(siteKey))
			{
				populateResultSet(dataBean);				
			}
		}
	}
    
    /**
     * Instantiates a new mental health instrument result set to.
     *
     * @param dataBean the data bean
     */
    public MentalHealthInstrumentResultSetTO(DataBean dataBean)
    {
    	populateResultSet(dataBean);
    }
    
    /**
     * Populate result set using the information in the dataBeqan received
     *
     * @param dataBean the data bean with the information
     */
    private void populateResultSet(DataBean dataBean)
    {
    	if(dataBean instanceof Fault)
		{
			this.setFault(new FaultTO((Fault)dataBean));
			return;
		}
		
		MentalHealthInstrumentResultSet resultSet = (MentalHealthInstrumentResultSet)dataBean;
		this.id = resultSet.getId();
		this.administrationId = resultSet.getAdministrationId();				
		this.rawScore = resultSet.getRawScore();
		if (resultSet.getScale() != null)
		{
			this.scale = new TaggedText(resultSet.getScale());
		}
		
		if (resultSet.getTransformedScores() != null)
		{
			this.transformedScores = new TaggedTextArray(resultSet.getTransformedScores());
		}
		
		if (resultSet.getInstrument() != null)
		{
			this.instrument = new TaggedText(resultSet.getInstrument());
		}
    }
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the administration id.
	 *
	 * @return the administration id
	 */
	public String getAdministrationId()
	{
		return administrationId;
	}
	
	/**
	 * Sets the administration id.
	 *
	 * @param administrationId the new administration id
	 */
	public void setAdministrationId(String administrationId)
	{
		this.administrationId = administrationId;
	}
	
	/**
	 * Gets the scale.
	 *
	 * @return the scale
	 */
	public TaggedText getScale()
	{
		return scale;
	}
	
	/**
	 * Sets the scale.
	 *
	 * @param scale the new scale
	 */
	public void setScale(TaggedText scale)
	{
		this.scale = scale;
	}
	
	/**
	 * Gets the raw score.
	 *
	 * @return the raw score
	 */
	public String getRawScore()
	{
		return rawScore;
	}
	
	/**
	 * Sets the raw score.
	 *
	 * @param rawScore the new raw score
	 */
	public void setRawScore(String rawScore)
	{
		this.rawScore = rawScore;
	}
	
	/**
	 * Gets the transformed scores.
	 *
	 * @return the transformed scores
	 */
	public TaggedTextArray getTransformedScores()
	{
		return transformedScores;
	}
	
	/**
	 * Sets the transformed scores.
	 *
	 * @param transformedScores the new transformed scores
	 */
	public void setTransformedScores(TaggedTextArray transformedScores)
	{
		this.transformedScores = transformedScores;
	}
	
	/**
	 * Gets the instrument.
	 *
	 * @return the instrument
	 */
	public TaggedText getInstrument()
	{
		return instrument;
	}
	
	/**
	 * Sets the instrument.
	 *
	 * @param instrument the new instrument
	 */
	public void setInstrument(TaggedText instrument)
	{
		this.instrument = instrument;
	}
	
	/**
	 * Gets the survey given date time.
	 *
	 * @return the survey given date time
	 */
	public String getSurveyGivenDateTime()
	{
		return surveyGivenDateTime;
	}
	
	/**
	 * Sets the survey given date time.
	 *
	 * @param surveyGivenDateTime the new survey given date time
	 */
	public void setSurveyGivenDateTime(String surveyGivenDateTime)
	{
		this.surveyGivenDateTime = surveyGivenDateTime;
	}
	
	/**
	 * Gets the survey saved date time.
	 *
	 * @return the survey saved date time
	 */
	public String getSurveySavedDateTime()
	{
		return surveySavedDateTime;
	}
	
	/**
	 * Sets the survey saved date time.
	 *
	 * @param surveySavedDateTime the new survey saved date time
	 */
	public void setSurveySavedDateTime(String surveySavedDateTime)
	{
		this.surveySavedDateTime = surveySavedDateTime;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "MentalHealthInstrumentResultSetTO [id=" + id
				+ ", administrationId=" + administrationId + ", scale=" + scale
				+ ", rawScore=" + rawScore + ", transformedScores="
				+ transformedScores + ", instrument=" + instrument
				+ ", surveyGivenDateTime=" + surveyGivenDateTime
				+ ", surveySavedDateTime=" + surveySavedDateTime
				+ ", toString()=" + super.toString() + "]";
	}
}
