package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.MicrobiologyReport;

// TODO: Auto-generated Javadoc
/**
 * The Class MicrobiologyRpt.
 */
@XmlRootElement(name="MicrobiologyRpt")
@XmlAccessorType(XmlAccessType.NONE)
public class MicrobiologyRpt extends AbstractTO
{
	   
    /** The id. */
	@XmlElement(name="id")
    protected String id;
       
    /** The title. */
	@XmlElement(name="title")	
    protected String title;
   
    /** The timestamp. */
	@XmlElement(name="timestamp")	
    protected String timestamp;
   
    /** The author. */
	@XmlElement(name="author")	
    protected AuthorTO author;
   
    /** The facility. */
	@XmlElement(name="facility")	
    protected TaggedText facility;
   
    /** The specimen. */
	@XmlElement(name="specimen")	
    protected LabSpecimenTO specimen;
   
    /** The comment. */
	@XmlElement(name="comment")	
    protected String comment;
   
    /** The sample. */
	@XmlElement(name="sample")	
    protected String sample;
   
    /** The text. */
	@XmlElement(name="text")	
    protected String text;
       
  	/**
	   * Instantiates a new microbiology rpt.
	   */
	  public MicrobiologyRpt() 
  	{
	}

	/**
	 * Instantiates a new microbiology rpt.
	 *
	 * @param report the report
	 */
	public MicrobiologyRpt(MicrobiologyReport report) 
	{
		if ( report.getFault()!=null ){
			this.setFault(new FaultTO(report.getFault()));
		}
		else{
			this.id = report.getId();
			this.title = report.getTitle();
			this.timestamp = report.getTimestamp();
			this.comment = report.getComment();
			this.sample = report.getSample();
			this.text = report.getText();
			
			if (report.getAuthor() != null)
			{
				this.author = new AuthorTO(report.getAuthor());
			}
			
			if (report.getFacility() != null)
			{
				this.facility = new TaggedText(report.getFacility().getId(), report.getFacility().getName());
			}
			
			if (report.getSpecimen() != null)
			{
				this.specimen = new LabSpecimenTO(report.getSpecimen());
			}
		}
	}
		
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public AuthorTO getAuthor()
	{
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(AuthorTO author)
	{
		this.author = author;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the specimen.
	 *
	 * @return the specimen
	 */
	public LabSpecimenTO getSpecimen()
	{
		return specimen;
	}
	
	/**
	 * Sets the specimen.
	 *
	 * @param specimen the new specimen
	 */
	public void setSpecimen(LabSpecimenTO specimen)
	{
		this.specimen = specimen;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/**
	 * Gets the sample.
	 *
	 * @return the sample
	 */
	public String getSample()
	{
		return sample;
	}
	
	/**
	 * Sets the sample.
	 *
	 * @param sample the new sample
	 */
	public void setSample(String sample)
	{
		this.sample = sample;
	}
	
	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}
	
	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "MicrobiologyRpt [id=" + id + ", title=" + title
				+ ", timestamp=" + timestamp + ", author=" + author
				+ ", facility=" + facility + ", specimen=" + specimen
				+ ", comment=" + comment + ", sample=" + sample + ", text="
				+ text + ", toString()=" + super.toString() + "]";
	}
}
