package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.NoteResult;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name="NoteResultTO")
@XmlAccessorType(XmlAccessType.NONE)
public class NoteResultTO
    extends AbstractTO
{
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The total pages. */
	@XmlElement(name="totalPages")
    protected Integer totalPages;
    
    /** The last page recd. */
	@XmlElement(name="lastPageRecd")
    protected Integer lastPageRecd;
    
    /** The explanation. */
	@XmlElement(name="explanation")
    protected String explanation;
    
	public NoteResultTO(DataBean noteDatabean){
		if(noteDatabean instanceof Fault){
			this.setFault(new FaultTO((Fault)noteDatabean));
		}
		else{
			populateNote((NoteResult)noteDatabean);	
		}
	}
	public NoteResultTO(NoteResult noteResult) 
	{
		populateNote(noteResult);
	}
	
	protected void populateNote(NoteResult noteResult){
		if ( noteResult.getFault()!=null ){
			this.fault= new FaultTO(noteResult.getFault());
		}
		else{
			this.id = noteResult.getId();
			this.totalPages=noteResult.getTotalPages();
			this.lastPageRecd=noteResult.getLastPageRecd();
			this.explanation=noteResult.getExplanation();
		}
		
	}

	public NoteResultTO() 
	{
	}

	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the total pages.
	 *
	 * @return the total pages
	 */
	public Integer getTotalPages()
	{
		return totalPages;
	}
	
	/**
	 * Sets the total pages.
	 *
	 * @param totalPages the new total pages
	 */
	public void setTotalPages(Integer totalPages)
	{
		this.totalPages = totalPages;
	}
	
	/**
	 * Gets the last page recd.
	 *
	 * @return the last page recd
	 */
	public Integer getLastPageRecd()
	{
		return lastPageRecd;
	}
	
	/**
	 * Sets the last page recd.
	 *
	 * @param lastPageRecd the new last page recd
	 */
	public void setLastPageRecd(Integer lastPageRecd)
	{
		this.lastPageRecd = lastPageRecd;
	}
	
	/**
	 * Gets the explanation.
	 *
	 * @return the explanation
	 */
	public String getExplanation()
	{
		return explanation;
	}
	
	/**
	 * Sets the explanation.
	 *
	 * @param explanation the new explanation
	 */
	public void setExplanation(String explanation)
	{
		this.explanation = explanation;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "NoteResultTO [id=" + id + ", totalPages=" + totalPages
				+ ", lastPageRecd=" + lastPageRecd + ", explanation="
				+ explanation + ", toString()=" + super.toString() + "]";
	}
}
