package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.HospitalLocation;
import gov.va.med.via.databeans.Note;
import gov.va.med.via.rpc.RPCStringUtils;


/**
 * The Class NoteTO.
 */
@XmlRootElement(name="NoteTO")
@XmlAccessorType(XmlAccessType.NONE)
public class NoteTO
    extends AbstractTO
{

    /** The id. */
	@XmlElement(name="id") 
    protected String id;
    
    /** The timestamp. */
	@XmlElement(name="timestamp") 
    protected String timestamp;
    
    /** The admit timestamp. */
	@XmlElement(name="admitTimestamp") 
    protected String admitTimestamp;
    
    public NoteTO() {
		super();
	}
    public NoteTO( Note note)
    {
    	admitTimestamp=note.getAdmitTimestamp();
    	approvedBy=note.getApprovedBy()==null?null:new AuthorTO(note.getApprovedBy());
    	author=note.getAuthor()==null?null:new AuthorTO(note.getAuthor());
    	consultId=note.getConsultId();
    	cosigner=note.getCosigner()==null?null:new AuthorTO(note.getCosigner());
    	dischargeTimestamp=note.getDischargeTimestamp();
    	hasAddendum=note.isHasAddendum();
    	hasImages=note.isHasImages();
    	id=note.getId();
    	isAddendum=note.isAddendum();
    	itemId=note.getItemId();
    	localTitle=note.getLocalTitle();
    	if (note.getLocation() != null)
    	{
    		location=new HospitalLocationTO(note.getLocation());
    	}
    	else if (note.getSiteIdBean() != null && !RPCStringUtils.isNullOrEmpty(note.getSiteIdBean().getId()) && !RPCStringUtils.isNullOrEmpty(note.getSiteIdBean().getName()))
    	{
    		location=new HospitalLocationTO(new HospitalLocation(note.getSiteIdBean().getId(), note.getSiteIdBean().getName()));
    	}
    	originalNoteID=note.getOriginalNoteID();
    	parentId=note.getParentId();
    	prfId=note.getPrfId();
    	procId=note.getProcId();
    	procTimestamp=note.getProcTimestamp();
    	serviceCategory=note.getServiceCategory();
    	signatureTimestamp=note.getSignatureTimestamp();
    	standardTitle=note.getStandardTitle();
    	status=note.getStatus();
    	subject=note.getSubject();
    	surgicalProcId=note.getSurgicalProcId();
    	text=note.getText();
    	timestamp=note.getTimestamp();
    	type=note.getType();
    }

	/** The discharge timestamp. */
    @XmlElement(name="dischargeTimestamp") 
    protected String dischargeTimestamp;
    
    /** The service category. */
    @XmlElement(name="serviceCategory") 
    protected String serviceCategory;
    
    /** The local title. */
    @XmlElement(name="localTitle") 
    protected String localTitle;
    
    /** The standard title. */
    @XmlElement(name="standardTitle") 
    protected String standardTitle;
    
    /** The author. */
    @XmlElement(name="author") 
    protected AuthorTO author;
    
    /** The cosigner - attributely manually added during MDWS 2.5 analysis of Note class	*/
    @XmlElement(name="cosigner") 
    protected AuthorTO cosigner;
    
    /** The location. */
    @XmlElement(name="location") 
    protected HospitalLocationTO location;
    
    /** The text. */
    @XmlElement(name="text") 
    protected String text;
    
    /** The has addendum. */
    @XmlElement(name="hasAddendum") 
    protected Boolean hasAddendum=null;
    
    /** The is addendum. */
    @XmlElement(name="isAddendum") 
    protected Boolean isAddendum=null;
    
    /** The original note id. */
    @XmlElement(name="originalNoteID") 
    protected String originalNoteID;
    
    /** The has images. */
    @XmlElement(name="hasImages") 
    protected Boolean hasImages;
    
    /** The item id. */
    @XmlElement(name="itemId") 
    protected String itemId;
    
    /** The approved by. */
    @XmlElement(name="approvedBy") 
    protected AuthorTO approvedBy;
    
    /** The status. */
    @XmlElement(name="status") 
    protected String status;
    
    /** The type. */
    @XmlElement(name="type") 
    protected String type;
    
    /** The signature timestamp. */
    @XmlElement(name="signatureTimestamp") 
    protected String signatureTimestamp;

    /// BEGIN: attributes manually added during MDWS 2.5 analysis of Note class
    
    /*
     * the site Id - 
     */
 //   protected SiteId siteId;
    
    protected String consultId;
    
    protected String surgicalProcId;
    
    protected String prfId;
    
    protected String parentId;
    
    protected String procId;
    
    protected String procTimestamp;
    
    protected String subject;
    
    /// END:
    
    
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the admit timestamp.
	 *
	 * @return the admit timestamp
	 */
	public String getAdmitTimestamp()
	{
		return admitTimestamp;
	}
	
	/**
	 * Sets the admit timestamp.
	 *
	 * @param admitTimestamp the new admit timestamp
	 */
	public void setAdmitTimestamp(String admitTimestamp)
	{
		this.admitTimestamp = admitTimestamp;
	}
	
	/**
	 * Gets the discharge timestamp.
	 *
	 * @return the discharge timestamp
	 */
	public String getDischargeTimestamp()
	{
		return dischargeTimestamp;
	}
	
	/**
	 * Sets the discharge timestamp.
	 *
	 * @param dischargeTimestamp the new discharge timestamp
	 */
	public void setDischargeTimestamp(String dischargeTimestamp)
	{
		this.dischargeTimestamp = dischargeTimestamp;
	}
	
	/**
	 * Gets the service category.
	 *
	 * @return the service category
	 */
	public String getServiceCategory()
	{
		return serviceCategory;
	}
	
	/**
	 * Sets the service category.
	 *
	 * @param serviceCategory the new service category
	 */
	public void setServiceCategory(String serviceCategory)
	{
		this.serviceCategory = serviceCategory;
	}
	
	/**
	 * Gets the local title.
	 *
	 * @return the local title
	 */
	public String getLocalTitle()
	{
		return localTitle;
	}
	
	/**
	 * Sets the local title.
	 *
	 * @param localTitle the new local title
	 */
	public void setLocalTitle(String localTitle)
	{
		this.localTitle = localTitle;
	}
	
	/**
	 * Gets the standard title.
	 *
	 * @return the standard title
	 */
	public String getStandardTitle()
	{
		return standardTitle;
	}
	
	/**
	 * Sets the standard title.
	 *
	 * @param standardTitle the new standard title
	 */
	public void setStandardTitle(String standardTitle)
	{
		this.standardTitle = standardTitle;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public AuthorTO getAuthor()
	{
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(AuthorTO author)
	{
		this.author = author;
	}
	
	/**
	 * Gets the location.
	 *
	 * @return the location
	 */
	public HospitalLocationTO getLocation()
	{
		return location;
	}
	
	/**
	 * Sets the location.
	 *
	 * @param location the new location
	 */
	public void setLocation(HospitalLocationTO location)
	{
		this.location = location;
	}
	
	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}
	
	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}
	
	/**
	 * Checks if is checks for addendum.
	 *
	 * @return true, if is checks for addendum
	 */
	public Boolean isHasAddendum()
	{
		return hasAddendum;
	}
	
	/**
	 * Sets the checks for addendum.
	 *
	 * @param hasAddendum the new checks for addendum
	 */
	public void setHasAddendum(boolean hasAddendum)
	{
		this.hasAddendum = hasAddendum;
	}
	
	/**
	 * Checks if is addendum.
	 *
	 * @return true, if is addendum
	 */
	public Boolean isAddendum()
	{
		return isAddendum;
	}
	
	/**
	 * Sets the addendum.
	 *
	 * @param isAddendum the new addendum
	 */
	public void setAddendum(boolean isAddendum)
	{
		this.isAddendum = isAddendum;
	}
	
	/**
	 * Gets the original note id.
	 *
	 * @return the original note id
	 */
	public String getOriginalNoteID()
	{
		return originalNoteID;
	}
	
	/**
	 * Sets the original note id.
	 *
	 * @param originalNoteID the new original note id
	 */
	public void setOriginalNoteID(String originalNoteID)
	{
		this.originalNoteID = originalNoteID;
	}
	
	/**
	 * Checks if is checks for images.
	 *
	 * @return true, if is checks for images
	 */
	public Boolean isHasImages()
	{
		return hasImages;
	}
	
	/**
	 * Sets the checks for images.
	 *
	 * @param hasImages the new checks for images
	 */
	public void setHasImages(boolean hasImages)
	{
		this.hasImages = hasImages;
	}
	
	/**
	 * Gets the item id.
	 *
	 * @return the item id
	 */
	public String getItemId()
	{
		return itemId;
	}
	
	/**
	 * Sets the item id.
	 *
	 * @param itemId the new item id
	 */
	public void setItemId(String itemId)
	{
		this.itemId = itemId;
	}
	
	/**
	 * Gets the approved by.
	 *
	 * @return the approved by
	 */
	public AuthorTO getApprovedBy()
	{
		return approvedBy;
	}
	
	/**
	 * Sets the approved by.
	 *
	 * @param approvedBy the new approved by
	 */
	public void setApprovedBy(AuthorTO approvedBy)
	{
		this.approvedBy = approvedBy;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the signature timestamp.
	 *
	 * @return the signature timestamp
	 */
	public String getSignatureTimestamp()
	{
		return signatureTimestamp;
	}
	
	/**
	 * Sets the signature timestamp.
	 *
	 * @param signatureTimestamp the new signature timestamp
	 */
	public void setSignatureTimestamp(String signatureTimestamp)
	{
		this.signatureTimestamp = signatureTimestamp;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "NoteTO [id=" + id + ", timestamp=" + timestamp
				+ ", admitTimestamp=" + admitTimestamp
				+ ", dischargeTimestamp=" + dischargeTimestamp
				+ ", serviceCategory=" + serviceCategory + ", localTitle="
				+ localTitle + ", standardTitle=" + standardTitle + ", author="
				+ author + ", location=" + location + ", text=" + text
				+ ", hasAddendum=" + hasAddendum + ", isAddendum=" + isAddendum
				+ ", originalNoteID=" + originalNoteID + ", hasImages="
				+ hasImages + ", itemId=" + itemId + ", approvedBy="
				+ approvedBy + ", status=" + status + ", type=" + type
				+ ", signatureTimestamp=" + signatureTimestamp
				+ ", toString()=" + super.toString() + "]";
	}

	public AuthorTO getCosigner() {
		return cosigner;
	}

	public void setCosigner(AuthorTO cosigner) {
		this.cosigner = cosigner;
	}
	
	public String getConsultId() {
		return consultId;
	}

	public void setConsultId(String consultId) {
		this.consultId = consultId;
	}

	public String getSurgicalProcId() {
		return surgicalProcId;
	}

	public void setSurgicalProcId(String surgicalProcId) {
		this.surgicalProcId = surgicalProcId;
	}

	public String getPrfId() {
		return prfId;
	}

	public void setPrfId(String prfId) {
		this.prfId = prfId;
	}

	public String getParentId() {
		return parentId;
	}

	public void setParentId(String parentId) {
		this.parentId = parentId;
	}

	public String getProcId() {
		return procId;
	}

	public void setProcId(String procId) {
		this.procId = procId;
	}

	public String getProcTimestamp() {
		return procTimestamp;
	}

	public void setProcTimestamp(String procTimestamp) {
		this.procTimestamp = procTimestamp;
	}

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}
}