package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlList;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * This is the generic patient object used for patient lookup. This class has a limited number of attributes.
 * 
 * @author DOMAINROMERJ
 */
@XmlRootElement(name="Patient")
@XmlAccessorType(XmlAccessType.NONE)
public class Patient
{
	/** Patient name. */
	@XmlElement(name="name")
    protected String name;
	
    /** The local pid. */
	@XmlElement(name="localPid")
    protected String localPid;
        
    /** The local site id. */
	@XmlElement(name="localSiteId")
    protected String localSiteId;

    /** The mpi pid. */
	@XmlElement(name="mpiPid")
    protected String mpiPid;
    
    /** The vista locations. */
	@XmlElement(name="vistaLocations")
	@XmlList
    protected String[] vistaLocations; 
    
	/** parameter element - not returned or displayed in response. */
	@XmlElement(name="ssn")
	protected String ssn;
	
	/** The in patient. */
	@XmlElement(name="inPatient")
	protected String inPatient;
	
	/** The age. */
	@XmlElement(name="age")
	protected String age;
	
	/** The gender. */
	@XmlElement(name="gender")
	protected String gender;
	
	/** The sc percentage. */
	@XmlElement(name="scPercentage")
	protected String scPercentage;
	

	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}

	/**
	 * Gets the local pid.
	 *
	 * @return the local pid
	 */
	public String getLocalPid()
	{
		return localPid;
	}
	
	/**
	 * Sets the local pid.
	 *
	 * @param localPid the new local pid
	 */
	public void setLocalPid(String localPid)
	{
		this.localPid = localPid;
	}
	
	
	/**
	 * Gets the local site id.
	 *
	 * @return the local site id
	 */
	public String getLocalSiteId()
	{
		return localSiteId;
	}

	/**
	 * Sets the local site id.
	 *
	 * @param localSiteId the new local site id
	 */
	public void setLocalSiteId(String localSiteId)
	{
		this.localSiteId = localSiteId;
	}

	/**
	 * Gets the mpi pid.
	 *
	 * @return the mpi pid
	 */
	public String getMpiPid()
	{
		return mpiPid;
	}

	/**
	 * Sets the mpi pid.
	 *
	 * @param mpiPid the new mpi pid
	 */
	public void setMpiPid(String mpiPid)
	{
		this.mpiPid = mpiPid;
	}

	/**
	 * Gets the vista locations.
	 *
	 * @return the vista locations
	 */
	public String[] getVistaLocations()
	{
		return vistaLocations; // TODO - if empty, set and return from SiteId list if not empty.
	}
	
	/**
	 * Sets the vista locations.
	 *
	 * @param vistaLocations the new vista locations
	 */
	public void setVistaLocations(String[] vistaLocations)
	{
		this.vistaLocations = vistaLocations;
	}

	/**
	 * Gets the ssn.
	 *
	 * @return the ssn
	 */
	public String getSsn() {
		return ssn;
	}

	/**
	 * Sets the ssn.
	 *
	 * @param ssn the new ssn
	 */
	public void setSsn(String ssn) {
		this.ssn = ssn;
	}
	

	/**
	 * Gets the in patient.
	 *
	 * @return the in patient
	 */
	public String getInPatient()
	{
		return inPatient;
	}

	/**
	 * Sets the in patient.
	 *
	 * @param inPatient the new in patient
	 */
	public void setInPatient(String inPatient)
	{
		this.inPatient = inPatient;
	}

	/**
	 * Gets the age.
	 *
	 * @return the age
	 */
	public String getAge()
	{
		return age;
	}

	/**
	 * Sets the age.
	 *
	 * @param age the new age
	 */
	public void setAge(String age)
	{
		this.age = age;
	}

	/**
	 * Gets the gender.
	 *
	 * @return the gender
	 */
	public String getGender()
	{
		return gender;
	}

	/**
	 * Sets the gender.
	 *
	 * @param gender the new gender
	 */
	public void setGender(String gender)
	{
		this.gender = gender;
	}

	/**
	 * Gets the sc percentage.
	 *
	 * @return the sc percentage
	 */
	public String getScPercentage()
	{
		return scPercentage;
	}

	/**
	 * Sets the sc percentage.
	 *
	 * @param scPercentage the new sc percentage
	 */
	public void setScPercentage(String scPercentage)
	{
		this.scPercentage = scPercentage;
	}
}
