package gov.va.med.via.dto.common;

import java.util.Calendar;

// TODO: Auto-generated Javadoc
/**
 * This class represents Appointments associated with a patient;.
 */
public class PatientAppointments extends DataBean
{
   /**
    * Date/time of appointment.
    */
	protected Calendar apptDate;
   /**
    * Name of clinic associated with appointment.
    */
	protected String clinic;
   /**
    * Status of appointment.
    */
	protected String status;
   /**
    * Type of appointment.
    */
	protected String apptType;
   /**
    * Name of provider associated with appointment. Not populated for vista appointments.
    */
	protected String providerName;
   /**
    * Reason for appointment.
    */
	protected String reason;
   /**
    * Internal id of clinic for this appointment.
    */
	protected String clinicId;
   /**
    * Internal ID of provider associated with appointment.  Not populated for vista
    * appointments.
    */
	protected String providerId;
   /**
    * Provider class of the provider associated with appointment.  Not populated for 
    * vista appointments.
    */
	protected String providerClass;
   /**
    * Phone number of provider associated with appointment. Not populated for vista
    * appointments.
    */
	protected String providerPhone;
   /**
    * pager number of provider associated with this appointment.  This property
    * is not populated for vista appointments.
    */
	protected String providerPager;
   /**
    * internal id of appointment.  this is used to retieve notes, diagnoses and/or
    * procedures associated with an appointment/visit.
    */
	protected String apptId;
  
	/**
	 * Gets the appt date.
	 *
	 * @return the appt date
	 */
	public Calendar getApptDate()
	{
		return apptDate;
	}
	
	/**
	 * Sets the appt date.
	 *
	 * @param apptDate the new appt date
	 */
	public void setApptDate(Calendar apptDate)
	{
		this.apptDate = apptDate;
	}
	
	/**
	 * Gets the clinic.
	 *
	 * @return the clinic
	 */
	public String getClinic()
	{
		return clinic;
	}
	
	/**
	 * Sets the clinic.
	 *
	 * @param clinic the new clinic
	 */
	public void setClinic(String clinic)
	{
		this.clinic = clinic;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the appt type.
	 *
	 * @return the appt type
	 */
	public String getApptType()
	{
		return apptType;
	}
	
	/**
	 * Sets the appt type.
	 *
	 * @param apptType the new appt type
	 */
	public void setApptType(String apptType)
	{
		this.apptType = apptType;
	}
	
	/**
	 * Gets the provider name.
	 *
	 * @return the provider name
	 */
	public String getProviderName()
	{
		return providerName;
	}
	
	/**
	 * Sets the provider name.
	 *
	 * @param providerName the new provider name
	 */
	public void setProviderName(String providerName)
	{
		this.providerName = providerName;
	}
	
	/**
	 * Gets the reason.
	 *
	 * @return the reason
	 */
	public String getReason()
	{
		return reason;
	}
	
	/**
	 * Sets the reason.
	 *
	 * @param reason the new reason
	 */
	public void setReason(String reason)
	{
		this.reason = reason;
	}
	
	/**
	 * Gets the clinic id.
	 *
	 * @return the clinic id
	 */
	public String getClinicId()
	{
		return clinicId;
	}
	
	/**
	 * Sets the clinic id.
	 *
	 * @param clinicId the new clinic id
	 */
	public void setClinicId(String clinicId)
	{
		this.clinicId = clinicId;
	}
	
	/**
	 * Gets the provider id.
	 *
	 * @return the provider id
	 */
	public String getProviderId()
	{
		return providerId;
	}
	
	/**
	 * Sets the provider id.
	 *
	 * @param providerId the new provider id
	 */
	public void setProviderId(String providerId)
	{
		this.providerId = providerId;
	}
	
	/**
	 * Gets the provider class.
	 *
	 * @return the provider class
	 */
	public String getProviderClass()
	{
		return providerClass;
	}
	
	/**
	 * Sets the provider class.
	 *
	 * @param providerClass the new provider class
	 */
	public void setProviderClass(String providerClass)
	{
		this.providerClass = providerClass;
	}
	
	/**
	 * Gets the provider phone.
	 *
	 * @return the provider phone
	 */
	public String getProviderPhone()
	{
		return providerPhone;
	}
	
	/**
	 * Sets the provider phone.
	 *
	 * @param providerPhone the new provider phone
	 */
	public void setProviderPhone(String providerPhone)
	{
		this.providerPhone = providerPhone;
	}
	
	/**
	 * Gets the provider pager.
	 *
	 * @return the provider pager
	 */
	public String getProviderPager()
	{
		return providerPager;
	}
	
	/**
	 * Sets the provider pager.
	 *
	 * @param providerPager the new provider pager
	 */
	public void setProviderPager(String providerPager)
	{
		this.providerPager = providerPager;
	}
	
	/**
	 * Gets the appt id.
	 *
	 * @return the appt id
	 */
	public String getApptId()
	{
		return apptId;
	}
	
	/**
	 * Sets the appt id.
	 *
	 * @param apptId the new appt id
	 */
	public void setApptId(String apptId)
	{
		this.apptId = apptId;
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.DataBean#toString()
	 */
	@Override
	public String toString()
	{
		return "PatientAppointments [apptDate=" + apptDate + ", clinic=" + clinic
				+ ", status=" + status + ", apptType=" + apptType
				+ ", providerName=" + providerName + ", reason=" + reason
				+ ", clinicId=" + clinicId + ", providerId=" + providerId
				+ ", providerClass=" + providerClass + ", providerPhone="
				+ providerPhone + ", providerPager=" + providerPager + ", apptId="
				+ apptId + ", toString()=" + super.toString() + "]";
	}
	  
}