package gov.va.med.via.dto.common;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


@XmlRootElement(name="PatientArray")
@XmlAccessorType(XmlAccessType.NONE)
public class PatientArray extends AbstractArrayTO
{

	/** The items. */
	@XmlElementWrapper(name="patients")
	@XmlElement(name="patientTO")	
	protected List<PatientTO> patients;

	public PatientArray() {
		super();
	}

	public PatientArray( gov.va.med.via.databeans.Patient[] pa)
	{
		if ( pa==null ) pa = new gov.va.med.via.databeans.Patient[0];
		
		patients = new ArrayList<PatientTO>(pa.length);
		for ( gov.va.med.via.databeans.Patient p: pa)
		{
			patients.add(new PatientTO(p));
		}
		setCount(pa.length);
	}

	/**
	 * Gets the patients.
	 *
	 * @return the patients
	 */
	public List<PatientTO> getPatients()
	{
		return patients;
	}

	/**
	 * Sets the patients.
	 *
	 * @param patients the new patients
	 */
	public void setPatients(List<PatientTO> patients)
	{
		this.patients = patients;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "PatientArray [patients=" + patients + ", toString()="
				+ super.toString() + "]";
	}
}
