package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.PatientAssociate;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class PatientAssociateTO.
 */
@XmlRootElement(name="PatientAssociateTO")
@XmlAccessorType(XmlAccessType.NONE)
public class PatientAssociateTO
    extends PersonTO
{
    /** The association. */
	@XmlElement(name="association")
    protected String association;
    
    /** The relationship to patient. */
	@XmlElement(name="relationshipToPatient")
    protected String relationshipToPatient;
    
    /** The facility name. */
	@XmlElement(name="facilityName")
    protected String facilityName;
	
	public PatientAssociateTO()
	{		
	}
	
	public PatientAssociateTO(PatientAssociate associate) 
	{
		super(associate);
		
		if ( associate.getFault()!=null )
		{
			this.setFault(new FaultTO(associate.getFault()));
		}
		else
		{
			this.association = associate.getAssociate();
			this.relationshipToPatient = associate.getRelationshipToPatient();
			this.facilityName = associate.getFacilityName();
		}
	}
	/**
	 * Gets the association.
	 *
	 * @return the association
	 */
	public String getAssociation()
	{
		return association;
	}
	
	/**
	 * Sets the association.
	 *
	 * @param association the new association
	 */
	public void setAssociation(String association)
	{
		this.association = association;
	}
	
	/**
	 * Gets the relationship to patient.
	 *
	 * @return the relationship to patient
	 */
	public String getRelationshipToPatient()
	{
		return relationshipToPatient;
	}
	
	/**
	 * Sets the relationship to patient.
	 *
	 * @param relationshipToPatient the new relationship to patient
	 */
	public void setRelationshipToPatient(String relationshipToPatient)
	{
		this.relationshipToPatient = relationshipToPatient;
	}
	
	/**
	 * Gets the facility name.
	 *
	 * @return the facility name
	 */
	public String getFacilityName()
	{
		return facilityName;
	}
	
	/**
	 * Sets the facility name.
	 *
	 * @param facilityName the new facility name
	 */
	public void setFacilityName(String facilityName)
	{
		this.facilityName = facilityName;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "PatientAssociateTO [association=" + association
				+ ", relationshipToPatient=" + relationshipToPatient
				+ ", facilityName=" + facilityName + ", toString()="
				+ super.toString() + "]";
	}
}
