package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.PatientRecordFlag;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * The Class PatientRecordFlagArray.
 */
@XmlRootElement(name="PatientRecordFlagArray")
@XmlAccessorType(XmlAccessType.NONE)
public class PatientRecordFlagArray
    extends AbstractArrayTO
{
	@XmlElementWrapper(name="flags")
	@XmlElement(name="patientRecordFlagTO")
    protected List<PatientRecordFlagTO> flags;

	public PatientRecordFlagArray(	Map<String, List<DataBean>> siteDataBeanMapForDao) 
	{
		List<PatientRecordFlagTO> flagList = new ArrayList<PatientRecordFlagTO>();
		int count =0;
		for ( String site: siteDataBeanMapForDao.keySet())
		{
			for ( DataBean dataBean: siteDataBeanMapForDao.get(site))
			{
				PatientRecordFlag prf = (PatientRecordFlag)dataBean;
				flagList.add(new PatientRecordFlagTO(prf));
				count++;
			}
		}
		setFlags(flagList);
		setCount(count);
	}

	public PatientRecordFlagArray() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * Gets the flags.
	 *
	 * @return the flags
	 */
	public List<PatientRecordFlagTO> getFlags()
	{
		return flags;
	}

	/**
	 * Sets the flags.
	 *
	 * @param flags the new flags
	 */
	public void setFlags(List<PatientRecordFlagTO> flags)
	{
		this.flags = flags;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "PatientRecordFlagArray [flags=" + flags + ", toString()="
				+ super.toString() + "]";
	}
    
}