package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.PatientRecordFlag;

/**
 * The Class PatientRecordFlagTO.
 */
@XmlRootElement(name="PatientRecordFlagArray")
@XmlAccessorType(XmlAccessType.NONE)
public class PatientRecordFlagTO
    extends AbstractTO
{

    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
	/** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The action id. */
	@XmlElement(name="actionId")
    protected String actionId;
    
    /** The action name. */
	@XmlElement(name="actionName")
    protected String actionName;
    
    /** The action timestamp. */
	@XmlElement(name="actionTimestamp")
    protected String actionTimestamp;
    
    /** The note id. */
	@XmlElement(name="noteId")
    protected String noteId;
	
	public PatientRecordFlagTO(PatientRecordFlag prf) 
	{
		id = prf.getId();
		name = prf.getName();
		actionId = prf.getActionId();
		actionName = prf.getActionName();
		actionTimestamp = prf.getActionTimestamp();
		noteId = prf.getNoteId();
	}

    public PatientRecordFlagTO() {
		super();
	}

	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the action id.
	 *
	 * @return the action id
	 */
	public String getActionId()
	{
		return actionId;
	}
	
	/**
	 * Sets the action id.
	 *
	 * @param actionId the new action id
	 */
	public void setActionId(String actionId)
	{
		this.actionId = actionId;
	}
	
	/**
	 * Gets the action name.
	 *
	 * @return the action name
	 */
	public String getActionName()
	{
		return actionName;
	}
	
	/**
	 * Sets the action name.
	 *
	 * @param actionName the new action name
	 */
	public void setActionName(String actionName)
	{
		this.actionName = actionName;
	}
	
	/**
	 * Gets the action timestamp.
	 *
	 * @return the action timestamp
	 */
	public String getActionTimestamp()
	{
		return actionTimestamp;
	}
	
	/**
	 * Sets the action timestamp.
	 *
	 * @param actionTimestamp the new action timestamp
	 */
	public void setActionTimestamp(String actionTimestamp)
	{
		this.actionTimestamp = actionTimestamp;
	}
	
	/**
	 * Gets the note id.
	 *
	 * @return the note id
	 */
	public String getNoteId()
	{
		return noteId;
	}
	
	/**
	 * Sets the note id.
	 *
	 * @param noteId the new note id
	 */
	public void setNoteId(String noteId)
	{
		this.noteId = noteId;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "PatientRecordFlagTO [id=" + id + ", name=" + name
				+ ", actionId=" + actionId + ", actionName=" + actionName
				+ ", actionTimestamp=" + actionTimestamp + ", noteId=" + noteId
				+ ", toString()=" + super.toString() + "]";
	} 
    
}