package gov.va.med.via.dto.common;

import java.util.Calendar;


// TODO: Auto-generated Javadoc
/**
 * Class representing patient problems.
 */
public class Problem extends DataBean
{
	  /**
	   * Internal ID of problem. Used to retrieve problem details.
	   */
	  private String Id;
	  /**
	   * ICD code of the problem.
	   */
	  private String icdCode;
	  /**
	   * Description of problem.
	   */
	  private String description;
	  
  	/** Acuity of problem (Acute or chronic). */
	  private String acuity;
	  /**
	   * Date of  onset of the problem.
	   */
	  private Calendar onsetDate;
	  /**
	   * Status of a problem.
	   */
	  private String status;
	  /**
	   * Date the problem was last modified.
	   */ 
	  private Calendar lastModifiedDate;
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return Id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		Id = id;
	}
	
	/**
	 * Gets the icd code.
	 *
	 * @return the icd code
	 */
	public String getIcdCode()
	{
		return icdCode;
	}
	
	/**
	 * Sets the icd code.
	 *
	 * @param icdCode the new icd code
	 */
	public void setIcdCode(String icdCode)
	{
		this.icdCode = icdCode;
	}
	
	/**
	 * Gets the description.
	 *
	 * @return the description
	 */
	public String getDescription()
	{
		return description;
	}
	
	/**
	 * Sets the description.
	 *
	 * @param description the new description
	 */
	public void setDescription(String description)
	{
		this.description = description;
	}
	
	/**
	 * Gets the acuity.
	 *
	 * @return the acuity
	 */
	public String getAcuity()
	{
		return acuity;
	}
	
	/**
	 * Sets the acuity.
	 *
	 * @param acuity the new acuity
	 */
	public void setAcuity(String acuity)
	{
		this.acuity = acuity;
	}
	
	/**
	 * Gets the onset date.
	 *
	 * @return the onset date
	 */
	public Calendar getOnsetDate()
	{
		return onsetDate;
	}
	
	/**
	 * Sets the onset date.
	 *
	 * @param onsetDate the new onset date
	 */
	public void setOnsetDate(Calendar onsetDate)
	{
		this.onsetDate = onsetDate;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the last modified date.
	 *
	 * @return the last modified date
	 */
	public Calendar getLastModifiedDate()
	{
		return lastModifiedDate;
	}
	
	/**
	 * Sets the last modified date.
	 *
	 * @param lastModifiedDate the new last modified date
	 */
	public void setLastModifiedDate(Calendar lastModifiedDate)
	{
		this.lastModifiedDate = lastModifiedDate;
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.DataBean#toString()
	 */
	@Override
	public String toString()
	{
		return "Problem [Id=" + Id + ", icdCode=" + icdCode + ", description="
				+ description + ", acuity=" + acuity + ", onsetDate=" + onsetDate
				+ ", status=" + status + ", lastModifiedDate=" + lastModifiedDate
				+ ", toString()=" + super.toString() + "]";
	}
	  
}