package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class ProblemTO.
 */
@XmlRootElement(name="ProblemTO")
@XmlAccessorType(XmlAccessType.NONE)
public class ProblemTO
    extends AbstractTO
{

    /** The removed. */
	@XmlElement(name="removed")
    protected Boolean removed;
    
    /** The verified. */
	@XmlElement(name="verified")
    protected Boolean verified;
    
    /** The comments. */
	@XmlElement(name="comments")
    protected TaggedNoteArray comments;
    
    /** The acuity. */
	@XmlElement(name="acuity")
    protected TaggedText acuity;
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The provider narrative. */
	@XmlElement(name="providerNarrative")
    protected String providerNarrative;
    
    /** The onset date. */
	@XmlElement(name="onsetDate")
    protected String onsetDate;
    
    /** The modified date. */
	@XmlElement(name="modifiedDate")
    protected String modifiedDate;
    
    /** The resolved date. */
	@XmlElement(name="resolvedDate")
    protected String resolvedDate;
    
    /** The exposures. */
	@XmlElement(name="exposures")
    protected String exposures;
    
    /** The note narrative. */
	@XmlElement(name="noteNarrative")
    protected String noteNarrative;
    
    /** The priority. */
	@XmlElement(name="priority")
    protected String priority;
    
    /** The observer. */
	@XmlElement(name="observer")
    protected AuthorTO observer;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The type. */
	@XmlElement(name="type")
    protected ObservationTypeTO type;
    
    /** The comment. */
	@XmlElement(name="comment")
    protected String comment;
    
    /** The organizational properties. */
	@XmlElement(name="organizationalProperties")
    protected TaggedTextArray organizationalProperties;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
	
	/**
	 * Instantiates a new problem to.
	 */
	public ProblemTO() 
	{
	}
	

	/**
	 * Instantiates a new problem to.
	 *
	 * @param problem the problem
	 */
	public ProblemTO(gov.va.med.via.databeans.Problem problem) 
	{
		if ( problem.getFault()!=null )
		{
			this.setFault(new FaultTO(problem.getFault()));
		}
		else
		{
			this.id = problem.getId();
			this.status = problem.getStatus();
			this.providerNarrative = problem.getProviderNarrative();
			this.onsetDate = problem.getOnsetDate();
			this.modifiedDate = problem.getLastModifiedDate();
			this.exposures = problem.getExposures();
			this.noteNarrative = problem.getNoteNarratives();
			this.comment = problem.getComment();
			
			if (problem.getObserver() != null)
			{
				this.observer = new AuthorTO(problem.getObserver());
			}
			
			if (problem.getFacility() != null)
			{
				this.facility = new TaggedText(problem.getFacility().getId(), problem.getFacility().getName());
			}
			
			if (problem.getType() != null)
			{
				this.type = new ObservationTypeTO(problem.getType());
			}
			
			if (problem.getOrgProps() != null)
			{
				this.organizationalProperties = new TaggedTextArray(problem.getOrgProps());
			}
		}
	}
	
		
	/**
	 * Sets the removed.
	 *
	 * @param removed the new removed
	 */
	public void setRemoved(Boolean removed)
	{
		this.removed = removed;
	}
	
	/**
	 * Sets the verified.
	 *
	 * @param verified the new verified
	 */
	public void setVerified(Boolean verified)
	{
		this.verified = verified;
	}
	
	/**
	 * Gets the comments.
	 *
	 * @return the comments
	 */
	public TaggedNoteArray getComments()
	{
		return comments;
	}
	
	/**
	 * Sets the comments.
	 *
	 * @param comments the new comments
	 */
	public void setComments(TaggedNoteArray comments)
	{
		this.comments = comments;
	}
	
	/**
	 * Gets the acuity.
	 *
	 * @return the acuity
	 */
	public TaggedText getAcuity()
	{
		return acuity;
	}
	
	/**
	 * Sets the acuity.
	 *
	 * @param acuity the new acuity
	 */
	public void setAcuity(TaggedText acuity)
	{
		this.acuity = acuity;
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the provider narrative.
	 *
	 * @return the provider narrative
	 */
	public String getProviderNarrative()
	{
		return providerNarrative;
	}
	
	/**
	 * Sets the provider narrative.
	 *
	 * @param providerNarrative the new provider narrative
	 */
	public void setProviderNarrative(String providerNarrative)
	{
		this.providerNarrative = providerNarrative;
	}
	
	/**
	 * Gets the onset date.
	 *
	 * @return the onset date
	 */
	public String getOnsetDate()
	{
		return onsetDate;
	}
	
	/**
	 * Sets the onset date.
	 *
	 * @param onsetDate the new onset date
	 */
	public void setOnsetDate(String onsetDate)
	{
		this.onsetDate = onsetDate;
	}
	
	/**
	 * Gets the modified date.
	 *
	 * @return the modified date
	 */
	public String getModifiedDate()
	{
		return modifiedDate;
	}
	
	/**
	 * Sets the modified date.
	 *
	 * @param modifiedDate the new modified date
	 */
	public void setModifiedDate(String modifiedDate)
	{
		this.modifiedDate = modifiedDate;
	}
	
	/**
	 * Gets the resolved date.
	 *
	 * @return the resolved date
	 */
	public String getResolvedDate()
	{
		return resolvedDate;
	}
	
	/**
	 * Sets the resolved date.
	 *
	 * @param resolvedDate the new resolved date
	 */
	public void setResolvedDate(String resolvedDate)
	{
		this.resolvedDate = resolvedDate;
	}
	
	/**
	 * Gets the exposures.
	 *
	 * @return the exposures
	 */
	public String getExposures()
	{
		return exposures;
	}
	
	/**
	 * Sets the exposures.
	 *
	 * @param exposures the new exposures
	 */
	public void setExposures(String exposures)
	{
		this.exposures = exposures;
	}
	
	/**
	 * Gets the note narrative.
	 *
	 * @return the note narrative
	 */
	public String getNoteNarrative()
	{
		return noteNarrative;
	}
	
	/**
	 * Sets the note narrative.
	 *
	 * @param noteNarrative the new note narrative
	 */
	public void setNoteNarrative(String noteNarrative)
	{
		this.noteNarrative = noteNarrative;
	}
	
	
	/**
	 * Gets the removed.
	 *
	 * @return the removed
	 */
	public Boolean getRemoved()
	{
		return removed;
	}


	/**
	 * Gets the verified.
	 *
	 * @return the verified
	 */
	public Boolean getVerified()
	{
		return verified;
	}


	/**
	 * Gets the priority.
	 *
	 * @return the priority
	 */
	public String getPriority()
	{
		return priority;
	}
	
	/**
	 * Sets the priority.
	 *
	 * @param priority the new priority
	 */
	public void setPriority(String priority)
	{
		this.priority = priority;
	}
	
	/**
	 * Gets the observer.
	 *
	 * @return the observer
	 */
	public AuthorTO getObserver()
	{
		return observer;
	}
	
	/**
	 * Sets the observer.
	 *
	 * @param observer the new observer
	 */
	public void setObserver(AuthorTO observer)
	{
		this.observer = observer;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public ObservationTypeTO getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(ObservationTypeTO type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/**
	 * Gets the organizational properties.
	 *
	 * @return the organizational properties
	 */
	public TaggedTextArray getOrganizationalProperties()
	{
		return organizationalProperties;
	}
	
	/**
	 * Sets the organizational properties.
	 *
	 * @param organizationalProperties the new organizational properties
	 */
	public void setOrganizationalProperties(TaggedTextArray organizationalProperties)
	{
		this.organizationalProperties = organizationalProperties;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "ProblemTO [removed=" + removed + ", verified=" + verified
				+ ", comments=" + comments + ", acuity=" + acuity + ", id="
				+ id + ", status=" + status + ", providerNarrative="
				+ providerNarrative + ", onsetDate=" + onsetDate
				+ ", modifiedDate=" + modifiedDate + ", resolvedDate="
				+ resolvedDate + ", exposures=" + exposures
				+ ", noteNarrative=" + noteNarrative + ", priority=" + priority
				+ ", observer=" + observer + ", facility=" + facility
				+ ", type=" + type + ", comment=" + comment
				+ ", organizationalProperties=" + organizationalProperties
				+ ", timestamp=" + timestamp + ", toString()="
				+ super.toString() + "]";
	}
}
