package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.ProstheticClaim;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * The Class ProstheticClaimTO.
 */
@XmlRootElement(name = "ProstheticClaimTO")
@XmlAccessorType(XmlAccessType.NONE)
public class ProstheticClaimTO extends ClaimTO {

	/** The prosthetic id. */
	@XmlElement(name = "prostheticId")
	protected String prostheticId;

	/** The prosthetic name. */
	@XmlElement(name = "prostheticName")
	protected String prostheticName;

	/**
	 * Instantiates a new ProstheticClaimTO.
	 */
	public ProstheticClaimTO() {
	}

	/**
	 * Instantiates a new ProstheticClaimTO with a prosthetic claim.
	 * 
	 * @param prostheticClaim The prosthetic claim object
	 */
	public ProstheticClaimTO(ProstheticClaim prostheticClaim) {
		
		super(prostheticClaim);
		
		if (prostheticClaim.getFault() != null) {
			this.setFault(new FaultTO(prostheticClaim.getFault()));
		} else {
			this.prostheticId = prostheticClaim.getProstheticId();
			this.prostheticName = prostheticClaim.getProstheticName();
		}
	}

	/**
	 * Gets the prosthetic id.
	 * 
	 * @return the prosthetic id
	 */
	public String getProstheticId() {
		return prostheticId;
	}

	/**
	 * Sets the prosthetic id.
	 * 
	 * @param prostheticId
	 *            the new prosthetic id
	 */
	public void setProstheticId(String prostheticId) {
		this.prostheticId = prostheticId;
	}

	/**
	 * Gets the prosthetic name.
	 * 
	 * @return the prosthetic name
	 */
	public String getProstheticName() {
		return prostheticName;
	}

	/**
	 * Sets the prosthetic name.
	 * 
	 * @param prostheticName
	 *            the new prosthetic name
	 */
	public void setProstheticName(String prostheticName) {
		this.prostheticName = prostheticName;
	}


	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.ClaimTO#toString()
	 */
	@Override
	public String toString() {
		return "ProstheticClaimTO [prostheticId=" + prostheticId + ", prostheticName="
				+ prostheticName + ", toString()=" + super.toString() + "]";
	}

}
