package gov.va.med.via.dto.common;

import java.util.Calendar;

/**
 * This class represents radiology exam data.
 */
public class RadiologyExam extends DataBean
{
  /**
   * Date of  the exam.
   */
  private Calendar examDate;
  /**
   * radiology study requested/ordered.
   */
  private String study;
  /**
   * Status of the exam.
   */
  private String status;
  /**
   * Internal Id for exam.  Used to retrieve Radiology report data.
   */
  private String examId;
  /**
   * reason for the exam.
   */
  private String reasonForOrder;

  /**
   * Exam accession number.
   *
   */
  private String accessionNumber;

	public Calendar getExamDate()
	{
		return examDate;
	}
	
	public void setExamDate(Calendar examDate)
	{
		this.examDate = examDate;
	}
	
	public String getStudy()
	{
		return study;
	}
	
	public void setStudy(String study)
	{
		this.study = study;
	}
	
	public String getStatus()
	{
		return status;
	}
	
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	public String getExamId()
	{
		return examId;
	}
	
	public void setExamId(String examId)
	{
		this.examId = examId;
	}
	
	public String getReasonForOrder()
	{
		return reasonForOrder;
	}
	
	public void setReasonForOrder(String reasonForOrder)
	{
		this.reasonForOrder = reasonForOrder;
	}
	
	public String getAccessionNumber()
	{
		return accessionNumber;
	}
	
	public void setAccessionNumber(String accessionNumber)
	{
		this.accessionNumber = accessionNumber;
	}
	
	@Override
	public String toString()
	{
		return "RadiologyExam [examDate=" + examDate + ", study=" + study
				+ ", status=" + status + ", examId=" + examId + ", reasonForOrder="
				+ reasonForOrder + ", accessionNumber=" + accessionNumber
				+ ", toString()=" + super.toString() + "]";
	}
	
	  
}