package gov.va.med.via.dto.common;

import java.util.Calendar;

// TODO: Auto-generated Javadoc
/**
 * This class respresents a Radiology reports and extends the RadiologyExam class.
 */
public class RadiologyReport extends RadiologyExam
{
 
  /**
   * Priority of the exam.
   */
  private String priority;
  /**
   * Result Code of the report. 
   */
  private String resultCode;
  /**
   * Provider interpreting the exam.
   */
  private String interpretingHCP;
  /**
   * Provider approving the report.
   */
  private String approvedBy;
  /**
   * Date the report was transcribed.
   */
  private Calendar transcribeDate;
  /**
   * Text of the report.
   */
  private String reportText;
  /**
   * Status of the report.
   */
  private String reportStatus;
  /**
   * Text describing the impression of the exam.
   */
  private String impressionText;
	
	/**
	 * Gets the priority.
	 *
	 * @return the priority
	 */
	public String getPriority()
	{
		return priority;
	}
	
	/**
	 * Sets the priority.
	 *
	 * @param priority the new priority
	 */
	public void setPriority(String priority)
	{
		this.priority = priority;
	}
	
	/**
	 * Gets the result code.
	 *
	 * @return the result code
	 */
	public String getResultCode()
	{
		return resultCode;
	}
	
	/**
	 * Sets the result code.
	 *
	 * @param resultCode the new result code
	 */
	public void setResultCode(String resultCode)
	{
		this.resultCode = resultCode;
	}
	
	/**
	 * Gets the interpreting hcp.
	 *
	 * @return the interpreting hcp
	 */
	public String getInterpretingHCP()
	{
		return interpretingHCP;
	}
	
	/**
	 * Sets the interpreting hcp.
	 *
	 * @param interpretingHCP the new interpreting hcp
	 */
	public void setInterpretingHCP(String interpretingHCP)
	{
		this.interpretingHCP = interpretingHCP;
	}
	
	/**
	 * Gets the approved by.
	 *
	 * @return the approved by
	 */
	public String getApprovedBy()
	{
		return approvedBy;
	}
	
	/**
	 * Sets the approved by.
	 *
	 * @param approvedBy the new approved by
	 */
	public void setApprovedBy(String approvedBy)
	{
		this.approvedBy = approvedBy;
	}
	
	/**
	 * Gets the transcribe date.
	 *
	 * @return the transcribe date
	 */
	public Calendar getTranscribeDate()
	{
		return transcribeDate;
	}
	
	/**
	 * Sets the transcribe date.
	 *
	 * @param transcribeDate the new transcribe date
	 */
	public void setTranscribeDate(Calendar transcribeDate)
	{
		this.transcribeDate = transcribeDate;
	}
	
	/**
	 * Gets the report text.
	 *
	 * @return the report text
	 */
	public String getReportText()
	{
		return reportText;
	}
	
	/**
	 * Sets the report text.
	 *
	 * @param reportText the new report text
	 */
	public void setReportText(String reportText)
	{
		this.reportText = reportText;
	}
	
	/**
	 * Gets the report status.
	 *
	 * @return the report status
	 */
	public String getReportStatus()
	{
		return reportStatus;
	}
	
	/**
	 * Sets the report status.
	 *
	 * @param reportStatus the new report status
	 */
	public void setReportStatus(String reportStatus)
	{
		this.reportStatus = reportStatus;
	}
	
	/**
	 * Gets the impression text.
	 *
	 * @return the impression text
	 */
	public String getImpressionText()
	{
		return impressionText;
	}
	
	/**
	 * Sets the impression text.
	 *
	 * @param impressionText the new impression text
	 */
	public void setImpressionText(String impressionText)
	{
		this.impressionText = impressionText;
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.RadiologyExam#toString()
	 */
	@Override
	public String toString()
	{
		return "RadiologyReport [priority=" + priority + ", resultCode="
				+ resultCode + ", interpretingHCP=" + interpretingHCP
				+ ", approvedBy=" + approvedBy + ", transcribeDate="
				+ transcribeDate + ", reportText=" + reportText + ", reportStatus="
				+ reportStatus + ", impressionText=" + impressionText
				+ ", toString()=" + super.toString() + "]";
	} 
  
}
