package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.RatedDisability;

/**
 * The Class RatedDisabilityTO.
 */
@XmlRootElement(name="RatedDisabilityTO")
@XmlAccessorType(XmlAccessType.NONE)
public class RatedDisabilityTO
    extends AbstractTO
{
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The percent. */
	@XmlElement(name="percent")
    protected String percent;
    
    /** The service connected. */
	@XmlElement(name="serviceConnected")
    protected String serviceConnected;
    
    /** The extremity affected. */
	@XmlElement(name="extremityAffected")
    protected String extremityAffected;
    
    /** The original effective date. */
	@XmlElement(name="originalEffectiveDate")
    protected String originalEffectiveDate;
    
    /** The current effective date. */
	@XmlElement(name="currentEffectiveDate")
    protected String currentEffectiveDate;

    /**
	 * Instantiates a new lab test to.
	 */
	public RatedDisabilityTO()
	{		
	}
	
	/**
	 * Instantiates a new lab test to.
	 *
	 * @param test the test
	 */
	public RatedDisabilityTO(RatedDisability disability) 
	{
		if (disability.getFault()!=null){
			this.setFault(new FaultTO(disability.getFault()));
		}
		else
		{
			this.id = disability.getId();
			this.name = disability.getName();
			this.percent = disability.getPercent();
			this.serviceConnected = disability.getServiceConnected();
			this.extremityAffected = disability.getExtremityAffected();
			this.originalEffectiveDate = disability.getOriginalEffectiveDate();
			this.currentEffectiveDate = disability.getCurrentEffectiveDate();
		}
	}
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Gets the percent.
	 *
	 * @return the percent
	 */
	public String getPercent()
	{
		return percent;
	}
	
	/**
	 * Sets the percent.
	 *
	 * @param percent the new percent
	 */
	public void setPercent(String percent)
	{
		this.percent = percent;
	}
	
	/**
	 * Gets the service connected.
	 *
	 * @return the service connected
	 */
	public String getServiceConnected()
	{
		return serviceConnected;
	}
	
	/**
	 * Sets the service connected.
	 *
	 * @param serviceConnected the new service connected
	 */
	public void setServiceConnected(String serviceConnected)
	{
		this.serviceConnected = serviceConnected;
	}
	
	/**
	 * Gets the extremity affected.
	 *
	 * @return the extremity affected
	 */
	public String getExtremityAffected()
	{
		return extremityAffected;
	}
	
	/**
	 * Sets the extremity affected.
	 *
	 * @param extremityAffected the new extremity affected
	 */
	public void setExtremityAffected(String extremityAffected)
	{
		this.extremityAffected = extremityAffected;
	}
	
	/**
	 * Gets the original effective date.
	 *
	 * @return the original effective date
	 */
	public String getOriginalEffectiveDate()
	{
		return originalEffectiveDate;
	}
	
	/**
	 * Sets the original effective date.
	 *
	 * @param originalEffectiveDate the new original effective date
	 */
	public void setOriginalEffectiveDate(String originalEffectiveDate)
	{
		this.originalEffectiveDate = originalEffectiveDate;
	}
	
	/**
	 * Gets the current effective date.
	 *
	 * @return the current effective date
	 */
	public String getCurrentEffectiveDate()
	{
		return currentEffectiveDate;
	}
	
	/**
	 * Sets the current effective date.
	 *
	 * @param currentEffectiveDate the new current effective date
	 */
	public void setCurrentEffectiveDate(String currentEffectiveDate)
	{
		this.currentEffectiveDate = currentEffectiveDate;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "RatedDisabilityTO [id=" + id + ", name=" + name + ", percent="
				+ percent + ", serviceConnected=" + serviceConnected
				+ ", extremityAffected=" + extremityAffected
				+ ", originalEffectiveDate=" + originalEffectiveDate
				+ ", currentEffectiveDate=" + currentEffectiveDate
				+ ", toString()=" + super.toString() + "]";
	}
}
