package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.SurgeryReport;

// TODO: Auto-generated Javadoc
/**
 * The Class SurgeryReportTO.
 */
@XmlRootElement(name="SurgeryReportTO")
@XmlAccessorType(XmlAccessType.NONE)
public class SurgeryReportTO
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The title. */
	@XmlElement(name="title")
    protected String title;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The author. */
	@XmlElement(name="author")
    protected AuthorTO author;
    
    /** The text. */
	@XmlElement(name="text")
    protected String text;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The specialty. */
	@XmlElement(name="specialty")
    protected TaggedText specialty;
    
    /** The pre op dx. */
	@XmlElement(name="preOpDx")
    protected String preOpDx;
    
    /** The post op dx. */
	@XmlElement(name="postOpDx")
    protected String postOpDx;
    
    /** The lab work. */
	@XmlElement(name="labWork")
    protected String labWork;
    
    /** The dictation timestamp. */
	@XmlElement(name="dictationTimestamp")
    protected String dictationTimestamp;
    
    /** The transcription timestamp. */
	@XmlElement(name="transcriptionTimestamp")
    protected String transcriptionTimestamp;
	
    public SurgeryReportTO() 
	{
	}

	/**
	 * Instantiates a new surgery report to.
	 *
	 * @param report the report
	 */
	public SurgeryReportTO(SurgeryReport report) 
	{
		if ( report.getFault()!=null )
		{
			this.setFault(new FaultTO(report.getFault()));
		}
		else
		{
			if (report.getAuthor() != null)
			{
				this.author = new AuthorTO(report.getAuthor());
			}
			if (report.getFacility() != null)
			{
				this.facility = new TaggedText(report.getFacility().getId(), report.getFacility().getName()); 	
			}
			this.id = report.getId();			
			this.dictationTimestamp = report.getDictationTimestamp();						
			this.labWork = report.getLabWork();
			this.postOpDx = report.getPostOpDx();
			this.preOpDx = report.getPreOpDx();
			this.specialty = new TaggedText(report.getSpecialty());
			this.status = report.getStatus();
			this.text = report.getText();
			this.timestamp = report.getTimestamp();
			this.title = report.getTitle();
			this.transcriptionTimestamp = report.getTranscriptionTimestamp();			
		}
	}
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public AuthorTO getAuthor()
	{
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(AuthorTO author)
	{
		this.author = author;
	}
	
	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}
	
	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the specialty.
	 *
	 * @return the specialty
	 */
	public TaggedText getSpecialty()
	{
		return specialty;
	}
	
	/**
	 * Sets the specialty.
	 *
	 * @param specialty the new specialty
	 */
	public void setSpecialty(TaggedText specialty)
	{
		this.specialty = specialty;
	}
	
	/**
	 * Gets the pre op dx.
	 *
	 * @return the pre op dx
	 */
	public String getPreOpDx()
	{
		return preOpDx;
	}
	
	/**
	 * Sets the pre op dx.
	 *
	 * @param preOpDx the new pre op dx
	 */
	public void setPreOpDx(String preOpDx)
	{
		this.preOpDx = preOpDx;
	}
	
	/**
	 * Gets the post op dx.
	 *
	 * @return the post op dx
	 */
	public String getPostOpDx()
	{
		return postOpDx;
	}
	
	/**
	 * Sets the post op dx.
	 *
	 * @param postOpDx the new post op dx
	 */
	public void setPostOpDx(String postOpDx)
	{
		this.postOpDx = postOpDx;
	}
	
	/**
	 * Gets the lab work.
	 *
	 * @return the lab work
	 */
	public String getLabWork()
	{
		return labWork;
	}
	
	/**
	 * Sets the lab work.
	 *
	 * @param labWork the new lab work
	 */
	public void setLabWork(String labWork)
	{
		this.labWork = labWork;
	}
	
	/**
	 * Gets the dictation timestamp.
	 *
	 * @return the dictation timestamp
	 */
	public String getDictationTimestamp()
	{
		return dictationTimestamp;
	}
	
	/**
	 * Sets the dictation timestamp.
	 *
	 * @param dictationTimestamp the new dictation timestamp
	 */
	public void setDictationTimestamp(String dictationTimestamp)
	{
		this.dictationTimestamp = dictationTimestamp;
	}
	
	/**
	 * Gets the transcription timestamp.
	 *
	 * @return the transcription timestamp
	 */
	public String getTranscriptionTimestamp()
	{
		return transcriptionTimestamp;
	}
	
	/**
	 * Sets the transcription timestamp.
	 *
	 * @param transcriptionTimestamp the new transcription timestamp
	 */
	public void setTranscriptionTimestamp(String transcriptionTimestamp)
	{
		this.transcriptionTimestamp = transcriptionTimestamp;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "SurgeryReportTO [id=" + id + ", title=" + title
				+ ", timestamp=" + timestamp + ", author=" + author + ", text="
				+ text + ", facility=" + facility + ", status=" + status
				+ ", specialty=" + specialty + ", preOpDx=" + preOpDx
				+ ", postOpDx=" + postOpDx + ", labWork=" + labWork
				+ ", dictationTimestamp=" + dictationTimestamp
				+ ", transcriptionTimestamp=" + transcriptionTimestamp
				+ ", toString()=" + super.toString() + "]";
	}
}
