package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.SurgicalPathologyReport;

// TODO: Auto-generated Javadoc
/**
 * The Class SurgicalPathologyRpt.
 */
@XmlRootElement(name="SurgicalPathologyReport")
@XmlAccessorType(XmlAccessType.NONE)
public class SurgicalPathologyRpt
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
	protected String id;
    
    /** The title. */
	@XmlElement(name="title")
    protected String title;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The author. */
	@XmlElement(name="author")
    protected AuthorTO author;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
    
    /** The specimen. */
	@XmlElement(name="specimen")
    protected LabSpecimenTO specimen;
    
    /** The clinical hx. */
	@XmlElement(name="clinicalHx")
    protected String clinicalHx;
    
    /** The description. */
	@XmlElement(name="description")
    protected String description;
    
    /** The exam. */
	@XmlElement(name="exam")
    protected String exam;
    
    /** The diagnosis. */
	@XmlElement(name="diagnosis")
    protected String diagnosis;
    
    /** The comment. */
	@XmlElement(name="comment")
    protected String comment;
	
	/**
	 * Instantiates a new surgical pathology rpt.
	 */
	public SurgicalPathologyRpt()
	{
		super();
	}
	
    /**
     * Instantiates a new surgical pathology rpt.
     *
     * @param report the report
     */
    public SurgicalPathologyRpt(SurgicalPathologyReport report) 
	{
		if ( report.getFault()!=null ){
			this.setFault(new FaultTO(report.getFault()));
		}
		else
		{
			this.id = report.getId();
			this.title = report.getTitle();
			this.timestamp = report.getTimestamp();
			this.clinicalHx = report.getClinicalHx();
			this.description = report.getDescription();
			this.exam = report.getExam();
			this.diagnosis = report.getDiagnosis();
			this.comment = report.getComment();
			
			if (report.getAuthor() != null)
			{
				this.author = new AuthorTO(report.getAuthor());
			}
			
			if (report.getFacility() != null)
			{
				this.facility = new TaggedText(report.getFacility().getId(), report.getFacility().getName());
			}
			
			if (report.getSpecimen() != null)
			{
				this.specimen= new LabSpecimenTO(report.getSpecimen());
			}
		}
	}
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle()
	{
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title)
	{
		this.title = title;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public AuthorTO getAuthor()
	{
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(AuthorTO author)
	{
		this.author = author;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the specimen.
	 *
	 * @return the specimen
	 */
	public LabSpecimenTO getSpecimen()
	{
		return specimen;
	}
	
	/**
	 * Sets the specimen.
	 *
	 * @param specimen the new specimen
	 */
	public void setSpecimen(LabSpecimenTO specimen)
	{
		this.specimen = specimen;
	}
	
	/**
	 * Gets the clinical hx.
	 *
	 * @return the clinical hx
	 */
	public String getClinicalHx()
	{
		return clinicalHx;
	}
	
	/**
	 * Sets the clinical hx.
	 *
	 * @param clinicalHx the new clinical hx
	 */
	public void setClinicalHx(String clinicalHx)
	{
		this.clinicalHx = clinicalHx;
	}
	
	/**
	 * Gets the description.
	 *
	 * @return the description
	 */
	public String getDescription()
	{
		return description;
	}
	
	/**
	 * Sets the description.
	 *
	 * @param description the new description
	 */
	public void setDescription(String description)
	{
		this.description = description;
	}
	
	/**
	 * Gets the exam.
	 *
	 * @return the exam
	 */
	public String getExam()
	{
		return exam;
	}
	
	/**
	 * Sets the exam.
	 *
	 * @param exam the new exam
	 */
	public void setExam(String exam)
	{
		this.exam = exam;
	}
	
	/**
	 * Gets the diagnosis.
	 *
	 * @return the diagnosis
	 */
	public String getDiagnosis()
	{
		return diagnosis;
	}
	
	/**
	 * Sets the diagnosis.
	 *
	 * @param diagnosis the new diagnosis
	 */
	public void setDiagnosis(String diagnosis)
	{
		this.diagnosis = diagnosis;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	/**
	 * To string.
	 *
	 * @return the string
	 */
	@Override
	public String toString()
	{
		return "SurgicalPathologyRpt [id=" + id + ", title=" + title
				+ ", timestamp=" + timestamp + ", author=" + author
				+ ", facility=" + facility + ", specimen=" + specimen
				+ ", clinicalHx=" + clinicalHx + ", description=" + description
				+ ", exam=" + exam + ", diagnosis=" + diagnosis + ", comment="
				+ comment + ", toString()=" + super.toString() + "]";
	}
}