package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Symptom;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class SymptomTO.
 */
@XmlRootElement(name="SymptomTO")
@XmlAccessorType(XmlAccessType.NONE)
public class SymptomTO
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The name. */
	@XmlElement(name="name")
    protected String name;
    
    /** The is national. */
	@XmlElement(name="isNational")
    protected Boolean isNational;
    
    /** The vuid. */
	@XmlElement(name="vuid")
    protected String vuid;
    
    /** The type. */
	@XmlElement(name="type")
    protected ObservationTypeTO type;
    
    /** The observer. */
	@XmlElement(name="observer")
    protected AuthorTO observer;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected TaggedText facility;
	
	public SymptomTO(){
		
	}
	
	public SymptomTO(Symptom symptom){
		this.id = symptom.getId();
		this.name = symptom.getName();
		this.isNational = symptom.isNational;
		this.vuid = symptom.getVuid();
		this.timestamp = symptom.getTimestamp();
		if(symptom.getType() != null) this.type = new ObservationTypeTO(symptom.getType());
		if(symptom.getObserver()!= null) this.observer = new AuthorTO(symptom.getObserver());
		if(symptom.getFacility()!= null) this.facility = new TaggedText(symptom.getFacility());	
	}
	
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**
	 * Checks if is national.
	 *
	 * @return true, if is national
	 */
	public boolean isNational()
	{
		return isNational;
	}
	
	/**
	 * Sets the national.
	 *
	 * @param isNational the new national
	 */
	public void setNational(boolean isNational)
	{
		this.isNational = isNational;
	}
	
	/**
	 * Gets the vuid.
	 *
	 * @return the vuid
	 */
	public String getVuid()
	{
		return vuid;
	}
	
	/**
	 * Sets the vuid.
	 *
	 * @param vuid the new vuid
	 */
	public void setVuid(String vuid)
	{
		this.vuid = vuid;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public ObservationTypeTO getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(ObservationTypeTO type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the observer.
	 *
	 * @return the observer
	 */
	public AuthorTO getObserver()
	{
		return observer;
	}
	
	/**
	 * Sets the observer.
	 *
	 * @param observer the new observer
	 */
	public void setObserver(AuthorTO observer)
	{
		this.observer = observer;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "SymptomTO [id=" + id + ", name=" + name + ", isNational="
				+ isNational + ", vuid=" + vuid + ", type=" + type
				+ ", observer=" + observer + ", timestamp=" + timestamp
				+ ", facility=" + facility + ", toString()=" + super.toString()
				+ "]";
	}
    
}
