package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Adt;
import gov.va.med.via.databeans.Consult;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedAdtArray.
 */
@XmlRootElement(name="TaggedAdtArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedAdtArray
    extends AbstractTaggedArrayTO
{
    
    /** The items. */
	@XmlElementWrapper(name="items")
	@XmlElement(name="adtTO")	
    protected List<AdtTO> items;

	/**
	 * Instantiates a new tagged adt array.
	 */
	public TaggedAdtArray()
	{
	}
	
	
	/**
	 * Instantiates a new tagged adt array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedAdtArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<AdtTO> myItems = new ArrayList<AdtTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			myItems.add(new AdtTO((Adt)dataBean));
		}
		
		if(!foundFault)
		{
			this.setItems(myItems);
			setCount(myItems.size());
		}
		
	}	
	
	/**
	 * Instantiates a new tagged adt array.
	 *
	 * @param adtBeans the adt beans
	 */
	public TaggedAdtArray(Adt[] adtBeans)
   	{
		if (adtBeans == null || adtBeans.length == 0) return;
		
		items = new ArrayList<AdtTO>();
    	
    	for (int i = 0; i < adtBeans.length; i++ )
    	{
    		items.add(new AdtTO(adtBeans[i]));
    	}
    		
        count = adtBeans.length;
        tag = adtBeans[0].getSiteId(); // TODO re-factor when multiple sites
    }
	
	/**
	 * Gets the items.
	 *
	 * @return the items
	 */
	public List<AdtTO> getItems()
	{
		return items;
	}

	/**
	 * Sets the items.
	 *
	 * @param items the new items
	 */
	public void setItems(List<AdtTO> items)
	{
		this.items = items;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedAdtArray [items=" + items + ", toString()="
				+ super.toString() + "]";
	}
}
