package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Adt;
import gov.va.med.via.databeans.Consult;
import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedAdtArrays.
 */
@XmlRootElement(name="TaggedAdtArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedAdtArrays
    extends AbstractArrayTO
{    
    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedAdtArray")	
    protected List<TaggedAdtArray> arrays;

    /**
     * Instantiates a new tagged adt arrays.
     */
    public TaggedAdtArrays()
    {    	
    }
    
    /**
     * Instantiates a new tagged adt arrays.
     *
     * @param beans the beans
     */
    public TaggedAdtArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
    {		
		List<TaggedAdtArray> taggedAdtArrayList = new ArrayList<TaggedAdtArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedAdtArrayList.add(new TaggedAdtArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedAdtArrayList);
		this.setCount(taggedAdtArrayList.size());
	}
    
    /**
     * Instantiates a new tagged adt arrays.
     *
     * @param beans the beans
     */
    public TaggedAdtArrays(List<DataBean> beans)
    {
    	if (beans == null || beans.size() == 0)  return;
    
    	arrays = new ArrayList<TaggedAdtArray>();   
    	arrays.add(new TaggedAdtArray(beans.toArray(new Adt[beans.size()])));
    	count = 1;
    }
    
	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedAdtArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedAdtArray> arrays)
	{
		this.arrays = arrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedAdtArrays [arrays=" + arrays + ", toString()="
				+ super.toString() + "]";
	}
}
