package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Allergy;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedAllergyArray.
 */
@XmlRootElement(name="TaggedAllergyArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedAllergyArray
    extends AbstractTaggedArrayTO
{

    /** The allergies. */
	@XmlElementWrapper(name="allergies")
	@XmlElement(name="allergyTO")
    protected List<AllergyTO> allergies;

	public TaggedAllergyArray()
	{
	    	
	}
	
    public TaggedAllergyArray(List<DataBean> databeans, String siteCode) {
		
		super();
		setTag(siteCode);
		
		this.allergies = new ArrayList<AllergyTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			this.allergies.add(new AllergyTO((Allergy)dataBean));
		}
		
		if(!foundFault){
			setCount(this.allergies.size());
		}
		
	}
    
	/**
	 * Gets the allergies.
	 *
	 * @return the allergies
	 */
	public List<AllergyTO> getAllergies()
	{
		return allergies;
	}

	/**
	 * Sets the allergies.
	 *
	 * @param allergies the new allergies
	 */
	public void setAllergies(List<AllergyTO> allergies)
	{
		this.allergies = allergies;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedAllergyArray [allergies=" + allergies + ", toString()="
				+ super.toString() + "]";
	}
}
