package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Appointment;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedAppointmentArray.
 */
@XmlRootElement(name="TaggedAppointmentArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedAppointmentArray
    extends AbstractTaggedArrayTO
{

    /** The appts. */
	@XmlElementWrapper(name="appts")
	@XmlElement(name="appointmentTO")
    protected List<AppointmentTO> appts;
	
	public TaggedAppointmentArray(){
		
	}

	public TaggedAppointmentArray(List<DataBean> databeans, String siteCode) {
		super();
		setTag(siteCode);
		
		this.appts = new ArrayList<AppointmentTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			this.appts.add(new AppointmentTO((Appointment)dataBean));
		}
		
		if(!foundFault){
			setCount(this.appts.size());
		}
		
	}

	
	/**
	 * Gets the appts.
	 *
	 * @return the appts
	 */
	public List<AppointmentTO> getAppts()
	{
		return appts;
	}

	/**
	 * Sets the appts.
	 *
	 * @param appts the new appts
	 */
	public void setAppts(List<AppointmentTO> appts)
	{
		this.appts = appts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedAppointmentArray [appts=" + appts + ", toString()="
				+ super.toString() + "]";
	}
        
}