package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


/**
 * The Class TaggedAppointmentArrays.
 */
@XmlRootElement(name="TaggedAppointmentArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedAppointmentArrays
    extends AbstractArrayTO
{

    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedAppointmentArray")
    protected List<TaggedAppointmentArray> arrays;
	
	public TaggedAppointmentArrays (){
		
	}

	public TaggedAppointmentArrays(Map<String, List<DataBean>> daoSiteDataBeans) {
		
		List<TaggedAppointmentArray> taggedAppointmentArrayList = new ArrayList<TaggedAppointmentArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedAppointmentArrayList.add(new TaggedAppointmentArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedAppointmentArrayList);
		this.setCount(taggedAppointmentArrayList.size());
	}
		

	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedAppointmentArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedAppointmentArray> arrays)
	{
		this.arrays = arrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedAppointmentArrays [arrays=" + arrays + ", toString()="
				+ super.toString() + "]";
	}
    
    
}