package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.ChemHemReport;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * The Class TaggedChemHemRptArray.
 */
@XmlRootElement(name="TaggedChemHemRptArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedChemHemRptArray extends AbstractTaggedArrayTO
{
	
	/** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="chemHemRpt")
	protected List<ChemHemRpt> rpts;
	
	public TaggedChemHemRptArray() {
		
	}

	public TaggedChemHemRptArray(List<DataBean> databeans, String siteCode) {
		super();
		setTag(siteCode);
		
		this.rpts = new ArrayList<ChemHemRpt>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			this.rpts.add(new ChemHemRpt((ChemHemReport)dataBean));
		}
		
		if(!foundFault){
			setCount(this.rpts.size());
		}
	}

	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<ChemHemRpt> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<ChemHemRpt> rpts)
	{
		this.rpts = rpts;
	}
	
}