package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Consult;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.jws.WebResult;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * The Class TaggedConsultArray.
 */
@XmlRootElement(name="TaggedConsultArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedConsultArray
    extends AbstractTaggedArrayTO
{
	/** The consults. */
	@XmlElementWrapper(name="consults")
	@XmlElement(name="consultTO")
    protected List<ConsultTO> consults;
    
	public TaggedConsultArray()
	{
	}
	
	public TaggedConsultArray(Consult[] consultBeans)
   	{
		if (consultBeans == null || consultBeans.length == 0) return;
		
		consults = new ArrayList<ConsultTO>();
    	
    	for (int i = 0; i < consultBeans.length; i++ )
    	{
    		consults.add(new ConsultTO(consultBeans[i]));
    	}
    		
        count = consultBeans.length;
        tag = consultBeans[0].getSiteId(); // TODO re-factor when multiple sites
    }
	
	public TaggedConsultArray(List<DataBean> databeans, String siteCode)
   	{
		super();
		setTag(siteCode);
		
		List<ConsultTO> consultsList = new ArrayList<ConsultTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			consultsList.add(new ConsultTO((Consult)dataBean));
		}
		
		if(!foundFault){
			this.setConsults(consultsList);
			setCount(consultsList.size());
		}
    }
	  


	/**
	 * Gets the consults.
	 *
	 * @return the consults
	 */
	public @WebResult(name="ConsultTO") List<ConsultTO> getConsults()
	{
		return consults;
	}

	/**
	 * Sets the consults.
	 *
	 * @param consults the new consults
	 */
	public void setConsults(List<ConsultTO> consults)
	{
		this.consults = consults;
	}
	
}