package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Consult;
import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.jws.WebResult;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


// TODO: Auto-generated Javadoc
/**
 * The Class TaggedConsultArrays.
 */
@XmlRootElement(name="TaggedConsultArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedConsultArrays
    extends AbstractArrayTO
{
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedConsultArray")
	protected List<TaggedConsultArray> arrays;
	
	public TaggedConsultArrays()
    {    	
    }
    
    public TaggedConsultArrays(List<DataBean> beans)
    {
    	if (beans == null || beans.size() == 0)  return;
    
    	// TODO - VERIFY NO EXCEPTIONS FIRST! If no exception, the databeans are consults
    	arrays = new ArrayList<TaggedConsultArray>();   
    	arrays.add(new TaggedConsultArray(beans.toArray(new Consult[beans.size()])));
    	count = 1;
    }
    
    public TaggedConsultArrays(Map<String, List<DataBean>> daoSiteDataBeans)
    {
    	List<TaggedConsultArray> taggedConsultArrayList = new ArrayList<TaggedConsultArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedConsultArrayList.add(new TaggedConsultArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedConsultArrayList);
		this.setCount(taggedConsultArrayList.size());
    }
    
	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedConsultArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */	
	public void setArrays(List<TaggedConsultArray> consultArray)
	{
		this.arrays = consultArray;
	}

}
