package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.CytologyReport;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedCytologyRptArray.
 */
@XmlRootElement(name="TaggedCytologyRptArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedCytologyRptArray extends AbstractTaggedArrayTO
{	
	/** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="cytologyRpt")
	protected List<CytologyRpt> rpts;

	/**
	 * Instantiates a new tagged user array.
	 */
	public TaggedCytologyRptArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged user array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedCytologyRptArray(List<DataBean> databeans, String siteCode) {
		
		super();
		setTag(siteCode);
		
		List<CytologyRpt> reports = new ArrayList<CytologyRpt>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			reports.add(new CytologyRpt((CytologyReport)dataBean));
		}
		
		if(!foundFault){
			this.setRpts(reports);
			setCount(reports.size());
		}
		
	}
	
	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<CytologyRpt> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<CytologyRpt> rpts)
	{
		this.rpts = rpts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedCytologyRptArray [rpts=" + rpts + ", toString()="
				+ super.toString() + "]";
	}
}
