package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Adt;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Drg;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.TaggedDrgArrayDataBean;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedDrgArray.
 */
public class TaggedDrgArray
    extends AbstractTaggedArrayTO
{

	
    public TaggedDrgArray(TaggedDrgArrayDataBean bean) 
    {
		super();
		this.tag =bean.getTag();
		this.items= new ArrayList<DrgTO>(bean.getItems().size());
		for ( Drg drg: bean.getItems())
		{
			DrgTO drgTO = new DrgTO();
			drgTO.setId(drg.getId());
			drgTO.setDescription(drg.getDescription());
			items.add(drgTO);
		}
	}
	
	
	
    public TaggedDrgArray() {
		super();
		
	}
    
    public TaggedDrgArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<DrgTO> myItems = new ArrayList<DrgTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			
			TaggedDrgArrayDataBean taggedDrgArrayDataBean = (TaggedDrgArrayDataBean)dataBean;
			myItems = new ArrayList<DrgTO>(taggedDrgArrayDataBean.getItems().size());
			for ( Drg drg: taggedDrgArrayDataBean.getItems())
			{
				myItems.add(new DrgTO((Drg)drg));
			}
			
		}
		
		if(!foundFault)
		{
			this.setItems(myItems);
			setCount(myItems.size());
		}
		
	}	

	/** The items. */
    protected @XmlElementWrapper(name="items") @XmlElement(name="drgTO") List<DrgTO> items;

	/**
	 * Gets the items.
	 *
	 * @return the items
	 */
	public List<DrgTO> getItems()
	{
		return items;
	}

	/**
	 * Sets the items.
	 *
	 * @param items the new items
	 */
	public void setItems(List<DrgTO> items)
	{
		this.items = items;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedDrgArray [items=" + items + ", toString()="
				+ super.toString() + "]";
	}
}