package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.HospitalLocation;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlList;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedHospitalLocationArray.
 */
@XmlRootElement(name="TaggedHospitalLocationArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedHospitalLocationArray
    extends AbstractTaggedArrayTO
{
    
    /** The locations. */
	//@XmlJavaTypeAdapter(ListAdapter.class)
	@XmlElementWrapper(name="locations")
	@XmlElement(name="hospitalLocationTO")
    protected List<HospitalLocationTO> locations;


	/**
	 * Instantiates a new tagged hospital location array.
	 */
	public TaggedHospitalLocationArray()
	{		
	}
	
	/**
	 * Instantiates a new tagged hospital location array.
	 *
	 * @param daoSiteDataBeans the dao site data beans
	 */
	public TaggedHospitalLocationArray(Map<String, List<DataBean>> daoSiteDataBeans) 
	{				
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys)
		{
			boolean foundFault = false;
			
			List<HospitalLocationTO> myLocations = new ArrayList<HospitalLocationTO>(); 
			for(DataBean dataBean: daoSiteDataBeans.get(siteKey))
			{
				if(dataBean instanceof Fault){
					this.setFault(new FaultTO((Fault)dataBean));
					foundFault = true;
					break;
				}
				myLocations.add(new HospitalLocationTO((HospitalLocation)dataBean));
			}
			
			if(!foundFault)
			{
				this.setLocations(myLocations);
				setCount(myLocations.size());
				setTag(siteKey);
			}			
		}
	}
	
	/**
	 * Gets the locations.
	 *
	 * @return the locations
	 */
	public List<HospitalLocationTO> getLocations()
	{
		//return Arrays.asList((HospitalLocationTO[])locations);
		
		return locations;
	}

	/**
	 * Sets the locations.
	 *
	 * @param locations the new locations
	 */
	public void setLocations(List<HospitalLocationTO> locations)
	{
		/*if (locations != null)
		{
			this.locations = locations.toArray(new HospitalLocationTO[0]);
		}*/
		this.locations = locations;
	}

	/*public TaggedHospitalLocationArray(List<DataBean> beans)
	{
		if (beans== null || beans.size() == 0){
			count=0;
		    return;
		}
		locations = new ArrayList<HospitalLocationTO>();   
		for (int i = 0; i < beans.size(); i++ ){
			locations.add(new HospitalLocationTO((HospitalLocation)beans.get(i)));
		}	    		
		count = beans.size();
	}
	
	public TaggedHospitalLocationArray(List<DataBean> beans, String tag)
	{
		this(beans);
		setTag(tag);
	}*/
	
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedHospitalLocationArray [locations=" + locations
				+ ", toString()=" + super.toString() + "]";
	}
}
