package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.IcdReport;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * The Class TaggedIcdRptArray.
 */
@XmlRootElement(name="TaggedIcdRptArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedIcdRptArray
    extends AbstractTaggedArrayTO
{    
    /** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="icdRpt")	
    protected List<IcdRpt> rpts;

    public TaggedIcdRptArray()
    {
    	
    }
    
    public TaggedIcdRptArray(List<DataBean> databeans, String siteCode) 
    {		
		super();
		setTag(siteCode);
		
		List<IcdRpt> rpts = new ArrayList<IcdRpt>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			rpts.add(new IcdRpt((IcdReport)dataBean));
		}
		
		if(!foundFault){
			this.setRpts(rpts);
			setCount(rpts.size());
		}
		
	}

	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<IcdRpt> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<IcdRpt> rpts)
	{
		this.rpts = rpts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedIcdRptArray [rpts=" + rpts + ", toString()="
				+ super.toString() + "]";
	}
}