package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.InpatientStay;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedInpatientStayArray.
 */
@XmlRootElement(name="TaggedInpatientStayArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedInpatientStayArray
    extends AbstractTaggedArrayTO
{
    
    /** The stays. */
	@XmlElementWrapper(name="stays")
	@XmlElement(name="inpatientStayTO")
    protected List<InpatientStayTO> stays;

	/**
	 * Gets the stays.
	 *
	 * @return the stays
	 */
	public List<InpatientStayTO> getStays()
	{
		return stays;
	}

	/**
	 * Sets the stays.
	 *
	 * @param stays the new stays
	 */
	public void setStays(List<InpatientStayTO> stays)
	{
		this.stays = stays;
	}
	
	public TaggedInpatientStayArray(){
	}

	public TaggedInpatientStayArray(List<DataBean> databeans){
		
		if (databeans== null || databeans.size() == 0){
			count=0;
		    return;
		}
		
		boolean foundFault = false;
		List<InpatientStayTO> staysList = new ArrayList<InpatientStayTO>();   
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			staysList.add(new InpatientStayTO((InpatientStay)dataBean));
		}
		
		if(!foundFault){
			this.setStays(staysList);
			setCount(staysList.size());
		}
		count = databeans.size();
	}
	
	public TaggedInpatientStayArray(List<DataBean> beans, String tag){
		this(beans);
		setTag(tag);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedInpatientStayArray [stays=" + stays + ", toString()="
				+ super.toString() + "]";
	}
    
}