package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedLabTestArray.
 */
@XmlRootElement(name="TaggedLabTestArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedLabTestArray
    extends AbstractTaggedArrayTO
{
    
    /** The lab tests. */
	@XmlElement(name="labTests")
    protected LabTestArray labTests;

    public TaggedLabTestArray() 
    {
		super();
	}
	
	public TaggedLabTestArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
				
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
		}
		
		if(!foundFault){
			labTests = new LabTestArray(databeans);
			this.setLabTests(labTests);
			setCount(databeans.size());
		}
		
	}
	/**
	 * Gets the lab tests.
	 *
	 * @return the lab tests
	 */
	public LabTestArray getLabTests()
	{
		return labTests;
	}

	/**
	 * Sets the lab tests.
	 *
	 * @param labTests the new lab tests
	 */
	public void setLabTests(LabTestArray labTests)
	{
		this.labTests = labTests;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedLabTestArray [labTests=" + labTests + ", toString()="
				+ super.toString() + "]";
	}
}
