package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Medication;
import gov.va.med.via.databeans.Fault;

import java.util.ArrayList;
import java.util.List;


import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedMedicationArray.
 */
@XmlRootElement(name="TaggedMedicationArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedMedicationArray extends AbstractTaggedArrayTO
{	
	/** The meds. */
	@XmlElementWrapper(name="meds")
	@XmlElement(name="medicationTO")
	protected List<MedicationTO> meds;

	public TaggedMedicationArray(){
		
	}
	
	public TaggedMedicationArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<MedicationTO> medications = new ArrayList<MedicationTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			medications.add(new MedicationTO((Medication)dataBean));
		}
		
		if(!foundFault)
		{
			if ( medications!= null && medications.size()>0){
				this.setMeds(medications);
			}			
			setCount(medications.size());
		}
		
	}

	/**
	 * Gets the meds.
	 *
	 * @return the meds
	 */
	public List<MedicationTO> getMeds()
	{
		return meds;
	}

	/**
	 * Sets the meds.
	 *
	 * @param meds the new meds
	 */
	public void setMeds(List<MedicationTO> meds)
	{
		this.meds = meds;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedMedicationArray [meds=" + meds + ", toString()="
				+ super.toString() + "]";
	}
	
	
}
