package gov.va.med.via.dto.common;


import gov.va.med.via.databeans.DataBean;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedMedicationArrays.
 */
@XmlRootElement(name="TaggedMedicationArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedMedicationArrays extends AbstractTaggedArrayTO
{	
	
	/** The medication arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedMedicationArray")
	protected List<TaggedMedicationArray> medicationArrays;

	/**
	 * Gets the medication arrays.
	 *
	 * @return the medication arrays
	 */
	public List<TaggedMedicationArray> getMedicationArrays()
	{
		return medicationArrays;
	}

	public TaggedMedicationArrays()
	{
		
	}
	
	
	public TaggedMedicationArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{
		
		List<TaggedMedicationArray> taggedMedicationArrayList = new ArrayList<TaggedMedicationArray>();		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			TaggedMedicationArray array = new TaggedMedicationArray(daoSiteDataBeans.get(siteKey), siteKey);
			taggedMedicationArrayList.add(array);
		}
		this.setMedicationArrays(taggedMedicationArrayList);
		this.setCount(taggedMedicationArrayList.size());
	}
	
	
	/**
	 * Sets the medication arrays.
	 *
	 * @param medicationArrays the new medication arrays
	 */
	public void setMedicationArrays(List<TaggedMedicationArray> medicationArrays)
	{
		this.medicationArrays = medicationArrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedMedicationArrays [medicationArrays=" + medicationArrays
				+ ", toString()=" + super.toString() + "]";
	}
}
