package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.MentalHealthInstrumentAdministration;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedMentalHealthInstrumentAdministrationArray.
 */
@XmlRootElement(name="TaggedMentalHealthInstrumentAdministrationArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedMentalHealthInstrumentAdministrationArray
    extends AbstractTaggedArrayTO
{

    /** The items. */
	@XmlElementWrapper(name="items")
	@XmlElement(name="mentalHealthInstrumentAdministrationTO")
    protected List<MentalHealthInstrumentAdministrationTO> items;

	/**
	 * Instantiates a new tagged user array.
	 */
	public TaggedMentalHealthInstrumentAdministrationArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged user array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedMentalHealthInstrumentAdministrationArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<MentalHealthInstrumentAdministrationTO> mentalInstrumentAdminList = new ArrayList<MentalHealthInstrumentAdministrationTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			mentalInstrumentAdminList.add(new MentalHealthInstrumentAdministrationTO((MentalHealthInstrumentAdministration)dataBean));
		}
		
		if(!foundFault){
			this.setItems(mentalInstrumentAdminList);
			setCount(mentalInstrumentAdminList.size());
		}		
	}
	
	/**
	 * Gets the items.
	 *
	 * @return the items
	 */
	public List<MentalHealthInstrumentAdministrationTO> getItems()
	{
		return items;
	}

	/**
	 * Sets the items.
	 *
	 * @param items the new items
	 */
	public void setItems(List<MentalHealthInstrumentAdministrationTO> items)
	{
		this.items = items;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedMentalHealthInstrumentAdministrationArray [items="
				+ items + ", toString()=" + super.toString() + "]";
	}
}