package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.MicrobiologyReport;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedMicrobiologyRptArray.
 * 
 * @author DOMAINROMERJ
 */
@XmlRootElement(name="TaggedMicrobiologyRptArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedMicrobiologyRptArray extends AbstractTaggedArrayTO
{
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="microbiologyRpt")
	public List<MicrobiologyRpt> rpts;
	
	public TaggedMicrobiologyRptArray() 
	{
		super();
	}
	
	public TaggedMicrobiologyRptArray(List<DataBean> databeans, String siteCode) 
	{	
		super();
		setTag(siteCode);
		
		List<MicrobiologyRpt> microReports = new ArrayList<MicrobiologyRpt>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			microReports.add(new MicrobiologyRpt((MicrobiologyReport)dataBean));
		}
		
		if(!foundFault){
			this.setRpts(microReports);
			setCount(microReports.size());
		}		
	}

	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<MicrobiologyRpt> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<MicrobiologyRpt> rpts)
	{
		this.rpts = rpts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedMicrobiologyRptArray [rpts=" + rpts + ", toString()="
				+ super.toString() + "]";
	}
}
