package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedMicrobiologyRptArrays.
 */
@XmlRootElement(name="TaggedMicrobiologyRptArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedMicrobiologyRptArrays extends AbstractArrayTO
{
	
	/** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedMicrobiologyRptArray")
	protected List<TaggedMicrobiologyRptArray> microbiologyRptArrays;

	public TaggedMicrobiologyRptArrays() 
	{
		super();
	}

	public TaggedMicrobiologyRptArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{	
		List<TaggedMicrobiologyRptArray> taggedMicrobiologyArrayList = new ArrayList<TaggedMicrobiologyRptArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedMicrobiologyArrayList.add(new TaggedMicrobiologyRptArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setMicrobiologyRptArrays(taggedMicrobiologyArrayList);
		this.setCount(taggedMicrobiologyArrayList.size());
	}
	
	/**
	 * Gets the microbiology rpt arrays.
	 *
	 * @return the microbiology rpt arrays
	 */
	public List<TaggedMicrobiologyRptArray> getMicrobiologyRptArrays()
	{
		return microbiologyRptArrays;
	}

	/**
	 * Sets the microbiology rpt arrays.
	 *
	 * @param microbiologyRptArrays the new microbiology rpt arrays
	 */
	public void setMicrobiologyRptArrays(
			List<TaggedMicrobiologyRptArray> microbiologyRptArrays)
	{
		this.microbiologyRptArrays = microbiologyRptArrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedMicrobiologyRptArrays [microbiologyRptArrays="
				+ microbiologyRptArrays + ", toString()=" + super.toString()
				+ "]";
	}
}
