package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Note;

import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * The Class TaggedNoteArrays.
 */
@XmlRootElement(name="TaggedNoteArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedNoteArrays
    extends AbstractArrayTO
{
	public TaggedNoteArrays() {
		super();	
	}
	/**
	 * constructor that takes a siteDataBeanMap.  The List of DataBeans is assumed to be Note DataBeans
	 * 
	 * @param siteDataBeanMap
	 */
	public TaggedNoteArrays(Map<String,List<DataBean>> siteDataBeanMap) 
	{
		super();
		
		setCount(siteDataBeanMap.keySet().size());
		TaggedNoteArray[] taggedNoteArrayArray = new TaggedNoteArray[siteDataBeanMap.keySet().size()];
		int siteIndex=0;
		for ( String site: siteDataBeanMap.keySet())
		{
			List<DataBean> noteList=siteDataBeanMap.get(site);
			NoteTO[] noteTOArray = new NoteTO[noteList.size()];
			int noteIndex=0; 
			for ( DataBean db: noteList)
			{
				Note note = (Note)db;
				NoteTO noteTO = new NoteTO(note);
				noteTOArray[noteIndex]=noteTO;
				noteIndex++;
			}
			TaggedNoteArray taggedNoteArray = new TaggedNoteArray();
			taggedNoteArray.setNotes(noteTOArray);
			taggedNoteArray.setTag(site);
			taggedNoteArray.setCount(noteTOArray.length);
			taggedNoteArrayArray[siteIndex] = taggedNoteArray;
			siteIndex++;
		}
		setArrays(taggedNoteArrayArray);
	}
	
	
	
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedNoteArray") protected TaggedNoteArray[] arrays;
	public TaggedNoteArray[] getArrays()
	{
		return arrays;
	}
	public void setArrays(TaggedNoteArray[] arrays)
	{
		this.arrays = arrays;
	}
}