package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Order;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedOrderArray.
 */
@XmlRootElement(name="TaggedOrderArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedOrderArray
    extends AbstractTaggedArrayTO
{
    
    /** The items. */
	@XmlElementWrapper(name="items")
	@XmlElement(name="orderTO")
    protected List<OrderTO> items;

	/**
	 * Instantiates a new tagged order array.
	 */
	public TaggedOrderArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged order array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedOrderArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<OrderTO> items = new ArrayList<OrderTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			items.add(new OrderTO((Order)dataBean));
		}
		
		if(!foundFault){
			this.setItems(items);
			setCount(items.size());
		}
		
	}
	/**
	 * Gets the items.
	 *
	 * @return the items
	 */
	public List<OrderTO> getItems()
	{
		return items;
	}

	/**
	 * Sets the items.
	 *
	 * @param items the new items
	 */
	public void setItems(List<OrderTO> items)
	{
		this.items = items;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedOrderArray [items=" + items + ", toString()="
				+ super.toString() + "]";
	}
}
