package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedOrderArrays.
 */
@XmlRootElement(name="TaggedOrderArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedOrderArrays
    extends AbstractArrayTO
{
    
    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedOrderArray")
    protected List<TaggedOrderArray> arrays;

	/**
	 * Instantiates a new tagged order arrays.
	 */
	public TaggedOrderArrays() 
	{
		super();
	}

	/**
	 * Instantiates a new tagged order arrays.
	 *
	 * @param daoSiteDataBeans the dao site data beans
	 */
	public TaggedOrderArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{
		
		List<TaggedOrderArray> taggedOrderArrayList = new ArrayList<TaggedOrderArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys)
		{
			taggedOrderArrayList.add(new TaggedOrderArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedOrderArrayList);
		this.setCount(taggedOrderArrayList.size());
	}

	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedOrderArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedOrderArray> arrays)
	{
		this.arrays = arrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedOrderArrays [arrays=" + arrays + ", toString()="
				+ super.toString() + "]";
	}    
}