package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Patient;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedPatientArrays.
 */
@XmlRootElement(name="TaggedPatientArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedPatientArrays extends AbstractArrayTO
{
    
    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedPatientArray")	
    protected List<TaggedPatientArray> arrays;

    public TaggedPatientArrays()
    {
    	
    }

    /**
     * Instantiates a new tagged patient arrays.
     *
     * @param daoSiteDataBeans the dao site data beans
     */
    public TaggedPatientArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
    {		
		List<TaggedPatientArray> taggedPatientArrayList = new ArrayList<TaggedPatientArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedPatientArrayList.add(new TaggedPatientArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedPatientArrayList);
		this.setCount(taggedPatientArrayList.size());
	}

	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedPatientArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedPatientArray> arrays)
	{
		this.arrays = arrays;
	}
	
	
	public TaggedPatientArrays(List<DataBean> beans) // change to data bean to see if type exception
	{
		
		// TODO Add logic to verify that the List contains exceptions, arrays or Allergies		
	    if (beans == null || beans.size() == 0)  return;
	    
	    // TODO - verify databean is an exception
	    //if (beans is exception) create FaultTO using exception bean
        
	    // If no exception, the databeans are allergies
	    arrays = new ArrayList<TaggedPatientArray>();   
	    arrays.add(new TaggedPatientArray(beans.toArray(new Patient[beans.size()])));
        count = 1;
       
		/*
		if (beans== null || beans.size() == 0){
			count=0;
		    return;
		}
		arrays = new ArrayList<TaggedPatientArray>();   
		for (int i = 0; i < beans.size(); i++ ){
			arrays.add(new TaggedPatientArray((TaggedPatientArray)beans.get(i)));
		}	    		
		count = beans.size();
        */
	}
	

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedPatientArrays [arrays=" + arrays + ", toString()="
				+ super.toString() + "]";
	}
    
}