package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.PatientAssociate;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedPatientAssociateArray.
 */
@XmlRootElement(name="TaggedPatientAssociateArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedPatientAssociateArray
    extends AbstractTaggedArrayTO
{

    /** The pas. */
	@XmlElementWrapper(name="pas")
	@XmlElement(name="patientAssociateTO")
    protected List<PatientAssociateTO> pas;

	public TaggedPatientAssociateArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged user array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedPatientAssociateArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<PatientAssociateTO> associates = new ArrayList<PatientAssociateTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			associates.add(new PatientAssociateTO((PatientAssociate)dataBean));
		}
		
		if(!foundFault){
			this.setPas(associates);
			setCount(associates.size());
		}
		
	}
	
	/**
	 * Gets the pas.
	 *
	 * @return the pas
	 */
	public List<PatientAssociateTO> getPas()
	{
		return pas;
	}

	/**
	 * Sets the pas.
	 *
	 * @param pas the new pas
	 */
	public void setPas(List<PatientAssociateTO> pas)
	{
		this.pas = pas;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedPatientAssociateArray [pas=" + pas + ", toString()="
				+ super.toString() + "]";
	}
    
}
