package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedProblemArray.
 */
@XmlRootElement(name="TaggedProblemArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedProblemArray
    extends AbstractTaggedArrayTO
{
    
    /** The problems. */
	@XmlElementWrapper(name="problems")
	@XmlElement(name="problemTO")
    protected List<ProblemTO> problems;

	/**
	 * Instantiates a new tagged problem array.
	 */
	public TaggedProblemArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged problem array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedProblemArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<ProblemTO> problems = new ArrayList<ProblemTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			problems.add(new ProblemTO((gov.va.med.via.databeans.Problem)dataBean));
		}
		
		if(!foundFault){
			this.setProblems(problems);
			setCount(problems.size());
		}
		
	}
	
	/**
	 * Gets the problems.
	 *
	 * @return the problems
	 */
	public List<ProblemTO> getProblems()
	{
		return problems;
	}

	/**
	 * Sets the problems.
	 *
	 * @param problems the new problems
	 */
	public void setProblems(List<ProblemTO> problems)
	{
		this.problems = problems;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedProblemArray [problems=" + problems + ", toString()="
				+ super.toString() + "]";
	}
}
