package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedProblemArrays.
 */
@XmlRootElement(name="TaggedProblemArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedProblemArrays
    extends AbstractArrayTO
{
    
    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedProblemArray")
    protected List<TaggedProblemArray> arrays;


	public TaggedProblemArrays() 
	{
		super();
	}

	public TaggedProblemArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{
		
		List<TaggedProblemArray> problemList = new ArrayList<TaggedProblemArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			problemList.add(new TaggedProblemArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(problemList);
		this.setCount(problemList.size());
	}

	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedProblemArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedProblemArray> arrays)
	{
		this.arrays = arrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedProblemArrays [arrays=" + arrays + ", toString()="
				+ super.toString() + "]";
	}
    
}
