package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;
import gov.va.med.via.databeans.RadiologyReport;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedRadiologyReportArray.
 */
@XmlRootElement(name="TaggedRadiologyReportArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedRadiologyReportArray
    extends AbstractTaggedArrayTO
{
    
    /** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="radiologyReportTO")	
    protected List<RadiologyReportTO> rpts;

	/**
	 * Instantiates a new tagged radiology report array.
	 */
	public TaggedRadiologyReportArray()
	{		
	}
	
	/**
	 * Instantiates a new tagged radiology report array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedRadiologyReportArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<RadiologyReportTO> reports = new ArrayList<RadiologyReportTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			reports.add(new RadiologyReportTO((RadiologyReport)dataBean));
		}
		
		if(!foundFault){
			this.setRpts(reports);
			setCount(reports.size());
		}
		
	}
	
	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<RadiologyReportTO> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<RadiologyReportTO> rpts)
	{
		this.rpts = rpts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedRadiologyReportArray [rpts=" + rpts + ", toString()="
				+ super.toString() + "]";
	}
}
