package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedRadiologyReportArrays.
 */
@XmlRootElement(name="TaggedRadiologyReportArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedRadiologyReportArrays
    extends AbstractArrayTO
{
    
    /** The radiology report arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedRadiologyReportArray")
    protected List<TaggedRadiologyReportArray> radiologyReportArrays;

	public TaggedRadiologyReportArrays()
	{		
	}
	
	public TaggedRadiologyReportArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{		
		List<TaggedRadiologyReportArray> taggedRadiologyReportArrayList = new ArrayList<TaggedRadiologyReportArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedRadiologyReportArrayList.add(new TaggedRadiologyReportArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setRadiologyReportArrays(taggedRadiologyReportArrayList);
		this.setCount(taggedRadiologyReportArrayList.size());
	}

	/**
	 * Gets the radiology report arrays.
	 *
	 * @return the radiology report arrays
	 */
	public List<TaggedRadiologyReportArray> getRadiologyReportArrays()
	{
		return radiologyReportArrays;
	}

	/**
	 * Sets the radiology report arrays.
	 *
	 * @param radiologyReportArrays the new radiology report arrays
	 */
	public void setRadiologyReportArrays(
			List<TaggedRadiologyReportArray> radiologyReportArrays)
	{
		this.radiologyReportArrays = radiologyReportArrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedRadiologyReportArrays [radiologyReportArrays="
				+ radiologyReportArrays + ", toString()=" + super.toString()
				+ "]";
	}
}
