package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;
import gov.va.med.via.databeans.SurgeryReport;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedSurgeryReportArray.
 */
@XmlRootElement(name="TaggedSurgeryReportArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedSurgeryReportArray
    extends AbstractTaggedArrayTO
{

    /** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="surgeryReportTO")
    protected List<SurgeryReportTO> rpts;

    /**
     * Instantiates a new tagged surgery report array.
     */
    public TaggedSurgeryReportArray() 
    {
		super();
	}
	
	/**
	 * Instantiates a new tagged surgery report array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedSurgeryReportArray(List<DataBean> databeans, String siteCode) 
	{		
		super();
		setTag(siteCode);
		
		List<SurgeryReportTO> reports = new ArrayList<SurgeryReportTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans)
		{
			if(dataBean instanceof Fault)
			{
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			reports.add(new SurgeryReportTO((SurgeryReport)dataBean));
		}
		
		if(!foundFault)
		{
			this.setRpts(reports);
			setCount(reports.size());
		}
		
	}
	
	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<SurgeryReportTO> getRpts()
	{
		return rpts;
	}

	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<SurgeryReportTO> rpts)
	{
		this.rpts = rpts;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedSurgeryReportArray [rpts=" + rpts + ", toString()="
				+ super.toString() + "]";
	}
}
