package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedSurgeryReportArrays.
 */
@XmlRootElement(name="TaggedSurgeryReportArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedSurgeryReportArrays
    extends AbstractArrayTO
{        
    /** The surgery report arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedSurgeryReportArray")
    protected List<TaggedSurgeryReportArray> surgeryReportArrays;

	
    public TaggedSurgeryReportArrays() 
    {
		super();
	}

	public TaggedSurgeryReportArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
	{
		
		List<TaggedSurgeryReportArray> taggedSurgeryReportList = new ArrayList<TaggedSurgeryReportArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedSurgeryReportList.add(new TaggedSurgeryReportArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setSurgeryReportArrays(taggedSurgeryReportList);
		this.setCount(taggedSurgeryReportList.size());
	}
	
    /**
	 * Gets the surgery report arrays.
	 *
	 * @return the surgery report arrays
	 */
	public List<TaggedSurgeryReportArray> getSurgeryReportArrays()
	{
		return surgeryReportArrays;
	}

	/**
	 * Sets the surgery report arrays.
	 *
	 * @param surgeryReportArrays the new surgery report arrays
	 */
	public void setSurgeryReportArrays(
			List<TaggedSurgeryReportArray> surgeryReportArrays)
	{
		this.surgeryReportArrays = surgeryReportArrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedSurgeryReportArrays [surgeryReportArrays="
				+ surgeryReportArrays + ", toString()=" + super.toString()
				+ "]";
	}
}