package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.SurgicalPathologyReport;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedSurgicalPathologyRptArray.
 */
@XmlRootElement(name="TaggedSurgicalPathologyRptArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedSurgicalPathologyRptArray
    extends AbstractTaggedArrayTO
{

    /** The rpts. */
	@XmlElementWrapper(name="rpts")
	@XmlElement(name="surgicalPathologyRpt")	
    protected List<SurgicalPathologyRpt> rpts;

    public TaggedSurgicalPathologyRptArray() 
    {
		super();
	}
	
	/**
	 * Instantiates a new tagged surgical pathology rpt array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedSurgicalPathologyRptArray(List<DataBean> databeans, String siteCode) {
		
		super();
		setTag(siteCode);
		
		List<SurgicalPathologyRpt> reports = new ArrayList<SurgicalPathologyRpt>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			reports.add(new SurgicalPathologyRpt((SurgicalPathologyReport)dataBean));
		}
		
		if(!foundFault){
			this.setRpts(reports);
			setCount(reports.size());
		}
		
	}
	
	/**
	 * Gets the rpts.
	 *
	 * @return the rpts
	 */
	public List<SurgicalPathologyRpt> getRpts()
	{
		return rpts;
	}


	/**
	 * Sets the rpts.
	 *
	 * @param rpts the new rpts
	 */
	public void setRpts(List<SurgicalPathologyRpt> rpts)
	{
		this.rpts = rpts;
	}


	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedSurgicalPathologyRptArray [rpts=" + rpts
				+ ", toString()=" + super.toString() + "]";
	}
    
    
}
