package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedSurgicalPathologyRptArrays.
 */
@XmlRootElement(name="TaggedSurgicalPathologyRptArrays")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedSurgicalPathologyRptArrays
    extends AbstractArrayTO
{    
    /** The arrays. */
	@XmlElementWrapper(name="arrays")
	@XmlElement(name="taggedSurgicalPathologyRptArray")	
    protected List<TaggedSurgicalPathologyRptArray> arrays;

    /**
     * Instantiates a new tagged surgical pathology rpt arrays.
     */
    public TaggedSurgicalPathologyRptArrays()
    {
    	super();
    }
        
    /**
     * Instantiates a new tagged surgical pathology rpt arrays.
     *
     * @param daoSiteDataBeans the dao site data beans
     */
    public TaggedSurgicalPathologyRptArrays(Map<String, List<DataBean>> daoSiteDataBeans) 
    {		
		List<TaggedSurgicalPathologyRptArray> taggedSurgicalPathologyRptArrayList = new ArrayList<TaggedSurgicalPathologyRptArray>();
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys){
			taggedSurgicalPathologyRptArrayList.add(new TaggedSurgicalPathologyRptArray(daoSiteDataBeans.get(siteKey), siteKey));
		}
		
		this.setArrays(taggedSurgicalPathologyRptArrayList);
		this.setCount(taggedSurgicalPathologyRptArrayList.size());
	}

	/**
	 * Gets the arrays.
	 *
	 * @return the arrays
	 */
	public List<TaggedSurgicalPathologyRptArray> getArrays()
	{
		return arrays;
	}

	/**
	 * Sets the arrays.
	 *
	 * @param arrays the new arrays
	 */
	public void setArrays(List<TaggedSurgicalPathologyRptArray> arrays)
	{
		this.arrays = arrays;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedSurgicalPathologyRptArrays [arrays=" + arrays
				+ ", toString()=" + super.toString() + "]";
	}
}