package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Text;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * <p>Java class for TaggedTextArray complex type.
 * 
 */
@XmlRootElement(name="TaggedTextArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedTextArray extends AbstractArrayTO
{

    /** The results. */
	@XmlElementWrapper(name="results")
	@XmlElement(name="taggedText")
    protected List<TaggedText> results;
    
    /** The text only. */
    /** MDWS 2.5 version only */
	@XmlElement(name="textOnly")
    protected Boolean textOnly;

    /**
     * Instantiates a new tagged text array.
     */
    public TaggedTextArray()
    {    	
    }
    
	public TaggedTextArray(List<DataBean> beans){
		if (beans== null || beans.size() == 0){
			count=0;
		    return;
		}
		results = new ArrayList<TaggedText>();   
		for (int i = 0; i < beans.size(); i++ ){
			results.add(new TaggedText((Text)beans.get(i)));
		}	    		
		count = beans.size();
	}

	
	public TaggedTextArray(List<DataBean> beans, String tag){
		this(beans);
	//	setTag(tag);
	}
	
	/**
	 * Instantiates a new tagged text array.
	 *
	 * @param daoSiteDataBeans the dao site data beans
	 */
	public TaggedTextArray(Map<String, List<DataBean>> daoSiteDataBeans){
		
		List<TaggedText> taggedTextArrayList = new ArrayList<TaggedText>();		
		
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys)
		{
			List<DataBean> daoDataBeans = daoSiteDataBeans.get(siteKey);
			for(DataBean databean:daoDataBeans)
			{
				taggedTextArrayList.add(new TaggedText(databean, siteKey));
			}
		}
		
		results = taggedTextArrayList;
		this.setCount(taggedTextArrayList.size());
	}
	
    /**
     * Instantiates a new tagged text array.
     *
     * @param map the map
     */
    public TaggedTextArray(HashMap<String, String> hashMap)
    {    	
    	if (hashMap == null || hashMap.isEmpty())
    	{
    		this.count = 0;
    		return;
    	}

    	results = new ArrayList<TaggedText>();    	
    	for (Iterator<String> iter = hashMap.keySet().iterator(); iter.hasNext();)
    	{
    		String key = (String)iter.next();
    		results.add(new TaggedText(key, hashMap.get(key)));
    	}
    	
    	count = results.size();
    }
   
    /**
     * Gets the value of the results property.
     *
     * @return the results
     * possible object is
     * {@link ArrayOfTaggedText }
     */
    public List<TaggedText> getResults() 
    {
        return results;
    }

    /**
     * Sets the value of the results property.
     * 
     * @param value
     *     allowed object is
     *     {@link ArrayOfTaggedText }
     *     
     */
    public void setResults(List<TaggedText> value) 
    {
        this.results = value;
    }
    

	/**
	 * Gets the text only.
	 *
	 * @return the text only
	 */
	public Boolean getTextOnly()
	{
		return textOnly;
	}

	/**
	 * Sets the text only.
	 *
	 * @param textOnly the new text only
	 */
	public void setTextOnly(Boolean textOnly)
	{
		this.textOnly = textOnly;
	}

}

