/*
 * 
 */
package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedUserArray.
 */
@XmlRootElement(name="TaggedUserArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedUserArray extends AbstractTaggedArrayTO
{    
    /** The users. */
	@XmlElementWrapper(name="users")
	@XmlElement(name="userTO")
    protected List<UserTO> users;

	/**
	 * Instantiates a new tagged user array.
	 */
	public TaggedUserArray() 
	{
		super();
	}
	
	/**
	 * Instantiates a new tagged user array.
	 *
	 * @param databeans the databeans
	 * @param siteCode the site code
	 */
	public TaggedUserArray(List<DataBean> databeans, String siteCode) {
		
		super();
		setTag(siteCode);
		
		List<UserTO> users = new ArrayList<UserTO>();
		boolean foundFault = false;
		for(DataBean dataBean: databeans){
			if(dataBean instanceof Fault){
				this.setFault(new FaultTO((Fault)dataBean));
				foundFault = true;
				break;
			}
			users.add(new UserTO((Provider)dataBean));
		}
		
		if(!foundFault){
			this.setUsers(users);
			setCount(users.size());
		}
		
	}

	/**
	 * Gets the users.
	 *
	 * @return the users
	 */
	public List<UserTO> getUsers()
	{
		return users;
	}

	/**
	 * Sets the users.
	 *
	 * @param users the new users
	 */
	public void setUsers(List<UserTO> users)
	{
		this.users = users;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedUserArray [users=" + users + ", toString()="
				+ super.toString() + "]";
	}
}
