package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Visit;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedVisitArray.
 */
@XmlRootElement(name="TaggedVisitArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedVisitArray
    extends AbstractTaggedArrayTO
{
    
    /** The visits. */
	@XmlElementWrapper(name="visits")
	@XmlElement(name="visitTO")
    protected List<VisitTO> visits;

	/**
	 * Gets the visits.
	 *
	 * @return the visits
	 */
	public List<VisitTO> getVisits()
	{
		return visits;
	}
	
	/**
	 * Sets the visits.
	 *
	 * @param visits the new visits
	 */
	public void setVisits(List<VisitTO> visits)
	{
		this.visits = visits;
	}
	
	public TaggedVisitArray(){
		
	}
	
	public TaggedVisitArray(List<DataBean> beans){
		if (beans== null || beans.size() == 0){
			count=0;
		    return;
		}
		visits = new ArrayList<VisitTO>();   
		for (int i = 0; i < beans.size(); i++ ){
			visits.add(new VisitTO((Visit)beans.get(i)));
		}	    		
		count = beans.size();
	}
	
	public TaggedVisitArray(List<DataBean> beans, String tag){
		this(beans);
		setTag(tag);
	}

	public TaggedVisitArray(Map<String, List<DataBean>> daoSiteDataBeans) 
	{
		List<VisitTO> curVisits = new ArrayList<VisitTO>();   
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		boolean foundFault = false;
		String tag="";
		for(String siteKey : databeanSiteKeys)
		{
			tag = siteKey;
			List<DataBean> siteDataBeans = daoSiteDataBeans.get(siteKey);
			for (int i = 0; i < siteDataBeans.size(); i++ )
			{
				DataBean dataBean = siteDataBeans.get(i);
				if(dataBean instanceof Fault)
				{
					this.setFault(new FaultTO((Fault)dataBean));
					foundFault = true;
					break;
				}
				curVisits.add(new VisitTO((Visit)siteDataBeans.get(i)));
			}	
		}
		if(!foundFault)
		{
			if ( curVisits.size()>0)
			{
				setVisits(curVisits);
				setCount(visits.size());
				
			}			
		}	
		setTag(tag);
	}
	
	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedVisitArray [visits=" + visits + ", toString()="
				+ super.toString() + "]";
	}
}
