package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Allergy;
import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.VitalSignSet;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class TaggedVitalSignSetArray.
 */
@XmlRootElement(name="TaggedVitalSignSetArray")
@XmlAccessorType(XmlAccessType.NONE)
public class TaggedVitalSignSetArray extends AbstractTaggedArrayTO
{
	
	/** The sets. */
	@XmlElementWrapper(name="sets")
	@XmlElement(name="vitalSignSetTO")
	protected List<VitalSignSetTO> sets;
	
	public TaggedVitalSignSetArray(){
		super();
	}
	
	public TaggedVitalSignSetArray(List<DataBean> databeans, String siteCode) {
			
			super();
			setTag(siteCode);
			
			this.sets= new ArrayList<VitalSignSetTO>();
			boolean foundFault = false;
			for(DataBean dataBean: databeans){
				if(dataBean instanceof Fault){
					this.setFault(new FaultTO((Fault)dataBean));
					foundFault = true;
					break;
				}
				this.sets.add(new VitalSignSetTO((VitalSignSet)dataBean));
			}
			
			if(!foundFault){
				setCount(this.sets.size());
			}
			
		}

	/**
	 * Gets the sets.
	 *
	 * @return the sets
	 */
	public List<VitalSignSetTO> getSets()
	{
		return sets;
	}

	/**
	 * Sets the sets.
	 *
	 * @param sets the new sets
	 */
	public void setSets(List<VitalSignSetTO> sets)
	{
		this.sets = sets;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.via.dto.common.AbstractTaggedArrayTO#toString()
	 */
	@Override
	public String toString()
	{
		return "TaggedVitalSignSetArray [sets=" + sets + ", toString()="
				+ super.toString() + "]";
	}
}
