package gov.va.med.via.dto.common;

import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessType;

import gov.va.med.via.databeans.DataBean;
import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Text;

// TODO: Auto-generated Javadoc
/**
 * The Class TextTO.
 */
@XmlRootElement(name="TextTO")
@XmlAccessorType(XmlAccessType.NONE)
public class TextTO extends AbstractTO
{
    
    /** The text. */
	@XmlElement(name="text")
    protected String text;

    /**
     * Instantiates a new text to - default constructor
     */
    public TextTO()
    {    	
    }

    public TextTO(Map<String, List<DataBean>> daoSiteDataBeans) 
    {    	
		Set<String> databeanSiteKeys = daoSiteDataBeans.keySet();
		for(String siteKey : databeanSiteKeys)
		{
			if (daoSiteDataBeans.get(siteKey).size() != 1)			// Should only be one at this level
	    		return; 
	    	
			for(DataBean dataBean: daoSiteDataBeans.get(siteKey))
			{
				if(dataBean instanceof Fault)
				{
					this.setFault(new FaultTO((Fault)dataBean));
					break;
				}
				
				Text textBean = (Text)dataBean;
				this.text = textBean.getText();
				
			}
		}
	}
    
    /**
     * Instantiates a new text to using the values of the Text instance received.
     *
     * @param Text the text instance
     */
    public TextTO(Text text)
    {    
       	if (text.hasErrors()) 
       	{
    		this.fault = new FaultTO(text.getFault());
       	}
    	else
    	{
  			this.text = text.getText();
    	}
    }
    
    public TextTO(DataBean text)
    {    
       	if (text instanceof Fault) 
       	{
    		this.fault = new FaultTO((Fault)text);
       	}
    	else
    	{
    		Text textDatabean = (Text)text;
  			this.text = textDatabean.getText();
    	}
    }

	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	public String getText()
	{
		return text;
	}

	/**
	 * Sets the text.
	 *
	 * @param text the new text
	 */
	public void setText(String text)
	{
		this.text = text;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "TextTO [text=" + text + ", toString()=" + super.toString()
				+ "]";
	}    
}