package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;
import gov.va.med.via.databeans.DataBean;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;


// TODO: Auto-generated Javadoc
/**
 * The Class UserArray.
 */
@XmlRootElement(name="UserArray")
@XmlAccessorType(XmlAccessType.NONE)
public class UserArray
    extends AbstractArrayTO
{
    /** The users. */
	@XmlElementWrapper(name="users")
	@XmlElement(name="userTO")
    protected List<UserTO> users;

	public UserArray()
	{
		super();
	}
	
	public UserArray(Provider[] providers)
   	{
    	createUsersCollection();
    	if(providers.length>0)
    	{
    		for( Provider provider:providers)
    		{
    			UserTO userTo = new UserTO(provider);
    			users.add(userTo);
    		}
    	}
			
        setCount(providers.length);
    }
	
	public UserArray(List<DataBean> databeans)
   	{
    	List<UserTO> userList = new ArrayList<UserTO>();
    	boolean foundFault = false;
    	for( DataBean databean : databeans)
    	{
    		if(databean instanceof Fault){
    			this.setFault(new FaultTO((Fault)databean));
    			foundFault = true;
    			break;
    		}
    		UserTO userTo = new UserTO((Provider)databean);
    		userList.add(userTo);
    	}
    
		if(!foundFault){
			 setCount(userList.size());
			 this.setUsers(userList);
		}
       
    }
	
	/**
	 * Gets the users.
	 *
	 * @return the users
	 */
	public List<UserTO> getUsers()
	{
		if(users == null)
		{
			createUsersCollection();
		}
		return users;
	}
	
	private void createUsersCollection(){
		this.users = new ArrayList<UserTO>();
	}

	/**
	 * Sets the users.
	 *
	 * @param users the new users
	 */
	public void setUsers(List<UserTO> users)
	{
		this.users = users;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "UserArray [users=" + users + ", toString()=" + super.toString()
				+ "]";
	}
}