package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.Fault;
import gov.va.med.via.databeans.Provider;
import gov.va.med.via.databeans.User;

// TODO: Auto-generated Javadoc
/**
 * <p>
 * Java class for UserTO complex type.
 * 
 */
@XmlRootElement(name="UserTO")
@XmlAccessorType(XmlAccessType.NONE)
public class UserTO extends AbstractTO 
{
	/** The name. */
	@XmlElement(name="name")
	protected String name;

	/** The ssn. */
	@XmlElement(name="SSN")
	protected String ssn;

	/** The duz. */
	@XmlElement(name="DUZ")
	protected String duz;

	/** The site id. */
	@XmlElement(name="siteId")
	protected String siteId;

	/** The office. */
	@XmlElement(name="office")
	protected String office;

	/** The phone. */
	@XmlElement(name="phone")
	protected String phone;

	/** The pager. */
	@XmlElement(name="pager")
	protected String pager;

	/** The service. */
	@XmlElement(name="service")
	protected String service;

	/** The title. */
	@XmlElement(name="title")
	protected String title;

	/** The order role. */
	@XmlElement(name="orderRole")
	protected String orderRole;

	/** The user class. */
	@XmlElement(name="userClass")
	protected String userClass;

	/** The greeting. */
	@XmlElement(name="greeting")
	protected String greeting;

	/** The site message. */
	@XmlElement(name="siteMessage")
	protected String siteMessage;

	/** The ids. */
	@XmlElement(name="ids")
	protected TaggedTextArray ids; // NOT IN 2.5 MDWS

	/** The email address. */
	@XmlElement(name="emailAddress")
	protected String emailAddress; // NOT IN 2.5 MDWS

	/** The username. */
	@XmlElement(name="username")
	protected String username; // NOT IN 2.5 MDWS

	public UserTO() 
	{
	}
	
	public UserTO(Fault fault){
		this.setFault(new FaultTO(fault));
	}

	public UserTO(Provider provider) 
	{
		if ( provider.getFault()!=null ){
			this.setFault(new FaultTO(provider.getFault()));
		}
		else{
			this.name = provider.getProviderName();
			this.ssn = provider.getSsn();
			this.duz = provider.getUserId();
			this.siteId = provider.getLoginSiteCode();
			this.office = provider.getOffice();
			this.phone = provider.getDutyPhone();
			this.pager = provider.getPager();
			this.service = provider.getService();
			this.title = provider.getTitle();
			this.orderRole = provider.getOrderRole();
			this.userClass = provider.getUserClass();
			this.greeting = provider.getGreeting();
			//this.siteMessage = provider.getSit;
			//this.ids = provider;
			this.emailAddress = provider.getEmail();		
			//this.username = provider; 
		}
	}

    public UserTO(User user)
    {
        if (user == null) return;
       
        this.name = user.getName() == null ? null : user.getName();
        this.ssn = user.getSsn() == null ? null : user.getSsn();
        this.duz = user.getUid();
        this.siteId = user.getLogonSiteId() == null ? null : user.getLogonSiteId().getId();
        this.office = user.getOffice();
        this.phone = user.getPhone();
        this.pager = user.getVoicePager();
        this.service = user.getService() != null? user.getService().getName(): null;
        this.title = user.getTitle();
        this.orderRole = user.getOrderRole();
        this.userClass = user.getUserClass();
        this.greeting = user.getGreeting();
   }
    
	/**
	 * Gets the value of the name property.
	 * 
	 * @return the name possible object is {@link String }
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the value of the name property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setName(String value) {
		this.name = value;
	}

	/**
	 * Gets the value of the ssn property.
	 * 
	 * @return the ssn possible object is {@link String }
	 */
	public String getSSN() {
		return ssn;
	}

	/**
	 * Sets the value of the ssn property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setSSN(String value) {
		this.ssn = value;
	}

	/**
	 * Gets the value of the duz property.
	 * 
	 * @return the duz possible object is {@link String }
	 */
	public String getDUZ() {
		return duz;
	}

	/**
	 * Sets the value of the duz property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setDUZ(String value) {
		this.duz = value;
	}

	/**
	 * Gets the value of the siteId property.
	 * 
	 * @return the site id possible object is {@link String }
	 */
	public String getSiteId() {
		return siteId;
	}

	/**
	 * Sets the value of the siteId property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setSiteId(String value) {
		this.siteId = value;
	}

	/**
	 * Gets the value of the office property.
	 * 
	 * @return the office possible object is {@link String }
	 */
	public String getOffice() {
		return office;
	}

	/**
	 * Sets the value of the office property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setOffice(String value) {
		this.office = value;
	}

	/**
	 * Gets the value of the phone property.
	 * 
	 * @return the phone possible object is {@link String }
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * Sets the value of the phone property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setPhone(String value) {
		this.phone = value;
	}

	/**
	 * Gets the value of the pager property.
	 * 
	 * @return the pager possible object is {@link String }
	 */
	public String getPager() {
		return pager;
	}

	/**
	 * Sets the value of the pager property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setPager(String value) {
		this.pager = value;
	}

	/**
	 * Gets the value of the service property.
	 * 
	 * @return the service possible object is {@link String }
	 */
	public String getService() {
		return service;
	}

	/**
	 * Sets the value of the service property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setService(String value) {
		this.service = value;
	}

	/**
	 * Gets the value of the title property.
	 * 
	 * @return the title possible object is {@link String }
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * Sets the value of the title property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setTitle(String value) {
		this.title = value;
	}

	/**
	 * Gets the value of the orderRole property.
	 * 
	 * @return the order role possible object is {@link String }
	 */
	public String getOrderRole() {
		return orderRole;
	}

	/**
	 * Sets the value of the orderRole property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setOrderRole(String value) {
		this.orderRole = value;
	}

	/**
	 * Gets the value of the userClass property.
	 * 
	 * @return the user class possible object is {@link String }
	 */
	public String getUserClass() {
		return userClass;
	}

	/**
	 * Sets the value of the userClass property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setUserClass(String value) {
		this.userClass = value;
	}

	/**
	 * Gets the value of the greeting property.
	 * 
	 * @return the greeting possible object is {@link String }
	 */
	public String getGreeting() {
		return greeting;
	}

	/**
	 * Sets the value of the greeting property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setGreeting(String value) {
		this.greeting = value;
	}

	/**
	 * Gets the value of the siteMessage property.
	 * 
	 * @return the site message possible object is {@link String }
	 */
	public String getSiteMessage() {
		return siteMessage;
	}

	/**
	 * Sets the value of the siteMessage property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setSiteMessage(String value) {
		this.siteMessage = value;
	}

	/**
	 * Gets the value of the ids property.
	 * 
	 * @return the ids possible object is {@link TaggedTextArray }
	 */
	public TaggedTextArray getIds() {
		return ids;
	}

	/**
	 * Sets the value of the ids property.
	 * 
	 * @param value
	 *            allowed object is {@link TaggedTextArray }
	 * 
	 */
	public void setIds(TaggedTextArray value) {
		this.ids = value;
	}

	/**
	 * Gets the value of the emailAddress property.
	 * 
	 * @return the email address possible object is {@link String }
	 */
	public String getEmailAddress() {
		return emailAddress;
	}

	/**
	 * Sets the value of the emailAddress property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setEmailAddress(String value) {
		this.emailAddress = value;
	}

	/**
	 * Gets the value of the username property.
	 * 
	 * @return the username possible object is {@link String }
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * Sets the value of the username property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setUsername(String value) {
		this.username = value;
	}

}