package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessType;

import gov.va.med.via.databeans.Visit;

// TODO: Auto-generated Javadoc
/**
 * The Class VisitTO.
 */
@XmlRootElement(name="VisitTO")
@XmlAccessorType(XmlAccessType.NONE)
public class VisitTO
    extends AbstractTO
{
    
    /** The id. */
	@XmlElement(name="id")
    protected String id;
    
    /** The type. */
	@XmlElement(name="type")
    protected String type;
    
    /** The patient. */
	@XmlElement(name="patient")
    protected PatientTO patient;
    
    /** The attending. */
	@XmlElement(name="attending")
    protected UserTO attending;
    
    /** The provider. */
	@XmlElement(name="provider")
    protected UserTO provider;
    
    /** The service. */
	@XmlElement(name="service")
    protected String service;
    
    /** The location. */
	@XmlElement(name="location")
    protected HospitalLocationTO location;
    
    /** The patient type. */
	@XmlElement(name="patientType")
    protected String patientType;
    
    /** The visit id. */
	@XmlElement(name="visitId")
    protected String visitId;
    
    /** The timestamp. */	
	@XmlElement(name="timestamp")
    protected String timestamp;
    
    /** The status. */
	@XmlElement(name="status")
    protected String status;
    
    /** The facility. */
	@XmlElement(name="facility")
    protected SiteTO facility;
	
    public VisitTO()
    {    	
    }
    
    /*
     * Constructor that takes a Visit object as parameter
     * @param visit - The Visit databean that is passed as a parameter 
     */
    public VisitTO(Visit visit)
    {
    	this.type = visit.getType();
    	this.timestamp = visit.getTimestamp();
    	this.status = visit.getStatus();
    	if ( visit.getHospitalLocation()!= null){
    		this.location = new HospitalLocationTO();
    		this.location.setId(visit.getHospitalLocation().getId());
    		this.location.setName(visit.getHospitalLocation().getName());
    	}
    	
    }
    
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id)
	{
		this.id = id;
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public String getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(String type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the patient.
	 *
	 * @return the patient
	 */
	public PatientTO getPatient()
	{
		return patient;
	}
	
	/**
	 * Sets the patient.
	 *
	 * @param patient the new patient
	 */
	public void setPatient(PatientTO patient)
	{
		this.patient = patient;
	}
	
	/**
	 * Gets the attending.
	 *
	 * @return the attending
	 */
	public UserTO getAttending()
	{
		return attending;
	}
	
	/**
	 * Sets the attending.
	 *
	 * @param attending the new attending
	 */
	public void setAttending(UserTO attending)
	{
		this.attending = attending;
	}
	
	/**
	 * Gets the provider.
	 *
	 * @return the provider
	 */
	public UserTO getProvider()
	{
		return provider;
	}
	
	/**
	 * Sets the provider.
	 *
	 * @param provider the new provider
	 */
	public void setProvider(UserTO provider)
	{
		this.provider = provider;
	}
	
	/**
	 * Gets the service.
	 *
	 * @return the service
	 */
	public String getService()
	{
		return service;
	}
	
	/**
	 * Sets the service.
	 *
	 * @param service the new service
	 */
	public void setService(String service)
	{
		this.service = service;
	}
	
	/**
	 * Gets the location.
	 *
	 * @return the location
	 */
	public HospitalLocationTO getLocation()
	{
		return location;
	}
	
	/**
	 * Sets the location.
	 *
	 * @param location the new location
	 */
	public void setLocation(HospitalLocationTO location)
	{
		this.location = location;
	}
	
	/**
	 * Gets the patient type.
	 *
	 * @return the patient type
	 */
	public String getPatientType()
	{
		return patientType;
	}
	
	/**
	 * Sets the patient type.
	 *
	 * @param patientType the new patient type
	 */
	public void setPatientType(String patientType)
	{
		this.patientType = patientType;
	}
	
	/**
	 * Gets the visit id.
	 *
	 * @return the visit id
	 */
	public String getVisitId()
	{
		return visitId;
	}
	
	/**
	 * Sets the visit id.
	 *
	 * @param visitId the new visit id
	 */
	public void setVisitId(String visitId)
	{
		this.visitId = visitId;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the status.
	 *
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	
	/**
	 * Sets the status.
	 *
	 * @param status the new status
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public SiteTO getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(SiteTO facility)
	{
		this.facility = facility;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "VisitTO [id=" + id + ", type=" + type + ", patient=" + patient
				+ ", attending=" + attending + ", provider=" + provider
				+ ", service=" + service + ", location=" + location
				+ ", patientType=" + patientType + ", visitId=" + visitId
				+ ", timestamp=" + timestamp + ", status=" + status
				+ ", facility=" + facility + ", toString()=" + super.toString()
				+ "]";
	}
}
