package gov.va.med.via.dto.common;

import gov.va.med.via.databeans.Symptom;
import gov.va.med.via.databeans.VitalSign;
import gov.va.med.via.databeans.VitalSignSet;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * The Class VitalSignSetTO.
 */
@XmlRootElement(name="VitalSignSetTO")
@XmlAccessorType(XmlAccessType.NONE)
public class VitalSignSetTO extends AbstractTO
{	
	/** The timestamp. */
	@XmlElement(name="timestamp")
	protected String timestamp;
    
    /** The facility. */
	@XmlElement(name="facility")
	protected TaggedText facility;
    
    /** The vital signs. */
	@XmlElementWrapper(name="vitalSigns")
	@XmlElement(name="vitalSignTO")
	protected List<VitalSignTO> vitalSigns = new ArrayList<VitalSignTO>();
    
    /** The units. */
	@XmlElement(name="units")
	protected String units;
    
    /** The qualifiers. */
	@XmlElement(name="qualifiers")
    protected String qualifiers;
    
    public VitalSignSetTO(){
    	super();
    }
    
    public VitalSignSetTO(VitalSignSet vitalSignSet){
    	
    	this.timestamp = vitalSignSet.getTimestamp();
    	this.facility = new TaggedText(vitalSignSet.getFacility()); // TaggedText
    	this.units = vitalSignSet.getUnits();
    	this.qualifiers = vitalSignSet.getQualifiers();
    	for(VitalSign vitalSign: vitalSignSet.getVitalSigns().values()){
    		this.vitalSigns.add(new VitalSignTO(vitalSign));
    	}
    	
    }
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the vital signs.
	 *
	 * @return the vital signs
	 */
	public List<VitalSignTO> getVitalSigns()
	{
		return vitalSigns;
	}
	
	/**
	 * Sets the vital signs.
	 *
	 * @param vitalSigns the new vital signs
	 */
	public void setVitalSigns(List<VitalSignTO> vitalSigns)
	{
		this.vitalSigns = vitalSigns;
	}
	
	/**
	 * Gets the units.
	 *
	 * @return the units
	 */
	public String getUnits()
	{
		return units;
	}
	
	/**
	 * Sets the units.
	 *
	 * @param units the new units
	 */
	public void setUnits(String units)
	{
		this.units = units;
	}
	
	/**
	 * Gets the qualifiers.
	 *
	 * @return the qualifiers
	 */
	public String getQualifiers()
	{
		return qualifiers;
	}
	
	/**
	 * Sets the qualifiers.
	 *
	 * @param qualifiers the new qualifiers
	 */
	public void setQualifiers(String qualifiers)
	{
		this.qualifiers = qualifiers;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "VitalSignSetTO [timestamp=" + timestamp + ", facility="
				+ facility + ", vitalSigns=" + vitalSigns + ", units=" + units
				+ ", qualifiers=" + qualifiers + ", toString()="
				+ super.toString() + "]";
	}
}
