package gov.va.med.via.dto.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import gov.va.med.via.databeans.VitalSign;

// TODO: Auto-generated Javadoc
/**
 * The Class VitalSignTO.
 */
@XmlRootElement(name="VitalSignTO")
@XmlAccessorType(XmlAccessType.NONE)
public class VitalSignTO extends AbstractTO
{
	/** The type. */
	@XmlElement(name="type")
	protected ObservationTypeTO type;
    
    /** The value1. */
	@XmlElement(name="value1")
	protected String value1;
    
    /** The value2. */
	@XmlElement(name="value2")
	protected String value2;
    
    /** The observer. */
	@XmlElement(name="observer")
	protected AuthorTO observer;
    
    /** The recorder. */
	@XmlElement(name="recorder")
	protected AuthorTO recorder;
    
    /** The timestamp. */
	@XmlElement(name="timestamp")
	protected String timestamp;
    
    /** The facility. */
	@XmlElement(name="facility")
	protected TaggedText facility;
    
    /** The location. */
	@XmlElement(name="location")
	protected HospitalLocationTO location;
    
    /** The comment. */
	@XmlElement(name="comment")
	protected String comment;
    
    /** The units. */
	@XmlElement(name="units")
	protected String units;
    
    /** The qualifiers. */
	@XmlElement(name="qualifiers")
	protected String qualifiers;
	
	public VitalSignTO(){
		super();
	}
	
	public VitalSignTO(VitalSign vitalSign){
		
		if(vitalSign.getType()!=null) this.type = new ObservationTypeTO(vitalSign.getType()); // ObservationTypeTO
		this.value1 = vitalSign.getValue1();
    	this.value2 = vitalSign.getValue2();
    	if(vitalSign.getObserver() !=null) this.observer = new AuthorTO(vitalSign.getObserver()); // AuthorTO
    	if(vitalSign.getRecorder()!=null)this.recorder = new AuthorTO(vitalSign.getRecorder()); // AuthorTO
    	this.timestamp = vitalSign.getTimestamp();
    	if(vitalSign.getFacility() != null)this.facility = new TaggedText(vitalSign.getFacility()); // TaggedText
    	if(vitalSign.getLocation()!=null)this.location = new HospitalLocationTO(vitalSign.getLocation());// HospitalLocationTO
    	this.comment = vitalSign.getComment();
    	this.units = vitalSign.getUnits();
    	this.qualifiers = vitalSign.getQualifiers();
    	    	
	}
	
	/**
	 * Gets the type.
	 *
	 * @return the type
	 */
	public ObservationTypeTO getType()
	{
		return type;
	}
	
	/**
	 * Sets the type.
	 *
	 * @param type the new type
	 */
	public void setType(ObservationTypeTO type)
	{
		this.type = type;
	}
	
	/**
	 * Gets the value1.
	 *
	 * @return the value1
	 */
	public String getValue1()
	{
		return value1;
	}
	
	/**
	 * Sets the value1.
	 *
	 * @param value1 the new value1
	 */
	public void setValue1(String value1)
	{
		this.value1 = value1;
	}
	
	/**
	 * Gets the value2.
	 *
	 * @return the value2
	 */
	public String getValue2()
	{
		return value2;
	}
	
	/**
	 * Sets the value2.
	 *
	 * @param value2 the new value2
	 */
	public void setValue2(String value2)
	{
		this.value2 = value2;
	}
	
	/**
	 * Gets the observer.
	 *
	 * @return the observer
	 */
	public AuthorTO getObserver()
	{
		return observer;
	}
	
	/**
	 * Sets the observer.
	 *
	 * @param observer the new observer
	 */
	public void setObserver(AuthorTO observer)
	{
		this.observer = observer;
	}
	
	/**
	 * Gets the recorder.
	 *
	 * @return the recorder
	 */
	public AuthorTO getRecorder()
	{
		return recorder;
	}
	
	/**
	 * Sets the recorder.
	 *
	 * @param recorder the new recorder
	 */
	public void setRecorder(AuthorTO recorder)
	{
		this.recorder = recorder;
	}
	
	/**
	 * Gets the timestamp.
	 *
	 * @return the timestamp
	 */
	public String getTimestamp()
	{
		return timestamp;
	}
	
	/**
	 * Sets the timestamp.
	 *
	 * @param timestamp the new timestamp
	 */
	public void setTimestamp(String timestamp)
	{
		this.timestamp = timestamp;
	}
	
	/**
	 * Gets the facility.
	 *
	 * @return the facility
	 */
	public TaggedText getFacility()
	{
		return facility;
	}
	
	/**
	 * Sets the facility.
	 *
	 * @param facility the new facility
	 */
	public void setFacility(TaggedText facility)
	{
		this.facility = facility;
	}
	
	/**
	 * Gets the location.
	 *
	 * @return the location
	 */
	public HospitalLocationTO getLocation()
	{
		return location;
	}
	
	/**
	 * Sets the location.
	 *
	 * @param location the new location
	 */
	public void setLocation(HospitalLocationTO location)
	{
		this.location = location;
	}
	
	/**
	 * Gets the comment.
	 *
	 * @return the comment
	 */
	public String getComment()
	{
		return comment;
	}
	
	/**
	 * Sets the comment.
	 *
	 * @param comment the new comment
	 */
	public void setComment(String comment)
	{
		this.comment = comment;
	}
	
	/**
	 * Gets the units.
	 *
	 * @return the units
	 */
	public String getUnits()
	{
		return units;
	}
	
	/**
	 * Sets the units.
	 *
	 * @param units the new units
	 */
	public void setUnits(String units)
	{
		this.units = units;
	}
	
	/**
	 * Gets the qualifiers.
	 *
	 * @return the qualifiers
	 */
	public String getQualifiers()
	{
		return qualifiers;
	}
	
	/**
	 * Sets the qualifiers.
	 *
	 * @param qualifiers the new qualifiers
	 */
	public void setQualifiers(String qualifiers)
	{
		this.qualifiers = qualifiers;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "VitalSignTO [type=" + type + ", value1=" + value1 + ", value2="
				+ value2 + ", observer=" + observer + ", recorder=" + recorder
				+ ", timestamp=" + timestamp + ", facility=" + facility
				+ ", location=" + location + ", comment=" + comment
				+ ", units=" + units + ", qualifiers=" + qualifiers
				+ ", toString()=" + super.toString() + "]";
	}
}
