/**
 * 
 */


package gov.va.med.via.log4j;


import gov.va.med.via.log4j.persistence.LoggerPersistenceManager;

import org.apache.log4j.spi.LoggingEvent;
import org.springframework.context.ApplicationContext;


/**
 *
 */
public class SpringAwareDbAppender
    extends
        AbstractSpringAwareProxy
{

    private LoggerPersistenceManager loggerPersistenceManager;


    @Override
    protected void append( LoggingEvent event )
    {
        ApplicationLogEvent appLogEvent = new ApplicationLogEvent( event );
        loggerPersistenceManager.persistApplicationLogEvent( appLogEvent );
    }


    @Override
    public void activateOptions( )
    {
        super.activateOptions();

        ApplicationContext appContext = getApplicationContext();
        if ( appContext != null )
        {
            loggerPersistenceManager = ( LoggerPersistenceManager )appContext.getBean( "loggerPersistenceManager" );
        }

    }


    /*
     * (non-Javadoc)
     * @see org.apache.log4j.AppenderSkeleton#requiresLayout()
     */
    public boolean requiresLayout( )
    {
        return false;
    }


    @Override
    public void close( )
    {
        // no-op
    }

}