/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc;

/**
 *
 * @author vhahonbrunos
 */
public class DdrFiler extends DdrQuery
{
    private String operation;
    private String[] args;

    public DdrFiler(RPCConnection cxn)
    {
        super(cxn);
    }

    protected String buildRequest() throws RPCException
    {
        if (operation == null || operation.equals(""))
        {
            throw new RPCException("Must have an operation");
        }
        VistaQuery vq = new VistaQuery("DDR FILER");
        vq.addParameter(vq.LITERAL, operation);
        DictionaryHashList lst = new DictionaryHashList();
        for (int i = 0; i < args.length; i++)
        {
            lst.add("" + (i+1), args[i]);
        }
        vq.addParameter(vq.LIST, lst);
        return vq.buildMessage();
    }

    public String execute() throws RPCException
    {
        String request = buildRequest();
        return this.execute(request);
    }

    public String[] getArgs() {
        return args;
    }

    public void setArgs(String[] args) {
        this.args = args;
    }

    public String getOperation() {
        return operation;
    }

    public void setOperation(String operation) {
        this.operation = operation;
    }
}
