/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc;

/**
 *
 * @author vhahonbrunos
 */
public class DdrQuery
{
    private RPCConnection cxn;

    public DdrQuery(RPCConnection cxn)
    {
        this.cxn = cxn;
    }

    public String execute(String request) throws RPCException
    {
        String currentContext = cxn.getCurrentContext();
        if (!currentContext.equals(VistaConstants.CAPRI_CONTEXT))
        {
            try
            {
                if (!cxn.setContext(VistaConstants.CAPRI_CONTEXT))
                {
                    throw new RPCException("Unable to set CAPRI context");
                }
            }
            catch (Exception e)
            {
                if (e.getMessage().indexOf("does not have access to option") != -1)
                {
                    //conferContext(cxn);
                }
            }
        }
        String response;
        response = (String) cxn.query(request);
        if (!currentContext.equals(VistaConstants.CAPRI_CONTEXT))
        {
            if (!cxn.setContext(currentContext))
            {
                throw new RPCException("Unable to reset " + currentContext + " context");
            }
        }
        return response;
    }


    /*protected void conferContext(VistaConnection currentCxn) 
    {
        VistaConnection cxn = new VistaConnection(currentCxn.getDataSource());
        cxn.connect();
        VistaUserDao dao = new VistaUserDao(cxn);
        User user = dao.getUserInfo(currentCxn.getUid());
        cxn.disconnect();
        cxn.connect();
        String duz = dao.visit(user, VistaConstants.CAPRI_CONTEXT, true);
        if (!duz.equals(cxn.getUid()))
        {
            cxn.disconnect();
            throw new RPCException("Mismatched DUZ's after visit. Expected " + cxn.getUid() + ", got " + duz);
        }
        if (!dao.authorize(VistaConstants.CAPRI_CONTEXT))
        {
            cxn.disconnect();
            throw new RPCException("Unable to set CAPRI context after visit");
        }
        cxn.disconnect();
        if (!currentCxn.setContext(VistaConstants.CAPRI_CONTEXT))
        {
            throw new RPCException("Unable to set CAPRI context after conferring context");
        }
    }*/
}
