/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc;

import gov.va.med.via.rpc.site.DataSource;
import java.util.Map;


/**
 *
 * @author vhahonbrunos
 */
public class UtilityRPCS
{
    public static String getWelcomeMessage(RPCConnection cxn) throws RPCException
    {
        try
        {
            if (!isVamcDataSource(cxn.getDataSource()))
            {
                return null;
            }
            String request = buildGetWelcomeMessageRequest();
            String response = (String) cxn.query(request);
            return response;
        }
        catch (Exception e)
        {
            throw new RPCException(e);
        }
    }

    private static String buildGetWelcomeMessageRequest()
    {
        VistaQuery vq = new VistaQuery("XUS INTRO MSG");
        return vq.buildMessage();
    }

    public static boolean isVamcDataSource(DataSource dataSource)
    {
        return dataSource.getProtocol().equals("VISTA");
    }

    public static String getTimestamp(RPCConnection cxn) throws RPCException
    {
        try
        {
            if (!isVamcDataSource(cxn.getDataSource()))
            {
                return "";
            }
            String request = buildGetTimestampRequest();
            String response = (String) cxn.query(request);
            return response;
        }
        catch (Exception e)
        {
            throw new RPCException(e);
        }
    }

    private static String buildGetTimestampRequest()
    {
        VistaQuery vq = new VistaQuery("ORWU DT");
        vq.addParameter(vq.LITERAL,"NOW");
        return vq.buildMessage();
    }


    public static Map getPatientTypes() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /** DECOMMISSIONED getVariableValue()
    public static String getOptionIen(RPCConnection cxn, String context) throws RPCException
    {
        try
        {
            String arg = "$O(^DIC(19,\"B\",\"" + context + "\",0))";
            String response = RPCUtils.getVariableValue(cxn, arg);
            return RPCUtils.errMsgOrIen(response);
        }
        catch (Exception e)
        {
            throw new RPCException(e);
        }
    }

    public static boolean hasSecurityLock(RPCConnection cxn, String contextIen) throws RPCException
    {
        String arg = "$P(^DIC(19," + contextIen + ",0),\"^\",6)";
        String response = RPCUtils.getVariableValue(cxn,arg);
        return (!response.equals(""));
    }

    public static String getSecurityKey(RPCConnection cxn, String context) throws RPCException
    {
        String contextIen = getOptionIen(cxn, context);
        String arg = "$G(^DIC(19," + contextIen + ",0))";
        String response = RPCUtils.getVariableValue(cxn,arg);
        return extractSecurityKey(response);
    }

    private static String extractSecurityKey(String response)
    {
        return RPCStringUtils.piece(response,"^",6);
    }

    public static String getSecurityKeyIen(RPCConnection cxn, String securityKey) throws RPCException
    {
        try
        {
            String arg = "$O(^DIC(19.1,\"B\",\"" + securityKey + "\",0))";
            String response = RPCUtils.getVariableValue(cxn, arg);
            return RPCUtils.errMsgOrIen(response);
        }
        catch (Exception e)
        {
            throw new RPCException(e);
        }
    }**/
}
