/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc;

/**
 *
 * @author vhahonbrunos
 */
public class VistaConstants
{
	// The context options below all point at the VIAB WEB SERVICES OPTION.  Developers should only use the 
	// VIAB_WEB_SERVICES_OPTION value, but just in case a mistake is made, the other available options/context 
	// point to the single VIA option.  
    public final static String CAPRI_CONTEXT = "VIAB WEB SERVICES OPTION";// "DVBA CAPRI GUI 2";
    public final static String CPRS_CONTEXT = "VIAB WEB SERVICES OPTION"; //"OR CPRS GUI CHART";
    public final static String BCMA_CONTEXT = "VIAB WEB SERVICES OPTION";//"PSB GUI CONTEXT - USER 2";
    public final static String VISTA_IMAGING_CONTEXT = "VIAB WEB SERVICES OPTION";//"MAG WINDOWS 2";
    public final static String KAAJEE_LOGIN_CONTEXT="VIAB WEB SERVICES OPTION";//"XUS KAAJEE WEB LOGON 2";

    public final static String DELEGATED_OPTIONS_FILE = "200.19";
    public final static String MENU_OPTIONS_FILE = "200.03";

    public final static String BEGIN_DATA = "[BEGIN_diDATA]";
    public final static String END_DATA = "[END_diDATA]";
    public final static String MISC = "[Misc]";
    public final static String BEGIN_ERRS = "[BEGIN_diERRORS]";
    public final static String END_ERRS = "[END_diERRORS]";
    public final static String BEGIN_HELP = "[BEGIN_diHELP]";
    public final static String END_HELP = "[END_diHELP]";
    public final static String BEGIN_IENS = "BEGIN_IENs";
    public final static String END_IENS = "END_IENs";
    public final static String BEGIN_IDVALS = "BEGIN_IDVALUES";
    public final static String END_IDVALS = "END_IDVALUES";
    public final static String UNPACKED_NO_RESULTS = "0^*^0^";

    // Order actions
    public final static String OA_COPY = "RW";
    public final static String OA_CHANGE = "XX";
    public final static String OA_RENEW = "RN";
    public final static String OA_HOLD = "HD";
    public final static String OA_DC = "DC";
    public final static String OA_UNHOLD = "RL";
    public final static String OA_FLAG = "FL";
    public final static String OA_UNFLAG = "UF";
    public final static String OA_COMPLETE = "CP";
    public final static String OA_ALERT = "AL";
    public final static String OA_REFILL = "RF";
    public final static String OA_VERIFY = "VR";
    public final static String OA_CHART = "CR";
    public final static String OA_RELEASE = "RS";
    public final static String OA_SIGN = "ES";
    public final static String OA_ONCHART = "OC";
    public final static String OA_COMMENT = "CM";
    public final static String OA_TRANSFER = "XFR";
    public final static String OA_CHGEVT = "EV";
    public final static String OA_EDREL = "MN";

    // Sign & release orders
    public final static String SS_ONCHART  = "0";
    public final static String SS_ESIGNED  = "1";
    public final static String SS_UNSIGNED = "2";
    public final static String SS_NOTREQD  = "3";
    public final static String SS_DIGSIG   = "7";
    public final static String RS_HOLD     = "0";
    public final static String RS_RELEASE  = "1";
    public final static String NO_PROVIDER = "E";
    public final static String NO_VERBAL   = "V";
    public final static String NO_PHONE    = "P";
    public final static String NO_POLICY   = "I";
    public final static String NO_WRITTEN  = "W";

    // Globals
    public final static String SURGERY_130 = "^SRF(";
    public final static String LABS_60 = "^LAB(60,";

    // Miscellaneous
    public final static String CONCAT_STR = "_\"^\"_";

    // File Numbers
    public final static String MEDICAL_CENTER_DIVISION = "40.8";
    public final static String FACILITY_MOVEMENT_TYPES = "405.1";
    public final static String MAS_MOVEMENT_TYPES = "405.2";
    public final static String PTF_SPECIALTIES = "42.4";
    public final static String SERVICES = "49";
    public final static String WARD_LOCATIONS = "42";
    public final static String ROOM_BEDS = "405.4";
    public final static String CLINIC_STOPS = "40.7";
    public final static String LOCATION_TYPES = "40.9";
    public final static String INSTITUTIONS = "4";
    public final static String APPT_TYPES = "409.1";
    public final static String TREATING_SPECIALTY = "45.7";
    public final static String ORDER_STATUS = "100.01";
    public final static String SECURITY_KEY = "19.1";
    public final static String MH_RESULTS = "601.92";
    public final static String MH_ADMINISTRATIONS = "601.84";
    public final static String MH_TESTS_AND_SURVEYS = "601.71";
}

