/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc.site;

/**
 *
 * @author vhahonuyehac
 */
public class DataSourceUtils {

    public static DataSource getDataSourceBySiteId(String siteId)
            throws SiteException
    {
        try
        {
            SiteTable siteTable = SiteTable.getInstance();

            Site site = siteTable.getSite(siteId);
            if(site == null)
                throw new SiteException("Site not found. Looking for siteId: " + siteId);
           // System.out.println(site.get)
            DataSource dataSource = site.getDataSourceByModality("HIS");
            if(dataSource != null)
                return dataSource;
            else
                throw new SiteException("DataSource not found. Looking for siteId: " + siteId);
        }
        catch (Exception ex)
        {
            throw new SiteException("getDataSourceBySiteId failed: " + ex.getMessage());
        }
    }

}
