/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc.site;

/**
 *
 * @author vhahonbrunos
 */
public class Site
{
    private String id;
    private String name;
    private String displayName;
    private String moniker;
    private String regionId;
    private String lastEventTimestamp;
    private String lastEventReason;
    private String errMsg;
    private DataSource[] dataSources;
    private String parentSiteId;
    private Site[] childSites;
    private String address;
    private String city;
    private String state;
    private String systemName;
    private String siteType;

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public Site[] getChildSites() {
        return childSites;
    }

    public void setChildSites(Site[] childSites) {
        this.childSites = childSites;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public DataSource[] getDataSources() {
        return dataSources;
    }

    public void setDataSources(DataSource[] dataSources) {
        this.dataSources = dataSources;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public String getErrMsg() {
        return errMsg;
    }

    public void setErrMsg(String errMsg) {
        this.errMsg = errMsg;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLastEventReason() {
        return lastEventReason;
    }

    public void setLastEventReason(String lastEventReason) {
        this.lastEventReason = lastEventReason;
    }

    public String getLastEventTimestamp() {
        return lastEventTimestamp;
    }

    public void setLastEventTimestamp(String lastEventTimestamp) {
        this.lastEventTimestamp = lastEventTimestamp;
    }

    public String getMoniker() {
        return moniker;
    }

    public void setMoniker(String moniker) {
        this.moniker = moniker;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getParentSiteId() {
        return parentSiteId;
    }

    public void setParentSiteId(String parentSiteId) {
        this.parentSiteId = parentSiteId;
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getSiteType() {
        return siteType;
    }

    public void setSiteType(String siteType) {
        this.siteType = siteType;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getSystemName() {
        return systemName;
    }

    public void setSystemName(String systemName) {
        this.systemName = systemName;
    }

    public DataSource getDataSourceByModality(String modality)
    {
        for (int i = 0; i < dataSources.length; i++)
        {
            if (dataSources[i].getModality().equals(modality))
            {
                return dataSources[i];
            }
        }
        return null;
    }
    
}
