/**
 * Janus 4.0 (c)
 * Copyright (c) 2011 Hawaii Resource Group LLC. All Rights Reserved.
 * Developed for the Pacific Telehealth & Technology Hui and the Pacific Joint Information Technology Center
 * Contributors:
 *     Honorable Senator Daniel K. Inouye
 *     VA Pacific Islands Health Care System
 *     Tripler Army Medical Center
 */
 
 
package gov.va.med.via.rpc.site;

/**
 *
 * @author vhahonbrunos
 */
public class SiteId
{
    private String id;
    private String name;
    private String lastSeenDate;
    private String lastEvent;

    public SiteId()
    {
        id = "";
        name = "";
        lastSeenDate = "";
        lastEvent = "";
    }

    public SiteId(String id)
    {
        this.id = id;
        this.name = "";
        this.lastSeenDate = "";
        this.lastEvent = "";
    }

    public SiteId(String id, String name)
    {
        this.id = id;
        this.name = name;
        this.lastSeenDate = "";
        this.lastEvent = "";
    }

    public SiteId(String id, String name, String lastSeenDate)
    {
        this.id = id;
        this.name = name;
        this.lastSeenDate = lastSeenDate;
        this.lastEvent = "";
    }

    public SiteId(String id, String name, String lastSeenDate, String lastEvent)
    {
        this.id = id;
        this.name = name;
        this.lastSeenDate = lastSeenDate;
        this.lastEvent = lastEvent;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLastEvent() {
        return lastEvent;
    }

    public void setLastEvent(String lastEvent) {
        this.lastEvent = lastEvent;
    }

    public String getLastSeenDate() {
        return lastSeenDate;
    }

    public void setLastSeenDate(String lastSeenDate) {
        this.lastSeenDate = lastSeenDate;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean equals(SiteId id1, SiteId id2)
    {
        if (id1 == null)
        {
            return id2 == null;
        }

        if (id2 == null)
        {
            return false;
        }

        Class clsId1 = id1.getClass();
        Class clsId2 = id2.getClass();

        if (!clsId1.getName().equals(clsId2.getName()))
        {
            return false;
        }

        if (!id1.getId().equals(id2.getId()))
        {
            return false;
        }

        return id1.getName().equals(id2.getName());
    }
}
