<%@ page language="java"%>
<!-- taglib uri="/tags/struts-html" prefix="html" -->
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ include file="include/cache-control.inc"%>
<html:html>
	<head>
		<meta http-equiv="Content-Type"
			content="text/html; charset=ISO-8859-1">
		<title>VistALink Configuration Editor</title>
<link rel="stylesheet" type="text/css" href="vistalinkj2m/standalone.css">
	</head>
	<body>
	
<script type="text/javascript">
<!--
function verifymoretime()
{
var message="${sessionTimeoutWarningIntervalMsg}";
alert(message);
}
function timer( ){
setTimeout("verifymoretime();",(${sessionTimeoutWarningTime}*1000));
}
timer(); // initial call to timer
// -->
</script>

		<%@ include file="include/toolbar1.inc"%>
			<html:link href="ConsoleMainAction.do" title="Jump to VistALink console main/top page">Console Main</html:link> &gt; 
			<b>Configuration File Editor</b>
		<%@ include file="include/toolbar2.inc"%>
		
		<c:choose>
			<c:when test="${isSaved}">
				<p align="center"><font color="green">Result: Changes to entry '<b>${jndiName}</b>' saved in configuration file.</font><br>&nbsp;</p>
			</c:when>
			<c:when test="${isDeleted}">
				<p align="center"><font color="green">Result: '<b>${jndiName}</b>' entry deleted from configuration file.</font><br>&nbsp;</p>
			</c:when>
			<c:when test="${isEncrypted}">
				<p align="center"><font color="green">Result: ${encryptCount} entries were encrypted!</font><br>&nbsp;</p>
			</c:when>
			<c:when test="${isEncryptionChanged}">
				<p align="center"><font color="green">Result: Encryption type changed to <b>${newEncryptType}</b>; ${newEncryptCount} entries updated/re-encrypted.</font><br>&nbsp;</p>
			</c:when>
		</c:choose>

		<html:errors />

		<h2>VistALink Configuration File Editor</h2>

		<html:form method="post" action="ConfiguratorRetrieveAction.do">
		
		<div align="center">
		<table border="0" cellspacing="3" cellpadding="3" align="center" summary="Configuration File Properties">
			<tr title="Configuration File Properties">
				<th align="right" scope="col" style="border-bottom: 1px solid black;white-space: nowrap;">Config File Attribute</th>
				<th align="left" scope="col" style="border-bottom: 1px solid black;white-space: nowrap;"colspan=2>Value</th>
			</tr>
			<tr title="Configuration File Location">
				<td align="right" valign="bottom">Location (on admin server):</td>
				<td align="left" valign="bottom" colspan=2>${configFilePath}</td>
			</tr>
			<tr title="Entry Count">
				<td align="right" valign="bottom">Entry Count:</td>
				<td align="left" valign="bottom" colspan=2>${configFileSize}</td>
			</tr>
			<tr title="Unencrypted Entry Control">
				<td align="right" valign="bottom">Unencrypted Entry Count:</td>
				<td align="left" valign="bottom">
					<c:choose>
						<c:when test="${(configFileUnencryptedCount==0)}">none</c:when>
						<c:otherwise>${configFileUnencryptedCount}</c:otherwise>
					</c:choose>
				</td>
				<td align="left" valign="bottom">
					<c:if test="${(configFileUnencryptedCount>0)}">
						<html:submit property="submitValue" value="Encrypt Unencrypted Entries" title="Encrypt Unencrypted Entries" accessKey="e" />
					</c:if>
				</td>
			</tr>
			<tr title="Encryption Type Control">
				<td align="right" valign="bottom">Encryption Type:</td>
        		<td align="left" valign="bottom">${configFileEncryptionType}</td>
				<td align="left" valign="bottom">
	        		<html:submit property="submitValue" value="Change Encryption Type" title="Change Encryption Type" accessKey="c" />
				</td>
			</tr>
			<tr title="Add New Connector">
				<td align="right" valign="bottom">&nbsp;</td>
        		<td align="left" valign="bottom">&nbsp;</td>
				<td align="left" valign="bottom">
	        		<html:submit property="submitValue" value="Add New Connector" title="Add New Entry to Configuration File" accessKey="a" />
				</td>
			</tr>
		</table>

		<table border="0" cellspacing="3" cellpadding="3" align="center" summary="Configuration File Connector Entry List">
			<tr>
				<th valign="bottom" align="left" style="border-bottom: 1px solid black" scope="col">
					<b>JNDI Name&nbsp;&nbsp;</b>
				</th>
				<th valign="bottom" align="left" style="border-bottom: 1px solid black" scope="col">
					<b>Primary Station&nbsp;&nbsp;</b>
				</th>
				<th valign="bottom" align="left" style="border-bottom: 1px solid black" scope="col">
					<b>IP/Port</b>
				</th>
				<th valign="bottom" align="left" style="border-bottom: 1px solid black" scope="col">
					<b>Enabled?</b>
				</th>
			</tr>
			
			<c:if test="${not empty connectorConfigList}">
				<c:forEach var="conn" items="${connectorConfigList}">
					<tr>
						<td align="left">
							<html:link href="ConfiguratorRetrieveAction.do?jndiName=${conn.jndiName}" title="edit connector ${conn.jndiName}">${conn.jndiName}</html:link>
						</td>
						<td align="left">${conn.primaryStation}</td>
						<td align="left">${conn.ip}/${conn.port}</td>
						<td align="left"><c:if test="${conn.enabled}">y</c:if></td>
					</tr>
				</c:forEach>
			</c:if>
		</table>
		</div>
		</html:form>		
		
		<%@ include file="include/footer.inc"%>

	</body>
</html:html>
