<%@ page language="java" %>
<!-- taglib uri="/tags/struts-html" prefix="html" -->
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ include file="include/cache-control.inc"%>
<html:html>
	<head>
		<meta http-equiv="Content-Type"
			content="text/html; charset=ISO-8859-1">
		<title>VistALink Connector Detail</title>
<link rel="stylesheet" type="text/css" href="vistalinkj2m/standalone.css">
	</head>
	<body>

<script type="text/javascript">
<!--
function verifymoretime()
{
var message="${sessionTimeoutWarningIntervalMsg}";
alert(message);
}
function timer( ){
setTimeout("verifymoretime();",(${sessionTimeoutWarningTime}*1000));
}
timer(); // initial call to timer
// -->
</script>

		<%@ include file="include/toolbar1.inc"%>
			<html:link href="ConsoleMainAction.do" title="Jump to VistALink console main/top page">Console Main</html:link> &gt;
			<html:link href="DisplayConnectorListAction.do?server=${server.serverConstructorAttributes}" title="Summary of deployed connectors">Connector Summary</html:link>
			-
			<html:link href="DisplayInstitutionMappingAction.do?server=${server.serverConstructorAttributes}" title="Institution Mapping on server ${server.serverName}">Institution Mapping</html:link>
		<%@ include file="include/toolbar2.inc"%>

		<html:errors />

		<h2>
			Server: '${server.serverName}', Connector: '${empty connectorDetailVO.displayName ? connectorDetailVO.jcaJndiName : connectorDetailVO.displayName}' Detail
			<br>&nbsp;
		</h2>
		
		<div align="center">
		<table border="0" cellpadding="3" summary="Connector Details List">
			<tr>
				<th style="border-bottom: double black;" scope="col" align="right">Attribute</th>
				<th style="border-bottom: double black;" scope="col" align="left">Value</th>
			</tr>
			<tr>
				<td valign="top" align="right" nowrap="nowrap"><u><b>J2EE Connector Configuration:</b></u></td>
				<td valign="top" align="left">&nbsp;</td>
			</tr>
			<tr title="JNDI Name: The JNDI name under which the connector is registered under">
				<td valign="top" align="right" nowrap="nowrap">Deployed JNDI Name:</td>
				<td valign="top" align="left">${connectorDetailVO.jcaJndiName}</td>
			</tr>
			<tr title="Deployment State: The J2EE deployment state of the connector">
				<td valign="top" align="right" nowrap="nowrap">Deployment State:</td>
				<td valign="top" align="left">${connectorDetailVO.jcaDeploymentStateString}</td>
			</tr>

			<c:if test="${not empty connectorDetailVO.platformSpecificItemsMap}">
				<tr>
					<td valign="top" align="right" nowrap="nowrap"><u><b>Platform-Specific Items:</b></u></td>
					<td valign="top" align="left">&nbsp;</td>
				</tr>
				<c:forEach var="platformItem" items="${connectorDetailVO.platformSpecificItemsMap}">
					<tr title="Platform-specific connector information">
						<td valign="top" align="right" nowrap="nowrap">${platformItem.key}:</td>
						<td valign="top" align="left">${platformItem.value}</td>
					</tr>
				</c:forEach>
			</c:if>

			<tr>
				<td valign="top" align="right" nowrap="nowrap"><u><b>VistaLink Configuration File Settings:</b></u></td>
				<td valign="top" align="left">&nbsp;</td>
			</tr>
			<tr title="The (JNDI) name, i.e. lookup key, used to retrieve settings for this connector from the VistALink configuration file">
				<td valign="top" align="right" nowrap="nowrap">connectorJndiName:</td>
				<td valign="top" align="left">${connectorDetailVO.cfgJndiName}</td>
			</tr>
			
			<c:if test="${conn.value.jndiMismatch}">
				<tr title="Serious configuration problem: The JNDI name the connector is deployed under does not match the JNDI name used to retrieve configuration values from the VistALink configuration file. In the deployment descriptors, connectorJndiName custom property value must match platform-specific JNDI name value.">
					<td>&nbsp;</td>
					<td><b>WARNING: DEPLOYED JNDI NAME DOES NOT MATCH CONFIGURATION FILE JNDI NAME!</b><br>
					In the deployment descriptors, connectorJndiName custom property value must match platform-specific JNDI name value.<br>
					Correct deployment descriptors and re-deploy.</td>
				</tr>
			</c:if>
			
			<tr title="Destination IP address for target M system">
				<td valign="top" align="right" nowrap="nowrap">M listener IP Address:</td>
				<td valign="top" align="left">${connectorDetailVO.cfgIpAddress}</td>
			</tr>
			<tr title="resolved (live) IP Address for target M system">
				<td valign="top" align="right" nowrap="nowrap">Resolved (live) M listener IP Address:</td>
				<td valign="top" align="left">${resolvedIPAddress}</td>
			</tr>
			<tr title="Destination port for target M system">
				<td valign="top" align="right" nowrap="nowrap">M listener Port:</td>
				<td valign="top" align="left">${connectorDetailVO.cfgPort}</td>
			</tr>
			<tr title="Default socket timeout for connections to this M system">
				<td valign="top" align="right" nowrap="nowrap">Default J2EE Socket Timeout:</td>
				<td valign="top" align="left">'${connectorDetailVO.cfgTimeout}' ms; &nbsp;&nbsp;Always use as Minimum?: ${connectorDetailVO.cfgTimeoutAlwaysUseDefaultAsMin}</td>
			</tr>

			<tr title="Station numbers associated with this connector in the live institution mapping">
				<td valign="top" align="right" nowrap="nowrap">Institution Mapping(s) - live:</td>
				<td valign="top" align="left">
				<c:choose>
					<c:when test="${empty connectorDetailVO.jcaJndiName}">
						Deployed JNDI name not yet available to look up mappings against.
					</c:when>
					<c:when test="${empty connectorDetailVO.cfgStationNumbers}">
						No institution mappings found.
					</c:when>
					<c:otherwise>
						<ul>
							<c:forEach var="stationNumber" items="${connectorDetailVO.cfgStationNumbers}">
								<li>${stationNumber}</li>
							</c:forEach>
						</ul>
					</c:otherwise>
				</c:choose>
			</td></tr>

			<tr><td valign="top" align="right" nowrap="nowrap"><u><b>Health Monitoring:</b></u></td><td>&nbsp;</td></tr>
			<tr title="Count of socket-level connection failures (network issues)">
				<td valign="top" align="right" nowrap="nowrap">Connection Failure Count:</td>
				<td valign="top" align="left">${connectorDetailVO.hlthConnectionFailureCount}</td>
			</tr>
			<tr title="Count of authentication-level connection failures (connection proxy logon problems)">
				<td valign="top" align="right" nowrap="nowrap">Connection Authentication Failure Count:</td>
				<td valign="top" align="left">${connectorDetailVO.hlthConnectionAuthFailureCount}</td>
			</tr>
			<tr title="Count of mismatches between J2EE and M server based on production/test settings">
				<td valign="top" align="right" nowrap="nowrap">Production Mismatch Failure Count:</td>
				<td valign="top" align="left">${connectorDetailVO.hlthProductionMismatchCount}</td>
			</tr>
			<tr title="Count of mismatches between request and M server regarding requested division">
				<td valign="top" align="right" nowrap="nowrap">Division Mismatch Count:</td>
				<td valign="top" align="left">${connectorDetailVO.hlthDivisionMismatchCount}</td>
			</tr>
			<tr title="Count of re-authentication failures on the connection (application-level user logons)">
				<td valign="top" align="right" nowrap="nowrap">Identity Failure Count:</td>
				<td valign="top" align="left">${connectorDetailVO.hlthIdentityFailureCount}</td>
			</tr>

			<tr>
				<td valign="top" align="right" nowrap="nowrap"><u><b>Performance Monitoring:</b></u></td>
				<td valign="top" align="left">&nbsp;</td>
			</tr>
			<tr title="The amount of time it takes for a VistaLink managed connection to create a new connection handle for the underlying physical connection represented by the ManagedConnection instance; this connection handle is used by the application code to refer to the underlying physical connection">
				<td valign="top" align="right" nowrap="nowrap">Create Connection Handle Avg (ms):</td>
				<td valign="top" align="left">${connectorDetailVO.perfCreateConnectionHandleAvgMillis}</td>
			</tr>
			<tr title="The amount of time it takes for the VistaLink connection factory to either a) match a connection request with an existing connection in pool of managed connections, or b) determine that no such match exists">
				<td valign="top" align="right" nowrap="nowrap">Match Managed Connection Avg (ms):</td>
				<td valign="top" align="left">${connectorDetailVO.perfMatchManagedConnectionAvgMillis}</td>
			</tr>

					<tr>
						<td valign="top" align="right" nowrap="nowrap"><u><b>Live VistALink M/VistA Server Query:</b></u></td>

			<c:choose>
				<c:when test="${empty connectorDetailVO.mumpsSystemInfo}">
						<td valign="top" align="left"><b>M system information could not be retrieved.</b>
						</td>
					</tr>
				</c:when>
				<c:when test="${empty connectorDetailVO.mumpsSystemInfo.errorMessage}">
				    	<td>&nbsp;</td>
					</tr>
					<tr title="Version of VistaLink on the remote M system ">
						<td valign="top" align="right" nowrap="nowrap">Remote VL Version:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.vistalinkVersion}</td>
					</tr>
					<tr title="VistaLink build# on the remote M system">
						<td valign="top" align="right" nowrap="nowrap">Remote VL Build:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.vistalinkBuild}</td>
					</tr>
					<tr title="The number of seconds that a VistaLink connection from J2EE to M is allowed to remain connected but inactive, before the remote M system drops the connection">
						<td valign="top" align="right" nowrap="nowrap">Remote VL Listener Timeout:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.appServerTimeout}</td>
					</tr>
					<tr title="The number of seconds that the remote M system considers a connection to remain reauthenicated after a successful reauthentication has occurred">
						<td valign="top" align="right" nowrap="nowrap">Remote VL Reauthenticated Session Timeout:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.reAuthSessionTimeout}</td>
					</tr>
					<tr title="The name (from the remote M system's File #200) of the user corresponding to the connection proxy access/verify codes used to log on the connector to the M system">
						<td valign="top" align="right" nowrap="nowrap">Remote VL Connector Proxy Username:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.cpName}</td>
					</tr>
					<tr title="The UCI of the remote M account, as reported by GETENV^%ZOSV">
						<td valign="top" align="right" nowrap="nowrap">Remote UCI:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.uci}</td>
					</tr>
					<tr title="The volume set of the remote M account, as reported by GETENV^%ZOSV">
						<td valign="top" align="right" nowrap="nowrap">Remote VOL:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.vol}</td>
					</tr>
					<tr title="The BOX-VOLUME pair from the TaskMan site parameters file of the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote BOX-VOLUME:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.boxVolume}</td>
					</tr>
					<tr title="The version of M running in the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote M Version:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.mumpsVersion}</td>
					</tr>
					<tr title="The host operating system for the computer system hosting the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote Operating System:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.operatingSystem}</td>
					</tr>
					<tr title="The MailMan Domain configured in the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote Domain:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.domainName}</td>
					</tr>
					<tr title="The production setting of the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote is Production?:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.vistaProduction}</td>
					</tr>
					<tr title="The default institution configured for the remote M account">
						<td valign="top" align="right" nowrap="nowrap">Remote Kernel Default Institution:</td>
						<td valign="top" align="left">${connectorDetailVO.mumpsSystemInfo.defaultInstitution}</td>
					</tr>
					<tr title="The introductory text configured in Kernel as the sign-on screen for the remote M account; serves as another form of system indentification">
						<td valign="top" align="right" nowrap="nowrap">Introductory Text:</td>
						<td><TEXTAREA NAME="introText" WRAP=OFF COLS=80 ROWS=15>${connectorDetailVO.mumpsSystemInfo.introText}</TEXTAREA></td>
					</tr>
				</c:when>
				<c:otherwise>
						<td valign="top" align="left"><b>M system information could not be retrieved:</b><p>${connectorDetailVO.mumpsSystemInfo.errorMessage}</p>
						</td>
					</tr>
				</c:otherwise>
			</c:choose>
		</table>
		</div>

		<%@ include file="include/footer.inc"%>

	</body>
</html:html>
